/*[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]*/
/*UAssociation.p*/
/*Copyright  1988-1989 by Apple Computer Inc.  All rights reserved.*/
#ifndef  __UAssociation__
#define __UAssociation__  0
#endif
#if  ! __UAssociation__
#define __UAssociation__  1

		/*  Auto-Include the requirements for this unit's interface. */
#ifndef  __UList__
#include "UList.h"
#endif

class TEntry : public TObject {
  public:

	StringHandle fKey;
	StringHandle fValue;

	virtual pascal void IEntry(StringPtr itsKey, StringPtr itsValue);

	virtual pascal void Free(void);

	virtual pascal void SetValue(StringPtr value);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

class TEntriesList : public TSortedList {
  public:

	virtual pascal short Compare(TObject *item1, TObject *item2);

};

class TAssociation : public TObject {
  public:

	TEntriesList *fEntries;

	virtual pascal void IAssociation(void);

	virtual pascal void Free(void);

	virtual pascal Boolean ValueAt(StringPtr keyStr, StringPtr valueStr);

	virtual pascal Boolean KeyAt(StringPtr valueStr, StringPtr keyStr);

	virtual pascal void EachEntryDo(pascal void (*DoToEntry)(TEntry *theEntry, void *
	   DoToEntry_StaticLink), void *DoToEntry_StaticLink);

	virtual pascal TEntry *EntryWithKey(StringPtr keyStr);

	virtual pascal TEntry *EntryWithValue(StringPtr valueStr);

	virtual pascal TEntry *FirstEntryThat(pascal Boolean (*TestEntry)(TEntry *theEntry, void *
	   TestEntry_StaticLink), void *TestEntry_StaticLink);

	virtual pascal void InsertEntry(StringPtr keyStr, StringPtr valueStr);

	virtual pascal void RemoveValueAt(StringPtr keyStr);

	virtual pascal void RemoveKeyAt(StringPtr valueStr);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

#endif

