/*[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]*/
/*UDialog.p*/
/*Copyright  1988-1989 by Apple Computer Inc.  All rights reserved.*/
#ifndef  __UDialog__
#define __UDialog__  0
#endif
#if  ! __UDialog__
#define __UDialog__  1

		/*  Auto-Include the requirements for this unit's interface. */
#ifndef  __UMacApp__
#include "UMacApp.h"
#endif
#ifndef  __UTEView__
#include "UTEView.h"
#endif

const short kPreferColor		= true;					/* argument to IIcon */
const short kControlOn			= true;					/* argument to ICheckBox and IRadio */

			/* Constants for TDialogView.Dismiss */
const short kFlash				= true;
const short kDontFlash			= false;

const unsigned char kFrame				= (adnLineTop | adnLineLeft | adnLineBottom | adnLineRight);

const short Chr00				='\000';				/* Needed for ControlCharSet */
const short Chr1F				='\037';

const short kMaxTEWidth			= 0x2B0;				/* Maximum width for TEditText autoscroll */

const short phInvalidValue		= 300;					/* Alert used when an invalid value is
                                                         entered */

const short kInvalidValueReasons = 300;
   /* String list used for invalid value alert */
const short kValidValue			= 0;					/* Not looked up in the string list. */
const short kInvalidValue		= 1;
const short kValueTooSmall		= 2;
const short kValueTooLarge		= 3;
const short kNonNumericCharacters = 4;
const short kNoOfDefaultReasons = 4;

typedef unsigned long ControlCharSet;

typedef struct DialogViewTemplate *DialogViewTemplatePtr; 
struct DialogViewTemplate {
	ResType defaultItem;
	ResType cancelItem;
};

class TDialogView : public TView {
  public:
	ResType fDefaultItem;								/* The identifier of the default item */
	ResType fCancelItem;
	   /* The identifier of item that cancels dialog
                                                         */
	TAssociation *fParamTxt;							/* the list of TEntrys for replacement */
	struct TEditText *fCurrentEditText;					/* Currently selected edit text item */
	struct TDialogTEView *fTEView;						/* Used for editing in EditText views */
	Boolean fDismissed;									/* Has the dialog been dismissed? */
	ResType fDismisser;									/* ID of view that caused dismissal */

	virtual pascal void IDialogView(TDocument *itsDocument, TView *itsSuperView, VPoint *itsLocation
	   , VPoint *itsSize, SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, ResType 
	   itsDefItemID, ResType itsCancelItemID);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal Boolean CanDismiss(ResType dismissing);

	virtual pascal void CantDeselect(struct TEditText *theEditText, long reason);

	virtual pascal void Close(void);

	virtual pascal void DismissDialog(ResType dismisser, Boolean flashDismisser);

	virtual pascal TCommand *DoCommandKey(short ch, EventInfo *info);
				/* Called when a keyDown event is received and the command key is down. */

	virtual pascal TCommand *DoKeyCommand(short ch, short aKeyCode, EventInfo *info);

	virtual pascal void DoOpen(void);

	virtual pascal Boolean DeselectCurrentEditText(void);

	virtual pascal void DoSelectEditText(struct TEditText *theEditText, Boolean selectChars);

	virtual pascal void EachEditText(pascal void (*DoToEditText)(struct TEditText *theEditText, void
	    *DoToEditText_StaticLink), void *DoToEditText_StaticLink);

	virtual pascal TView *GetDialogView(void);

	virtual pascal void Tab(Boolean tabBackward);

	virtual pascal void DoChoice(TView *origView, short itsChoice);

	virtual pascal struct TDialogTEView *MakeTEView(void);

	virtual pascal void Open(void);

	virtual pascal void ParamTxt(StringPtr keyStr, StringPtr valueStr);

	virtual pascal ResType PoseModally(void);

	virtual pascal void ReplaceText(StringPtr theText);

	virtual pascal void SelectEditText(ResType itsIdentifier, Boolean selectChars);

	virtual pascal void SurveyEditText(struct TEditText **first, struct TEditText **last, struct 
	   TEditText **next, struct TEditText **previous);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

typedef struct ButtonTemplate *ButtonTemplatePtr; 
struct ButtonTemplate {
	Str255 itsLabel;									/* Actually, variable length */
};

class TButton : public TCtlMgr {
  public:

	virtual pascal void IButton(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, StringPtr itsLabel);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

typedef struct CheckBoxTemplate *CheckBoxTemplatePtr; 
struct CheckBoxTemplate {
	Boolean isOn;
	Str255 itsLabel;									/* Actually, variable length */
};

class TCheckBox : public TCtlMgr {
  public:

	virtual pascal void ICheckBox(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, StringPtr itsLabel, Boolean 
	   isTurnedOn);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void DoChoice(TView *origView, short itsChoice);

	virtual pascal Boolean IsOn(void);

	virtual pascal void SetState(Boolean state, Boolean redraw);

	virtual pascal void Toggle(Boolean redraw);

	virtual pascal void ToggleIf(Boolean matchState, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

typedef struct RadioTemplate *RadioTemplatePtr; 
struct RadioTemplate {
	Boolean isOn;
	Str255 itsLabel;									/* Actually, variable length */
};

class TRadio : public TCtlMgr {
  public:

	virtual pascal void IRadio(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, StringPtr itsLabel, Boolean 
	   isTurnedOn);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void DoChoice(TView *origView, short itsChoice);

	virtual pascal Boolean isOn(void);

	virtual pascal void SetState(Boolean state, Boolean redraw);

	virtual pascal void Toggle(Boolean redraw);

	virtual pascal void ToggleIf(Boolean matchState, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

};

typedef struct ClusterTemplate *ClusterTemplatePtr; 
struct ClusterTemplate {
	Str255 itsLabel;									/* Actually, variable length */
};

class TCluster : public TControl {
  public:

	short fRsrcID;
	short fIndex;
	StringHandle fDataHandle;

	virtual pascal void ICluster(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID, short itsIndex);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void Draw(Rect *area);

	virtual pascal void DoChoice(TView *origView, short itsChoice);

	virtual pascal void GetLabel(StringPtr theLabel);

	virtual pascal void ReleaseLabel(void);

	virtual pascal ResType ReportCurrent(void);

	virtual pascal void SetLabel(StringPtr theLabel, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct IconTemplate *IconTemplatePtr; 
struct IconTemplate {
	Boolean preferColor;
	short rsrcID;
};

class TIcon : public TControl {
  public:

	Boolean fPreferColor;
	short fRsrcID;
	Handle fDataHandle;

	virtual pascal void IIcon(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID, Boolean preferColor)
	   ;

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void Draw(Rect *area);

	virtual pascal void ReleaseIcon(void);

	virtual pascal void SetIcon(Handle theIcon, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct PatternTemplate *PatternTemplatePtr; 
struct PatternTemplate {
	Boolean preferColor;
	short rsrcID;
};

class TPattern : public TControl {
  public:

	Boolean fPreferColor;
	short fRsrcID;
	Handle fDataHandle;

	virtual pascal void IPattern(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID, Boolean preferColor)
	   ;

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void Draw(Rect *area);

	virtual pascal void ReleasePattern(void);

	virtual pascal void SetPattern(Handle thePattern, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct PictureTemplate *PictureTemplatePtr; 
struct PictureTemplate {
	short rsrcID;
};

class TPicture : public TControl {
  public:

	short fRsrcID;
	PicHandle fDataHandle;

	virtual pascal void IPicture(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void Draw(Rect *area);

	virtual pascal void ReleasePicture(void);

	virtual pascal void SetPicture(PicHandle thePicture, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct PopupTemplate *PopupTemplatePtr; 
struct PopupTemplate {
	short rsrcID;
	short currentItem;
	short itemOffset;
};

class TPopup : public TControl {
  public:

	short fRsrcID;
	short fMenuID;
	MenuHandle fMenuHandle;
	short fCurrentItem;
	short fItemOffset;

	virtual pascal void IPopup(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID, short itsCurrentItem
	   , short itsItemOffset);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void AdjustBotRight(void);

	virtual pascal void CalcLabelRect(Rect *theRect);

	virtual pascal void CalcMenuRect(Rect *theRect);

	virtual pascal TCommand *DoMouseCommand(Point *theMouse, EventInfo *info, Point *hysteresis);

	virtual pascal void Draw(Rect *area);

	virtual pascal void DrawLabel(Rect *area);

	virtual pascal void DrawPopupBox(Rect *area);

	virtual pascal short GetCurrentItem(void);

	virtual pascal void GetItemText(short item, StringPtr theText);

	virtual pascal void ReleasePopup(void);

	virtual pascal void SetCurrentItem(short item, Boolean redraw);

	virtual pascal void SetPopup(MenuHandle theMenu, short theRsrcID, short currentItem, Boolean 
	   redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct StaticTextTemplate *StaticTextTemplatePtr; 
struct StaticTextTemplate {
	short just;
	Str255 data;										/* Actually, variable length */
};

class TStaticText : public TControl {
  public:

	short fRsrcID;
	short fIndex;
	short fJust;
	StringHandle fDataHandle;

	virtual pascal void IStaticText(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, 
	   SizeDeterminer itsHSizeDet, SizeDeterminer itsVSizeDet, short itsRsrcID, short itsIndex);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal void DoSubstitution(StringPtr theText);

	virtual pascal void Draw(Rect *area);

	virtual pascal void GetText(StringPtr theText);

	virtual pascal void ImageText(Ptr text, long length, Rect *box, short just);

	virtual pascal void ReleaseText(void);

	virtual pascal void SetJustification(short theJust, Boolean redraw);

	virtual pascal void SetText(StringPtr theText, Boolean redraw);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct EditTextTemplate *EditTextTemplatePtr; 
struct EditTextTemplate {
	short maxChars;
	ControlCharSet controlChars;
};

class TEditText : public TStaticText {
  public:

	ControlCharSet fControlChars;
	short fMaxChars;
	struct TDialogTEView *fTEView;

	virtual pascal void IEditText(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, short 
	   itsMaxChars);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void Free(void);

	virtual pascal Boolean DoIdle(IdlePhase phase);

	virtual pascal TCommand *DoKeyCommand(short ch, short aKeyCode, EventInfo *info);

	virtual pascal TCommand *DoMenuCommand(short aCmdNumber);

	virtual pascal TCommand *DoMouseCommand(Point *theMouse, EventInfo *info, Point *hysteresis);

	virtual pascal void DoSetupMenus(void);

	virtual pascal void DoSubstitution(StringPtr theText);

	virtual pascal void Draw(Rect *area);

	virtual pascal void GetText(StringPtr theText);

	virtual pascal void ImageText(Ptr text, long length, Rect *box, short just);

	virtual pascal void InstallSelection(Boolean wasActive, Boolean beActive);

	virtual pascal void Locate(VCoordinate h, VCoordinate v, Boolean invalidate);

	virtual pascal void Resize(VCoordinate width, VCoordinate height, Boolean invalidate);

	virtual pascal void RestartEdit(StringPtr restartText);

	virtual pascal void SetJustification(short theJust, Boolean redraw);

	virtual pascal void SetSelection(short selStart, short selEnd, Boolean redraw);

	virtual pascal void SetText(StringPtr theText, Boolean redraw);

	virtual pascal void StartEdit(Boolean selectChars, struct TDialogTEView *theTEView);

	virtual pascal void StopEdit(void);

	virtual pascal long Validate(void);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

typedef struct NumberTextTemplate *NumberTextTemplatePtr; 
struct NumberTextTemplate {
	long value;
	long minimum;
	long maximum;
};

class TNumberText : public TEditText {
  public:

	long fMinimum;
	long fMaximum;

	virtual pascal void INumberText(TView *itsSuperView, VPoint *itsLocation, VPoint *itsSize, long 
	   itsValue, long itsMinimum, long itsMaximum);

	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void WRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal void WriteRes(ViewRsrcHndl theResource, Ptr *itsParams);

	virtual pascal long GetValue(void);

	virtual pascal void SetValue(long newValue, Boolean redraw);

	virtual pascal long Validate(void);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

class TDialogTEView : public TTEView {
  public:

	TEditText *fEditText;

	virtual pascal void DrawContents(void);

	virtual pascal void InstallEditText(TEditText *theEditText, Boolean selectChars);

	virtual pascal void InstallSelection(Boolean wasActive, Boolean beActive);

	virtual pascal void RecalcText(void);

	virtual pascal void ScrollSelectionIntoView(void);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);
};

extern pascal void InitUDialog(void);
#endif

