/*[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]*/
/* UObject.p */
/* Copyright  1984-1989  Apple Computer, Inc.  All rights reserved. */
#ifndef  __UObject__
#define __UObject__  0
#endif
#if  ! __UObject__
#define __UObject__  1

		/*  Auto-Include the requirements for this unit's interface. */
#ifndef  __UMacAppUtilities__
#include "UMacAppUtilities.h"
#endif

const short kFailNone			= 1;
const short kFailAbstract		= 2;
const short kFailCoercion		= 3;
const short kFailMethNotFound	= 4;

const unsigned char kInvalidObj[]		  = "\p*Not an object*";
   /* return value from LookupObjName if not an
                                                         object*/
const short kNilClass			= 0;
   /* Value for superclass of the root object */

typedef unsigned short ObjClassID;						/* Object Class identifier */
typedef ObjClassID *PObjClassID;
typedef PObjClassID *HObjClassID;

/*--------------------------------------------------------------------------------------
   ------------*/
			/* Definition of the system's root object */

typedef struct TObject **PTObject;
typedef PTObject *HTObject; 
class TObject : public PascalObject {
  public:
	virtual pascal TObject *Clone(void);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

	virtual pascal void ForAllSubClassesDo(pascal void (*DoToSubClass)(ObjClassID theClass, void *
	   DoToSubClass_StaticLink), void *DoToSubClass_StaticLink);

	virtual pascal void ForAllSuperClassesDo(pascal void (*DoToSubClass)(ObjClassID theClass, void *
	   DoToSubClass_StaticLink), void *DoToSubClass_StaticLink);

	virtual pascal void Free(void);

	virtual pascal ObjClassID GetClass(void);

	virtual pascal void GetClassName(StringPtr clName);

	virtual pascal short GetClassSize(void);

	virtual pascal short GetInstanceSize(void);

	virtual pascal ObjClassID GetSuperClass(void);

	virtual pascal void GetInspectorName(StringPtr inspectorName);

	virtual pascal void Initialize(void);

	virtual pascal void Inspect(void);

	virtual pascal void IObject(void);

	virtual pascal Boolean IsMemberClass(ObjClassID testClass);

	virtual pascal Boolean IsSameClass(ObjClassID testClass);

	virtual pascal Boolean Lock(Boolean lockIt);

	virtual pascal void SetInstanceSize(short newSize);

	virtual pascal TObject *ShallowClone(void);

	virtual pascal void ShallowFree(void);

};

/*--------------------------------------------------------------------------------------
   ------------*/
			/* Utility routines to support objects */


extern pascal Boolean AddNewObjectsToInspector(Boolean add);


extern pascal Boolean DisciplineMethodCalls(Boolean discipline);

extern pascal void EachClassDo(pascal void (*DoToClass)(ObjClassID theClass, void *
   DoToClass_StaticLink), void *DoToClass_StaticLink);

extern pascal void EachSubClassDo(ObjClassID testClass, pascal void (*DoToClass)(ObjClassID theClass
   , void *DoToClass_StaticLink), void *DoToClass_StaticLink);

extern pascal void EachSuperClassDo(ObjClassID testClass, pascal void (*DoToClass)(ObjClassID 
   theClass, void *DoToClass_StaticLink), void *DoToClass_StaticLink);

extern pascal void FailNonObject(void *obj);

extern pascal void FreeIfObject(TObject *obj);

extern pascal void FreeObject(TObject *obj);

extern pascal short GetClassSizeFromID(ObjClassID classID);

extern pascal void GetClassNameFromID(ObjClassID classID, StringPtr clName);

extern pascal ObjClassID GetClassIDFromName(StringPtr clName);

extern pascal ObjClassID GetClassID(TObject *obj);

extern pascal ObjClassID GetSuperClassID(ObjClassID objID);


extern pascal void IDUobject(void);

extern pascal void InitUObject(void);


extern pascal void InspectObject(TObject *obj);

extern pascal Boolean IsObject(void *obj);

extern pascal Boolean IsClassIDMemberClass(ObjClassID testClass, ObjClassID superClass);

extern pascal Boolean IsMemberClassID(TObject *obj, ObjClassID objID);

extern pascal void OBJFail(short error);

extern pascal TObject *NewObjectByClassId(ObjClassID classID);

extern pascal TObject *NewObjectByClassName(StringPtr className);

extern pascal Boolean VerboseIsObject(void *obj);

extern pascal void WrLblField(StringPtr fieldName, Ptr fieldAddr, short fieldType);

#endif

