/*[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]*/
/* UTranscriptView.p */
/* Copyright  1985-1989 Apple Computer, Inc. All rights reserved. */
#ifndef  __UTranscriptView__
#define __UTranscriptView__  0
#endif
#if  ! __UTranscriptView__
#define __UTranscriptView__  1

		/*  Auto-Include the requirements for this unit's interface. */
#ifndef  __UMacApp__
#include "UMacApp.h"
#endif

const short kHMargin			= 4;
const short kVMargin			= 4;
const short kWWEol				='\n';
const short kForceDepth			= 10;

typedef enum {WrForceOn, WrForceOff, WrForceUnchanged} WrForceOptions;		 /* corresponds to
                TrcForceOptions */

typedef unsigned char AText[10001];
typedef AText *PText;
typedef PText *HText;

typedef short ALineLens[10001];
typedef ALineLens *PLineLens;
typedef PLineLens *HLineLens;

struct ForceState {
	Boolean toWindow;
	Boolean toFile;
};
	/* C A U T I O N -- this object is not really for public consumption.  Use it at your ow
	   n risk! */
class TTranscriptView : public TView {
  public:
	Boolean fWrToWindow;
	   /* set to TRUE to enable writelns to window */
	Boolean fWrToFile;									/* set to TRUE to enable writelns to file */
	short fCols;										/* Max characters per line */
	short fRows;										/* number of lines saved */
	short fTotal;
	   /* number of characters in all lines together
                                                         */
	HText fText;										/* the ring buffer: blanks pad each line to
                                                         80 chars */
	HLineLens fLineLengths;								/* linelength of each line.
                                                         fBufferLinesLens^^[0] is # of characters
                                                         in the line that begins with fText^^[0] */
	HLineLens fLineStarts;								/* offset into the fText handle of the first
                                                         character in the line*/
	short fFirstLineIndex;								/* index where in the linelengths/starts
                                                         array the top line starts */

	TextStyle fTextStyle;
	FontInfo fFontInfo;
	short fFontHeight;									/* font height */

	Boolean fGotRefnum;
	short fRefnum;										/* refnum for redirect output */
	short fVRefNum;										/* likewise, vrefnum */

	ForceState fForceStack[10];
	short fForcePtr;

	Ptr fHelpProc;										/* Call this to show help */
	long fLastInsertionPointTime;						/* Last time InsertionPoint was on */
	Boolean fInsertionPointOn;							/* True if InsertionPoint was turned on by
                                                         idle */
	Point fInsertionPt;
	   /* location of the insertion pt in Row, col */
	short fLastCh;										/* last character typed */
	RgnHandle fUpdateRgn;								/* used in scrolling shortcut */

	virtual pascal Boolean DoIdle(IdlePhase phase);

	virtual pascal TCommand *DoHelp(EventInfo *info, long *message);

	virtual pascal TCommand *DoKeyCommand(short ch, short aKeyCode, EventInfo *info);

	virtual pascal void Draw(Rect *area);

	virtual pascal void Fields(pascal void (*DoToField)(StringPtr fieldName, Ptr fieldAddr, short 
	   fieldType, void *DoToField_StaticLink), void *DoToField_StaticLink);

	virtual pascal void Free(void);

	virtual pascal Boolean HandleMouseDown(VPoint *theMouse, EventInfo *info, Point *hysteresis, 
	   TCommand **theCommand);

				/* TranscriptWindow Specific methods */
	virtual pascal void IRes(TDocument *itsDocument, TView *itsSuperView, Ptr *itsParams);

	virtual pascal void AddText(Ptr textBuf, short byteCount);

	virtual pascal void AddTextToFile(Ptr textBuf, short byteCount);

	virtual pascal void RevealInsertionPoint(void);

	virtual pascal void EndForce(void);

	virtual pascal void ForceOutput(WrForceOptions wrToWindow, WrForceOptions wrToFile);

	virtual pascal Rect GetInsertionPointRect(void);

	virtual pascal void CommonInit(TView *itsSuperView, short outputFont, short outputSize, short 
	   numLines, short numCharsPerLine);

	virtual pascal void ITranscriptView(TView *itsSuperView, short outputFont, short outputSize, 
	   short numLines, short numCharsPerLine);

	virtual pascal short PrevIndex(short ln);

	virtual pascal short SuccIndex(short ln);

	virtual pascal short IndexToRow(short index);
	virtual pascal short RowToIndex(short row);
	virtual pascal short IndexToLocal(short index);
	virtual pascal void InstallTextStyle(TextStyle *theStyle);

	virtual pascal short LocalToIndex(short local);

	virtual pascal Point IndexColToLocal(short index, short col);

	virtual pascal short LocalToCol(short local);

	virtual pascal OSErr Redirect(short vRefnum, StringPtr fileName);

	virtual pascal void Scroll(short howManyLines);

	virtual pascal void RevealInsertionPointLine(void);
};

extern pascal void IDUTranscriptView(void);

#endif

