{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}

{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UDrawShapes.p}
{ Copyright  1986-1990 by Apple Computer, Inc. All rights reserved.}

{ **** Still to do on this sample: ****}
{}
{Scroll selection into view when doing, undoing, or redoing commands}
{(as in OneBox)}
{}
{[f-]}
{}
{This is a sample application illustrating numerous features of MacApp and the}
{Printing building block.}
{}
{The application's windows show a palette at left, and a drawing area to the}
{right; this is similar to MacDraw and MacPaint.}
{}
{In the windows, the user can draw quadrilaterals and ovals (choosing which}
{from the palette) and can move already-drawn shapes around.}
{}
{Command-D is used to toggle the availability of a special 'More Debug' menu}
{in the menu bar, both to illustrate how to have commands on command-keys that}
{aren't themselves in the menu and how to insert and delete menus dynamically.}
{Three special debugging commands are only available when this special menu}
{is inserted.}
{}
{Full Clipboard support is also illustrated, including most features that any}
{application would be likely to need.  Shapes can be cut or pasted between}
{documents, and picture-versions of shapes on the Clipboard can be pasted into}
{other applications such as MacPaint.}
{}
{Printing and Filing are also supported.  Window state is preserved in saved}
{files.	Filing uses both data and resource forks, to illustrate both}
{techniques.}
{}
{All commands are undoable.	Commands illustrated include commands to Draw,}
{commands to move objects around within the view, and commands to change}
{properties of objects.}
{}
{Hold the OPTION key down while drawing to constrain the drawing to be a}
{square/circle rather than a general rectangle/oval while sketching.  This}
{constrains the object being drawn to be a square/circle whose side/diameter}
{is a horizontal or vertical offset of the mouse from the anchor point,}
{whichever is SMALLER.  This may feel a bit strange in practice, but it does}
{illustrate a feature.}
{}
{[f+]}

unit UDrawShapes;

interface

	uses
		SysEqu, Traps, ULoMem, UMacAppUtilities, UPatch, UObject, UViewCoords, UMemory, UFailure, UMenuSetup, UList, PrintTraps,
{  MacApp }
		UMacApp,
{  Building Blocks }
		UPrinting, UBetterFeedbackCmd, UMenu, UTearOffMenu,
{  Implementation Use }
		Picker;

	const
		kWindowInBounds = TRUE;
		kWindowOutOfBounds = not kWindowInBounds;


			{ graphic menu }

			{ Patterns custom pulldown menu, menu drawing placement parameters }
		kPatternsAcross = 4;					{ how many Patterns across }
		kPatternsDown = 10;					{ how many Patterns down }
		kTotalPatterns = kPatternsAcross * kPatternsDown;

		kWPatternsCell = 18;					{ Width of Cell }
		kHPatternsCell = 14;					{ Height of Cell }

		kFrameWidth = 1;
		kHorizontalFrames = kPatternsDown - 1;
		kVerticalFrames = kPatternsAcross - 1;
		kTotalFrames = kHorizontalFrames * kVerticalFrames;

		kWPatternsChoice = kWPatternsCell * kPatternsAcross + kVerticalFrames;
		kHPatternsChoice = kHPatternsCell * kPatternsDown + kHorizontalFrames;

			{ command numbers }

		cArrow = 1100;
		cBox = 1101;
		cCircle = 1102;
		cHBox = 1103;

		cPatterns = 1300;					{ used to enable the Patterns tear-off menu }
		cPatternsMax = cPatterns + kTotalPatterns; {}

		cPickColor = 1005; 				{Use Color Picker for shape's color}

		cNewShape = 1010; 				{Drawing a new shape}
		cMoveShape = 1011; 				{Moving one or more shapes}

		cCmdDTyped = 1200; 				{Command representing the fact that the user}
{														 typed "Command-D"; in this app this is}
{														 used as a signal to put up the "More}
{														 Debug" menu, or if it is already up, to}
{														 take it down -- thus demonstrating both}
{														 how to handle commands not in the menu bar}
{														 and how to put entire menus up and take}
{														 them down dynamically}

		{ The following three commands are only available in the 'More Debug' menu,}
{		 which is only accessible if you type Cmd-D to insert that menu into}
{		 the menu bar}

		cPasteReplacesSelection = 118;				{Debugging: whether pasting into a shapeView}
{														 should supplant any existing selection or}
{														 not; if not, the pastee instead is}
{														 centered in the window}
		cRecalcExtent = 119;					{Debugging: performs immediate recomputation}
{														 of view extent; if gConstrainDrags is}
{														 FALSE, it is possible for a shape to be}
{														 beyond the view border; the view's extent}
{														 can be refigured on demand by using this}
{														 command}
		cConstrainDrags = 120;					{Debugging: whether shape-dragging should be}
{														 constrained so that the entire selection}
{														 fits within the view or not}
		cBetterFeedback = 121;					{Debugging: whether to use the code which}
{														 provides better TrackFeedback}

			{ Resource types and Resource IDs }

		kDocRsrcKind = 'DSTA';				{Resource type for document state}
		kDocStateID = 1;					{Resource id for document state}

		kShapeWindowRSRCID = 1005; 				{Resource id for the windows used by}
{														 documents in the application}
		kShapeViewRSRCID = 1006;					{Resource id for the shape view template,}
{														used when printing & using template views}

		kDocType = 'SF05';				{File-type for document files created by}
{														 this application}
		kSignature = 'SS05';				{Application signature; Creator type for}
{														 documents}

		kShapeClipType = 'SHAP';				{Clipboard type for my shapes}

		mTools = 5;					{the Tools menu resource id}
		mPatterns = 6;					{the Patterns menu resource id}
		mColor = 7;					{The Color menu resource id}
		mMoreDebug = 8;					{Menu number for the 'More Debug' menu}

			{ Miscellaneous }

		IDBox = 1;					{ID of TBox items}
		IDCircle = 2;					{ID of TCircle items}
		IDhBox = 3;					{IDF of THeavyBox}

		kShapesInPalette = 3;					{Number of shapes in the palette, in}
{														 addition to the arrow}

	type

	{ Document state: stored in the Resource Fork of the document file; holds the}
{	  following general properties of the document, necessary for rereading}
{	  a saved document and restoring the appearance of the window (location,}
{	  size, and scrolling) to its state when last saved}
		DocState = record
				theNumberOfShapes: INTEGER;
				theWindowRect: Rect;
				theScrollPosition: VPoint;
			end;
		HDocState = ^PDocState;			{Handle to DocState information}
		PDocState = ^DocState;			{Pointer to DocState information}

	{ Information about a single shape; same format used both in the data file}
{	  and in the desk scrap}
		ShapeData = record
				theId: INTEGER;			{1 => rectangle; 2 => oval; etc.}
				theRect: Rect;				{the shape's extent}
				thePattern: INTEGER;			{the shape's current Pattern}
				theColor: RGBColor;			{the shape's current color}
				theSelected: BOOLEAN;			{for saving window state; not relevant for}
{														 clipboard}
			end;

			{ Data types used for storing shapes in the Desk Scrap }
		ShapesOnClipboard = ^PShapesOnClipboard;
		PShapesOnClipboard = ^ShapeClipRecord;
		ShapeClipRecord = record
				theNumberOfShapes: INTEGER;
				theBoundingBox: Rect;
				theShapes: array[0..1536] of ShapeData;
			end;

		TShapeApplication = object(TApplication)

			{ Initialization }
				procedure TShapeApplication.IShapeApplication;

				{ Document creation }
				function TShapeApplication.DoMakeDocument (itsCmdNumber: CmdNumber): TDocument;
				OVERRIDE;

				{ Commands }
				{$IFC qDebug}
				function TShapeApplication.DoCommandKey (ch: CHAR; var info: EventInfo): TCommand;
				OVERRIDE;
				function TShapeApplication.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;
				OVERRIDE;
				procedure TShapeApplication.DoSetupMenus;
				OVERRIDE;
				{$ENDC}

				function TShapeApplication.MakeViewForAlienClipboard: TView;
				OVERRIDE;
				{ Handle data found left in the Clipboard by forces outside the application }

				{ Debugging }
				{$IFC qDebug}
				procedure TShapeApplication.IdentifySoftware;
				OVERRIDE;
				{$ENDC}

			end;


		TShapeDocument = object(TDocument)

				fShapeView: TShapeView;
				fToolsPalette: TToolsPalette;
				fShapeList: TList;

				fDocState: DocState;
				fReopening: BOOLEAN;

				fReplaceCommand: TShapeReplaceCommand; {Tells us what the current replace command}
{														   is (Cut, Paste). NIL means there is no}
{														   current replace command.}
				fFiltering: BOOLEAN;			{Tells us whether shapes that are}
{														 'wasSelected' are not to be drawn if}
{														 gLastCmdDone is TRUE}

								{ Initialize and Free }

				procedure TShapeDocument.IShapeDocument (fileType: OSType);
				procedure TShapeDocument.Free;
				OVERRIDE;
				procedure TShapeDocument.FreeData;
				OVERRIDE;

				{ Adding/deleting shapes }

				procedure TShapeDocument.AddShape (shape: TShape);
				procedure TShapeDocument.DeleteShape (shape: TShape);

				{ Enumeration of shapes }

				procedure TShapeDocument.EachShapeDo (procedure DoThis (shape: TShape));
				{ Iterate through the list of shapes }

				procedure TShapeDocument.EachPotentialShapeDo (procedure DoThis (shape: TShape));
				{ Iterate through all the shapes in the document plus any}
{				  'pastee' shapes which may have been added by a not-yet-committed PASTE.}

				procedure TShapeDocument.EachVirtualShapeDo (procedure DoThis (shape: TShape));
				{ Iterate through only those shapes that appear to be present at the moment}
{				  to the USER, given the UNDO/REDO status of the last command.}
{				  Thus it iterates through some but possibly not all of the the shapes in the}
{				  document, and possibly also through not-yet-in-the-document pastees.}

				function TShapeDocument.FirstSelectedShapeThat (function TestSelectedShape (aShape: TShape): BOOLEAN): TShape;

				procedure TShapeDocument.SurveyShapes (selecteesOnly: BOOLEAN; var numberOfShapes: INTEGER; var combinedExtent: Rect);

				{ Overrides of basic TDocument methods }

				procedure TShapeDocument.DoMakeViews (forPrinting: BOOLEAN);
				OVERRIDE;
				procedure TShapeDocument.DoSetupMenus;
				OVERRIDE;
				procedure TShapeDocument.DoNeedDiskSpace (var dataForkBytes, rsrcForkBytes: LONGINT);
				OVERRIDE;

				procedure TShapeDocument.DoRead (aRefNum: INTEGER; rsrcExists, forPrinting: BOOLEAN);
				OVERRIDE;
				procedure TShapeDocument.DoWrite (aRefNum: INTEGER; makingCopy: BOOLEAN);
				OVERRIDE;

				{ Inspecting }
				procedure TShapeDocument.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

			{ the tools tear-off menu }
		TToolsMenu = object(TTearOffMenu)

				procedure TToolsMenu.IToolsMenu;

			end;

			{ the tools palette: used in -}
{				the main document window}
{				the tools tear-off menu}
{				the tools floating window}
		TToolsPalette = object(TView)

				fCurrTool: INTEGER;			{currently selected Tool, or 0 for the arrow}

				fCurrSelection: INTEGER;			{ tool selected by DoHighlightSelection }

				fOldTool: INTEGER;			{ previously selected Tool }

				fSelectedTool: INTEGER;			{ Tool selected during tracking }

				{ bounds of each square in palette }
				fChoiceArray: array[0..kShapesInPalette] of Rect;


				procedure TToolsPalette.IToolsPalette (itsDocument: TDocument; itsSuperview: TView);

				{$IFC qTemplateViews}
				procedure TToolsPalette.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
				OVERRIDE;
				{$ENDC}

				procedure TToolsPalette.Activate (entering: BOOLEAN);
				OVERRIDE;

				procedure TToolsPalette.BuildChoiceArray;

				procedure TToolsPalette.DoHighlightSelection (fromHL, toHL: HLState);
				OVERRIDE;

				function TToolsPalette.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;
				OVERRIDE;

				procedure TToolsPalette.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;

				function TToolsPalette.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
				OVERRIDE;

				procedure TToolsPalette.Draw (area: Rect);
				OVERRIDE;

				procedure TToolsPalette.SelectNewTool (whichTool: INTEGER);

				{ Inspecting }

				procedure TToolsPalette.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TToolSelectCmd = object(TCommand)
			{ this tracker tracks in:}
{				- the tools floating window}
{				- the tools palette in the document window}
{				- the tools tearoff menu}

				fTool: INTEGER;
				fExitTracking: BOOLEAN;
				fMenuToolsPalette: TToolsPalette;
				fFloatingToolsPalette: TToolsPalette;
				fDocumentToolsPalette: TToolsPalette;

								{ Command execution }

				procedure TToolSelectCmd.IToolSelectCmd (theToolsPalette, theDocumentToolsPalette, theMenuToolsPalette, theFloatingToolsPalette: TToolsPalette; theMouse: Point);
				{ must keep a reference to both the current TToolsPalette view that we're tracking in}
{				and the TToolsPalette view that is in the floating window}

				function TToolSelectCmd.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
				OVERRIDE;

				procedure TToolSelectCmd.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;

				function TToolSelectCmd.IsDoneTracking: BOOLEAN;
				OVERRIDE;

				procedure TToolSelectCmd.DoIt;
				OVERRIDE;

				procedure TToolSelectCmd.RedoIt;
				OVERRIDE;

				procedure TToolSelectCmd.UndoIt;
				OVERRIDE;

			end;

		TShapeView = object(TView)

				fDragging: BOOLEAN;			{tells us whether the mouse is dragging}
				fToolsPalette: TToolsPalette;		{corresponding palette}

				fClickPt: Point;				{on PASTE, this is where the top-left point}
{														 of the clipboard boxes go}
				fShapeDocument: TShapeDocument; 	{The associated document which owns the}
{														 shapes}
				fScroller: TScroller;			{corresponding scroller}

								{ Initialization }
				procedure TShapeView.IShapeView (itsDocument: TShapeDocument; itsPalette: TToolsPalette; forClipboard: BOOLEAN);
				{ Initialize the view, associating it with the stated document}
{				  and palette objects. Make it a view to be seen in the}
{				  Clipboard only if 'forClipboard' is TRUE}

				{$IFC qTemplateViews}
				procedure TShapeView.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
				OVERRIDE;
				{$ENDC}

				{ Size determination }
				procedure TShapeView.CalcMinSize (var minSize: VPoint);
				OVERRIDE;

				{ Menu commands }
				function TShapeView.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;
				OVERRIDE;
				{ Handle the reshading and recoloring commands }

				procedure TShapeView.DoSetupMenus;
				OVERRIDE;
				{ Arm the menu items handled by DoMenuCommand }

				{ Mouse commands }
				function TShapeView.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;
				OVERRIDE;

				{ Screen display }
				procedure TShapeView.DoHighlightSelection (fromHL, toHL: HLState);
				OVERRIDE;
				function TShapeView.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
				OVERRIDE;
				procedure TShapeView.Draw (area: Rect);
				OVERRIDE;
				procedure TShapeView.InvalShape (aShape: TShape);

				{ State transition }

				procedure TShapeView.Deselect;
				procedure TShapeView.RestoreSelection;
				procedure TShapeView.SaveSelection (andInval: BOOLEAN);

				{ Methods only relevant for a shapeView installed in the Clipboard }

				function TShapeView.ContainsClipType (aType: ResType): BOOLEAN;
				OVERRIDE;
				procedure TShapeView.WriteToDeskScrap;
				OVERRIDE;

				{ Inspecting }

				procedure TShapeView.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TShape = object(TObject)
				fID: INTEGER;
				fExtentRect: Rect;				{size of object}
				fPattern: INTEGER;			{Pattern of object}
				fOldPattern: INTEGER;			{with the reshade command the Undo/Redo need}
{														 to know the old shade}

				fColor: RGBColor;			{color of object}
				fOldColor: RGBColor;			{with the recolor command the Undo/Redo need}
{														 to know the old color}

				fIsSelected: BOOLEAN;			{is this shape selected?}
				fWasSelected: BOOLEAN;			{old selection status, set when the last}
{														 command was performed}

								{ Initialization }

				procedure TShape.Initialize;
				OVERRIDE;
				{ Put the object into a known state from which it may be safely FREEd.}
{				 (and hopefully a usable state)}

				procedure TShape.IShape (itsExtent: Rect; itsID: INTEGER);
				{ Initialize a shape procedurally }

				{ Screen display }

				procedure TShape.Draw;
				procedure TShape.DrawOutline;

				procedure TShape.EachHandleDo (procedure DoThis (handle: Rect; handVHS: VHSelect; handTopOrLeft: BOOLEAN));

				procedure TShape.Highlight (fromHL, toHL: HLState);

				{ Filing }

				function TShape.ID: INTEGER;
				{ Used so that a filed shape can identify what kind of shape object}
{				is to be launched to represent it in memory}

				procedure TShape.ReadFrom (aRefNum: INTEGER);
				{ Read the shape from input file }

				procedure TShape.WriteTo (aRefNum: INTEGER);
				{ Write data characterizing the shape onto the Save-file }

				{ Inspecting }

				procedure TShape.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TBox = object(TShape)

			{ Initialization }

				procedure TBox.IBox (itsExtent: Rect; itsID: INTEGER);

				{ Other methods }

				procedure TBox.Draw;
				OVERRIDE;
				procedure TBox.DrawOutline;
				OVERRIDE;
			end;

		THeavyBox = object(TBox) 		{ like a box except uses up 4K bytes }
				fFiller: array[0..2048] of INTEGER;

				procedure THeavyBox.IHeavyBox (itsExtent: Rect; itsID: INTEGER);

				procedure THeavyBox.Draw;
				OVERRIDE;
			end;

		TCircle = object(TShape)

				procedure TCircle.ICircle (itsExtent: Rect; itsID: INTEGER);

				procedure TCircle.Draw;
				OVERRIDE;
				procedure TCircle.DrawOutline;
				OVERRIDE;
			end;

		TShapeCommand = object(TBetterFeedbackCmd)
			{ This is a common ancestor for all commands operating on one or more shapes}

				fShapeView: TShapeView;
				fShapeDocument: TShapeDocument;

				procedure TShapeCommand.IShapeCommand (itsCmdNumber: CmdNumber; itsShapeView: TShapeView; betterFeedbackDesired: BOOLEAN);

				{ Inspecting }

				procedure TShapeCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TShapeSelector = object(TShapeCommand)
			{ This command demonstrates the use of a command object that}
{			  is not saved and that does not commit the last command.}
{			  The same effect could have been achieved by selecting the}
{			  shapes in the TrackMouse method.}

				fBounds: Rect;
				fShiftKey: BOOLEAN;

				procedure TShapeSelector.IShapeSelector (itsCmdNumber: CmdNumber; itsShapeView: TShapeView);

				procedure TShapeSelector.DoIt;
				OVERRIDE;

				procedure TShapeSelector.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;

				function TShapeSelector.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
				OVERRIDE;

				{ Inspecting }

				procedure TShapeSelector.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TShapeDragger = object(TShapeCommand)

				fBounds: Rect;				{Union of fExtentRect of all shapes being}
{														 dragged, before the move}
				fDeltaH: INTEGER;
				fDeltaV: INTEGER;

								{ Initialization }

				procedure TShapeDragger.IShapeDragger (aShapeView: TShapeView);

				{ Command performing }

				procedure TShapeDragger.DoIt;
				OVERRIDE;
				procedure TShapeDragger.UndoIt;
				OVERRIDE;
				procedure TShapeDragger.RedoIt;
				OVERRIDE;

				{ Utility routine }

				procedure TShapeDragger.MoveBy (deltaH, deltaV: INTEGER);

				{ Mouse Tracking }

				procedure TShapeDragger.TrackConstrain (anchorPoint, previousPoint: VPoint; var nextPoint: VPoint);
				OVERRIDE;
				{ Only if gConstrainDrags is TRUE is a shapeDragger marked as}
{				  constraining the mouse, so be sure to make gConstrainsDrags TRUE}
{				  before mousing down on something you want to drag under constraint.}
{				  You manipulate the gConstrainsDrags flag through a toggle in the}
{				  'More Debug' menu, which you get displayed by hitting Command-D}

				procedure TShapeDragger.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;
				function TShapeDragger.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
				OVERRIDE;

				{ Inspecting }

				procedure TShapeDragger.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TReshadeCmd = object(TCommand)
			{ Note that the set of shapes affected by the reshade request is}
{			  defined by the fWasSelected fields of the shapes themselves}

				fShapeView: TShapeView;
				fShapeDocument: TShapeDocument;
				fPattern: INTEGER;
				fExitTracking: BOOLEAN;
				fMenuPatternsPalette: TPatternsPalette;
				fFloatingPatternsPalette: TPatternsPalette;

								{ Command execution }

				procedure TReshadeCmd.IReshadeCmd (itsCmdNumber: INTEGER; itsShapeView: TShapeView; thePatternsPalette, menuPatternsPalette, floatingPatternsPalette: TPatternsPalette; theMouse: Point);

				function TReshadeCmd.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
				OVERRIDE;

				procedure TReshadeCmd.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;

				function TReshadeCmd.IsDoneTracking: BOOLEAN;
				OVERRIDE;

				procedure TReshadeCmd.DoIt;
				OVERRIDE;

				procedure TReshadeCmd.RedoIt;
				OVERRIDE;

				procedure TReshadeCmd.UndoIt;
				OVERRIDE;

			end;

		TRecolorCmd = object(TShapeCommand)
			{ Note that the set of shapes affected by the reshade request is}
{			  defined by the fWasSelected fields of the shapes themselves}

				fColor: RGBColor;

				procedure TRecolorCmd.IRecolorCmd (itsColor: RGBColor; itsShapeView: TShapeView);
				procedure TRecolorCmd.DoIt;
				OVERRIDE;
				procedure TRecolorCmd.RedoIt;
				OVERRIDE;
				procedure TRecolorCmd.UndoIt;
				OVERRIDE;

			end;

		TShapeReplaceCommand = object(TShapeCommand)
			{ This is a common ancestor for all commands that can add or delete shapes }

				procedure TShapeReplaceCommand.Commit;
				OVERRIDE;
				procedure TShapeReplaceCommand.EachNewShapeDo (procedure DoThis (shape: TShape));
				function TShapeReplaceCommand.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;
				procedure TShapeReplaceCommand.RedoIt;
				OVERRIDE;
				procedure TShapeReplaceCommand.UndoIt;
				OVERRIDE;
			end;

		TShapeSketcher = object(TShapeReplaceCommand)

				fShape: TShape; 			{the shape sketched by the user}

				procedure TShapeSketcher.IShapeSketcher (aShapeView: TShapeView; protoShape: TShape; constrain: BOOLEAN);
				procedure TShapeSketcher.Free;
				OVERRIDE;

				procedure TShapeSketcher.EachNewShapeDo (procedure DoThis (shape: TShape));
				OVERRIDE;
				function TShapeSketcher.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;
				OVERRIDE;

				{ Command performing }
				procedure TShapeSketcher.DoIt;
				OVERRIDE;
				procedure TShapeSketcher.RedoIt;
				OVERRIDE;
				procedure TShapeSketcher.UndoIt;
				OVERRIDE;

				procedure TShapeSketcher.Commit;
				OVERRIDE;

				{ Mouse tracking }
				procedure TShapeSketcher.TrackConstrain (anchorPoint, previousPoint: VPoint; var nextPoint: VPoint);
				OVERRIDE;
				procedure TShapeSketcher.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;
				function TShapeSketcher.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
				OVERRIDE;

				{ Inspecting }

				procedure TShapeSketcher.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

		TShapeCutCopyCommand = object(TShapeReplaceCommand)

				procedure TShapeCutCopyCommand.IShapeCutCopyCommand (itsCmdNumber: CmdNumber; itsShapeView: TShapeView);
				procedure TShapeCutCopyCommand.DoIt;
				OVERRIDE;
				procedure TShapeCutCopyCommand.RedoIt;
				OVERRIDE;

			end;

		TShapeClearCommand = object(TShapeReplaceCommand)

				procedure TShapeClearCommand.IShapeClearCommand (itsShapeView: TShapeView);

				procedure TShapeClearCommand.DoIt;
				OVERRIDE;
				procedure TShapeClearCommand.RedoIt;
				OVERRIDE;

			end;

		TShapePasteCommand = object(TShapeReplaceCommand)

				fPasteList: TList;

				procedure TShapePasteCommand.IShapePasteCommand (itsShapeView: TShapeView);

				procedure TShapePasteCommand.Free;
				OVERRIDE;

				procedure TShapePasteCommand.EachNewShapeDo (procedure DoThis (shape: TShape));
				OVERRIDE;
				function TShapePasteCommand.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;
				OVERRIDE;

				procedure TShapePasteCommand.Commit;
				OVERRIDE;
				procedure TShapePasteCommand.DoIt;
				OVERRIDE;
				procedure TShapePasteCommand.UndoIt;
				OVERRIDE;
				procedure TShapePasteCommand.RedoIt;
				OVERRIDE;

			end;

			{ the patterns tear-off menu }
		TPatternsMenu = object(TTearOffMenu)

				procedure TPatternsMenu.IPatternsMenu;

			end;

			{ the patterns palette: used in -}
{				the tools tear-off menu}
{				the tools floating window}
		TPatternsPalette = object(TView)

				fCurrPattern: INTEGER;			{ currently selected Pattern }

				fOldPattern: INTEGER;			{ previously selected Pattern }

				fSelectedPattern: INTEGER;			{ pattern selected during tracking }

				fChoiceArray: array[1..kTotalPatterns] of Rect;
				{ the rectangle in the view containing a Pattern }

				fFramesArray: array[1..kTotalFrames] of Rect;
				{ the frames in the patterns palette }

				procedure TPatternsPalette.IPatternsPalette (itsSuperview: TView);

				{$IFC qTemplateViews}
				procedure TPatternsPalette.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
				OVERRIDE;
				{$ENDC}

				procedure TPatternsPalette.BuildChoiceArray;

				procedure TPatternsPalette.BuildFramesArray;

				procedure TPatternsPalette.DoHighlightSelection (fromHL, toHL: HLState);
				OVERRIDE;

				procedure TPatternsPalette.FrameCurrPattern;

				procedure TPatternsPalette.SelectNewPattern (whichPattern: INTEGER);

				function TPatternsPalette.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;
				OVERRIDE;

				procedure TPatternsPalette.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
				OVERRIDE;

				function TPatternsPalette.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
				OVERRIDE;

				procedure TPatternsPalette.Draw (area: Rect);
				OVERRIDE;

				{ Inspecting }

				procedure TPatternsPalette.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
				OVERRIDE;

			end;

implementation


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UDrawShapes.inc1.p}
{ Copyright  1985 - 1990 by Apple Computer, Inc.  All rights reserved.}

	const
		kRainbowArrow = 140;

		kToolsPaletteRSRCID = 1007;							{Resource id for the floating window}
{														with tools palette}
		kPatternsPaletteRSRCID = 1008;						{Resource id for the floating window}
{														with Patterns palette}
		kToolsPaletteWidth = 41;						{Width of the palette}
		kToolsPaletteHeight = 160;						{Height of the palette}

		kMinWidth = 20;							{minimum width of new shapes}
		kMinHeight = 20;							{minimum height of new shapes}
	{ The above two constants define the minimum size a newly-sketched shape}
{	  must become before it is considered a legitimate attempt to draw}

		kStaggerAmount = 16;							{Amount to stagger windows by}

		kColorMenuBar = 131;							{Menu bar for a color system}
		kNonColorMenuBar = 132;							{Menu bar for a black & white system}

		kPickerPrompt = 256;							{'STR ' resource for Color Picker}

		cChangeShade = 1012; 						{Buzz command for "Undo Shade Change"}
		cChangeColor = 1013; 						{Buzz command for "Undo Color Change"}
		cChangeTool = 1014;							{Buzz command for "Undo Tool Change"}

		kNoToolSelection = -1;

	var
		gPat: array[1..kTotalPatterns] of Pattern;

	{ prototype shapes for the palette }

		gShapesArray: array[1..kShapesInPalette] of TShape;

		gArwBitMap: BitMap; 						{bitmap used to draw the arrow in palette}

		gClipMargin: Point;							{the top & left margins to use when}
{														 displaying shapes in the Clipboard}
		gPasteReplacesSelection: BOOLEAN;					{Tells whether PASTE should REPLACE the}
{														 existing selection, or instead simply add}
{														 new shapes without replacement. Default:}
{														 FALSE; change its value by using the "More}
{														 Debug" menu, obtainable by typing}
{														 command-D}

		gConstrainDrags: BOOLEAN;						{Whether dragging shapes with the mouse}
{														 should be constrained so that nothing}
{														 overlaps the view's borders. Default:}
{														 TRUE; change its value by using the "More}
{														 Debug" menu, obtainable by typing}
{														 command-D}

		gStaggerCount: INTEGER;						{For SimpleStagger}

		gRainbowArrow: CCrsrHandle;

		gToolsMenu: TToolsMenu;
		gPatternsMenu: TPatternsMenu;

		gBetterFeedback: BOOLEAN;						{ TRUE to invoke BetterFeedback routines }

		gToolsPaletteWindow: TWindow;
		gPatternsWindow: TWindow;

{--------------------------------------------------------------------------------------------------}
	{$S AInit}

	procedure TShapeApplication.IShapeApplication;			{Initialize the application}

		var
			i: INTEGER;
			r: Rect;
			box: TBox;
			circle: TCircle;
			hBox: THeavyBox;
			toolsMenu: TToolsMenu;
			PatternMenu: TPatternsMenu;
			patListHdl: Handle;
			hState: SignedByte;
			numPatterns: INTEGER;
			startAddress: LONGINT;

	begin

		if qNeedsColorQD | gConfiguration.hasColorQD then
			gMBarDisplayed := kColorMenuBar
		else
			gMBarDisplayed := kNonColorMenuBar;

		IApplication(kDocType); 							{Generic initialization}
		gTrackingInMenu := FALSE;							{ !!! this should go in IApplication }

	{ copy patterns into global array of patterns }
		patListHdl := GetResource('PAT#', 128);
		if patListHdl = nil then
			begin
				gPat[1] := white;
				gPat[2] := ltGray;
				gPat[3] := gray;
				gPat[4] := dkGray;
				gPat[5] := black;
				for i := 6 to kTotalPatterns do
					gPat[i] := black;
			end
		else
			begin
				hState := HGetState(patListHdl);
				LockHandleHigh(patListHdl);
				numPatterns := Min(kTotalPatterns, IntegerHandle(patListHdl)^^);	{ first word in pattern list is array size }
				startAddress := ORD(patListHdl^) + sizeof(INTEGER);		{ the address where the patterns start }
				for i := 1 to numPatterns do
					BlockMove(POINTER(startAddress + (i - 1) * sizeof(Pattern)), @gPat[i], sizeof(Pattern));
				HSetState(patListHdl, hState);
			end;

	{ now create the floating palette window }
		gToolsPaletteWindow := NewTemplateWindow(kToolsPaletteRSRCID, nil);
		FailNil(gToolsPaletteWindow);

	{ now create the floating Patterns window }
		gPatternsWindow := NewTemplateWindow(kPatternsPaletteRSRCID, nil);
		FailNIL(gPatternsWindow);

	{ Install our custom tools menu }
		New(toolsMenu);
		FailNil(toolsMenu);
		toolsMenu.IToolsMenu;
		gToolsMenu := toolsMenu;

	{ Install our custom pattern menu }
		New(patternMenu);
		FailNil(patternMenu);
		patternMenu.IPatternsMenu;
		gPatternsMenu := patternMenu;

	{ Set the standard margins to use in the clipboard }
		SetPt(gClipMargin, 16, 16);

		SetRect(r, 10, 50, 28, 70); 						{Define the prototype shapes}
		New(box);
		FailNil(box);
		box.IBox(r, IDBox);
		gShapesArray[IDBox] := box;

		OffSetRect(r, 0, 40);
		New(circle);
		FailNil(circle);
		circle.ICircle(r, IDCircle);
		gShapesArray[IDCircle] := circle;

		OffSetRect(r, 0, 40);
		New(hBox);
		FailNil(hBox);
		hBox.IHeavyBox(r, IDhBox);
		gShapesArray[IDhBox] := hBox;

		with gArwBitMap do									{Define the arrow bitmap to be drawn in the}
{														 palette}
			begin
				rowBytes := 2;
				SetRect(bounds, 0, 0, 16, 16);
				baseAddr := @arrow.data;
			end;

		gPasteReplacesSelection := FALSE;
		gConstrainDrags := TRUE;
		gStaggerCount := 0;

		if qNeedsColorQD | gConfiguration.hasColorQD then
			begin
		{ Unlike GetCursor, GetCCursor makes a copy of the color cursor}
{		  resource.  Therefore, you should make one call to GetCCursor}
{		  and multiple calls to SetCCursor}
				gRainbowArrow := GetCCursor(kRainbowArrow);
				FailNil(gRainbowArrow);
			end;
		gBetterFeedback := kBetterFeedbackDesired;

		if qTemplateViews & gDeadStripSuppression then
			begin
				if Member(TObject(nil), TShapeView) then
					;
				if Member(TObject(nil), TToolsPalette) then
					;
				if Member(TObject(nil), TPatternsPalette) then
					;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S ASelCommand}

	function TShapeApplication.DoCommandKey (ch: CHAR; var info: EventInfo): TCommand;
		OVERRIDE;

{ This illustrates how to have a 'Command-key-only' command, i.e. a command}
{  which is NOT in a menu, but rather only available when the user types}
{  the 'command' key and another key concurrently.  In this example, the}
{  user presses 'Command-D' (the D can be in upper or lower case) to}
{  request that the special 'more debug' menu be put up (or be taken down}
{  if it was already up)}

	begin
		if ((ch = 'D') | (ch = 'd')) then
			DoCommandKey := DoMenuCommand(cCmdDTyped)
		else
			DoCommandKey := inherited DoCommandKey(ch, info);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	function TShapeApplication.DoMakeDocument (itsCmdNumber: CmdNumber): TDocument;
{ NB: Not used to create the document for a shape view in the Clipboard }

		var
			shapeDocument: TShapeDocument;

	begin
		New(shapeDocument);
		FailNil(shapeDocument);
		shapeDocument.IShapeDocument(kDocType);
		DoMakeDocument := shapeDocument;
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S ASelCommand}

	function TShapeApplication.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;
		OVERRIDE;

	begin
		DoMenuCommand := nil;
		case aCmdNumber of

			cPasteReplacesSelection: 
				gPasteReplacesSelection := not gPasteReplacesSelection;

			cConstrainDrags: 
				gConstrainDrags := not gConstrainDrags;

			cCmdDTyped: 									{Command-D typed by user}
				begin
					if GetMHandle(mMoreDebug) = nil then		{menu not currrently up--put it up}
						InsertMenu(GetResMenu(mMoreDebug), 0)
					else										{menu currently up -- take it down}
						DeleteMenu(mMoreDebug);
					InvalidateMenuBar;							{ Get it redrawn }
				end;

			otherwise
				DoMenuCommand := inherited DoMenuCommand(aCmdNumber);
		end;												{Case}
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S ARes}

	procedure TShapeApplication.DoSetupMenus;
		OVERRIDE;
{The only menu commands handled here are the following two debugging commands:}

	begin
		inherited DoSetupMenus;
		EnableCheck(cPasteReplacesSelection, TRUE, gPasteReplacesSelection);
		EnableCheck(cConstrainDrags, TRUE, gConstrainDrags);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S ADebug}

	procedure TShapeApplication.IdentifySoftware;
		OVERRIDE;

	begin
		WriteLn('DrawShapes Source date: 6 June 86; Compiled on: ', COMPDATE, ' @ ', COMPTIME);
		inherited IdentifySoftware;
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S AClipboard}

	function TShapeApplication.MakeViewForAlienClipboard: TView;
		OVERRIDE;
{ Launch a view to represent the data found in the Clipboard at}
{  application start-up time, or when returning from an excursion}
{  to Switcher, or when returning from a Desk Accessory}

		var
			offset: LONGINT;
			clipShapeView: TShapeView;
			clipShapeDoc: TShapeDocument;
			clipShapes: ShapesOnClipboard;
			aNewShape: TShape;
			i: INTEGER;
			err: LONGINT;
			perm: BOOLEAN;
			fi: FailInfo;

		procedure HdlFailure (error: OSErr; message: LONGINT);

		begin
			Handle(clipShapes) := DisposeIfHandle(clipShapes);

			FreeIfObject(clipShapeDoc);
			clipShapeDoc := nil;
		end;

	begin
		clipShapes := nil;

	{Before doing anything else, make sure the scrap contains shapes}
		if GetScrap(nil, kShapeClipType, offset) > 0 then	{found my kind of data }
			begin
				New(clipShapeDoc);
				FailNil(clipShapeDoc);
				clipShapeDoc.IShapeDocument(kDocType);

				CatchFailures(fi, HdlFailure);
				New(clipShapeView);
				FailNil(clipShapeView);
				clipShapeView.IShapeView(clipShapeDoc, nil, TRUE);

				clipShapeDoc.fShapeView := clipShapeView;

				clipShapes := ShapesOnClipboard(NewPermHandle(0));
				FailNil(clipShapes);
				FailSpaceIsLow;

				perm := PermAllocation(TRUE);					{Don't allow GetScrap to use temp space}
				err := GetScrap(Handle(clipShapes), kShapeClipType, offset);
				perm := PermAllocation(perm);					{Restore perm allocation setting}

  { Only a negative result indicates an error--FailOSErr considers}
{	any non-zero result an error.}
				if err < 0 then
					FailOSErr(err);

				for i := 0 to clipShapes^^.theNumberOfShapes - 1 do
					begin
						aNewShape := TShape(gShapesArray[clipShapes^^.theShapes[i].theId].Clone);
						FailNil(aNewShape);
						with aNewShape, clipShapes^^.theShapes[i] do
							begin
								fPattern := thePattern;
								fColor := theColor;
								fExtentRect := theRect;
							end;
						clipShapeDoc.AddShape(aNewShape);
					end;

				Success(fi);
				Handle(clipShapes) := DisposeIfHandle(clipShapes);

				MakeViewForAlienClipboard := clipShapeView;
			end
		else
			MakeViewForAlienClipboard := inherited MakeViewForAlienClipboard;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TShapeDocument.IShapeDocument (fileType: OSType);

		var
			fi: FailInfo;

		procedure HdlNewList (error: OSErr; message: LONGINT);

		begin
			Free;
		end;

	begin
		fShapeView := nil;
		fToolsPalette := nil;
		fShapeList := nil;									{Just in case IDocument fails}
		IDocument(fileType, kDocType, kUsesDataFork, kUsesRsrcFork, not kDataOpen, not kRsrcOpen);

		CatchFailures(fi, HdlNewList);						{ In case NewList fails.}
		fShapeList := NewList;
		Success(fi);

	{$IFC qDebug}
		fShapeList.SetEltType('TShape');
	{$ENDC}

		fSavePrintInfo := TRUE;

		fReopening := FALSE;
		fFiltering := FALSE;
		fReplaceCommand := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.AddShape (shape: TShape);

	begin
		fShapeList.InsertLast(shape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.DeleteShape (shape: TShape);
{ Doesn't work for shape still belonging to a command}
{  (i.e., not yet committed to the document}

	begin
		fShapeList.Delete(shape);
		FreeIfObject(shape);
		shape := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TShapeDocument.DoMakeViews (forPrinting: BOOLEAN);

		var
			shapeView: TShapeView;
			toolsPalette: TToolsPalette;
			aWindow: TWindow;
			aDocState: DocState;
			minSize: Point;
			maxSize: Point;

		procedure CreateProceduralShapeView;
		{ CreateProceduralShapeView used when creating views procedurally to create the shapes view}
{		in both printing & non-printing cases}

		begin
			New(shapeView);
			FailNil(shapeView);
			shapeView.IShapeView(SELF, toolsPalette, FALSE);

			fShapeView := shapeView;
		end;

		procedure RestoreWindow;
		{ RestoreWindow restores the window & scroller using the settings in the documents fDocState}
{		field}

		begin
			aDocState := fDocState;
			with aDocState.theWindowRect do
				begin
					aWindow.Resize(right - left, bottom - top, FALSE);
					aWindow.Locate(left, top, FALSE);
				end;
			aWindow.ForceOnScreen;
			with aDocState.theScrollPosition do
				fShapeView.fScroller.ScrollTo(h, v, FALSE);
		end;

	begin
		if forPrinting then
			begin
				if qTemplateViews then
					begin
						shapeView := TShapeView(DoCreateViews(SELF, nil, kShapeViewRSRCID, gZeroVPt));
						fShapeView := shapeView;
					end
				else
					begin
						toolsPalette := nil;
						CreateProceduralShapeView;
					end;
			end 											{ this is the end of the "forPrinting=TRUE"}
{														 case}
		else
			begin
				if qTemplateViews then
					begin
						aWindow := NewTemplateWindow(kShapeWindowRSRCID, SELF);
						FailNil(aWindow);

						fToolsPalette := TToolsPalette(aWindow.FindSubView('PLTT'));
						FailNil(fToolsPalette);

						fShapeView := TShapeView(aWindow.FindSubView('SHAP'));
						FailNil(fShapeView);

						fShapeView.fToolsPalette := fToolsPalette;
					end
				else
					begin
						New(toolsPalette);
						FailNil(toolsPalette);

						toolsPalette.IToolsPalette(SELF, nil);
						fToolsPalette := toolsPalette;

						CreateProceduralShapeView;

						aWindow := NewPaletteWindow(kShapeWindowRSRCID, kWantHScrollBar, kWantVScrollBar, SELF, fShapeView, fToolsPalette, kToolsPaletteWidth, kLeftPalette);
					end;

				fShapeView.fScroller := fShapeView.GetScroller(TRUE);

				if fReopening then
					RestoreWindow
				else
					begin
						aWindow.AdaptToScreen;
						aWindow.SimpleStagger(kStaggerAmount, kStaggerAmount, gStaggerCount);
					end;

		{ set window's resize limits so it can't become wider than the shapeview's edge }
				with aWindow.fResizeLimits do
					begin
						minSize := topLeft;
						maxSize := botRight;
					end;
				with maxSize do
					h := Min(fShapeView.fSize.h + fToolsPalette.fSize.h + kSBarSizeMinus1, h);
				aWindow.SetResizeLimits(minSize, maxSize);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.DoSetupMenus;

		var
			i: INTEGER;

	begin
		inherited DoSetupMenus;

		for i := cArrow to cHBox do
			Enable(i, TRUE);
	end;												{ DoSetupMenus }

{--------------------------------------------------------------------------------------------------}
{$S AWriteFile}

	procedure TShapeDocument.DoNeedDiskSpace (var dataForkBytes, rsrcForkBytes: LONGINT);

	begin
	{ get Print record requirements }
		inherited DoNeedDiskSpace(dataForkBytes, rsrcForkBytes);

		dataForkBytes := dataForkBytes + fShapeList.GetSize * SIZEOF(ShapeData);
		rsrcForkBytes := rsrcForkBytes + kRsrcTypeOverhead + kRsrcOverhead + SIZEOF(DocState);
	end;

{}
{Doc file has the following format:}
{  Data Fork:}
{	(a)  kSizePrintInfo (120 bytes) => PrintInfo}
{	(b)  The rest => The shapes themselves}
{}
{ Resource Fork:}
{	(a)  SIZEOF(DocState) => DocState (rsrc type: 'DSTA', number: 1)}
{}

{--------------------------------------------------------------------------------------------------}
{$S AReadFile}

	procedure TShapeDocument.DoRead (aRefNum: INTEGER; rsrcExists, forPrinting: BOOLEAN);

		var
			i: INTEGER;
			id: INTEGER;
			count: LONGINT;
			newShape: TShape;
			docStateHandle: HDocState;

	begin
		inherited DoRead(aRefNum, rsrcExists, forPrinting); {read print info stuff}

		if rsrcExists then
			begin
				docStateHandle := HDocState(GetResource(kDocRsrcKind, kDocStateID));
				if docStateHandle <> nil then
					begin
						fDocState := docStateHandle^^;
						fReopening := TRUE;
					end;
			end
		else
			begin
		{$IFC qDebug}
				ProgramBreak('Resource fork doesn''t exist for saved file');
		{$ENDC}
				Failure(1, 0);										{???}
			end;

		for i := 1 to fDocState.theNumberOfShapes do
			begin
				count := SIZEOF(INTEGER);
				FailOSErr(FSRead(aRefNum, count, @id));

				if (id >= 1) & (id <= kShapesInPalette) then
					begin
						newShape := TShape(gShapesArray[id].Clone);
						FailNil(newShape);

						newShape.ReadFrom(aRefNum);

						AddShape(newShape);
					end
			{$IFC qDebug}
				else
					WriteLn('Ignored invalid shape ID = ', id : 1, ' shape #: ', i : 1);
			{$ENDC}
{	PSC Warning: Floating Semicolon	}
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AWriteFile}

	procedure TShapeDocument.DoWrite (aRefNum: INTEGER; makingCopy: BOOLEAN);

		var
			vhs: VHSelect;
			aDocState: DocState;
			count: LONGINT;
			window: TWindow;
			numberOfShapes: INTEGER;
			dummyRect: Rect;
			docStateHandle: HDocState;

{--------------------------------------------------------------------------------------------------}

		procedure WriteShape (shape: TShape);

		begin
			shape.WriteTo(aRefNum);
		end;

	begin
		inherited DoWrite(aRefNum, makingCopy); 			{write print info stuff}

	{ Call SurveyShapes just to get number of shapes }
		SurveyShapes(FALSE, numberOfShapes, dummyRect);
		window := TWindow(fWindowList.First);

		docStateHandle := HDocState(NewHandle(SIZEOF(DocState)));
		FailNil(docStateHandle);

		with docStateHandle^^ do
			begin
				window.GetGlobalBounds(theWindowRect);
				theScrollPosition := fShapeView.fScroller.fTranslation;
				theNumberOfShapes := numberOfShapes;
			end;

		AddResource(Handle(docStateHandle), kDocRsrcKind, kDocStateID, 'Doc State');
		FailOSErr(ResError);

		EachVirtualShapeDo(WriteShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.EachShapeDo (procedure DoThis (shape: TShape));
{ Iterates through the list of shapes. We have a separate method for this}
{  to hide the actual implementation of the shape list structure.}

	begin
		fShapeList.Each(DoThis);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.EachPotentialShapeDo (procedure DoThis (shape: TShape));
{ Iterates through all the shapes in document plus any 'pastee' shapes}
{  which may have been added by a not-yet-committed Paste.}

	begin
		EachShapeDo(DoThis);
		if fReplaceCommand <> nil then
			fReplaceCommand.EachNewShapeDo(DoThis);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.EachVirtualShapeDo (procedure DoThis (shape: TShape));
{ EachVirtualShape iterates through only those shapes that appear}
{  to be present at the moment to the USER, given the}
{  UNDO/REDO status of the last command. Thus it iterates}
{  through some but possibly not all of the shapes in the}
{  document, and possibly also through not-yet-in-the-document pastees}

{--------------------------------------------------------------------------------------------------}

		procedure MaybeDoThis (shape: TShape);

		begin
			if (not fFiltering) | (not shape.fWasSelected) then
				DoThis(shape);
		end;

	begin
		EachShapeDo(MaybeDoThis);
		if fReplaceCommand <> nil then
			fReplaceCommand.EachNewShapeDo(DoThis);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeDocument.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeDocument', nil, bClass);
		DoToField('fShapeView', @fShapeView, bObject);
		DoToField('fToolsPalette', @fToolsPalette, bObject);
		DoToField('fShapeList', @fShapeList, bObject);
		DoToField('fDocState.theNumberOfShapes', @fDocState.theNumberOfShapes, bInteger);
		DoToField('fDocState.theWindowRect', @fDocState.theWindowRect, bRect);
		DoToField('fDocState.theScrollPosition', @fDocState.theScrollPosition, bPoint);
		DoToField('fReopening', @fReopening, bBoolean);
		DoToField('fReplaceCommand', @fReplaceCommand, bObject);
		DoToField('fFiltering', @fFiltering, bBoolean);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TShapeDocument.FirstSelectedShapeThat (function TestSelectedShape (aShape: TShape): BOOLEAN): TShape;

		var
			aShape: TShape;

		function TestShape (aShape: TObject): BOOLEAN;

		begin
			if TShape(aShape).fIsSelected then
				TestShape := TestSelectedShape(TShape(aShape))
			else
				TestShape := FALSE;
		end;

	begin
		aShape := TShape(fShapeList.FirstThat(TestShape));
		if (aShape = nil) & (fReplaceCommand <> nil) then
			aShape := fReplaceCommand.FirstShapeThat(TestSelectedShape);
		FirstSelectedShapeThat := aShape;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AClose}

	procedure TShapeDocument.Free;
		OVERRIDE;

	begin
		FreeData;
		FreeIfObject(fShapeList);
		fShapeList := nil;

		inherited Free;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AClose}

	procedure TShapeDocument.FreeData;

		procedure DoToShape (aShape: TShape);

		begin
			FreeIfObject(aShape);
			aShape := nil;
		end;

	begin
		if fShapeList <> nil then
			begin
				EachShapeDo(DoToShape);
				fShapeList.DeleteAll;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeDocument.SurveyShapes (selecteesOnly: BOOLEAN; var numberOfShapes: INTEGER; var combinedExtent: Rect);

		procedure UnionizeShapes (shape: TShape);

		begin
			if shape.fIsSelected | not selecteesOnly then
				begin
					numberOfShapes := numberOfShapes + 1;
					if numberOfShapes > 1 then
			{$Push}
						UnionRect(shape.fExtentRect, combinedExtent, combinedExtent)
				{$Pop}

					else
						combinedExtent := shape.fExtentRect;
				end;
		end;

	begin
		numberOfShapes := 0;
		combinedExtent := gZeroRect;
		EachVirtualShapeDo(UnionizeShapes);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TToolsPalette.IToolsPalette (itsDocument: TDocument; itsSuperview: TView);

		var
			itsSize: VPoint;

	begin
		SetVPt(itsSize, kToolsPaletteWidth, kToolsPaletteHeight);
		IView(itsDocument, itsSuperview, gZeroVPt, itsSize, sizeFixed, sizeFixed);

		fCurrTool := 0;
		fOldTool := 0;
		fSelectedTool := 0;
		fCurrSelection := kNoToolSelection;

		BuildChoiceArray;
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qTemplateViews}
{$S AOpen}

	procedure TToolsPalette.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
		OVERRIDE;

	begin
		inherited IRes(itsDocument, itsSuperview, itsParams);

		fCurrTool := 0;
		fOldTool := 0;
		fSelectedTool := 0;
		fCurrSelection := kNoToolSelection;

		BuildChoiceArray;
	end;

{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TToolsPalette.Activate (entering: BOOLEAN);
		OVERRIDE;

	begin
		if not entering then
			fCurrSelection := kNoToolSelection;

		inherited Activate(entering);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TToolsPalette.BuildChoiceArray;

		var
			top: INTEGER;
			i: INTEGER;
			r: Rect;

	begin
		top := 0;
		for i := 0 to kShapesInPalette do					{Define the palette choices}
			begin
				SetRect(r, 0, top, kToolsPaletteWidth - 1, top + kToolsPaletteWidth - 1);
				fChoiceArray[i] := r;
				top := top + kToolsPaletteWidth - 1;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TToolsPalette.DoHighlightSelection (fromHL, toHL: HLState);

		procedure Toggle (which: INTEGER);

			var
				r: Rect;

		begin
			r := fChoiceArray[fCurrTool];
			UseSelectionColor;
			InvertRect(r);
		end;

	begin
		if (fCurrTool >= 0) & (fCurrTool <= kShapesInPalette) then
			case toHL of
				hlOn: 
					if fCurrSelection <> fCurrTool then	{ if it's not already selected }
						begin
					{ if another tool is selected, turn it off }
							if fCurrSelection <> kNoToolSelection then
								Toggle(fCurrSelection);
							fCurrSelection := fCurrTool;
							Toggle(fCurrTool);
						end;
				hlOff: 
					if fCurrSelection = fCurrTool then	{ if it's already selected, deselect it }
						begin
							Toggle(fCurrTool);
							fCurrSelection := kNoToolSelection;
						end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	function TToolsPalette.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;

		var
			aWindow: TWindow;
			aToolSelectCmd: TToolSelectCmd;
			documentToolsPalette: TToolsPalette;
			menuToolsPalette: TToolsPalette;
			floatingToolsPalette: TToolsPalette;

	begin
		DoMouseCommand := nil;

		New(aToolSelectCmd);
		FailNIL(aToolSelectCmd);

		documentToolsPalette := nil;
		aWindow := gApplication.GetActiveWindow;
		if (aWindow <> nil) & aWindow.IsShown then
			documentToolsPalette := TToolsPalette(aWindow.FindSubView('PLTT'));

		menuToolsPalette := nil;
		if (gToolsMenu <> nil) then
			menuToolsPalette := TToolsPalette(gToolsMenu.FindSubView('MTUL'));

		floatingToolsPalette := nil;
		if (gToolsPaletteWindow <> nil) & gToolsPaletteWindow.IsShown then
			floatingToolsPalette := TToolsPalette(gToolsPaletteWindow.FindSubView('TPLT'));

		aToolSelectCmd.IToolSelectCmd(SELF, documentToolsPalette, menuToolsPalette, floatingToolsPalette, theMouse);

	{ the tracker will get tracked immediately if this is the tools view in the toolsmenu }
		DoMouseCommand := aToolSelectCmd;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TToolsPalette.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);
		OVERRIDE;

		var
			r: Rect;
			qdPt: Point;
			i: INTEGER;

		procedure FrameTool (toolRect: Rect);
		begin
			PenNormal;
			PenMode(patXOr);
			PenSize(2, 2);
			FrameRect(r);
		end;

	begin
		if mouseDidMove then
			begin
				if Focus then
					;
				qdPt := ViewToQDPt(nextPoint);
				for i := 0 to kShapesInPalette do
					begin
						r := fChoiceArray[i];
						if PtInRect(qdPt, r) then
							begin
								FrameTool(r);
								if turnItOn then
									fSelectedTool := i			{ remember the Tool currently selected }
								else
									fSelectedTool := 0;			{ no Tool currently selected }
								LEAVE;
							end;
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TToolsPalette.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
		OVERRIDE;

		var
			qdExtent: Rect;

	begin
		SetCursor(arrow);
		GetQDExtent(qdExtent);
		RectRgn(cursorRgn, qdExtent);
		DoSetCursor := TRUE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TToolsPalette.Draw (area: Rect);

		var
			i: INTEGER;
			r: Rect;

	begin
		PenSize(1, 1);
		MoveTo(fSize.h - 1, 0);
		Line(0, fSize.v);
		for i := 0 to kShapesInPalette do
			begin
				r := fChoiceArray[i];
				FrameRect(r);

				if i = 0 then
					begin
						SetRect(r, 14, 12, 30, 28);
						CopyBits(gArwBitMap, thePort^.portBits, gArwBitMap.bounds, r, srcOR, nil);
					end
				else
					gShapesArray[i].Draw;
			end;

		inherited Draw(area);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TToolsPalette.SelectNewTool (whichTool: INTEGER);

	begin
		if IsShown then
			begin
				if Focus then
					;
				DoHighlightSelection(hlOn, hlOff);
				fCurrTool := whichTool;
				DoHighlightSelection(hlOff, hlOn);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TToolsPalette.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TToolsPalette', nil, bClass);
		DoToField('fCurrTool', @fCurrTool, bInteger);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TToolSelectCmd.IToolSelectCmd (theToolsPalette, theDocumentToolsPalette, theMenuToolsPalette, theFloatingToolsPalette: TToolsPalette; theMouse: Point);

		var
			hitVPt: VPoint;
			hitPt: Point;

	begin
		ICommand(cChangeTool, nil, theToolsPalette, nil);
		fTool := 0; 	{ the tools that the user selects with this cmd }
		fExitTracking := FALSE;
		fMenuToolsPalette := theMenuToolsPalette;
		fDocumentToolsPalette := theDocumentToolsPalette;
		fFloatingToolsPalette := theFloatingToolsPalette;
		fViewConstrain := FALSE;
		fTracksMouse := TRUE;

		PtToVPt(theMouse, hitVPt);
		theToolsPalette.LocalToWindow(hitVPt);
		hitPt := VPtToPt(hitVPt);
		LocalToGlobal(hitPt);
		fInitialPt := hitPt;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TToolSelectCmd.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
		OVERRIDE;

	begin
		TrackMouse := SELF;
		if gTrackingInMenu then
			begin
		{ quit tracking when the mouse leaves the view }
{		  - if gTrackingInMenu is TRUE, view constrain is set to FALSE, so nextPoint CAN leave the view}
{		  - all other times, view constrain is TRUE, so nextPoint WON'T leave the view}
				if (fView <> nil) & (fView.IsShown) then
					fExitTracking := not fView.ContainsMouse(previousPoint);

		{ if gTrackingInMenu is TRUE, then fExitTracking might get set to TRUE above meaning that the user}
{		is either returning to the menubar or trying to tear off this menu, so simply return NIL when}
{		we're done tracking and the tracker will be freed by TApplication.TrackMouse}
				if (aTrackPhase = trackRelease) & fExitTracking then
					TrackMouse := nil;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TToolSelectCmd.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

	begin
	{ all we really want to do here is let the view give us some feedback, so...}
		if (fView <> nil) & (fView.IsShown) & mouseDidMove then
			fView.TrackFeedback(anchorPoint, nextPoint, turnItOn, mouseDidMove);

	{ When we're selecting a pattern (ie turning it on) then this command needs to know}
{	about the new selection. When we're deselecting a pattern (ie turning it off) then this command}
{	MUST ignore the deselection since MacApp's tracking will turn off the current selection as part}
{	of its default tracking behavior even when the user has made a valid selection in the view.}
		if turnItOn then
			fTool := TToolsPalette(fView).fSelectedTool;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TToolSelectCmd.IsDoneTracking: BOOLEAN;
		OVERRIDE;

	begin
		IsDoneTracking := not StillDown | fExitTracking;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TToolSelectCmd.DoIt;
		OVERRIDE;

	begin
	{ tell the TToolsPalette in the menu which tool is selected }
		if (fMenuToolsPalette <> nil) then
			begin
				fMenuToolsPalette.fOldTool := fFloatingToolsPalette.fCurrTool;
				fMenuToolsPalette.fCurrTool := fTool;
			end;

	{ tell the TToolsPalette in the floating window which tool is selected }
		if (fFloatingToolsPalette <> nil) then
			begin
				fFloatingToolsPalette.fOldTool := fFloatingToolsPalette.fCurrTool;
				fFloatingToolsPalette.SelectNewTool(fTool);
			end;

	{ tell the TToolsPalette in the document window which tool is selected }
		if (fDocumentToolsPalette <> nil) then
			begin
				fDocumentToolsPalette.fOldTool := fDocumentToolsPalette.fCurrTool;
				fDocumentToolsPalette.SelectNewTool(fTool);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TToolSelectCmd.RedoIt;
		OVERRIDE;

	begin
	{ tell the TToolsPalette in the menu which tool is selected }
		if (fMenuToolsPalette <> nil) then
			fMenuToolsPalette.fCurrTool := fTool;

	{ tell the TToolsPalette in the floating window which tool is selected }
		if (fFloatingToolsPalette <> nil) then
			fFloatingToolsPalette.SelectNewTool(fTool);

	{ tell the TToolsPalette in the document window which pattern is selected }
		if (fDocumentToolsPalette <> nil) then
			fDocumentToolsPalette.SelectNewTool(fTool);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TToolSelectCmd.UndoIt;
		OVERRIDE;

	begin
	{ tell the TToolsPalette in the menu which tool *was* selected }
		if (fMenuToolsPalette <> nil) then
			fMenuToolsPalette.fCurrTool := fMenuToolsPalette.fOldTool;

	{ tell the TToolsPalette in the floating window which tool *was* selected }
		if (fFloatingToolsPalette <> nil) then
			fFloatingToolsPalette.SelectNewTool(fFloatingToolsPalette.fOldTool);

	{ tell the TToolsPalette in the document window which tool *was* selected }
		if (fDocumentToolsPalette <> nil) then
			fDocumentToolsPalette.SelectNewTool(fDocumentToolsPalette.fOldTool);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TShapeView.IShapeView (itsDocument: TShapeDocument; itsPalette: TToolsPalette; forClipboard: BOOLEAN);

		var
			itsLocation: VPoint;
			itsSize: VPoint;
			aHandler: TStdPrintHandler;
			aDocState: DocState;
			sd: SizeDeterminer;

	begin
		fDragging := FALSE;
		fToolsPalette := itsPalette;
		SetVPt(itsSize, kMaxCoord, kMaxCoord);
		if forClipboard then
			sd := sizeVariable
		else
			sd := sizeFillPages;
		IView(itsDocument, nil, gZeroVPt, itsSize, sd, sd);
		fScroller := nil;

		fShapeDocument := itsDocument;

	{$IFC FALSE}
										{!!! Need to handle this}
		if forClipboard then
			fWouldMakePICTScrap := TRUE;
	{$ENDC}

		if not forClipboard then
			begin
				New(aHandler);
				FailNil(aHandler);
				aHandler.IStdPrintHandler(itsDocument, SELF, not kSquareDots, kFixedSize, kFixedSize); { does not have square dots }
			{ horizontal page size is fixed }
			{ vertical page size is fixed }
			end;

		fClickPt := gZeroPt;								{plausible starting value}
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qTemplateViews}
{$S AOpen}

	procedure TShapeView.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
		OVERRIDE;

		var
			aHandler: TStdPrintHandler;

	begin
		fDragging := FALSE;
		fScroller := nil;
		fToolsPalette := nil;

		inherited IRes(itsDocument, itsSuperview, itsParams);

		fShapeDocument := TShapeDocument(itsDocument);

		New(aHandler);
		FailNil(aHandler);
		aHandler.IStdPrintHandler(itsDocument, SELF, not kSquareDots, kFixedSize, kFixedSize); { does not have square dots }
				{ horizontal page size is fixed }
				{ vertical page size is fixed }

		fClickPt := gZeroPt;								{plausible starting value}
	end;

{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.CalcMinSize (var minSize: VPoint);

		var
			aRect: Rect;
			numberOfShapes: INTEGER;

	begin
		fShapeDocument.SurveyShapes(FALSE, numberOfShapes, aRect);
		SetVPt(minSize, Max(100, aRect.right), Max(100, aRect.bottom));
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TShapeView.ContainsClipType (aType: ResType): BOOLEAN;

	begin
		ContainsClipType := (aType = kShapeClipType);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.Deselect;

		procedure DeselShape (shape: TShape);

		begin
			shape.fIsSelected := FALSE;
		end;

	begin
		DoHighlightSelection(hlOn, hlOff);
		fShapeDocument.EachPotentialShapeDo(DeselShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.DoHighlightSelection (fromHL, toHL: HLState);

		procedure HiliteShape (shape: TShape);

		begin
			if shape.fIsSelected & (not fDragging) then
				shape.Highlight(fromHL, toHL);
		end;

	begin
		fShapeDocument.EachVirtualShapeDo(HiliteShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	function TShapeView.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;

		var
			recolorCmd: TRecolorCmd;
			reshadeCmd: TReshadeCmd;
			shapeCutCopyCommand: TShapeCutCopyCommand;
			shapePasteCommand: TShapePasteCommand;
			shapeClearCommand: TShapeClearCommand;
			menu, item: INTEGER;
			pMCEntry: MCEntryPtr;
			theColor: RGBColor;
			pickerPrompt: StringHandle;

		procedure SelectIt (aShape: TShape);

		begin
			if not aShape.fIsSelected then
				begin
					aShape.fIsSelected := TRUE;
					aShape.Highlight(hlOff, hlOn);
				end;
		end;

		function GetShapeColor (aShape: TShape): BOOLEAN;

		begin
			GetShapeColor := TRUE;
		end;

	begin
		DoMenuCommand := nil;

		case aCmdNumber of
			cCut, cCopy: 
				begin
					New(shapeCutCopyCommand);
					FailNil(shapeCutCopyCommand);
					shapeCutCopyCommand.IShapeCutCopyCommand(aCmdNumber, SELF);
					PostCommand(shapeCutCopyCommand);
				end;

			cPaste: 
				begin
					New(shapePasteCommand);
					FailNil(shapePasteCommand);
					shapePasteCommand.IShapePasteCommand(SELF);
					PostCommand(shapePasteCommand);
				end;

			cClear: 
				begin
					New(shapeClearCommand);
					FailNil(shapeClearCommand);
					shapeClearCommand.IShapeClearCommand(SELF);
					PostCommand(shapeClearCommand);
				end;

		{$IFC qDebug}
			cRecalcExtent: 
				AdjustSize;
		{$ENDC}

			cSelectAll: 
				begin
					if Focus then
						;								{At least try to focus}
					fShapeDocument.EachVirtualShapeDo(SelectIt);
				end;

			cPickColor: 
				begin
					theColor := fShapeDocument.FirstSelectedShapeThat(GetShapeColor).fColor;
					pickerPrompt := GetString(kPickerPrompt);
					FailNil(pickerPrompt);
					if GetColor(gZeroPt, pickerPrompt^^, theColor, theColor) then
						begin
							New(recolorCmd);
							FailNil(recolorCmd);
							recolorCmd.IRecolorCmd(theColor, SELF);
							PostCommand(recolorCmd);
						end;
				end;

			cBetterFeedback: 
				gBetterFeedback := not gBetterFeedback;

			otherwise
				begin
					CmdToMenuItem(aCmdNumber, menu, item);
					if menu = mColor then
						begin
							New(recolorCmd);
							FailNil(recolorCmd);
							pMCEntry := GetMCEntry(menu, item);
							theColor := pMCEntry^.mctRGB2;			{the MC entry can move}
							recolorCmd.IRecolorCmd(theColor, SELF);
							PostCommand(recolorCmd);
						end
					else
						DoMenuCommand := inherited DoMenuCommand(aCmdNumber);
				end;

		end;												{Case}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	function TShapeView.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;

		var
			palette: TToolsPalette;
			protoShape: TShape;
			shapeSketcher: TShapeSketcher;
			shapeUnderMouse: TShape;
			shapeSelector: TShapeSelector;
			shapeDragger: TShapeDragger;
			fi: FailInfo;

		procedure HdlInitCmdFailed (error: OSErr; message: LONGINT);

		begin
			FreeIfObject(protoShape);
			protoShape := nil;
		end;

		procedure CheckShape (aShape: TShape);

		begin
		{$Push}
			if PtInRect(theMouse, aShape.fExtentRect) then
				shapeUnderMouse := aShape;
		{$Pop}
		end;

	begin												{ DoMouseCommand }
		DoMouseCommand := nil;

		palette := fToolsPalette;
		fClickPt := theMouse;
		if palette.fCurrTool > 0 then						{draw mode}
			begin
				FailSpaceIsLow; 								{ Make sure we aren't low on memory }

				Deselect;

		{Clone appropriate shape}

				protoShape := TShape(gShapesArray[palette.fCurrTool].Clone);
				FailNil(protoShape);

				CatchFailures(fi, HdlInitCmdFailed);
		{ Make sure cloning the shape left us with enough memory to continue.}
				FailSpaceIsLow;

				New(shapeSketcher);
				FailNil(shapeSketcher);
				shapeSketcher.IShapeSketcher(SELF, protoShape, info.theOptionKey);
				Success(fi);
				DoMouseCommand := shapeSketcher;
			end 											{draw mode}
		else
			begin											{select mode}
				shapeUnderMouse := nil;
				fShapeDocument.EachVirtualShapeDo(CheckShape);

				if shapeUnderMouse = nil then					{area select}
					begin
						if not info.theShiftKey then
							Deselect;
						New(shapeSelector);
						FailNil(shapeSelector);
						shapeSelector.IShapeSelector(cMouseCommand, SELF);
						DoMouseCommand := shapeSelector;
					end 										{area select}

				else
					begin										{shape select/move/...}

						if not (shapeUnderMouse.fIsSelected | info.theShiftKey) then
							Deselect;

						if info.theShiftKey then
							begin
								shapeUnderMouse.fIsSelected := not shapeUnderMouse.fIsSelected;
								if shapeUnderMouse.fIsSelected then
									shapeUnderMouse.Highlight(hlOff, hlOn)
								else
									shapeUnderMouse.Highlight(hlOn, hlOff);
							end
						else if not shapeUnderMouse.fIsSelected then
							begin
								shapeUnderMouse.fIsSelected := TRUE;
								DoHighlightSelection(hlOff, hlOn);
							end;

						if shapeUnderMouse.fIsSelected then
							begin
								New(shapeDragger);
								FailNil(shapeDragger);
								shapeDragger.IShapeDragger(SELF);
								DoMouseCommand := shapeDragger;
							end;
					end;										{shape select/move/...}
			end;											{Select mode}
	end;												{ DoMouseCommand }

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TShapeView.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
		OVERRIDE;

		var
			cursorSet: BOOLEAN;
			qdExtent: Rect;
			shapeExtent: Rect;

		procedure TestShape (shape: TShape);

		begin
		{$Push}
			if PtInRect(localPoint, shape.fExtentRect) then
		{$Pop}
				begin
					UseROMMap(TRUE);
					SetCursor(GetCursor(plusCursor)^^);
					shapeExtent := shape.fExtentRect;			{RectRgn may move memory}
					RectRgn(cursorRgn, shapeExtent);
					cursorSet := TRUE;

 {can't exit from the middle of an Each, because TList}
{ doesn't allow it; should really use FirstWhich;}
{ no harm in skipping the Exit, just takes longer}
			{* Exit(DoSetCursor); *}
				end;
		end;

	begin												{ DoSetCursor }
		if fToolsPalette.fCurrTool = 0 then 					{selection}
			begin
				cursorSet := FALSE;
				fShapeDocument.EachVirtualShapeDo(TestShape);
				if not cursorSet then
					if qNeedsColorQD | gConfiguration.hasColorQD then
			{set cursor to color arrow}
						SetCCursor(gRainbowArrow)
					else
						SetCursor(arrow);
				DoSetCursor := TRUE;
			end
		else
			begin
				DoSetCursor := TRUE;
				UseROMMap(TRUE);
				SetCursor(GetCursor(crossCursor)^^);
				GetQDExtent(qdExtent);
				RectRgn(cursorRgn, qdExtent);
			end;
	end;												{ DoSetCursor }

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.DoSetupMenus;

		var
			i: INTEGER;
			anySelection: BOOLEAN;
			anyShapes: BOOLEAN;
			haveMemory: BOOLEAN;
			aMenuHandle: MenuHandle;
			item: INTEGER;
			itemName: Str255;

		procedure TestShapes (theShape: TShape);

		begin
			anySelection := anySelection | theShape.fIsSelected;
			anyShapes := anyShapes | (not fShapeDocument.fFiltering) | (not theShape.fWasSelected);
		end;

	begin

		inherited DoSetupMenus;

		anySelection := FALSE;
		anyShapes := FALSE;

		haveMemory := not MemSpaceIsLow;
	{ Find out if we are low on memory.  If we are then we'll disable all}
{	  memory-intensive commands.}

		fShapeDocument.EachVirtualShapeDo(TestShapes);
	{ This checks every virtual shape--could be made faster. }

	{ enable the Pattern menu if there is a selection }
		Enable(cPatterns, anySelection);

		if anySelection & (qNeedsColorQD | gConfiguration.hasColorQD) then
			begin
		{ Enable each of the Color menu items, if the Color menu is present }
				aMenuHandle := GetMHandle(mColor);
				if aMenuHandle <> nil then
					for item := 1 to CountMItems(aMenuHandle) do
						begin
 { There can be more than 31 menu entries with scrolling menus,}
{   but trying to enable an item with number > 31 is bad news.}
{   If the menu itself is enabled (which it will be in MacApp}
{   if any of the first 31 items is enabled), then the extras}
{   will always be enabled.}
				{Don't enable line separators.}
							GetItem(aMenuHandle, item, itemName);
							if (item <= 31) & (itemName <> '-') then
								EnableItem(aMenuHandle, item);
						end;
			end;

	{$IFC qDebug}
		Enable(cRecalcExtent, TRUE);
	{$ENDC}
		Enable(cCut, anySelection & haveMemory);
		Enable(cCopy, anySelection & haveMemory);
		if haveMemory then
			CanPaste(kShapeClipType);
		Enable(cClear, anySelection);

		Enable(cSelectAll, anyShapes);
		EnableCheck(cBetterFeedback, TRUE, gBetterFeedback);
	end;												{ DoSetupMenus }

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.Draw (area: Rect);

		procedure DrawShape (shape: TShape);

			var
				r: Rect;

		begin
		{$Push}
			if not (fDragging & shape.fIsSelected) & SectRect(shape.fExtentRect, area, r) then
				shape.Draw;
		{$Pop}
		end;

	begin
		fShapeDocument.EachVirtualShapeDo(DrawShape);		{draw the shapes}

		inherited Draw(area);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeView.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeView', nil, bClass);
		DoToField('fDragging', @fDragging, bBoolean);
		DoToField('fToolsPalette', @fToolsPalette, bObject);
		DoToField('fClickPt', @fClickPt, bPoint);
		DoToField('fShapeDocument', @fShapeDocument, bObject);
		DoToField('fScroller', @fScroller, bObject);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.InvalShape (aShape: TShape);

		var
			r: Rect;

	begin
		r := aShape.fExtentRect;
		InsetRect(r, -2, -2);
		InvalidRect(r);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.RestoreSelection;

		procedure DoRestore (aShape: TShape);

			var
				wantInval: BOOLEAN;

		begin
			wantInval := aShape.fIsSelected | aShape.fWasSelected;
			aShape.fIsSelected := aShape.fWasSelected;
			if wantInval then
				InvalShape(aShape);
		end;

	begin
		if Focus then
			;
		Deselect;
		fShapeDocument.EachPotentialShapeDo(DoRestore);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeView.SaveSelection (andInval: BOOLEAN);

		procedure DoToShape (aShape: TShape);

		begin
			with aShape do
				fWasSelected := fIsSelected;
			if andInval & aShape.fWasSelected then
				InvalShape(aShape);
		end;

	begin
		if Focus then
			;
		fShapeDocument.EachPotentialShapeDo(DoToShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AClipboard}

	procedure TShapeView.WriteToDeskScrap;

		var
			err: LONGINT;
			clipShapes: ShapesOnClipboard;
			count: INTEGER;
			bBox: Rect;
			i: INTEGER;
			outline: Rect;
			aShapeDatum: ShapeData;
			wantBytes: INTEGER;

		procedure CopyToDeskScrap (aShape: TShape);

		begin
			with aShapeDatum do
				begin
					theId := aShape.id;
					thePattern := aShape.fPattern;
					theColor := aShape.fColor;
					theRect := aShape.fExtentRect;
				end;
			clipShapes^^.theShapes[i] := aShapeDatum;
			i := i + 1;
		end;

	begin
 { Write the PICT scrap first in case we will be unable to write both}
{   the PICT scrap and our own scrap type.}
		inherited WriteToDeskScrap; 						{Generate PICT-type scrap}

		fShapeDocument.SurveyShapes(FALSE, count, bBox);	{count shapes}
		wantBytes := SIZEOF(INTEGER) + SIZEOF(Rect) + (count * SIZEOF(ShapeData));
	{??? call CanAllocate, and if can't get enough, put up alert?}
		clipShapes := ShapesOnClipboard(NewPermHandle(wantBytes));
		FailNil(clipShapes);

		with clipShapes^^ do
			begin
				theBoundingBox := bBox;
				theNumberOfShapes := count;
			end;
		i := 0;
		fShapeDocument.EachShapeDo(CopyToDeskScrap);
		err := PutDeskScrapData(kShapeClipType, Handle(clipShapes));
		Handle(clipShapes) := DisposeIfHandle(clipShapes);

		FailOSErr(err);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.Initialize;
		OVERRIDE;

	begin
		inherited Initialize;

		fID := 0;
		fExtentRect := gZeroRect;
		fPattern := 1;
		fOldPattern := 1;
		fColor := gRGBWhite;
		fIsSelected := FALSE;
		fWasSelected := FALSE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.IShape (itsExtent: Rect; itsID: INTEGER);

	begin
		IObject;
		fExtentRect := itsExtent;
		fID := itsID;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.Draw;

	begin
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.DrawOutline;

	begin
	{$IFC qDebug}
		ProgramBreak('TShape.DrawOutline called!');
	{$ENDC}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.EachHandleDo (procedure DoThis (Handle: Rect; handVHS: VHSelect; handTopOrLeft: BOOLEAN));

		var
			r: Rect;
			extent: Rect;

	begin
		SetRect(r, -2, -2, 2, 2);
		extent := fExtentRect;

		with extent do
			begin
				OffSetRect(r, left, (top + bottom) div 2);
				DoThis(r, h, TRUE); 							{left}

				OffSetRect(r, right - left, 0);
				DoThis(r, h, FALSE);							{right}

				OffSetRect(r, -(right - left) div 2, top - ((top + bottom) div 2));
				DoThis(r, v, TRUE); 							{top}

				OffSetRect(r, 0, bottom - top);
				DoThis(r, v, FALSE);							{bottom}
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShape.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShape', nil, bClass);
		DoToField('fID', @fID, bInteger);
		DoToField('fExtentRect', @fExtentRect, bRect);
		DoToField('fPattern', @fPattern, bInteger);
		DoToField('fOldPattern', @fOldPattern, bInteger);
		DoToField('fColor', @fColor, bRGBColor);
		DoToField('fOldColor', @fOldColor, bRGBColor);
		DoToField('fIsSelected', @fIsSelected, bBoolean);
		DoToField('fWasSelected', @fWasSelected, bBoolean);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShape.Highlight (fromHL, toHL: HLState);

{--------------------------------------------------------------------------------------------------}

		procedure PaintHandle (Handle: Rect; handVHS: VHSelect; handTopOrLeft: BOOLEAN);

		begin
			PaintRect(Handle);
		end;

	begin
		SetHLPenState(fromHL, toHL);
		EachHandleDo(PaintHandle);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TShape.id: INTEGER;

	begin
		id := fID;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AReadFile}

	procedure TShape.ReadFrom (aRefNum: INTEGER);

		var
			data: ShapeData;
			count: LONGINT;

	begin
	{ DoRead has already read in the id; read the rest of the data }
		count := SIZEOF(ShapeData) - SIZEOF(INTEGER);
		FailOSErr(FSRead(aRefNum, count, @data.theRect));

		with data do
			begin
				fExtentRect := theRect;
				fPattern := thePattern;
				fColor := theColor;
				fIsSelected := theSelected;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AWriteFile}

	procedure TShape.WriteTo (aRefNum: INTEGER);

		var
			data: ShapeData;
			count: LONGINT;

	begin
		with data do
			begin
				theId := id;
				theRect := fExtentRect;
				thePattern := fPattern;
				theColor := fColor;
				theSelected := fIsSelected;
			end;
		count := SIZEOF(ShapeData);
		FailOSErr(FSWrite(aRefNum, count, @data));
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TBox.IBox (itsExtent: Rect; itsID: INTEGER);

	begin
		IShape(itsExtent, itsID);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TBox.Draw;

		var
			itsExtent: Rect;
			itsColor: RGBColor;

	begin
		PenNormal;
		itsExtent := fExtentRect;

		if qNeedsColorQD | gConfiguration.hasColorQD then
			begin
		{Get the color of the menu item representing the shape's color}
				itsColor := fColor;
				RGBForeColor(itsColor);
				FillRect(itsExtent, gPat[fPattern]);
				ForeColor(blackColor);
			end
		else
			FillRect(itsExtent, gPat[fPattern]);

		DrawOutline;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TBox.DrawOutline;

		var
			itsExtent: Rect;

	begin
		PenSize(1, 1);
		itsExtent := fExtentRect;							{FrameRect may move memory.}
		FrameRect(itsExtent);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure THeavyBox.IHeavyBox (itsExtent: Rect; itsID: INTEGER);

	begin
		IBox(itsExtent, itsID);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure THeavyBox.Draw;

		const
			s = '4K';

		var
			itsExtent: Rect;
			wid: INTEGER;
			r: Rect;
			x: INTEGER;

	begin
		inherited Draw;

		itsExtent := fExtentRect;

		PenSize(2, 2);
		FrameRect(itsExtent);
		PenSize(1, 1);

		TextFont(geneva);
		TextFace([]);
		TextSize(9);
		TextMode(srcOR);

		wid := StringWidth(s);

		with itsExtent do
			x := (left + right) div 2;

		SetRect(r, x - 7, itsExtent.bottom - 14, x + 7, itsExtent.bottom - 4);
		EraseRect(r);
		MADrawString(AtStr(s), r, teJustCenter);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TCircle.ICircle (itsExtent: Rect; itsID: INTEGER);

	begin
		IShape(itsExtent, itsID);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TCircle.Draw;

		var
			itsExtent: Rect;
			itsColor: RGBColor;

	begin
		PenNormal;
		itsExtent := fExtentRect;							{FillOval may move memory}

		if qNeedsColorQD | gConfiguration.hasColorQD then
			begin
		{Get the color of the menu item representing the shape's color}
				itsColor := fColor;
				RGBForeColor(itsColor);
				FillOval(itsExtent, gPat[fPattern]);
				ForeColor(blackColor);
			end
		else
			FillOval(itsExtent, gPat[fPattern]);

		DrawOutline;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TCircle.DrawOutline;

		var
			itsExtent: Rect;

	begin
		PenSize(1, 1);
		itsExtent := fExtentRect;							{FrameOval may move memory}
		FrameOval(itsExtent);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeCommand.IShapeCommand (itsCmdNumber: CmdNumber; itsShapeView: TShapeView; betterFeedbackDesired: BOOLEAN);

	begin
		IBetterFeedbackCmd(itsCmdNumber, itsShapeView.fShapeDocument, itsShapeView, itsShapeView.fScroller, betterFeedbackDesired);
		fShapeView := itsShapeView;
		fShapeDocument := itsShapeView.fShapeDocument;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeCommand', nil, bClass);
		DoToField('fShapeView', @fShapeView, bObject);
		DoToField('fShapeDocument', @fShapeDocument, bObject);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeSelector.IShapeSelector (itsCmdNumber: CmdNumber; itsShapeView: TShapeView);

	begin
		IShapeCommand(itsCmdNumber, itsShapeView, gBetterFeedback);
		fCausesChange := FALSE;
		fCanUndo := FALSE;
		fBounds := gZeroRect;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSelector.DoIt;
		OVERRIDE;

		var
			shapeView: TShapeView;

		procedure TestShape (shape: TShape);

		begin
		{$Push}
			if RectsNest(fBounds, shape.fExtentRect) then
		{$Pop}
				begin
					if shape.fIsSelected then
						shape.Highlight(hlOn, hlOff)
					else
						shape.Highlight(hlOff, hlOn);
					shape.fIsSelected := not shape.fIsSelected;
				end;
		end;

	begin
		shapeView := fShapeView;
		shapeView.fShapeDocument.EachVirtualShapeDo(TestShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeSelector.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeSelector', nil, bClass);
		DoToField('fBounds', @fBounds, bRect);
		DoToField('fShiftKey', @fShiftKey, bBoolean);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSelector.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

		var
			r: Rect;

	begin
		inherited TrackFeedback(anchorPoint, nextPoint, turnItOn, mouseDidMove);
		if (fView <> nil) & mouseDidMove then
			begin

				PenPat(Gray);
				Pt2Rect(fView.ViewToQDPt(anchorPoint), fView.ViewToQDPt(nextPoint), r);
				FrameRect(r);									{ draw/erase }

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TShapeSelector.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;

		var
			r: Rect;
			qdAnchor, qdPrevious: Point;

	begin
		TrackMouse := inherited TrackMouse(aTrackPhase, anchorPoint, previousPoint, nextPoint, mouseDidMove);
		qdAnchor := fShapeView.ViewToQDPt(anchorPoint);
		qdPrevious := fShapeView.ViewToQDPt(previousPoint);
		Pt2Rect(qdAnchor, qdPrevious, r);
		fBounds := r;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeDragger.IShapeDragger (aShapeView: TShapeView);

		var
			bounds: Rect;
			numberOfShapes: INTEGER;

	begin
		IShapeCommand(cMoveShape, aShapeView, gBetterFeedback);

		aShapeView.fShapeDocument.SurveyShapes(TRUE, numberOfShapes, bounds);
		aShapeView.fDragging := FALSE;
		fBounds := bounds;

		fConstrainsMouse := gConstrainDrags;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.DoIt;

	begin
		MoveBy(fDeltaH, fDeltaV);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeDragger.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeDragger', nil, bClass);
		DoToField('fBounds', @fBounds, bRect);
		DoToField('fDeltaH', @fDeltaH, bInteger);
		DoToField('fDeltaV', @fDeltaV, bInteger);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.MoveBy (deltaH, deltaV: INTEGER);

		procedure MoveShape (shape: TShape);

		begin
			if shape.fIsSelected then
				begin
			{$Push}
					OffSetRect(shape.fExtentRect, deltaH, deltaV);
			{$Pop}
					fShapeView.InvalShape(shape);
				end;
			shape.fWasSelected := shape.fIsSelected;
		end;

	begin
		if fShapeView.Focus then
			;
		fShapeDocument.EachShapeDo(MoveShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.RedoIt;

	begin
		fShapeView.RestoreSelection;

		MoveBy(fDeltaH, fDeltaV);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.TrackConstrain (anchorPoint, previousPoint: VPoint; var nextPoint: VPoint);
		OVERRIDE;

		var
			vhs: VHSelect;
			temp: INTEGER;

	begin
		for vhs := v to h do
			begin
				temp := anchorPoint.vh[vhs] - fBounds.topLeft.vh[vhs];
				nextPoint.vh[vhs] := Max(temp, nextPoint.vh[vhs]);

				temp := fShapeView.fSize.vh[vhs] - (fBounds.botRight.vh[vhs] - anchorPoint.vh[vhs]);
				nextPoint.vh[vhs] := Min(temp, nextPoint.vh[vhs]);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

		var
			aRect: Rect;
			delta: Point;

	begin
		inherited TrackFeedback(anchorPoint, nextPoint, turnItOn, mouseDidMove);
		if mouseDidMove & fShapeView.fDragging then
			begin
				delta.h := nextPoint.h - anchorPoint.h;
				delta.v := nextPoint.v - anchorPoint.v;

				aRect := fBounds;
				OffSetRect(aRect, delta.h, delta.v);

				FrameRect(aRect);								{ draw/erase it }
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TShapeDragger.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;

		procedure EraseShape (shape: TShape);

		begin
			if shape.fIsSelected then
				fShapeView.InvalShape(shape);
		end;

	begin
		TrackMouse := inherited TrackMouse(aTrackPhase, anchorPoint, previousPoint, nextPoint, mouseDidMove);

		if aTrackPhase = trackRelease then					{set up for moving the shape(s)}
			begin
				if fShapeView.fDragging then					{actually did move}
					begin
						fDeltaH := previousPoint.h - anchorPoint.h;
						fDeltaV := previousPoint.v - anchorPoint.v;

						fShapeView.fDragging := FALSE;
					end
				else
					TrackMouse := nil;
			end

		else if aTrackPhase = trackMove then
			if mouseDidMove then
				if not fShapeView.fDragging then			{this is first move}
					begin
						fShapeView.DoHighlightSelection(hlOn, hlOff);
						fShapeDocument.EachVirtualShapeDo(EraseShape);
						fShapeView.fDragging := TRUE;
						fShapeView.GetWindow.Update;
						if fShapeView.Focus then
							;				{UpdateEvent changes the focus - restore it}
					end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeDragger.UndoIt;

	begin
		fShapeView.RestoreSelection;

		MoveBy(-fDeltaH, -fDeltaV);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TReshadeCmd.IReshadeCmd (itsCmdNumber: INTEGER; itsShapeView: TShapeView; thePatternsPalette, menuPatternsPalette, floatingPatternsPalette: TPatternsPalette; theMouse: Point);

		var
			hitVPt: VPoint;
			hitPt: Point;

	{	trackingPatternsPalette is the view we're tracking in}
{		floatingPatternsPalette is the view that's in the floating window}
	begin
		ICommand(cChangeShade, nil, thePatternsPalette, nil);
		fShapeView := itsShapeView;
		fShapeDocument := itsShapeView.fShapeDocument;
		fMenuPatternsPalette := menuPatternsPalette;
		fFloatingPatternsPalette := floatingPatternsPalette;
		fPattern := itsCmdNumber - cPatterns;
		fExitTracking := FALSE;
		fViewConstrain := FALSE;
		fTracksMouse := TRUE;

		PtToVPt(theMouse, hitVPt);
		thePatternsPalette.LocalToWindow(hitVPt);
		hitPt := VPtToPt(hitVPt);
		LocalToGlobal(hitPt);
		fInitialPt := hitPt;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TReshadeCmd.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;
		OVERRIDE;

	begin
		TrackMouse := SELF;
		if gTrackingInMenu then
			begin
		{ quit tracking when the mouse leaves the view }
{		  - if gTrackingInMenu is TRUE, view constrain is set to FALSE, so nextPoint CAN leave the view}
{		  - all other times, view constrain is TRUE, so nextPoint WON'T leave the view}
				if (fView <> nil) & (fView.IsShown) then
					fExitTracking := not fView.ContainsMouse(nextPoint);

		{ if gTrackingInMenu is TRUE, then fExitTracking might get set to TRUE above meaning that the user}
{		is either returning to the menubar or trying to tear off this menu, so simply return NIL when}
{		we're done tracking and the tracker will be freed by TApplication.TrackMouse}
				if (aTrackPhase = trackRelease) & fExitTracking then
					TrackMouse := nil;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TReshadeCmd.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

	begin
	{ all we really want to do here is let the view give us some feedback, so...}
		if (fView <> nil) & (fView.IsShown) & mouseDidMove then
			fView.TrackFeedback(anchorPoint, nextPoint, turnItOn, mouseDidMove);

	{ When we're selecting a pattern (ie turning it on) then this command needs to know}
{	about the new selection. When we're deselecting a pattern (ie turning it off) then this command}
{	MUST ignore the deselection since MacApp's tracking will turn off the current selection as part}
{	of its default tracking behavior even when the user has made a valid selection in the view.}
		if turnItOn then
			fPattern := TPatternsPalette(fView).fSelectedPattern;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TReshadeCmd.IsDoneTracking: BOOLEAN;
		OVERRIDE;

	begin
		IsDoneTracking := not StillDown | fExitTracking;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TReshadeCmd.DoIt;

		procedure ReshadeShape (shape: TShape);

		begin
			if shape.fIsSelected then
				begin
					shape.fOldPattern := shape.fPattern;
					shape.fPattern := fPattern;
					fShapeView.InvalShape(shape);
				end;
			shape.fWasSelected := shape.fIsSelected;
		end;

	begin
	{ tell the patterns view in the menu which pattern is selected }
		if (fMenuPatternsPalette <> nil) then
			begin
				fMenuPatternsPalette.fOldPattern := fMenuPatternsPalette.fCurrPattern;
				fMenuPatternsPalette.fCurrPattern := fPattern;
			end;

	{ tell the floating window which pattern is selected }
		if (fFloatingPatternsPalette <> nil) then
			begin
				fFloatingPatternsPalette.fOldPattern := fFloatingPatternsPalette.fCurrPattern;
				fFloatingPatternsPalette.SelectNewPattern(fPattern);
			end;

		if fShapeView <> nil then
			begin
				if fShapeView.Focus then
					;
				fShapeDocument.EachShapeDo(ReshadeShape);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TReshadeCmd.RedoIt;

		procedure ReshadeShape (shape: TShape);

		begin
			if shape.fWasSelected then
				begin
					shape.fOldPattern := shape.fPattern;
					shape.fPattern := fPattern;
					fShapeView.InvalShape(shape);
				end;
			shape.fIsSelected := shape.fWasSelected;
		end;

	begin
	{ tell the floating window which pattern is selected }
		if (fFloatingPatternsPalette <> nil) then
			fFloatingPatternsPalette.SelectNewPattern(fPattern);

		if fShapeView <> nil then
			begin
				if fShapeView.Focus then
					;
				fShapeView.Deselect;
				fShapeDocument.EachShapeDo(ReshadeShape);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TReshadeCmd.UndoIt;

		procedure ReshadeShape (shape: TShape);

		begin
			if shape.fWasSelected then
				begin
					shape.fPattern := shape.fOldPattern;
					fShapeView.InvalShape(shape);
				end;
			shape.fIsSelected := shape.fWasSelected;
		end;

	begin
	{ tell the floating window which pattern *was* selected }
		if (fFloatingPatternsPalette <> nil) then
			fFloatingPatternsPalette.SelectNewPattern(fFloatingPatternsPalette.fOldPattern);

		if fShapeView <> nil then
			begin
				if fShapeView.Focus then
					;
				fShapeView.Deselect;
				fShapeDocument.EachShapeDo(ReshadeShape);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TRecolorCmd.IRecolorCmd (itsColor: RGBColor; itsShapeView: TShapeView);

	begin
		IShapeCommand(cChangeColor, itsShapeView, not kBetterFeedbackDesired);
		fColor := itsColor;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TRecolorCmd.DoIt;

		procedure RecolorShape (shape: TShape);

		begin
			if shape.fIsSelected then
				begin
					shape.fOldColor := shape.fColor;
					shape.fColor := fColor;
					fShapeView.InvalShape(shape);
				end;
			shape.fWasSelected := shape.fIsSelected;
		end;

	begin
		if fShapeView.Focus then
			;
		fShapeDocument.EachShapeDo(RecolorShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TRecolorCmd.RedoIt;

		procedure RecolorShape (shape: TShape);

		begin
			if shape.fWasSelected then
				begin
					shape.fOldColor := shape.fColor;
					shape.fColor := fColor;
					fShapeView.InvalShape(shape);
				end;
			shape.fIsSelected := shape.fWasSelected;
		end;

	begin
		if fShapeView.Focus then
			;
		fShapeView.Deselect;
		fShapeDocument.EachShapeDo(RecolorShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TRecolorCmd.UndoIt;

		procedure RecolorShape (shape: TShape);

		begin
			if shape.fWasSelected then
				begin
					shape.fColor := shape.fOldColor;
					fShapeView.InvalShape(shape);
				end;
			shape.fIsSelected := shape.fWasSelected;
		end;

	begin
		if fShapeView.Focus then
			;
		fShapeView.Deselect;
		fShapeDocument.EachShapeDo(RecolorShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeReplaceCommand.Commit;
		OVERRIDE;

		procedure HandleIt (aShape: TShape);

		begin
			if aShape.fWasSelected then
				fShapeDocument.DeleteShape(aShape);
		end;

	begin
		if fShapeDocument.fFiltering then
			fShapeDocument.EachShapeDo(HandleIt);
		fShapeDocument.fFiltering := FALSE;
		fShapeDocument.fReplaceCommand := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeReplaceCommand.EachNewShapeDo (procedure DoThis (shape: TShape));

	begin
	end;

{--------------------------------------------------------------------------------------------------}


	function TShapeReplaceCommand.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;

	begin
		FirstShapeThat := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeReplaceCommand.RedoIt;
		OVERRIDE;

	begin
		if fShapeDocument.fFiltering then
			fShapeView.RestoreSelection;
		fShapeDocument.fReplaceCommand := SELF;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeReplaceCommand.UndoIt;
		OVERRIDE;

	begin
		fShapeView.RestoreSelection;
		fShapeDocument.fReplaceCommand := nil;
		fShapeDocument.fFiltering := FALSE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeSketcher.IShapeSketcher (aShapeView: TShapeView; protoShape: TShape; constrain: BOOLEAN);

	begin
		IShapeCommand(cNewShape, aShapeView, gBetterFeedback);
		fShape := protoShape;
		fConstrainsMouse := constrain;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.Free;

	begin
		FreeIfObject(fShape);
		fShape := nil;

		inherited Free;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.DoIt;

		var
			pMCEntry: MCEntryPtr;

	begin
		fShape.fIsSelected := TRUE;
		fShape.fPattern := 1 + ABS(Random mod kTotalPatterns);
		if qNeedsColorQD | gConfiguration.hasColorQD then
	{ Pick a random color from the Color menu }
			begin
				pMCEntry := GetMCEntry(mColor, ABS(Random mod CountMItems(GetMHandle(mColor))) + 1);
				fShape.fColor := pMCEntry^.mctRGB2;
			end
		else
			fShape.fColor := gRGBBlack; 					{ Set color to black }

		fShapeDocument.fReplaceCommand := SELF;
		fShapeView.InvalShape(fShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.UndoIt;

	begin
		inherited UndoIt;
		fShapeView.InvalShape(fShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.RedoIt;

	begin
		if fShapeView.Focus then
			;
		fShapeView.Deselect;
		inherited RedoIt;
		fShape.fIsSelected := TRUE;
		fShapeView.InvalShape(fShape);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.Commit;

	begin
		fShapeDocument.AddShape(fShape);					{ Add the shape to the list }
	{ Set this field to NIL to prevent Free from freeing it}
		fShape := nil;
		inherited Commit;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapeSketcher.EachNewShapeDo (procedure DoThis (shape: TShape));
		OVERRIDE;

	begin
		DoThis(fShape); 									{ there's only one shape }
	end;

{--------------------------------------------------------------------------------------------------}


	function TShapeSketcher.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;
		OVERRIDE;

	begin
		if TestShape(fShape) then							{ there's only one shape to test }
			FirstShapeThat := fShape
		else
			FirstShapeThat := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TShapeSketcher.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

	begin
		DoToField('TShapeSketcher', nil, bClass);
		DoToField('fShape', @fShape, bRect);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.TrackConstrain (anchorPoint, previousPoint: VPoint; var nextPoint: VPoint);
		OVERRIDE;

		var
			dh: INTEGER;
			dv: INTEGER;
			absDh: INTEGER;
			absDv: INTEGER;
			delta: INTEGER;

	begin
		dh := nextPoint.h - anchorPoint.h;
		dv := nextPoint.v - anchorPoint.v;
		absDh := ABS(dh);
		absDv := ABS(dv);
		delta := Min(absDh, absDv);
		if dh < 0 then
			dh := -delta
		else
			dh := delta;
		if dv < 0 then
			dv := -delta
		else
			dv := delta;
		nextPoint.h := anchorPoint.h + dh;
		nextPoint.v := anchorPoint.v + dv;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeSketcher.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

	begin
		inherited TrackFeedback(anchorPoint, nextPoint, turnItOn, mouseDidMove);
		if mouseDidMove & (fShape <> nil) then
			fShape.DrawOutline; 							{ draw/erase }
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	function TShapeSketcher.TrackMouse (aTrackPhase: TrackPhase; var anchorPoint, previousPoint, nextPoint: VPoint; mouseDidMove: BOOLEAN): TCommand;

		var
			aVRect: VRect;
			r: Rect;
			size: Point;
			bigEnough: BOOLEAN;

	begin
		TrackMouse := inherited TrackMouse(aTrackPhase, anchorPoint, previousPoint, nextPoint, mouseDidMove);

		if aTrackPhase = trackRelease then					{create the new shape}
			begin
				bigEnough := FALSE;

				size.h := nextPoint.h - anchorPoint.h;
				size.v := nextPoint.v - anchorPoint.v;
				if ABS(size.h) >= kMinWidth then
					if ABS(size.v) >= kMinHeight then
						bigEnough := TRUE;

				if not bigEnough then
					begin
						FreeIfObject(fShape);
						fShape := nil;

						TrackMouse := nil;
					end;
			end
		else
			begin
				Pt2VRect(anchorPoint, nextPoint, aVRect);
				VRectToRect(aVRect, r); 						{ okay because we know the view's size is in}
{														 QD dimensions}
				fShape.fExtentRect := r;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeCutCopyCommand.IShapeCutCopyCommand (itsCmdNumber: CmdNumber; itsShapeView: TShapeView);

	begin
		IShapeCommand(itsCmdNumber, itsShapeView, not kBetterFeedbackDesired);
		fChangesClipboard := TRUE;
		fCausesChange := itsCmdNumber = cCut;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeCutCopyCommand.DoIt;

		var
			succeeded: BOOLEAN;
			clipShapeView: TShapeView;
			clipDoc: TShapeDocument;
			selTopLeft: Point;
			count: INTEGER;
			outline: Rect;
			fi: FailInfo;

{--------------------------------------------------------------------------------------------------}

		procedure CopyToClip (shape: TShape);

			var
				aNewShape: TShape;
				r: Rect;

		begin
			if shape.fIsSelected then
				begin
					aNewShape := TShape(shape.Clone);
					FailNil(aNewShape);
					with aNewShape do
						begin
							fIsSelected := FALSE;
							fWasSelected := FALSE;
						end;
					r := aNewShape.fExtentRect;
					OffSetRect(r, gClipMargin.h - outline.left, gClipMargin.v - outline.top);
					aNewShape.fExtentRect := r;

					clipDoc.AddShape(aNewShape);
				end;
		end;

		procedure HdlFailure (error: OSErr; message: LONGINT);

		begin
			FreeIfObject(clipDoc);
			clipDoc := nil;
		end;

	begin												{ TShapeCutCopyCommand.DoIt }
		fShapeView.SaveSelection(fCmdNumber = cCut);		{don't inval if it's just COPY}
		New(clipDoc);
		FailNil(clipDoc);
		clipDoc.IShapeDocument(kDocType);

		CatchFailures(fi, HdlFailure);
		fShapeDocument.SurveyShapes(TRUE, count, outline);

		New(clipShapeView);
		FailNil(clipShapeView);
		clipShapeView.IShapeView(clipDoc, nil, TRUE);

	{ Set fShapeView since the doc will NOT be told to DoMakeViews }
		clipDoc.fShapeView := clipShapeView;

		if fCmdNumber = cCut then
			if fShapeView.Focus then
				;

		fShapeDocument.EachShapeDo(CopyToClip);
		clipShapeView.AdjustSize;

	{ Make sure the Cut left us with enough memory to continue. }
		FailSpaceIsLow;
		Success(fi);

		gApplication.ClaimClipboard(clipShapeView);

		fShapeDocument.fFiltering := (fCmdNumber <> cCopy);

		fShapeDocument.fReplaceCommand := SELF;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeCutCopyCommand.RedoIt;

	begin
		fShapeDocument.fFiltering := (fCmdNumber <> cCopy);
		inherited RedoIt;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapePasteCommand.IShapePasteCommand (itsShapeView: TShapeView);

		var
			fi: FailInfo;

		procedure HdlFailure (error: OSErr; message: LONGINT);

		begin
			FreeIfObject(SELF);
		end;

	begin
		fPasteList := nil;									{ So free works when we can't allocated it }
		IShapeCommand(cPaste, itsShapeView, not kBetterFeedbackDesired);
		CatchFailures(fi, HdlFailure);
		fPasteList := NewList;
		Success(fi);
	{$IFC qDebug}
		fPasteList.SetEltType('TShape');
	{$ENDC}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapePasteCommand.Commit;
		OVERRIDE;

		var
			theShape: TShape;

	begin
		if gPasteReplacesSelection then
			inherited Commit;								{Deletes old selectees from the document}

 { The following loop transfers shapes from fPasteList to the document's}
{   shape list, in such a way that fPasteList is shrunk while the}
{   document's shape list is grown.  This helps prevent running out}
{   of memory when committing a Paste command.}
		theShape := TShape(fPasteList.First);
		while theShape <> nil do
			begin
				fPasteList.Delete(theShape);
				fShapeDocument.AddShape(theShape);
				theShape := TShape(fPasteList.First);
			end;

		fShapeDocument.fReplaceCommand := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapePasteCommand.DoIt;
		OVERRIDE;

		var
			whereToPaste: Point;
			noOfShapes: INTEGER;
			translation: VPoint;
			t: INTEGER;
			vhs: VHSelect;
			extent: Rect;
			scrollerExtent: VRect;

		procedure PasteShape (clipShape: TShape);

			var
				aShape: TShape;

		begin
			aShape := TShape(clipShape.Clone);
			FailNil(aShape);
			with aShape do
				begin
					fIsSelected := TRUE;
					fWasSelected := TRUE;
			{$Push}
					OffSetRect(fExtentRect, whereToPaste.h, whereToPaste.v);
			{$Pop}
				end;
			fPasteList.InsertLast(aShape);
			fShapeView.InvalShape(aShape);
		end;

	begin
	{$IFC qDebug}
		if not Member(gClipView, TShapeView) then
			ProgramBreak('Attempt to paste a non-TShapeView clipboard');
	{$ENDC}

 { The next section figures out where the pasted shapes should be placed}
{   in the view. Lovely, isn't it?}
		if gPasteReplacesSelection then
			begin
		{ If we're replacing shapes, then paste the new shapes starting at}
{		  the top-left corner of the replaced shapes. Otherwise, start}
{		  at the last clicked point in the view}
				fShapeDocument.SurveyShapes(TRUE, noOfShapes, extent);
				if noOfShapes > 0 then
					whereToPaste := extent.topLeft
				else
					whereToPaste := fShapeView.fClickPt;
			end
		else
			begin
				fShapeView.fSuperView.GetExtent(scrollerExtent);
				for vhs := v to h do
					with scrollerExtent.topLeft do
						begin
				{ temp var "t" needed because Code Generator finds the}
{				  following expression too complex}
							t := (scrollerExtent.botRight.vh[vhs] + vh[vhs] - gClipView.fSize.vh[vhs]) div 2; {scrollerExtent.}
							whereToPaste.vh[vhs] := Max(vh[vhs], t);			{translation.}
						end;
			end;
		SubPt(gClipMargin, whereToPaste);

		fShapeView.SaveSelection(gPasteReplacesSelection);
		fShapeView.Deselect;

		TShapeView(gClipView).fShapeDocument.EachShapeDo(PasteShape);

		fShapeDocument.fFiltering := gPasteReplacesSelection;
		fShapeDocument.fReplaceCommand := SELF;
		fShapeView.AdjustSize;								{Make sure all the Pasted shapes can be}
{														 seen}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapePasteCommand.Free;
		OVERRIDE;

	begin
		fPasteList := FreeListIfObject(fPasteList); 		{Free the TList object itself}

		inherited Free;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TShapePasteCommand.EachNewShapeDo (procedure DoThis (shape: TShape));

	begin
		fPasteList.Each(DoThis);
	end;

{--------------------------------------------------------------------------------------------------}


	function TShapePasteCommand.FirstShapeThat (function TestShape (aShape: TShape): BOOLEAN): TShape;

	begin
		FirstShapeThat := TShape(fPasteList.FirstThat(TestShape));
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapePasteCommand.UndoIt;
		OVERRIDE;

{--------------------------------------------------------------------------------------------------}

		procedure BeInvalidated (theShape: TShape);

		begin
			fShapeView.InvalShape(theShape);
		end;

	begin
		inherited UndoIt;
		EachNewShapeDo(BeInvalidated);
		if fShapeView.Focus then
			;
		fShapeDocument.fFiltering := FALSE;
		fShapeView.AdjustSize;								{In case we replaced shapes when we Pasted}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapePasteCommand.RedoIt;
		OVERRIDE;

		procedure BeSelected (shape: TShape);

		begin
			shape.fIsSelected := TRUE;
			fShapeView.InvalShape(shape);
		end;

	begin
		if fShapeView.Focus then
			;
		fShapeView.Deselect;
		EachNewShapeDo(BeSelected); 						{Invalidate all the newly-added shapes}
		fShapeDocument.fFiltering := gPasteReplacesSelection;
		inherited RedoIt;
		fShapeView.AdjustSize;								{Make sure size reflects the Paste}
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	procedure TShapeClearCommand.IShapeClearCommand (itsShapeView: TShapeView);

	begin
		IShapeCommand(cClear, itsShapeView, not kBetterFeedbackDesired);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeClearCommand.DoIt;

	begin
		fShapeView.SaveSelection(TRUE); 					{TRUE means invalidate the shapes}
		fShapeDocument.fFiltering := TRUE;
		fShapeDocument.fReplaceCommand := SELF;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ADoCommand}

	procedure TShapeClearCommand.RedoIt;

	begin
		fShapeDocument.fFiltering := TRUE;
		inherited RedoIt;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AInit}

	procedure TPatternsMenu.IPatternsMenu;

		var
			aPatternsPalette: TPatternsPalette;

	begin
		ITearOffMenu(mPatterns, kWPatternsChoice, kHPatternsChoice, gPatternsWindow);

		New(aPatternsPalette);
		FailNIL(aPatternsPalette);
		aPatternsPalette.IPatternsPalette(SELF);
		aPatternsPalette.fIdentifier := 'MPLT';		{ identifies the patterns palette in the menu }
	end;

{--------------------------------------------------------------------------------------------------}
{$S AInit}

	procedure TToolsMenu.IToolsMenu;

		var
			aToolsPalette: TToolsPalette;

	begin
		ITearOffMenu(mTools, kToolsPaletteWidth, kToolsPaletteHeight, gToolsPaletteWindow);

		New(aToolsPalette);
		FailNIL(aToolsPalette);
		aToolsPalette.IToolsPalette(nil, SELF);
		aToolsPalette.fIdentifier := 'MTUL';
	end;

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TPatternsPalette.IPatternsPalette (itsSuperview: TView);

		var
			itsSize: VPoint;

	begin
		SetVPt(itsSize, kWPatternsChoice, kHPatternsChoice);
		IView(nil, itsSuperview, gZeroVPt, itsSize, sizeFixed, sizeFixed);

		fCurrPattern := 0;									{ the pattern currently selected by user }
		fSelectedPattern := 0;								{ the pattern selected by user during tracking }
		fHLDesired := hlOn;

		BuildChoiceArray;
		BuildFramesArray;
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qTemplateViews}
{$S AOpen}

	procedure TPatternsPalette.IRes (itsDocument: TDocument; itsSuperview: TView; var itsParams: Ptr);
		OVERRIDE;

		var
			r: Rect;
			choiceID: INTEGER;
			i: INTEGER;
			j: INTEGER;

	begin
		inherited IRes(itsDocument, itsSuperview, itsParams);

		fCurrPattern := 0;									{ the pattern currently selected by user }
		fSelectedPattern := 0;								{ the pattern selected by user during tracking }
		fHLDesired := hlOn;

		BuildChoiceArray;
		BuildFramesArray;
	end;

{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S AOpen}

	procedure TPatternsPalette.BuildChoiceArray;

		var
			r: Rect;
			choiceID: INTEGER;
			i: INTEGER;
			j: INTEGER;

	begin
	{ Create the Pattern choice rectangles that hold the Patterns }
		SetRect(r, 0, 0, kWPatternsCell, kHPatternsCell);
		choiceID := 1;
		for i := 1 to kPatternsAcross do					{all the rectangles across}
			begin
				for j := 1 to kPatternsDown do					{all the rectangles down}
					begin
						fChoiceArray[choiceID] := r;
						OffSetRect(r, 0, kHPatternsCell + kFrameWidth);
						choiceID := choiceID + 1;
					end;
		{ move rectangle over one column }
				SetRect(r, r.right + kFrameWidth, 0, r.right + kFrameWidth + kWPatternsCell, kHPatternsCell);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S AInit}

	procedure TPatternsPalette.BuildFramesArray;

		var
			i: INTEGER;
			theMenuColors: MenuColors;
			tempRect: Rect;

	begin
	{ build the vertical borders between the patterns }
		tempRect := gZeroRect;
		tempRect.bottom := kHPatternsChoice;
		tempRect.left := kWPatternsCell;
		tempRect.right := kWPatternsCell + kFrameWidth;
		for i := 1 to kVerticalFrames do
			begin
				fFramesArray[i] := tempRect;
				OffSetRect(tempRect, kWPatternsCell + kFrameWidth, 0);
			end;

	{ build the horizontal borders between the patterns }
		tempRect := gZeroRect;
		tempRect.right := kWPatternsChoice;
		tempRect.top := kHPatternsCell;
		tempRect.bottom := kHPatternsCell + kFrameWidth;
		for i := 1 to kHorizontalFrames do
			begin
				fFramesArray[i + kVerticalFrames] := tempRect;
				OffSetRect(tempRect, 0, kHPatternsCell + kFrameWidth);
			end;
	end;


{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TPatternsPalette.TrackFeedback (anchorPoint, nextPoint: VPoint; turnItOn, mouseDidMove: BOOLEAN);

		var
			r: Rect;
			qdPt: Point;
			i: INTEGER;

		procedure TurnOffPattern (patternRect: Rect; whichPattern: INTEGER);

		begin
		{ only turn it off if it's already on }
			if fSelectedPattern = whichPattern then
				begin
					PenNormal;
					FillRect(patternRect, gPat[whichPattern]);	{ draw pattern }
					InsetRect(patternRect, -1, -1);				{ draw frame }
					FrameRect(patternRect);
					FrameCurrPattern;							{ frame for current pattern }

					fSelectedPattern := 0;						{ remember the pattern currently selected }
				end;
		end;

		procedure TurnOnPattern (patternRect: Rect; whichPattern: INTEGER);

		begin
		{ only turn it on if it's not already on }
			if fSelectedPattern <> whichPattern then
				begin
					PenNormal;
					PenMode(patXOr);
					InsetRect(patternRect, -1, -1);
					PenSize(2, 2);
					FrameRect(patternRect);

					fSelectedPattern := whichPattern;			{ remember the pattern currently selected }
				end;
		end;

	begin
		if Focus then
			;
		qdPt := ViewToQDPt(nextPoint);
		for i := 1 to kTotalPatterns do
			begin
				r := fChoiceArray[i];
				if PtInRect(qdPt, r) then
					begin
						if turnItOn then
							TurnOnPattern(r, i)
						else
							TurnOffPattern(r, i);
						LEAVE;
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TPatternsPalette.FrameCurrPattern;
{ frame the currently selected pattern }

		var
			r: Rect;

	begin
		if fCurrPattern <> 0 then	{ frame selected pattern, if any }
			begin
				r := fChoiceArray[fCurrPattern];

				PenMode(patCopy);
				InsetRect(r, -1, -1);
				FrameRect(r);								{ frame it }
				InsetRect(r, -3, -3);						{ outer white frame }
				PenSize(3, 3);
				PenPat(white);
				FrameRect(r);
				InsetRect(r, -1, -1);						{ outer black frame }
				PenSize(1, 1);
				PenPat(black);
				FrameRect(r);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TPatternsPalette.DoHighlightSelection (fromHL, toHL: HLState);

		var
			r: Rect;

	begin
		if (fCurrPattern >= 1) & (fCurrPattern <= kTotalPatterns) then
			case toHL of
				hlOff: 
					begin
						r := fChoiceArray[fCurrPattern];
						InsetRect(r, -5, -5);
						Draw(r);
					end;
				hlOn: 
					FrameCurrPattern;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TPatternsPalette.SelectNewPattern (whichPattern: INTEGER);

	begin
		if IsShown then
			begin
				if Focus then
					;
				DoHighlightSelection(hlOn, hlOff);
				fCurrPattern := whichPattern;
				DoHighlightSelection(hlOff, hlOn);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

	function TPatternsPalette.DoMouseCommand (var theMouse: Point; var info: EventInfo; var hysteresis: Point): TCommand;

		var
			aReshadeCmd: TReshadeCmd;
			aShapeView: TShapeView;
			aWindow: TWindow;
			menuPatternsView: TPatternsPalette;
			floatingPatternsView: TPatternsPalette;

	begin
		DoMouseCommand := nil;

		New(aReshadeCmd);
		FailNIL(aReshadeCmd);

	{ find the active TShapeView }
		aShapeView := nil;
		aWindow := gApplication.GetActiveWindow;
		if (aWindow <> nil) then
			aShapeView := TShapeView(aWindow.FindSubview('SHAP'));

		menuPatternsView := nil;
		if (gPatternsMenu <> nil) then
			menuPatternsView := TPatternsPalette(gPatternsMenu.FindSubview('MPLT'));

		floatingPatternsView := nil;
		if (gPatternsWindow <> nil) & gPatternsWindow.IsShown then
			floatingPatternsView := TPatternsPalette(gPatternsWindow.FindSubview('PPLT'));

		aReshadeCmd.IReshadeCmd(cPatterns, aShapeView, SELF, menuPatternsView, floatingPatternsView, theMouse);

		PostCommand(aReshadeCmd);
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	function TPatternsPalette.DoSetCursor (localPoint: Point; cursorRgn: RgnHandle): BOOLEAN;
		OVERRIDE;

		var
			qdExtent: Rect;

	begin
		SetCursor(arrow);
		GetQDExtent(qdExtent);
		RectRgn(cursorRgn, qdExtent);
		DoSetCursor := TRUE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

	procedure TPatternsPalette.Draw (area: Rect);

		var
			i: INTEGER;
			r, tempRect, drawRect: Rect;

	begin
	{ draw the frames }
		for i := 1 to kTotalFrames do
			begin
				r := fFramesArray[i];
				if SectRect(r, area, drawRect) then
					FrameRect(drawRect);
			end;

	{ draw the Patterns }
		for i := 1 to kTotalPatterns do
			begin
				r := fChoiceArray[i];
				if SectRect(r, area, drawRect) then
					FillRect(drawRect, gPat[i]);
			end;

		inherited Draw(area);
	end;

{--------------------------------------------------------------------------------------------------}
{$S AFields}

	procedure TPatternsPalette.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER));
		OVERRIDE;

		var
			i: INTEGER;
			str: Str255;

	begin
		DoToField('TPatternsPalette', nil, bClass);
		DoToField('fCurrPattern', @fCurrPattern, bInteger);
		for i := 1 to kTotalPatterns do
			begin
				NumToString(i, str);
				DoToField(Concat('fChoiceArray[', str, ']'), @fChoiceArray[i], bRect);
			end;
		inherited Fields(DoToField);
	end;


end.