{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}
{	This file has then been modified to support floaters with MacApp 2.0. }

{}
{}
{	This file is a shell for UMacApp's TView.p include file.}
{	}
{	}
{	Rich Siegel, 8/22/89}
{}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := FALSE}
{$ENDC}

unit UMacAppTWindow;

interface

	uses
		SysEqu, Traps, ULoMem, UMacAppUtilities, UPatch, UObject, UList, UViewCoords, UMemory, UFailure, UMenuSetup, 
{$SETC __UMacApp__ := TRUE}
{  MacApp }







		UAssociation,
{  Implementation use }

		UBusyCursor, 

		UDebug, 
{$IFC qInspector}
		UInspector, 
{$ENDC}
		FixMath, Script, PasLibIntf,
{RMS 8/22/89 added USES of UMacApp}
		UMacApp;

implementation


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UMacApp.TWindow.p }
{ Copyright  1987-1990 by Apple Computer Inc.	All rights reserved. }

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TCloseWindowCommand.DoIt;

	begin
		if fView <> nil then
			TWindow(fView).CloseByUser;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	procedure TCloseWindowCommand.ICloseWindowCommand (itsCmdNumber: CmdNumber; itsWindow: TWindow);

	begin
		INoChangesCommand(itsCmdNumber, nil, itsWindow, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TCloseWindowCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TCloseWindowCommand', nil, bClass);

		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.IWindow (itsDocument: TDocument; itsWMgrWindow: WindowPtr; canResize, canClose, disposeOnFree: BOOLEAN);

		var
			preDocname: integer;
			constTitle: integer;
			aString: Str255;
			fi: FailInfo;
			p: Point;
			vp: VPoint;

		procedure HandleFailure (error: OSErr; message: LONGINT);

		begin
			Free;
		end;

		function GetSetVPt (v, h: VCoordinate): VPoint;

			var
				aVPt: VPoint;

		begin
			aVPt.v := v;
			aVPt.h := h;
			GetSetVPt := aVPt;
		end;

	begin
	{ set up fields necessary to free myself }
		fWMgrWindow := itsWMgrWindow;
		fFreeOnClosing := FALSE;
		fDisposeOnFree := disposeOnFree;

		SetPort(GetGrafPort);								{ ??? Why is this necessary? }
		with fWMgrWindow^.portRect do
			begin
				p := topleft;
				LocalToGlobal(p);
				PtToVPt(p, vp);
				IView(itsDocument, nil, vp, GetSetVPt(bottom - top, right - left), SizeVariable, SizeVariable);
			end;

		fProcID := GetWRefCon(itsWMgrWindow);
		SetWRefcon(itsWMgrWindow, LONGINT(SELF));

		fHideOnSuspend := FALSE;
		fAdapted := FALSE;									{ Set by AdaptToScreen }
		fHorzCentered := FALSE; 							{ Set by Center }
		fVertCentered := FALSE; 							{ Set by Center }
		fStaggered := FALSE;								{ Set by SimpleStagger }
		fForcedOnScreen := FALSE;							{ Set by ForceOnScreen }

	{ We can't tell if any changing will be required so we just set these false here.}
{	If the developer sets them true then we respect them or if the developer calls the}
{	corresponding functions we set them.}
		fMustAdapt := FALSE;
		fMustHorzCenter := FALSE;
		fMustVertCenter := FALSE;
		fMustStagger := FALSE;
		fMustForceOnScreen := FALSE;

		fIsActive := FALSE;
		fIsResizable := canResize;
		fIsClosable := canClose;
		fTarget := SELF;
		fTargetID := fIdentifier;
		fClosesDocument := TRUE;
		fOpenInitially := TRUE;
		fIsModal := FALSE;
		fDoFirstClick := FALSE;
		fFloats := FALSE;
		if BuildWindowRgns(BuildWindowRgns(kBuild)) then
			;	{ sets fContRgnInset & fContDifference }

		CatchFailures(fi, HandleFailure);

		fMoveBounds := gStdWMoveBounds;
		SetResizeLimits(gStdWSizeRect.topleft, gStdWSizeRect.botRight);
		GetTitle(aString);
		if ParseTitleTemplate(aString, preDocname, constTitle) then
			SetWTitle(itsWMgrWindow, aString);
		fPreDocname := preDocname;
		fConstTitle := constTitle;

		InstallDocument(itsDocument);

		Success(fi);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.IRes (itsDocument: TDocument; itsSuperView: TView; var itsParams: Ptr);

		var
			bounds: Rect;
			aWMgrWindow: WindowPtr;
			preDocname: integer;
			constTitle: integer;
			aString: Str255;
			fi: FailInfo;
			behind: WindowPtr;

		procedure HandleFailure (error: OSErr; message: LONGINT);

		begin
			Free;
		end;

	begin
	{ set up fields necessary to free myself }
		fWMgrWindow := nil;
		fFreeOnClosing := FALSE;
		fDisposeOnFree := TRUE;

		inherited IRes(itsDocument, itsSuperView, itsParams);

		SetRect(bounds, fLocation.h, fLocation.v, fLocation.h + fSize.h, fLocation.v + fSize.v);

		with WindowTemplatePtr(itsParams)^ do
			begin
				CatchFailures(fi, HandleFailure);

				fProcID := procID;

				if isModal then
					behind := WindowPtr(-1)
				else
					behind := GetBehindWindowPtr;
				if qNeedsColorQD | gConfiguration.hasColorQD then
					aWMgrWindow := WindowPtr(NewCWindow(nil, bounds, title, FALSE, procID, behind, hasGoAway, ORD4(SELF)))
				else
					aWMgrWindow := NewWindow(nil, bounds, title, FALSE, procID, behind, hasGoAway, ORD4(SELF));
				fWMgrWindow := aWMgrWindow;

				fHideOnSuspend := FALSE;
				fAdapted := FALSE;								{ Set by AdaptToScreen }
				fHorzCentered := FALSE; 						{ Set by Center }
				fVertCentered := FALSE; 						{ Set by Center }
				fStaggered := FALSE;							{ Set by SimpleStagger }
				fForcedOnScreen := FALSE;						{ Set by ForceOnScreen }
				fIsActive := FALSE;
				fIsResizable := resizable;
				fIsClosable := hasGoAway;
				fTarget := SELF;
				fTargetID := targetID;
				fIsModal := isModal;
				fDoFirstClick := doFirstClick;
				fFreeOnClosing := freeOnClosing;
				fDisposeOnFree := disposeOnFree;
				fClosesDocument := closesDocument;
				fOpenInitially := openInitially;
				fMoveBounds := gStdWMoveBounds;
				SetResizeLimits(gStdWSizeRect.topleft, gStdWSizeRect.botRight);
				fFloats := FALSE;
				if BuildWindowRgns(BuildWindowRgns(kBuild)) then
					; { sets fContRgnInset & fContDifference }

				GetTitle(aString);
				if ParseTitleTemplate(aString, preDocname, constTitle) then
					SetWTitle(aWMgrWindow, aString);
				fPreDocname := preDocname;
				fConstTitle := constTitle;

				InstallDocument(itsDocument);

				Success(fi);

				fMustAdapt := mustAdaptToScreen;
				fMustHorzCenter := horzCenter;
				fMustVertCenter := vertCenter;
				fMustStagger := stagger;
				fMustForceOnScreen := mustForceOnScreen;

				OffsetPtrWStr(itsParams, SIZEOF(WindowTemplate));
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	function TWindow.GetBehindWindowPtr: WindowPtr;

		var
			behind: WindowPtr;

	begin
		behind := GetLastFloatingWindowPtr;
		if behind = nil then
			behind := WindowPtr(-1);	{ bring the window up in front of all other windows }

		GetBehindWindowPtr := behind;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWriteRes}

	procedure TWindow.WRes (theResource: ViewRsrcHandle; var itsParams: Ptr);
		OVERRIDE;

		var
			theTitle: Str255;
			wnPtr: WindowTemplatePtr;

	begin
		inherited WRes(theResource, itsParams);

		GetTitle(theTitle);

		wnPtr := WindowTemplatePtr(ExpandPtrWStr(theResource, itsParams, SIZEOF(WindowTemplate), LENGTH(theTitle)));

		with wnPtr^ do
			begin
				procID := fProcID;
				hasGoAway := fIsClosable;
				resizable := fIsResizable;
				isModal := fIsModal;
				doFirstClick := fDoFirstClick;
				freeOnClosing := fFreeOnClosing;
				disposeOnFree := fDisposeOnFree;
				closesDocument := fClosesDocument;
				openInitially := fOpenInitially;
				mustAdaptToScreen := fMustAdapt;
				stagger := fMustStagger;
				mustForceOnScreen := fMustForceOnScreen;
				vertCenter := fMustVertCenter;
				horzCenter := fMustHorzCenter;
				targetID := fTargetID;
				CopyStr255(theTitle, PRStr(title));
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWriteRes}

	procedure TWindow.WriteRes (theResource: ViewRsrcHandle; var itsParams: Ptr);
		OVERRIDE;

	begin
		gWResSignature := 'wind';
		gWResType := 'TWindow';
		WRes(theResource, itsParams);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TWindow.Free;
		OVERRIDE;

		var
			disposeOnFree: BOOLEAN;
			wmgrWindow: WindowPtr;

	begin
		disposeOnFree := fDisposeOnFree;
		wmgrWindow := fWMgrWindow;
		fWMgrWindow := nil; 								{ ??? will this help? }

		if fDocument <> nil then
			fDocument.DeleteWindow(SELF)
		else
			gApplication.DeleteFreeWindow(SELF);

		inherited Free;

	{ ****** DON'T REFER TO ANY FIELDS OR METHODS OF SELF ****** }

		wmgrWindow := FreeIfWMgrWindow(wmgrWindow, disposeOnFree);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAActivate}

	procedure TWindow.Activate (entering: BOOLEAN);

		var
			different: BOOLEAN;
			aWindow: TWindow;

	begin
		InvalidateFocus;									{ Must refocus to make sure thePort is set }
		different := entering <> fIsActive;

		if different then
			begin
				Update; 										{ Logically the order is wrong, but it gives}
{														 the correct visual effect. ??? Revisit?}
				inherited Activate(entering);

				if entering then
					begin
						aWindow := gApplication.GetActiveWindow;
						if aWindow <> nil then						{ So lost deactivate doesn't screw up}
{														 gTarget}
							aWindow.Activate(FALSE);
						fIsActive := entering;
						gApplication.SetTarget(fTarget);
					end
				else
					begin
						fIsActive := entering;
						gApplication.SetTarget(gApplication);
						SetCursor(arrow);							{ ensure that the cursor is an arrow when}
{														 MacApp loses control}
					end;
			end;

		if fIsResizable & Focus & IsVisible then
			DrawResizeIcon;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.AdaptToScreen;

		const
			stdHScreen = 512;
			stdVScreen = 342;
			stdScreen = $10000 * stdVScreen + stdHScreen;

		var
			diff: Point;
			windRect: Rect;
			newSize: Point;
			theLimits: Rect;

	begin
		fAdapted := TRUE;									{ We adapted to the screen }
	{ Compute difference between current screen and std Mac screen }
		diff := screenBits.bounds.botRight;
		SubPt(screenBits.bounds.topleft, diff);
		SubPt(Point(stdScreen), diff);
		GetGlobalBounds(windRect);

	{ If screen is larger, enlarge the window. If the window is too large, shrink it }
		if (LONGINT(diff) <> 0) | (windRect.bottom > screenBits.bounds.bottom) | (windRect.right > screenBits.bounds.right) then { do an adjustment for}
{		   larger screen}
			begin
				newSize := windRect.botRight;
				AddPt(diff, newSize);							{ the window adapted to the new screen size}
{}
				theLimits := fResizeLimits;
				with theLimits do
					begin
			{ Consider the location of the window, bound it by the resize limits }
						newSize.v := MinMax(top, newSize.v - windRect.top, bottom);
						newSize.h := MinMax(left, newSize.h - windRect.left, right);
					end;

				Resize(newSize.h, newSize.v, kInvalidate);

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.AllowsMenuAccess: BOOLEAN;

	begin
	{ Default is to always allow menu access, even if modal }
		AllowsMenuAccess := TRUE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function GetAndLoadWDefProc (windowDefProc: Handle): Handle;
{ utility routine: given a windowDefProc, this routine returns its actual address and loads it }

		var
			wDefProc: Handle;

	begin
		wDefProc := Handle(StripLong(windowDefProc));
		if wDefProc^ = nil then
			LoadResource(wDefProc);
		GetAndLoadWDefProc := wDefProc;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function GetWindowVariant (theWindow: WindowPtr): integer;
{ given a windowPtr, this routine returns its variant }

	begin
		if TrapExists(_GetWVariant) then
			GetWindowVariant := GetWVariant(theWindow)
		else
			GetWindowVariant := BAND($0F, BSR(LONGINT(WindowPeek(theWindow)^.windowDefProc), 24));
	end;

{--------------------------------------------------------------------------------------------------}

	function CallWDefProc (varCode: integer; theWindow: WindowPtr; message: integer; param: LONGINT; wDefProc: univ Handle): LONGINT;
	inline
		$205F,										{ MOVE.L (A7)+,A0 }
		$2050,										{ MOVE.L (A0),A0 }
		$4E90;										{ JSR (A0) }

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.Center (horizontally, vertically, forDialog: BOOLEAN);

		var
			windowSize: Point;
			screenSize: Point;
			contentSize: Point;
			bottomRightInset: Point;
			globalbounds, screenRect: Rect;
			rgnsWereBuilt: BOOLEAN;

	begin
		fHorzCentered := horizontally;
		fVertCentered := vertically;
		if (fWMgrWindow <> nil) & (horizontally | vertically) then
			begin
				if GetMaxIntersectedDevice(screenRect) = nil then
					; { don't care about result }
				with screenRect do
					begin
						screenSize.h := right - left;
						screenSize.v := bottom - top;				{ NOTE: GetMaxIntersectedDevice accounts for}
{														 menubar so don't subtract gMbarHeight}
					end;

				with WindowPeek(fWMgrWindow)^ do
					begin
						rgnsWereBuilt := BuildWindowRgns(kBuild);
						with strucRgn^^.rgnBBox do
							begin
								windowSize.h := right - left;
								windowSize.v := bottom - top;
							end;
						if BuildWindowRgns(rgnsWereBuilt) then
							; 	{ discard result }

						GetGlobalBounds(globalbounds);
						with globalbounds do
							begin
								contentSize.h := right - left;
								contentSize.v := bottom - top;
							end;

			{ The top-left content inset isn't enough; factor in the amount to the right of the }
			{ content also. }
						bottomRightInset := windowSize;
						SubPt(contentSize, bottomRightInset);
						SubPt(fContRgnInset, bottomRightInset);
			{$PUSH}
						SubPt(bottomRightInset, fContRgnInset);
			{$POP}
					end;

				with globalbounds do
					begin
						if horizontally then
							left := (screenSize.h - contentSize.h + fContRgnInset.h) div 2;
						if vertically then
							if forDialog then
				{ Put it in the top third of the screen }
								top := ((screenSize.v - contentSize.v + fContRgnInset.v) div 3) + 20
							else
								top := ((screenSize.v - contentSize.v + fContRgnInset.v) div 2) + 20;
					end;
				Locate(globalbounds.left, globalbounds.top, kDontInvalidate);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TWindow.Close;
		OVERRIDE;

	begin
		inherited Close;

		Show(FALSE, kRedraw);
		Activate(FALSE);									{ ??? Is this necessary? }

		if fFreeOnClosing then
			Free;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TWindow.CloseByUser;

	begin
		if fDocument = nil then 							{ free window }
			Close
		else
			fDocument.CloseView(SELF);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	function TWindow.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;
		OVERRIDE;

		var
			aCloseWindowCommand: TCloseWindowCommand;
			oldObjectPerm: BOOLEAN;

	begin
		DoMenuCommand := nil;

		case aCmdNumber of
			cClose: 
				begin
					oldObjectPerm := AllocateObjectsFromPerm(FALSE); { Guarantee the allocation }
					New(aCloseWindowCommand);
					if AllocateObjectsFromPerm(oldObjectPerm) then
						;

					FailNil(aCloseWindowCommand);				{ just in case }
					aCloseWindowCommand.ICloseWindowCommand(aCmdNumber, SELF);
					DoMenuCommand := aCloseWindowCommand;
				end;
			otherwise
				DoMenuCommand := inherited DoMenuCommand(aCmdNumber);
		end;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.DoSetupMenus;
		OVERRIDE;

	begin
		if not fIsModal then								{ Don't enable menu/app commands if modal }
			begin
				Enable(cClose, fIsClosable);					{ window objects take care of themselves! }

				inherited DoSetupMenus;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.DrawContents;
		OVERRIDE;

		var
			visRect: Rect;
		{$IFC qExperimentalAndUnsupported}
			fi: FailInfo;
			oldgEnableDoubleBuffering: Boolean;
		{$EndC}

		procedure HdlDrawContents (error: OSErr; message: LONGINT);

		begin
		{$IFC qExperimentalAndUnsupported}
			gEnableDoubleBuffering := oldgEnableDoubleBuffering;
		{$EndC}
		end;

		procedure DoDrawContents;

			var
				visRect: Rect;

		begin
			if Focus then
				begin
			{ Ensure that the background is correct }
					GetVisibleRect(visRect);
					EraseRect(visRect);

					inherited DrawContents;

			{ Draw the resize icon last so other views don't munch it.}
{			??? Should the resize icon be a subview that is always drawn last?}
					if fIsResizable then
						DrawResizeIcon;
				end;
		end;

	begin
	{$IFC qExperimentalAndUnsupported}
		if Focus & IsVisible then
			begin
				if gEnableDoubleBuffering & not (gPrinting | gDrawingPictScrap) then
					begin
						oldgEnableDoubleBuffering := gEnableDoubleBuffering;
						gEnableDoubleBuffering := FALSE;			{ so subviews won't attempt to do off screen}
{}
						CatchFailures(fi, HdlDrawContents);
						DoOffScreen(DoDrawContents);
						Success(fi);
						gEnableDoubleBuffering := oldgEnableDoubleBuffering;
					end
				else
					DoDrawContents;
			end;
	{$ELSEC}
		DoDrawContents;
	{$EndC}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.DrawResizeIcon;

		var
			r: Rect;

	begin
		if qDebug then
			AssumeFocused;

		GetQDExtent(r);
		r.left := r.right - kSBarSizeMinus1;
		r.top := r.bottom - kSBarSizeMinus1;

	{$IFC qDebug}
		UseTempRgn('TWindow.DrawResizeIcon');
	{$ENDC}

		GetClip(gTempRgn);
		ClipRect(r);
		PenNormal;
		DrawGrowIcon(fWMgrWindow);
		SetClip(gTempRgn);

	{$IFC qDebug}
		DoneWithTempRgn;
	{$ENDC}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.Focus: BOOLEAN;
		OVERRIDE;

{$IFC qDebug OR qExperimentalAndUnsupported}

		var
		{$EndC}
		{$IFC qDebug}
			currentPort: GrafPtr;
		{$ENDC}
		{$IFC qExperimentalAndUnsupported}
			aFocusRec: FocusRec;
		{$EndC}

	begin
		Focus := TRUE;										{ Hope for the best }

		if IsFocused then
			begin
		{$IFC qDebug}
				if LONGINT(GetGrafPort^.portRect.topleft) <> 0 then
					ProgramBreak('TWindow.Focus: Origin is not (0,0)');

				GetPort(currentPort);
				if currentPort <> GetGrafPort then
					begin
						ProgramBreak('TWindow.Focus: Port is incorrect');
						Focus := FALSE
					end;
		{$ENDC}
				Exit(Focus);
			end;

	{$IFC qExperimentalAndUnsupported}
		if fFocusRec.IsValid then
			begin
				aFocusRec := fFocusRec;
				SetFocus(aFocusRec);
				Exit(Focus);
			end;
	{$EndC}

		if (gDrawingPictScrapView = SELF) | ((gCurrPrintHandler <> nil) & (gCurrPrintHandler.fView = SELF)) then
			begin
		{ GrafPort has been supplied }
				gFocusedView := SELF;
			end

		else if fWMgrWindow <> nil then
			begin
				SetPort(GetGrafPort);
				SetOrigin(0, 0);
				gLongOffset := gZeroVPt;
				SetClip(thePort^.visRgn);
				gFocusedView := SELF;

		{$IFC qExperimentalAndUnsupported}
				aFocusRec.clip := fFocusRec.clip;
				GetFocus(aFocusRec);
				fFocusRec := aFocusRec;
		{$EndC}
			end
		else
			begin
		{ If we get this far, then we can't focus }
				ClipRect(gZeroRect);
				InvalidateFocus;
				Focus := FALSE;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.FocusOnSuperView: BOOLEAN;
		OVERRIDE;

	begin
		FocusOnSuperView := FALSE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.ForceOnScreen;

{ ForceOnScreen guarantees that some minimal drag area is accessible to the user, to be dragged}
{  to the desired location.}

		const
			kMinDragArea = 4;						{ ??? should this be settable? }

		var
			global: Rect;
			deltaH: integer;
			deltaV: integer;
			aTempRgn: RgnHandle;
			rgnsWereBuilt: BOOLEAN;

		procedure AdjustGlobalBounds (var boundsToAdjust: Rect);
	{ assume "boundsToAdjust" is set to the window bounds in global coordinates }

			var
				visScreenRect: Rect;

		begin
		{ since we don't _really_ know what the drag rgn is, we'll assume that moving the topleft}
{		  pt of the window on screen is sufficient to make it draggable, so calculate the deltas}
{		  necessary to move the topleft pt into visible screen rect}

			if GetMaxIntersectedDevice(visScreenRect) = nil then
				; { NOTE: uses gTempRgn }
			InsetRect(visScreenRect, kMinDragArea, kMinDragArea);
			with visScreenRect do
				begin
					if boundsToAdjust.top < top then
						deltaV := top - boundsToAdjust.top + fContRgnInset.v
					else if boundsToAdjust.top > bottom then
						deltaV := bottom - boundsToAdjust.top - fContRgnInset.v;

					if boundsToAdjust.left < left then
						deltaH := left - boundsToAdjust.left + fContRgnInset.h
					else if boundsToAdjust.left > right then
						deltaH := right - boundsToAdjust.right - fContRgnInset.h;
				end;
		end;

	begin
		fForcedOnScreen := TRUE;

		deltaH := 0;
		deltaV := 0;

		{ On many systems (including Color QD & the Radius FPD), it's possible to have a}
{		non-rectangular desktop.	Try to be nice to people who saved windows}
{		on secondary screens.  GrayRgn is the true indicator of the shape}
{		of the desktop--screenBits.bounds is the size of the screen with the}
{		menu bar on it.}

	{$IFC qDebug}
		UseTempRgn('ForceOnScreen');
	{$ENDC}

		rgnsWereBuilt := BuildWindowRgns(kBuild);
		with WindowPeek(fWMgrWindow)^ do
			begin
				DiffRgn(strucRgn, contRgn, gTempRgn);			{ strucRgn less contRgn  drag rgn }
				if EmptyRgn(gTempRgn) then
					CopyRgn(strucRgn, gTempRgn);				{ at least get the strucRgn }
			end;											{ WITH WindowPeek(fWMgrWindow)^ }
		if BuildWindowRgns(rgnsWereBuilt) then
			; 			{ discard result }

	{ get the desktop rgn, inset by a minimal drag area }
		aTempRgn := MakeNewRgn;
		CopyRgn(GetGrayRgn, aTempRgn);						{ aTempRgn := desktop rgn }
		InsetRgn(aTempRgn, kMinDragArea, kMinDragArea); 	{ inset aTempRgn }
		SectRgn(gTempRgn, aTempRgn, aTempRgn);				{ do drag rgn & desktop rgn instersect ? }
	{$IFC qDebug}
		DoneWithTempRgn;									{ (AdjustGlobalBounds needs gTempRgn) }
	{$ENDC}

		GetGlobalBounds(global);

		if EmptyRgn(aTempRgn) | not IsDraggable(aTempRgn^^.rgnBBox) then
			AdjustGlobalBounds(global); 					{ no => adjust the window's global bounds }
		DisposeRgn(aTempRgn);
		OffsetRect(global, deltaH, deltaV);
		with global do
			Locate(left, top, kDontInvalidate);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.GetGlobalBounds (var globalbounds: Rect);

		var
			savedPort: GrafPtr;

	begin
		if fWMgrWindow = nil then
			globalbounds := gZeroRect						{ CSK 89.11.30 }
		else
			begin
				GetPort(savedPort);
				SetPort(GetGrafPort);
				globalbounds := GetGrafPort^.portRect;
				LocalToGlobal(globalbounds.topleft);
				LocalToGlobal(globalbounds.botRight);
				SetPort(savedPort);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function TWindow.GetMaxIntersectedDevice (var screenRect: Rect): GDHandle;

		procedure CalcScreenRect;

			var
				aGDHandle, maxSectGD: GDHandle;
				globalStrucRect, aGDScreenRect: Rect;
				gdSectRect, dontCare: Rect;
				sectArea: LONGINT;
				maxSectArea: LONGINT;
				moveBounds: Rect;
				rgnsWereBuilt: BOOLEAN;

		begin
			rgnsWereBuilt := BuildWindowRgns(kBuild);		{ sets fContRgnInset & fContDifference, and}
{														 make sure contrgn and strucrgn are}
{														 available}
			globalStrucRect := WindowPeek(fWMgrWindow)^.strucRgn^^.rgnBBox;
			if BuildWindowRgns(rgnsWereBuilt) then
				; 		{ discard result }

			moveBounds := fMoveBounds;

			aGDHandle := GetDeviceList;
			maxSectGD := GetMainDevice; 					{ set as best choice default }
			maxSectArea := 0;
			repeat											{ calc which scrn intersects largest part of}
{														 window}
				begin
					aGDScreenRect := aGDHandle^^.gdRect;
					if SectRect(aGDScreenRect, moveBounds, dontCare) & SectRect(globalStrucRect, aGDScreenRect, gdSectRect) then
						begin
							with gdSectRect do
								sectArea := IntMultiply(bottom - top, right - left);
							if sectArea > maxSectArea then			{ do we have a new winner? }
								begin
									maxSectArea := sectArea;
									maxSectGD := aGDHandle;
								end;
						end;
					aGDHandle := GetNextDevice(aGDHandle);
				end;
			until aGDHandle = nil;

			if maxSectGD <> GetMainDevice then
				screenRect := maxSectGD^^.gdRect
			else
				begin										{ Account for menu bar on the main screen.}
{														 Don't just assume that its at the top of}
{														 the screen!}
			{$IFC qDebug}
					UseTempRgn('TWindow.GetMaxIntersectedDevice');
			{$ENDC}
					RectRgn(gTempRgn, maxSectGD^^.gdRect);		{ main screen with menubar }
					SectRgn(gTempRgn, GetGrayRgn, gTempRgn);	{ GetGrayRgn = desktop rgn w/o menubar }
					screenRect := gTempRgn^^.rgnBBox;			{ => main screen w/o menubar }
			{$IFC qDebug}
					DoneWithTempRgn;
			{$ENDC}
				end;
			GetMaxIntersectedDevice := maxSectGD;
		end;

	begin
		if qNeedsColorQD | gConfiguration.hasColorQD then
			CalcScreenRect
		else
			begin											{ Account for menu bar on the main screen.}
{														 Don't just assume that its at the top of}
{														 the screen!}
				GetMaxIntersectedDevice := nil; 				{ we only have GDHandle in CQD world }
		{$IFC qDebug}
				UseTempRgn('TWindow.GetMaxIntersectedDevice');
		{$ENDC}
				RectRgn(gTempRgn, screenBits.bounds);			{ main screen with menubar }
				SectRgn(gTempRgn, GetGrayRgn, gTempRgn);		{ GetGrayRgn = desktop rgn w/o menubar }
				screenRect := gTempRgn^^.rgnBBox;				{ => main screen w/o menubar }
		{$IFC qDebug}
				DoneWithTempRgn;
		{$ENDC}
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInspector}

	procedure TWindow.GetInspectorName (var inspectorName: Str255);
		OVERRIDE;

	begin
		if (fWMgrWindow <> nil) & (not ODD(ORD4(fWMgrWindow))) then
			GetTitle(inspectorName);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.GetGrafPort: GrafPtr;
		OVERRIDE;

	begin
		if gPrinting | gDrawingPictScrap then
			GetGrafPort := thePort							{thePort assumed to be set by print handler}
		else if fWMgrWindow <> nil then
			GetGrafPort := GrafPtr(fWMgrWindow)
		else
			GetGrafPort := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.GetTitle (var theTitle: Str255);

	begin
		GetWTitle(fWMgrWindow, theTitle);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.GetWindow: TWindow;
		OVERRIDE;

	begin
		GetWindow := SELF;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TWindow.GoAwayByUser (globalMouse: Point);

		var
			aCloseWindowCommand: TCloseWindowCommand;
			oldObjectPerm: BOOLEAN;

	begin
		if fIsClosable & TrackGoAway(fWMgrWindow, globalMouse) then
			begin
				oldObjectPerm := AllocateObjectsFromPerm(FALSE); { Guarantee the allocation }
				New(aCloseWindowCommand);
				if AllocateObjectsFromPerm(oldObjectPerm) then
					;

				FailNil(aCloseWindowCommand);					{ just in case }
				aCloseWindowCommand.ICloseWindowCommand(cClose, SELF);
				PostCommand(aCloseWindowCommand);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	function TWindow.HandleMouseDown (theMouse: VPoint; var info: EventInfo; var hysteresis: Point; var theCommand: TCommand): BOOLEAN;
		OVERRIDE;

		const
			systemEventMask = app4Mask; 				{ !!! defined as OSEvt in the MPW 3.1}
{														 interfaces}

		var
			wantsTheMouse: BOOLEAN;
			anEvent: EventRecord;
			aWMgrWindow: WindowPtr;
			whereMouseDown: integer;

	begin
		theCommand := nil;
		HandleMouseDown := TRUE;

		with info, thePEvent^ do
			begin
				whereMouseDown := FindWindow(where, aWMgrWindow);

				if aWMgrWindow = fWMgrWindow then
					begin
						case whereMouseDown of
							inContent: 
								begin
									wantsTheMouse := TRUE;
									if gApplication.GetActiveWindow <> SELF then
										begin
											Select;
											if fDoFirstClick then
						{ Make sure this window is activated and updated }
												gApplication.UpdateAllWindows
											else
												wantsTheMouse := FALSE;
										end;

									if wantsTheMouse then
										HandleMouseDown := inherited HandleMouseDown(theMouse, info, hysteresis, theCommand)
									else
										HandleMouseDown := FALSE;
								end;

							inDrag: 
								MoveByUser(where);

							inGrow: 
								ResizeByUser(where);

							inGoAway: 
								GoAwayByUser(where);

							inZoomIn, inZoomOut: 
								ZoomByUser(where, whereMouseDown);

							inDesk: 
								;

						end;
					end
				else if qDebug then
					ProgramBreak('in TWindow.HandleMouseDown: passed an event that didn''t belong to the window');
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.HasPendingUpdate: BOOLEAN;

	begin
		HasPendingUpdate := not EmptyRgn(WindowPeek(fWMgrWindow)^.updateRgn);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.InstallDocument (itsDocument: TDocument);

		var
			aString: Str255;

	begin
		fDocument := itsDocument;
		if itsDocument <> nil then
			begin
				gApplication.DeleteFreeWindow(SELF);			{ Just in case }
				itsDocument.AddWindow(SELF);
				aString := itsDocument.fTitle^^;				{ SetTitleForDoc may move memory }
				if aString <> '' then							{ not an untitled document }
					SetTitleForDoc(aString);
				fNextHandler := itsDocument;
			end
		else
			begin
				gApplication.AddFreeWindow(SELF);
				fNextHandler := gApplication;
			end;
	end;

{--------------------------------------------------------------------------------------------------}

	function PushLong (h, v: integer): LONGINT;
{ This can be used to push a longint given a point. 	PushLong(aPt.h,aPt.v); }
	inline
		$2E9F;										{ MOVE.L (A7)+,(A7) }

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function TWindow.IsDraggable (whichRect: Rect): BOOLEAN;
{ Returns TRUE if any of the corner points of whichRect are draggable. }

		var
			wDefProc: Handle;
			variant: integer;
			dontCare: LONGINT;
			saveState: SignedByte;
			rgnsWereBuilt: BOOLEAN;

	begin
		IsDraggable := TRUE;
		rgnsWereBuilt := BuildWindowRgns(kBuild);			{ regions needed for hit testing }
		wDefProc := GetAndLoadWDefProc(WindowPeek(fWMgrWindow)^.windowDefProc);
		variant := GetWindowVariant(fWMgrWindow);
		saveState := GetHandleBits(wDefProc);
		LockHandleHigh(wDefProc);

		with whichRect do									{ is any corner pt in the drag region? }
			if (CallWDefProc(variant, fWMgrWindow, wHit, PushLong(left, top), wDefProc) <> wInDrag) & (CallWDefProc(variant, fWMgrWindow, wHit, PushLong(right, bottom), wDefProc) <> wInDrag) & (CallWDefProc(variant, fWMgrWindow, wHit, PushLong(left, bottom), wDefProc) <> wInDrag) & (CallWDefProc(variant, fWMgrWindow, wHit, PushLong(right, top), wDefProc) <> wInDrag) then
				IsDraggable := FALSE;						{ no, so window _isn't_ draggable }

		SetHandleBits(wDefProc, saveState);
		if BuildWindowRgns(rgnsWereBuilt) then
			; 			{ discard result }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function TWindow.BuildWindowRgns (build: BOOLEAN): BOOLEAN;
{ Calculate window size including structure region (i.e. title bar).  To do this}
{ we need to force the window to compute its structure region by calling its defproc,}
{ if the window isn't shown.}
{ IF build is FALSE, set the regions back to empty regions, so as not to confuse the}
{ window manager.}
{ Return the previous state of the regions.}

		var
			dontCare: LONGINT;
			wDefProc: Handle;
			topLeftInset, contDifference: Point;
			globalStrucRect, globalContRect: Rect;
			saveState: SignedByte;

	begin
		with WindowPeek(fWMgrWindow)^ do
			begin
		{ The regions are considered to be built if either:}
{		  a) the window is shown; or}
{		  b) the structure rgn is not empty.}
				if IsShown | not EmptyRgn(strucRgn) then
					begin
						BuildWindowRgns := kBuild;
						if (build <> kBuild) & not IsShown then
							begin
								SetEmptyRgn(strucRgn);
								SetEmptyRgn(contRgn);
							end;
					end
				else
					begin
						BuildWindowRgns := not kBuild;
						if (build = kBuild) then
							begin
								wDefProc := GetAndLoadWDefProc(windowDefProc);
								saveState := GetHandleBits(wDefProc);
								LockHandleHigh(wDefProc);
								dontCare := CallWDefProc(GetWindowVariant(fWMgrWindow), fWMgrWindow, wCalcRgns, 0, wDefProc);
								SetHandleBits(wDefProc, saveState);

				{ Calculate offset from top-left of window structure to top-left of window content}
								topLeftInset := contRgn^^.rgnBBox.topleft;
								SubPt(strucRgn^^.rgnBBox.topleft, topLeftInset);
								fContRgnInset := topLeftInset;
								globalStrucRect := WindowPeek(fWMgrWindow)^.strucRgn^^.rgnBBox;
								globalContRect := WindowPeek(fWMgrWindow)^.contRgn^^.rgnBBox;
								contDifference.v := (globalStrucRect.bottom - globalStrucRect.top) - (globalContRect.bottom - globalContRect.top);
								contDifference.h := (globalStrucRect.right - globalStrucRect.left) - (globalContRect.right - globalContRect.left);
								fContDifference := contDifference;
							end;
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	function TWindow.IsHidOnSuspend: BOOLEAN;

	begin
		IsHidOnSuspend := fHideOnSuspend;	{ clipboard windows & floaters should return TRUE (and any}
{										other window that wants to get hid when the application is}
{										suspended by the Process Manager). }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	function TWindow.IsShown: BOOLEAN;
		OVERRIDE;

	begin
		if fWMgrWindow <> nil then
			IsShown := Ord(WindowPeek(fWMgrWindow)^.visible) <> 0
		else
			IsShown := FALSE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.Locate (h, v: VCoordinate; invalidate: BOOLEAN);
		OVERRIDE;
		var
			currLoc: Point;

	begin

		inherited Locate(h, v, invalidate);

		if fWMgrWindow <> nil then
			begin
				currLoc := fWMgrWindow^.portRect.topleft;
				LocalToGlobal(currLoc);
				if (h <> currLoc.h) | (v <> currLoc.v) then
					MoveWindow(fWMgrWindow, h, v, FALSE);		{ ??? should offset by fContRgnInset.v }
			end;
		if (fIsActive | fDoFirstClick) & IsShown then
			gApplication.InvalidateCursorRgn;				{??? should this be a view method? }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.Select;

	begin
		gApplication.SelectWMgrWindow(fWMgrWindow);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.MoveByUser (globalMouse: Point);

		var
			boundsRect: Rect;
			currLoc: Point;

	begin
		boundsRect := fMoveBounds;
		DragWindow(fWMgrWindow, globalMouse, boundsRect);
		gLastUpTime := TickCount;							{ needed for double clicking the title bar,}
{														 because DragWindow eats the mouseUpEvent}

	{ Don't forget to tell the window object }
		currLoc := fWMgrWindow^.portRect.topLeft;
		LocalToGlobal(currLoc);
		Locate(currLoc.h, currLoc.v, kDontInvalidate);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.Open;
		OVERRIDE;

	begin
		if not IsShown then
			begin
		{ Keep us matching the window since we are parallel structures }
				with fWMgrWindow^.portRect do
					Resize(right - left, bottom - top, kDontInvalidate);	{ Be sure all views are sized right }

				AdjustSize; 									{ Give non-template views a shot at}
{														 correcting for sizedeterminers}

				if fMustAdapt & not fAdapted then
					AdaptToScreen;
				if (fMustHorzCenter & not fHorzCentered) | (fMustVertCenter & not fVertCentered) then
					Center(fMustHorzCenter, fMustVertCenter, fIsModal);
				if fMustStagger & not fStaggered then
					begin
			{ If both staggering and forcing on screen are specified then we must ensure}
{			that the window is forced on screen FIRST so that the staggering will occur}
{			in a visible (and usable) location.  BUT, after staggering we must STILL ensure}
{			that the window is forced on screen so, we reset the forced flag so that}
{			forcing will occur on schedule later.}
						if fMustForceOnScreen & not fForcedOnScreen then
							begin
								ForceOnScreen;
								fForcedOnScreen := FALSE;				{ Make sure we can be forced again }
							end;
						SimpleStagger(kStdStaggerAmount, kStdStaggerAmount, gStdStaggerCount);
					end;
				if fMustForceOnScreen & not fForcedOnScreen then
					ForceOnScreen;

				Show(TRUE, kRedraw);							{ Make me visible }

			end;
		inherited Open; 									{ Tell subviews to open in case they care }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TWindow.Resize (width, height: VCoordinate; invalidate: BOOLEAN);
		OVERRIDE;

		var
			r: Rect;

	begin
		if (width <> fSize.h) | (height <> fSize.v) then
			begin
				SizeWindow(fWMgrWindow, width, height, invalidate);
				InvalidateFocus;

				if fIsResizable & invalidate & Focus then
					begin

						SetRect(r, -kSBarSizeMinus1, -kSBarSizeMinus1, 0, 0);

						OffsetRect(r, fSize.h, fSize.v);
						InvalidRect(r);

						OffsetRect(r, width - fSize.h, height - fSize.v);
						InvalidRect(r);
					end;

				inherited Resize(width, height, invalidate);

				if (fIsActive | fDoFirstClick) & IsShown then
					gApplication.InvalidateCursorRgn;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TWindow.ResizeByUser (globalMouse: Point);

		var
			growResult: LONGINT;
			resizeLimits: Rect;

	begin
		if fIsResizable then
			begin
				resizeLimits := fResizeLimits;					{ GrowWindow may move SELF }
				growResult := GrowWindow(fWMgrWindow, globalMouse, resizeLimits);
				if growResult <> 0 then
					Resize(LoWrd(growResult), HiWrd(growResult), kInvalidate);
				if (fIsActive | fDoFirstClick) & IsShown then
					gApplication.InvalidateCursorRgn;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.SetResizeLimits (itsMinSize, itsMaxSize: Point);

		type
			WStateDataPtr = ^WStateData;
			WStateDataHandle = ^WStateDataPtr;

	begin
		fResizeLimits.topleft := itsMinSize;
		fResizeLimits.botRight := itsMaxSize;

	{ If the window is zoomable, keep the window's state data current }
		if BAND(fProcID, zoomDocProc) <> 0 then
			with WStateDataHandle(WindowPeek(fWMgrWindow)^.DataHandle)^^.stdState do
				begin
					right := Min(right, fLocation.h + itsMaxSize.h - 1);
					bottom := Min(bottom, fLocation.v + itsMaxSize.v - 1);
				end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.SetTarget (newTarget: TEvtHandler);

	begin
		if newTarget = nil then 							{ Would be annoying if a nil got in here! }
			newTarget := SELF;

		fTarget := newTarget;
		if gApplication.GetActiveWindow = SELF then
			gApplication.SetTarget(newTarget);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.SetTitle (newTitle: Str255);

		var
			oldTitle: Str255;

	begin
		GetWTitle(fWMgrWindow, oldTitle);					{ to minimize flash, we only set the title}
{														 if it's different from the current title}
		if CompareStrings(oldTitle, newTitle) <> sortsEqual then
			SetWTitle(fWMgrWindow, newTitle);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFile}

	procedure TWindow.SetTitleForDoc (newDocTitle: Str255);

		var
			title: Str255;

	begin
		if fPreDocname > 0 then 							{ optimize for case of nothing to do }
			begin
				GetTitle(title);

				if SubstituteInTitle(title, newDocTitle, fPreDocname, fConstTitle) then
					SetTitle(title);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TWindow.Show (state, redraw: BOOLEAN);
		OVERRIDE;

	begin
		if (fWMgrWindow <> nil) & redraw then
			if (fIsActive | fDoFirstClick) then
				gApplication.InvalidateCursorRgn;
		if state then
			begin
				with fWMgrWindow^.portRect do
					Resize(right - left, bottom - top, redraw);	{ Be sure all views are sized right }
				ShowWindow(fWMgrWindow);
			end
		else
			begin
				HideWindow(fWMgrWindow);
				Activate(FALSE);
			end;

		inherited Show(state, redraw);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TWindow.SimpleStagger (dh, dv: integer; var counter: integer);

		var
			globalRect: Rect;						{ The topLeft of the window must fall in}
{														 here.}
			Pt: Point;
			nSlots: integer;
			slot: integer;

	begin
		fStaggered := TRUE;
	{ Get window rect, which gives us globalRect.topLeft & size of window }
		GetGlobalBounds(globalRect);

	{ Compute globalRect.botRight = globalRect.topleft + <bounds botRight> - <window botRight> }
		Pt := globalRect.topleft;
		AddPt(fMoveBounds.botRight, Pt);
		SubPt(globalRect.botRight, Pt);
		globalRect.botRight := Pt;

		{ This covers the case of dh & dv both >= 0; if either is less than}
{		0, the right (bottom) limit is set to the left (top) edge of the}
{		screen -- allowing for some margin.  This makes the right (bottom)}
{		edge less than the left (top) edge, but this is OK since the DIV}
{		statement below will be dividing 2 negative numbers.}

		if dh < 0 then
			globalRect.right := fMoveBounds.left;
		if dv < 0 then
			globalRect.bottom := fMoveBounds.top;

	{ This code avoids divide by zero problems }
		if (dh = 0) | (dv = 0) then
			nSlots := 0
		else
			nSlots := Min((globalRect.right - globalRect.left + dh - 1) div dh, (globalRect.bottom - globalRect.top + dv - 1) div dv);
		if nSlots = 0 then
			slot := 0
		else
			slot := counter mod nSlots;

		if slot <> 0 then									{ move the window }
			begin
		{ pt ends up as the place to position the window }
				Pt := globalRect.topleft;

				Pt.h := Pt.h + (slot * dh);
				Pt.v := Pt.v + (slot * dv);

				Locate(Pt.h, Pt.v, kDontInvalidate);
			end;

		counter := counter + 1;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAWindowRes}

	procedure TWindow.Update;
		OVERRIDE;

		var
			fi: FailInfo;

		procedure HdlUpdate (error: OSErr; message: LONGINT);

		begin
			EndUpdate(fWMgrWindow); 						{ Need to balance the BeginUpdate }
		{ Or we get into an infinite loop }
		{ trying to update the window when }
		{ displaying an alert }
			InvalidateFocus;
		end;

	begin
		if HasPendingUpdate then
			begin
				InvalidateFocus;
				BeginUpdate(fWMgrWindow);

				CatchFailures(fi, HdlUpdate);
				DrawContents;
				Success(fi);

				EndUpdate(fWMgrWindow);
				InvalidateFocus;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TWindow.Zoom (partCode: integer);

		var
			aGDScreenRect: Rect;

		procedure CalcZoomRect (forScreenRect: Rect);

			const
				edge = 2;					{ leave space around window structure area,}
{														 ??? settable?}

			type
				WStateDataPtr = ^WStateData;
				WStateDataHandle = ^WStateDataPtr;

			var
				zoomRect: Rect;
				width, height: integer;

		begin
			InsetRect(forScreenRect, edge, edge);
			with forScreenRect do
				begin
			{ calculate the maximum structure size }
					width := Min((right - left), fResizeLimits.botRight.h + fContDifference.h);
					height := Min((bottom - top), fResizeLimits.botRight.v + fContDifference.v);

					zoomRect.top := top + fContRgnInset.v + ((bottom - top) - height) div 2;
					zoomRect.left := left + fContRgnInset.h + ((right - left) - width) div 2;
					zoomRect.right := zoomRect.left + width - fContDifference.h + 1;
					zoomRect.bottom := zoomRect.top + height - fContDifference.v + 1;

				end;

			if BAND(fProcID, zoomDocProc) <> 0 then
				WStateDataHandle(WindowPeek(fWMgrWindow)^.DataHandle)^^.stdState := zoomRect; { new}
{			zoom-out rect}
		end;

	begin
		if (qNeedsColorQD | gConfiguration.hasColorQD) & (partCode = inZoomOut) then { support multiple}
{		   screens}
			begin
				if (GetMaxIntersectedDevice(aGDScreenRect) = nil) then
					; { dont care about result }
				CalcZoomRect(aGDScreenRect);
			end;

		if Focus then										{ ??? (still true?) The ROM has a bug}
{														 requiring that thePort be the window being}
{														 zoomed.}
			begin
				EraseRect(thePort^.portRect);					{ Erasing was suggested by Ernie B.; the}
{														 Finder does this. ??? is this _still_ a}
{														 good idea. Help stamp out flicker.}
				ZoomWindow(fWMgrWindow, partCode, FALSE);

		{ let the View know what we've done }
				with fWMgrWindow^.portRect do
					Resize(right - left, bottom - top, kInvalidate);
			end;

		if (fIsActive | fDoFirstClick) & IsShown then
			gApplication.InvalidateCursorRgn;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TWindow.ZoomByUser (globalMouse: Point; partCode: integer);

	begin
		if TrackBox(fWMgrWindow, globalMouse, partCode) then
			Zoom(partCode);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TWindow.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

		var
			theFlag: BOOLEAN;

	begin
		DoToField('TWindow', nil, bClass);
		DoToField('fWMgrWindow', @fWMgrWindow, bWindowPtr);
		DoToField('fProcID', @fProcID, bInteger);
		DoToField('fMoveBounds', @fMoveBounds, bRect);
		DoToField('fResizeLimits', @fResizeLimits, bRect);
		DoToField('fTarget', @fTarget, bObject);
		DoToField('fTargetID', @fTargetID, bIDType);
		DoToField('fPreDocName', @fPreDocname, bInteger);
		DoToField('fConstTitle', @fConstTitle, bInteger);
		DoToField('fMustAdapt', @fMustAdapt, bBoolean);
		DoToField('fMustHorzCenter', @fMustHorzCenter, bBoolean);
		DoToField('fMustVertCenter', @fMustVertCenter, bBoolean);
		DoToField('fMustStagger', @fMustStagger, bBoolean);
		DoToField('fMustForceOnScreen', @fMustForceOnScreen, bBoolean);
		DoToField('fAdapted', @fAdapted, bBoolean);
		DoToField('fHorzCentered', @fHorzCentered, bBoolean);
		DoToField('fVertCentered', @fVertCentered, bBoolean);
		DoToField('fStaggered', @fStaggered, bBoolean);
		DoToField('fForcedOnScreen', @fForcedOnScreen, bBoolean);
		DoToField('fIsActive', @fIsActive, bBoolean);
		DoToField('fIsResizable', @fIsResizable, bBoolean);
		DoToField('fIsClosable', @fIsClosable, bBoolean);
		DoToField('fFreeOnClosing', @fFreeOnClosing, bBoolean);
		DoToField('fDisposeOnFree', @fDisposeOnFree, bBoolean);
		DoToField('fClosesDocument', @fClosesDocument, bBoolean);
		DoToField('fOpenInitially', @fOpenInitially, bBoolean);
		DoToField('fIsModal', @fIsModal, bBoolean);
		DoToField('fDoFirstClick', @fDoFirstClick, bBoolean);
		DoToField('fFloats', @fFloats, bBoolean);
		DoToField('fContRgnInset', @fContRgnInset, bPoint);
		DoToField('fContDifference', @fContDifference, bPoint);
		inherited Fields(DoToField);
	end;


end.