{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}

{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UPatch.p }
{ Copyright  1984-1990  Apple Computer, Inc.  All rights reserved. }

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := FALSE}
{$ENDC}

unit UPatch;

interface

	uses
		SysEqu, Traps, ULoMem, 
{$SETC __UPatch__ := TRUE}
{  MacApp }
		UMacAppUtilities;
{  Implementation USES }


			{  Include the public interface }



{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UPatch.p }
{ Copyright  1985-1990 by Apple Computer, Inc.  All rights reserved. }
{[f-]}
{}
{		T H E O R Y   O F	O P E R A T I O N}
{}
{This unit implements a general trap-patching mechanism.  Two types of}
{patches are implemented:}
{}
{Normal Patch	The trap is patched such that it jumps to the routine}
{			of your choice, ignoring the routine it previously}
{			jumped to.	On a 128K ROM machine, the patch is made}
{			by setting the trap address to your routine.  On a 64K}
{			machine, a small block of code is allocated in the}
{			system heap:  The trap address is set to point to the}
{			block, and the block contains code to jump to your}
{			routine.}
{}
{Head Patch	The trap is patched such that it jumps to the}
{			routine of your choice, then jumps to the trap's}
{			routine.  Head patches come in two flavors:  with}
{			no parameters and with one long-word parameter.  The}
{			patch is made by allocating a small block of code in}
{			the application heap (system heap for 64K ROMs).  The}
{			trap address is set to the block, and the block contains}
{			code to jump to your routine and return to the trap's}
{			original address.}
{}
{References to patches are kept in TrapPatch records.  For each trap}
{patched you must define a variable of type TrapPatch.	This unit links}
{the TrapPatch records to form a linked list for facilitate unpatching}
{all patches without specifying each individual patch.}
{}
{[f+]}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := FALSE}
{$ENDC}








		{  Auto-Include the requirements for this unit's interface. }



		{$IFC UNDEFINED UsingTypes}
  {$ENDC}
		{$IFC UNDEFINED UsingMemory}
  {$ENDC}


	type
		TrapPatchPtr = ^TrapPatch;			{ Preferred. The pointer type _MUST_ be}
{														 declared first since the record is self}
{														 referential}
		TrapPatch = record
				jmpPtr: Ptr;				{ Addr of sys heap block }
				trapNum: INTEGER;			{ trap # being patched }
				oldTrapAddr: LONGINT;			{ old trap address }
				nextPatch: TrapPatchPtr;		{ next link in linked list of patches }
			end;

		CallBack = record
				saveRtnAdd: INTEGER;			{ Internal use }
				moveRefCon: INTEGER;			{ Internal use }
				refCon: LONGINT;			{ the refCon that will be passed as last}
{														 parm}
				targOffset: INTEGER;			{ Internal use }
				jmpInst: INTEGER;			{ Internal use }
				jmpTarg: LONGINT;			{ Internal use }
			end;
		CallBackPtr = ^CallBack;

		{ The following variable is really private but is in the interface just in case}
{		you're doing something really wierd and you really need it}

	var
		pPatchList: TrapPatchPtr;			{ Head of linked list of patches }

	procedure InitUPatch;
		{ Call this once to set things up. Initializes the linked list of patches to NIL. }

	procedure EachPatchDo (function DoToPatch (thePatchPtr: TrapPatchPtr): BOOLEAN);
		{ Calls DoToPatch for each patch in the list from pPatchList to the last patch.}
{		Stops at end of list or when DoToPatch returns TRUE.  DoToPatch may not remove patches.}

	function HeadPatch (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): INTEGER;
		{ HeadPatch patches a trap such that it calls theRoutine first, then executes the old trap}
{		routine. theRoutine must be a procedure with no arguments. This type of patch is}
{		implemented by setting up a block in the system heap, patching the trap to jump to the}
{		block, and inserting code in the block that pushes the original trap address on the stack}
{		and jumps to theRoutine. Thus, theRoutine returns to the original trap routine.}

	function Head1Patch (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): INTEGER;
		{ Head1Patch is just like HeadPatch, except that it is intended to patch traps with a single}
{		long-word parameter. The parameter passed to the trap is also passed to theRoutine.}
{		theRoutine must be a procedure with one long-word parameter.}

	function PatchTrap (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): INTEGER;
		{ PatchTrap patches the given trap to theRoutine.  On a 64K ROM machine, we must set up a}
{		block in the system heap, patch the trap to jump to the block, and insert code in the block}
{		to jump to theRoutine.}

	procedure SetCallBack (targProc: ProcPtr; itsRefCon: LONGINT; theCallBackPtr: CallBackPtr);
		{ Prepares a call back record for use.  Stuffs in the target of the call back and the refcon}
{		to pass as an _additional_ and _last_ parameter to it.  Useful for getting context when being}
{		called back from the toolBox.  Also useful for avoiding use of globals when getting context}

	procedure UnpatchTrap (var thePatch: TrapPatch);
		{ UnpatchTrap unpatches the given trap. }

	procedure UnpatchAll;
		{ UnpatchAll unpatches all traps. }






implementation


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UPatch.inc1.p }
{ Copyright  1985-1990 by Apple Computer, Inc.  All rights reserved. }

	type
	{ System heap block record for PatchTrap }
		PTBlockPtr = ^PTBlock;
		PTBlock = record
				Jmp: INTEGER;
				Routine: Ptr;
			end;

	{ System heap block record for HeadPatch }
		TPBlockPtr = ^TPBlock;
		TPBlock = record
				MoveL: INTEGER;
				OldTrapAddr: LONGINT;
				Jmp: INTEGER;
				Routine: Ptr;
			end;

	{ System heap block record for Head1Patch }
		T1PBlockPtr = ^T1PBlock;
		T1PBlock = record
				MoveParameter: LONGINT;
				MoveL: INTEGER;
				OldTrapAddr: LONGINT;
				Jmp: INTEGER;
				Routine: Ptr;
			end;

	function NewPermPtr (logicalSize: Size): Ptr;			{ So we don't have to USE UMemory }
	EXTERNAL;

{--------------------------------------------------------------------------------------------------}
{$S MAMiniInit}

	procedure InitUPatch;

	begin
		pPatchList := nil;									{ Initialize the linked list of patches. }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	function AllocBlock (blockSize: INTEGER; theTrapNum: INTEGER; var thePatch: TrapPatch): Ptr;

 { If blockSize is greater than zero, AllocBlock allocates a non-}
{  relocatable block in the system heap, of size blockSize.	It then}
{  fills all fields of thePatch.  If blockSize is zero, then no block}
{  is allocated and AllocBlock fills fields of thePatch.}

		var
			theBlock: Ptr;

	begin
		if blockSize > 0 then
			begin
				if qNeedsROM128K | gConfiguration.hasROM128K then
					theBlock := NewPermPtr(blockSize)
				else
					theBlock := NewPtrSys(blockSize);
			end
		else
			theBlock := nil;

		with thePatch do									{ get thePatch in a register for speed }
			begin
				jmpPtr := theBlock;
				OldTrapAddr := NGetTrapAddress(theTrapNum, GetTrapType(theTrapNum));
				trapNum := theTrapNum;
				nextPatch := pPatchList;
			end;
		pPatchList := @thePatch;
		AllocBlock := theBlock;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	function PatchTrap (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): OSErr;

		var
			patchBlock: PTBlockPtr;

	begin
		if qNeedsROM128K | gConfiguration.hasROM128K then
			begin
		{ On 128K ROMs, setup the patch record and the trap address }
				patchBlock := PTBlockPtr(AllocBlock(0, theTrapNum, thePatch));
				NSetTrapAddress(ORD4(theRoutine), theTrapNum, GetTrapType(theTrapNum));
				PatchTrap := noErr;
			end
		else
			begin

		{ Allocate the system heap block, and fill thePatch }
				patchBlock := PTBlockPtr(AllocBlock(SIZEOF(PTBlock), theTrapNum, thePatch));

				if patchBlock <> nil then
					begin
			{ Stuff the code into the block }
						with patchBlock^ do
							begin
								Jmp := $4EF9;							{ JMP #Routine }
								Routine := theRoutine;
							end;

			{ Set the trap address to the block of code in the system heap }
						NSetTrapAddress(ORD4(patchBlock), theTrapNum, GetTrapType(theTrapNum));
					end;

				PatchTrap := MemError;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	function HeadPatch (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): OSErr;

		var
			patchBlock: TPBlockPtr;

	begin
	{ Allocate the system heap block, and fill thePatch }
		patchBlock := TPBlockPtr(AllocBlock(SIZEOF(TPBlock), theTrapNum, thePatch));

		if patchBlock <> nil then
			begin
		{ Stuff the code into the block }
				with patchBlock^ do
					begin
						MoveL := $2F3C; 							{ MOVE.L #OldTrapAddr,-(SP) }
						OldTrapAddr := thePatch.OldTrapAddr;
						Jmp := $4EF9;								{ JMP #Routine }
						Routine := theRoutine;
					end;

		{ Set the trap address to the block of code in the system heap }
				NSetTrapAddress(ORD4(patchBlock), theTrapNum, GetTrapType(theTrapNum));
			end;
		HeadPatch := MemError;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	function Head1Patch (var thePatch: TrapPatch; theTrapNum: INTEGER; theRoutine: Ptr): OSErr;

		var
			patchBlock: T1PBlockPtr;

	begin
	{ Allocate the system heap block, and fill thePatch }
		patchBlock := T1PBlockPtr(AllocBlock(SIZEOF(T1PBlock), theTrapNum, thePatch));

		if patchBlock <> nil then
			begin
		{ Stuff the code into the block }
				with patchBlock^ do
					begin
						MoveParameter := $2F2F0004; 				{ MOVE.L 4(SP),-(SP) }
						MoveL := $2F3C; 							{ MOVE.L #OldTrapAddr,-(SP) }
						OldTrapAddr := thePatch.OldTrapAddr;
						Jmp := $4EF9;								{ JMP #Routine }
						Routine := theRoutine;
					end;

		{ Set the trap address to the block of code in the system heap }
				NSetTrapAddress(ORD4(patchBlock), theTrapNum, GetTrapType(theTrapNum));
			end;
		Head1Patch := MemError;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	procedure UnpatchTrap (var thePatch: TrapPatch);

		var
			aPatchPtr: TrapPatchPtr;
			newerPatchPtr: TrapPatchPtr;

		function GetPreviousPatchPtr (thePatchPtr: TrapPatchPtr): TrapPatchPtr;
	{ walks the patch list backwards to return the patch record just prior to thePatchPtr^ in the patch list }

			var
				tempPatchPtr: TrapPatchPtr;

		begin
			tempPatchPtr := pPatchList;
			while (tempPatchPtr <> nil) & (tempPatchPtr^.nextPatch <> thePatchPtr) do
				tempPatchPtr := tempPatchPtr^.nextPatch;
			GetPreviousPatchPtr := tempPatchPtr;
		end;

		function GetNewerPatchPtr: TrapPatchPtr;
	{ returns a newer patch record in the patch list which has the *same* trapNum as thePatch }

		begin
			aPatchPtr := GetPreviousPatchPtr(@thePatch);
			while (aPatchPtr <> nil) & (aPatchPtr^.trapNum <> thePatch.trapNum) do
				aPatchPtr := GetPreviousPatchPtr(aPatchPtr);
			GetNewerPatchPtr := aPatchPtr;
		end;

	begin
{ If this trap has a newer patch than the patch we're removing, then we have to take some extra }
{ special precautions . We have to muck with that patch 's oldTrapAddr to point to this}
{ patch record's oldTrapAddr (for both the patch record and the jumpPtr code). We can pretty well ignore the }
{ case of an older patch on this same trap since the trapaddress in our patch record will be correct . }
		newerPatchPtr := GetNewerPatchPtr;
		if (newerPatchPtr = nil) then
			with thePatch do
				NSetTrapAddress(OldTrapAddr, trapNum, GetTrapType(trapNum))	{ only set the trap address if there *isn't* a newer patch }
		else
			begin
		{ set up newerPatchPtr patch record so that it points to thePatch's OldTrapAddr }
				newerPatchPtr^.oldTrapAddr := thePatch.oldTrapAddr;

		{ set up newerPatchPtr^.jmpPtr code so that it jumps to where thePatch's code jumps to }
				if (newerPatchPtr^.jmpPtr <> nil) then
					begin
						if LongIntPtr(newerPatchPtr^.jmpPtr)^ = $2F2F0004 then		{ is it a Head1Patch with a T1PBlockPtr? }
							T1PBlockPtr(newerPatchPtr^.jmpPtr)^.OldTrapAddr := thePatch.oldTrapAddr
						else if IntegerPtr(newerPatchPtr^.jmpPtr)^ = $2F3C then		{ is it a HeadPatch with a TPBlockPtr? }
							TPBlockPtr(newerPatchPtr^.jmpPtr)^.OldTrapAddr := thePatch.oldTrapAddr
						else
				{$IFC qDebug}
							Writeln('###In UnpatchTrap: can''t figure out what kind of patch ', ORD(newerPatchPtr), ' is!');
				{$ENDC}
					end;
			end;

	{ Unlink the patch from the linked list of patches }
		if @thePatch = pPatchList then
			pPatchList := thePatch.nextPatch
		else
			begin
				aPatchPtr := pPatchList;
				while (aPatchPtr <> nil) & (aPatchPtr^.nextPatch <> @thePatch) do
					aPatchPtr := aPatchPtr^.nextPatch;
				if aPatchPtr = nil then		{ Couldn't find thePatch, so don't try to unpatch it. }
					EXIT(UnpatchTrap);
				aPatchPtr^.nextPatch := thePatch.nextPatch;
			end;

	{ If the patch allocated a block in the system heap, deallocate it }
		with thePatch do
			jmpPtr := DisposeIfPtr(jmpPtr);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	procedure UnpatchAll;

	begin
		while pPatchList <> nil do
			UnpatchTrap(pPatchList^);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	procedure EachPatchDo (function DoToPatch (thePatchPtr: TrapPatchPtr): BOOLEAN);

		var
			aPatchPtr: TrapPatchPtr;

	begin
		aPatchPtr := pPatchList;

		while aPatchPtr <> nil do
			if not DoToPatch(aPatchPtr) then
				aPatchPtr := aPatchPtr^.nextPatch
			else
				LEAVE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAPatchRes}

	procedure SetCallBack (targProc: ProcPtr; itsRefCon: Longint; theCallBackPtr: CallBackPtr);

{}
{00000000: 2F17			 '/.'			   MOVE.L	  (A7),-(A7)	; move old rtn address}
{00000002: 2F7C 1122 3344 '/|."3D'		   MOVE.L	  #$11223344,$0004(A7)	; plop refcon in}
{			 0004}
{0000000A: 4EF9 1122 3344 'N.."3D'		   JMP		  $11223344 	; shove off}
{}

	begin
		with theCallBackPtr^ do
			begin
				saveRtnAdd := $2F17;
				moveRefCon := $2F7C;
				refCon := itsRefCon;
				targOffset := $0004;
				jmpInst := $4EF9;
				jmpTarg := ORD(targProc);
			end;
		{ ??? should we flush the processor cache at this point? }
	end;


end.