{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ Copyright  1988 - 1990 by Apple Computer, Inc. All rights reserved. }

UNIT UDemoDialogs;

	INTERFACE

		USES

			{  MacApp }
			UMacApp,

			{  Building Blocks }
			UPrinting, UGridView, UTEView, UDialog,

			{  Required for this unit's interface }
			Sane,

			{  Implementation use }
			ToolUtils, Fonts, Resources, Packages;

		CONST

			{ Command numbers }
			cMakePicture		= 1000;

			kSignature			= 'SS11';				{ Application signature }
			kFileType			= 'SF11';				{ File-type code used for document files
														 created by this application }
			kTestWindowID		= 1001; 				{ This is passed to NewSimpleWindow as the
														 resource ID of the the WIND Resource which
														 defines the window for this application's
														 documents }

			kMaxFonds			= 100;					{ Max number of FONDs the FontList holds }

		TYPE
			CalcOperator		= (noOperator, divOperator, mulOperator, subOperator, addOperator);

			FontList			= ARRAY [1..kMaxFonds] OF INTEGER; { FOND resource IDs }
			FontListPtr 		= ^FontList;

			TTestApplication	= OBJECT (TApplication)

				PROCEDURE TTestApplication.ITestApplication(itsMainFileType: OSType);
				{ Initializes the application and globals. }

				FUNCTION TTestApplication.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;

				PROCEDURE TTestApplication.DoSetupMenus; OVERRIDE;

				PROCEDURE TTestApplication.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TNumbersView		= OBJECT (TView)

				PROCEDURE TNumbersView.Draw(area: Rect); OVERRIDE;

				PROCEDURE TNumbersView.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TMonthlyDialog		= OBJECT (TDialogView)

				FUNCTION TMonthlyDialog.DoKeyCommand(ch: CHAR;
													 aKeyCode: INTEGER;
													 VAR info: EventInfo): TCommand; OVERRIDE;

				PROCEDURE TMonthlyDialog.DismissDialog(dismisser: IDType); OVERRIDE;

				PROCEDURE TMonthlyDialog.StuffValues;

				PROCEDURE TMonthlyDialog.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TModelessMarkDialog = OBJECT (TDialogView)

				PROCEDURE TModelessMarkDialog.DoChoice(origView: TView;
													   itsChoice: INTEGER); OVERRIDE;

				PROCEDURE TModelessMarkDialog.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TFontListView		= OBJECT (TTextListView)

				fFontList:			FontListPtr;		{ font resource ids }

				PROCEDURE TFontListView.InitFontList;
				{ Build an array of ids of font resources whose names are in alphabetical order }

				PROCEDURE TFontListView.Free; OVERRIDE;
				{ Make sure the font list gets freed }

				PROCEDURE TFontListView.GetItemText(anItem: INTEGER;
													VAR aString: Str255); OVERRIDE;

				PROCEDURE TFontListView.SelectItem(anItem: INTEGER;
												   extendSelection, highlight,
					select: BOOLEAN); OVERRIDE;

				PROCEDURE TFontListView.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TSizeListView		= OBJECT (TTextListView)

				fSelection: 		INTEGER;
				fSelectedSize:		INTEGER;
				fFondID:			INTEGER;

				PROCEDURE TSizeListView.GetItemText(anItem: INTEGER;
													VAR aString: Str255); OVERRIDE;

				PROCEDURE TSizeListView.InstallFontFamily(theFondID: INTEGER);

				PROCEDURE TSizeListView.SelectItem(anItem: INTEGER;
												   extendSelection, highlight,
					select: BOOLEAN); OVERRIDE;

				PROCEDURE TSizeListView.SetNumberOfItems(aNumber: INTEGER);

				PROCEDURE TSizeListView.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TPageSetupDialog	= OBJECT (TDialogView)

				fOrientation:		VHSelect;

				PROCEDURE TPageSetupDialog.DoChoice(origView: TView;
													itsChoice: INTEGER); OVERRIDE;

				PROCEDURE TPageSetupDialog.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TRadioIcon			= OBJECT (TIcon)

				PROCEDURE TRadioIcon.TrackMouse(aTrackPhase: TrackPhase;
												VAR anchorPoint, previousPoint, nextPoint: VPoint;
												mouseDidMove: BOOLEAN); OVERRIDE;

				PROCEDURE TRadioIcon.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			THomeBrewDialog 	= OBJECT (TDialogView)

				FUNCTION THomeBrewDialog.DoSetCursor(localPoint: Point;
													 cursorRgn: RgnHandle): BOOLEAN; OVERRIDE;

				FUNCTION THomeBrewDialog.HandleCursor(theMouse: VPoint;
													  cursorRgn: RgnHandle): TView; OVERRIDE;

				PROCEDURE THomeBrewDialog.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TArrowsControl		= OBJECT (TPicture)

				fLastChange:		LONGINT;			{ tick count of last call to DoChoice }

				PROCEDURE TArrowsControl.IRes(itsDocument: TDocument;
											  itsSuperView: TView;
											  VAR itsParams: Ptr); OVERRIDE;

				PROCEDURE TArrowsControl.TrackMouse(aTrackPhase: TrackPhase;
													VAR anchorPoint, previousPoint,
													nextPoint: VPoint;
													mouseDidMove: BOOLEAN); OVERRIDE;

				PROCEDURE TArrowsControl.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TTemperatureCluster = OBJECT (TCluster)

				PROCEDURE TTemperatureCluster.DoChoice(origView: TView;
													   itsChoice: INTEGER); OVERRIDE;
				FUNCTION TTemperatureCluster.GetValue: LONGINT;

				PROCEDURE TTemperatureCluster.SetValue(newValue: LONGINT;
													   redraw: BOOLEAN);

				PROCEDURE TTemperatureCluster.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TTemperatureConversionCluster = OBJECT (TCluster)

				PROCEDURE TTemperatureConversionCluster.DoChoice(origView: TView;
																 itsChoice: INTEGER); OVERRIDE;

				PROCEDURE TTemperatureConversionCluster.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TSlider 			= OBJECT (TPicture)

				fValue: 			INTEGER;
				fKnobPicture:		PicHandle;
				fKnobRect:			Rect;
				fMinTop:			INTEGER;
				fMaxTop:			INTEGER;

				PROCEDURE TSlider.IRes(itsDocument: TDocument;
									   itsSuperView: TView;
									   VAR itsParams: Ptr); OVERRIDE;

				FUNCTION TSlider.ContainsMouse(theMouse: VPoint): BOOLEAN; OVERRIDE;

				PROCEDURE TSlider.Draw(area: Rect); OVERRIDE;

				PROCEDURE TSlider.DrawKnob;

				PROCEDURE TSlider.GetKnobRect(VAR knobRect: Rect);

				PROCEDURE TSlider.TrackMouse(aTrackPhase: TrackPhase;
											 VAR anchorPoint, previousPoint, nextPoint: VPoint;
											 mouseDidMove: BOOLEAN); OVERRIDE;

				PROCEDURE TSlider.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TSumStaticText		= OBJECT (TStaticText)

				PROCEDURE TSumStaticText.Draw(area: Rect); OVERRIDE;

				PROCEDURE TSumStaticText.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

			TCalcDialog 		= OBJECT (TPicture)

				fSum:				Extended;
				fArgument:			Extended;
				fOperator:			CalcOperator;
				fDecimalPoint:		BOOLEAN;
				fRestart:			BOOLEAN;

				PROCEDURE TCalcDialog.DoChoice(origView: TView;
											   itsChoice: INTEGER); OVERRIDE;

				FUNCTION TCalcDialog.DoKeyCommand(ch: CHAR;
												  aKeyCode: INTEGER;
												  VAR info: EventInfo): TCommand; OVERRIDE;

				PROCEDURE TCalcDialog.ClearSum;

				PROCEDURE TCalcDialog.FetchValue(VAR aValue: Extended);

				PROCEDURE TCalcDialog.SetValue;

				PROCEDURE TCalcDialog.TotalSum(newOperator: CalcOperator);

				PROCEDURE TCalcDialog.NewDigit(theNumber: CHAR);

				PROCEDURE TCalcDialog.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;

	IMPLEMENTATION

		{$I UDemoDialogs.inc1.p}

END.
