/*
	Debug.r
	MacApp Debugging Resources
	Copyright  1986-1990 Apple Computer, Inc.  All rights reserved.
*/

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#define      kDebugBuzzStrings			251
#define      kDebugErrorStrings			252
#define      kTranscriptWindowType		901
#define      kForDebugging				128
#define		 kDebugSICN					901

#define		kIDTranscriptView			'trns'


/* memory stuff */
resource 'mem!' (kForDebugging,
#if qNames
	"ForDebugging",
#endif
	purgeable) {
	2048,				// Add to temporary reserve
	0,					// Add to permanent reserve
	0					// stack space
};


resource 'seg!' (kForDebugging,
#if qNames
	"ForDebugging",
#endif
	purgeable) {
	{
		"GDebug";
		"GDebugger";
		"GFields";
		"GInspector";
		"GNonRes";								// Window resizing, beinport, drawprintfeedback, etc.
		"GSelCommand";							// Handling mousedowns
		"GWriteLn"
	};
};

resource 'res!' (kForDebugging,
#if qNames
	"ForDebugging",
#endif
	purgeable) {
	{
		"GDebug";
		"GDebugger";
		"GFields";
		"GInspector";
		"GWriteLn"
	};
};

resource 'cmnu' (mDebug,
#if qNames
	"mDebug",
#endif
	nonpurgeable) {
	mDebug,
	textMenuProc,
	0x7FFFFFBF,
	enabled,
	"Debug",
	{
#if qInspector
	"New Inspector Window", 				noIcon, noKey,	noMark, plain,	cNewInspectorWindow;
#endif
	"-",									noIcon, noKey,	noMark, plain,	nocommand;
	"Make Front Window Modal",				noIcon, noKey,	noMark, plain,	cModalToggle;
	"Do First Click For This Window",		noIcon, noKey,	noMark, plain,	cDoFirstClick;
	"Refresh Front Window", 				noIcon, "",	noMark, plain,	cRefreshFrontWindow;
	"-",									noIcon, noKey,	noMark, plain,	nocommand;
	"Allow Trace of Menu Setups",			noIcon, noKey,	noMark, plain,	cTraceSetupMenus;
	"Allow Trace During Idle",				noIcon, noKey,	noMark, plain,	cTraceIdle;
	/*"Show Page Breaks",					noIcon, noKey,	noMark, plain,	cShowBreaks;	*/
	"Set system justification",				noIcon, noKey,	noMark, plain,	cSetSysJust;
	"-",									noIcon, noKey,	noMark, plain,	nocommand;
	"Enter MacApp Debugger",				noIcon, "`",	noMark, plain,	cEnterMacAppDebugger;
	"Show Debug Transcript",				noIcon, noKey,	noMark, plain,	cDebugWind;
	"Show Software Version",				noIcon, noKey,	noMark, plain,	cIdentifySoftware
	}
};


/* Debug Buzz-Strings */
resource 'STR#' (kDebugBuzzStrings,
#if qNames
	"DebugBuzzStrings",
#endif
	purgeable) {
	 {	/* [1] */	"Make Front Window Modal";
		/* [2] */	"Make Front Window Modeless";
		/* [3] */	"Do First Click For This Window";
		/* [4] */	"Don't Do First Click For This Window";
		/* [5] */	"Set system to right justification";
		/* [6] */	"Set system to left justification"
	}
};


/* Debug Error-Strings */
resource 'STR#' (kDebugErrorStrings,
#if qNames
	"kDebugErrorStrings",
#endif
	purgeable) {
	 {
	"Level 7 Interupt";
	"Bus error:  Invalid memory reference";
	"Address error:  Word or long-word reference made to an odd address";
	"Illegal instruction:  The processor received an instruction it didn't recognize.";
	"Zero divide:  Signed Divide (DIVS) or Unsigned Divide (DIVU) instruction with a divisor of 0 was executed.";
	"Check exception:  Check Register Against Bounds (CHK) instruction was executed and failed.  Pascal 'value out of range' errors are usually reported in this way.";
	"TrapV exception:  Trap On Overflow (TRAPV) instruction was executed and failed.";
	"Privilege violation:  Macintosh always runs in supervisor mode; perhaps an erroneous Return From Execution (RTE) instruction was executed.";
	"Trace exception:  The trace bit in the status register is set.";
	"Line 1010 exception:  The 1010 trap dispatcher has failed.";
	"Line 1111 exception:  Unimplemented instruction";
	"Miscellaneous exception:  All other processor exceptions";
	"Unimplemented core routine:  An unimplemented trap number was encountered.";
	"Spurious interrupt:  The interrupt vector table entry for a particular level of interrupt is NIL; usually occurs with level 4, 5, 6, or 7 interrupts.";
	"I/O system error:  The File Manager is attempting to dequeue an entry from an I/O request queue that has a bad queue type field.";
	"Segment Loader error:  A GetResource call to read a segment into memory failed.";
	"Floating point error:  The halt bit in the floating-point environment word was set.";
	"Can't load package 0:  A GetResource call to read a package into memory failed.";
	"Can't load package 1:  A GetResource call to read a package into memory failed.";
	"Can't load Disk Initialization package:  A GetResource call to read a package into memory failed.";
	"Can't load Standard File package:  A GetResource call to read a package into memory failed.";
	"Can't load Floating Point package:  A GetResource call to read a package into memory failed.";
	"Can't load Trancendentals package:  A GetResource call to read a package into memory failed.";
	"Can't load International Utilities package:  A GetResource call to read a package into memory failed.";
	"Can't load Binary-Decimal package:  A GetResource call to read a package into memory failed.";
	"Can't allocate requested memory block in the heap";
	"Segment Loader error:  A GetResource call to read 'CODE' resource 0 into memory failed; usually indicates a nonexecutable file.";
	"File map destroyed:  A logical block number was found that's greater than the number of the last logical block on the volume or less than the logical block number of the first allocation block on the volume.";
	"Stack overflow error:  The stack has expanded into the heap.";
	"Negative ZcbFree value (Memory manager error.  See TN-151)";
	"The file named 'Finder' can't be found on the disk.";
	"ShutDown Alert";
	"Unserviceable slot interrupt";
	"Bad opcode given to SANE package 4";
	"Menu Manager tried to access a menu that's been purged.";
	"Menu bar not found";
	"Menu find error";
	"Can't mount system startup volume.  The system couldn't read the system resource file into memory.";
	"'Sorry, a system error occurred':  Default alert message";
	"Mem Mgr Err";
	"Unlisted error.  See IM III-205"
	 }
};


#if qTemplateViews
resource 'view' (kTranscriptWindowType,
#if qNames
	"TranscriptWindowType",
#endif
	purgeable)  { {
	root, 'WIND', { 270, 40 }, { 80, 410 }, sizeVariable, sizeVariable, notShown, enabled,
	Window {
		"",
			zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick, dontFreeOnClosing,
			disposeOnFree, closesDocument, openWithDocument, dontAdaptToScreen,
			dontStagger, ForceOnScreen, dontCenter, kIDTranscriptView, "Debug Transcript <<<>>>" };

	'WIND', 'SCLR', { 0, 0 }, { 80-kSBarSizeMinus1, 410-kSBarSizeMinus1 },
	sizeRelSuperView, sizeRelSuperView, shown, enabled,
	Scroller {
		"",
			vertScrollBar, horzScrollBar, 0, 0, 16, 16,
			vertConstrain, horzConstrain, { 0, 0, 0, 0 } };
	
	'SCLR', kIDTranscriptView, { 0, 0 }, { 500, 500 }, sizeVariable, sizeVariable, shown, disabled,
	View {
		"TTranscriptView" }
} };
#else

/* This guy is used when the template stuff isn't */
resource 'WIND' (kTranscriptWindowType,
#if qNames
	"TranscriptWindowType",
#endif
	purgeable) {
	{20, 20, 250, 215},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"Debug Transcript <<<>>>"
};
#endif

resource 'SICN' (kDebugSICN,
#if qNames
	"MacApp Debugger",
#endif
	purgeable) {
	{	/* array: 1 elements */
		/* [1] */
		$"00 00 FF FF FF FF FF FF 00 00 88 8E D9 49 AA 29"
		$"8B E9 8A 29 8A 2E 00 00 FF FF FF FF FF FF"
	}
};

