{Copyright  1989 by Apple Computer, Inc.  All rights reserved.}




{-------------------------------------------------------------------------------------------}
{--------------------------------TIconApplication methods-----------------------------------}
{-------------------------------------------------------------------------------------------}

PROCEDURE TIconApplication.IIconApplication(iconFileType: OSType);

BEGIN
	IApplication(iconFileType);
END;



{-------------------------------------------------------------------------------------------}

FUNCTION  TIconApplication.DoMakeDocument(itsCmdNumber: CmdNumber): TDocument; OVERRIDE;

VAR
	anIconDocument:		TIconDocument;

BEGIN
	New(anIconDocument);							{ Create a TIconDocument object.		}
	FailNIL(anIconDocument);						{ Make sure we were successful.			}
	anIconDocument.IIconDocument;					{ Initialize it.						}

	DoMakeDocument := anIconDocument;				{ Return a reference to the document.	}
END;
	
	
	
	
{-------------------------------------------------------------------------------------------}
{----------------------------------TIconDocument methods------------------------------------}
{-------------------------------------------------------------------------------------------}

PROCEDURE TIconDocument.IIconDocument;

BEGIN
	IDocument(kFileType, 							{ This document's file type.			}
			  kSignature, 							{ This document's creator.				}
			  kUsesDataFork, 						{ This document does use the data fork	}
			  NOT kUsesRsrcFork,					{ but doesn't use the resource fork.	}
			  NOT kDataOpen,						{ We don't want the data fork kept open	}
			  NOT kRsrcOpen);						{ nor the resource fork.				}

	{ Here you will initialize the data specific to your document. }
END;


{-------------------------------------------------------------------------------------------}

PROCEDURE TIconDocument.DoInitialState; OVERRIDE;

BEGIN
	{ Here you will set your documents data to its new state. }
END;


{-------------------------------------------------------------------------------------------}

PROCEDURE TIconDocument.Free; OVERRIDE;
	
BEGIN
	{ Here you will free any memory allocated in your documents initialization methods. 	}

	INHERITED Free;
END;


{-------------------------------------------------------------------------------------------}

PROCEDURE TIconDocument.DoMakeViews(forPrinting: boolean); OVERRIDE;

BEGIN
	{ Do nothing for now. }
END;



	