/*********************************************************************************/
/* IconEdit.r																	 */
/*																				 */
/* Copyright  1988, 1989 Apple Computer, Inc.  All rights reserved. 			 		 */
/* 																				 */
/*********************************************************************************/

/* ==============================   Includes   ================================= */

#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#ifdef Debugging
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Printing.rsrc";

include "IconEdit" 'CODE';

/* ==============================   Constants   ================================ */

#define cZoomIn				1000
#define cZoomOut			1001
#define cInvert				1002
#define cDrawCommand		1003

#define kSeedIconId			1000
#define kIconWindowId		1000
#define kIconEditViewId		1001
#define kPencilCursorId		1000

#define kIconViewHeight		32 * 7 + 10	 /* 7 times actual size, 5 pixel borders */
#define kIconViewWidth		32 * 7 + 10	 /* 7 times actual size, 5 pixel borders */

#define kIconWindowHeight	kIconViewHeight + kSBarSizeMinus1
#define kIconWindowWidth	kIconViewWidth + kSBarSizeMinus1


/* =====================   The overall package version   ====================== */
RESOURCE 'vers' (2,
#if qNames
"Package Version",
#endif
	purgeable) {
	0x02,
	0x00,
	beta,
	0x08,
	verUs,
	"2.08",
	"MacApp 2.08, Apple Computer, Inc. 1985-1989"
};


/* =================   The revision of this particular file   ================= */
RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x00,
	beta,
	0x08,
	verUs,
	"1.08",
	"IconEdit 1.08, Apple Computer, Inc. 1988-1989"
};

/*--------------------------------------------------------------------------------
 MultiFinder/Switcher info
--------------------------------------------------------------------------------*/
resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	(720-32) * 1024,
	(620-32) * 1024
#else
	(600-32) * 1024,
	(500-32) * 1024
#endif
};

/* ============================   Bundle Stuff   ============================== */

resource 'ICN#' (128, "Application Icon") {
	{
	$"0007 FF80 0008 0000 0008 7E20 0028 0120 0048 0120 0488 0120 0D08 0120 0808 0120"
	$"6608 0120 9908 0120 8108 FE20 8008 0020 8008 0020 4A00 0028 3400 3F24 80FC 4082"
	$"4300 8041 2401 3022 1401 C814 0BEE 7F8F 0402 0007 0211 0007 0120 8007 00A0 6007"
	$"0058 1FE7 0024 021F 0010 C407 0009 2800 0006 5000 0002 A800 0001 4800 0000 9000",
	
	$"0007 FF80 000F FFC0 001F FFE0 003F FFE0 007F FFE0 04FF FFE0 0DFF FFE0 0BFF FFE0"
	$"67FF FFE0 FFFF FFE0 FFFF FFE0 FFFF FFE0 FFFF FFF0 7FFF FFF8 7FFF FFFC FFFF FFFE"
	$"7FFF FFFF 3FFF FFFE 1FFF FFFC 0FFF FFFF 07FF FFFF 03FF FFFF 01FF FFFF 00FF FFFF"
	$"007F FFFF 003F FE1F 001F FC07 000F F800 0007 F000 0003 E800 0001 C800 0000 9000"
	}
};

resource 'ICN#' (129, "Document Icon") {
	{
	$"0FE7 FF80 0808 0000 0808 7E20 0808 0120 0008 0128 0408 0124 0C08 012E 0808 0122"
	$"6608 0122 9908 0122 8108 FE22 8008 0022 8008 0022 4A00 1F22 3400 0022 00FC 0022"
	$"0300 0002 0401 FFF2 0400 0008 03E0 1FE4 0810 0552 0810 00A9 0820 0001 0820 01FE"
	$"0818 0000 0804 0002 0800 C002 0801 2002 0802 5002 0800 8802 0800 0802 0FFF 93FE",

	$"0FFF FF80 0FFF FFC0 0FFF FFE0 0FFF FFF0 0FFF FFF8 0FFF FFFC 0FFF FFFE 0FFF FFFE"
	$"6FFF FFFE FFFF FFFE FFFF FFFE FFFF FFFE FFFF FFFE 7FFF FFFE 3FFF FFFE 0FFF FFFE"
	$"0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFF 0FFF FFFF 0FFF FFFE"
	$"0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE"
	}
};

/* ----------------------------------------------------------------------------- */

type 'ICED' as 'STR ';

resource 'ICED' (0) {				/* Creator (or Signature) */
	"IconEdit";
};

/* ----------------------------------------------------------------------------- */

resource 'FREF' (128) {
	'APPL', 0, ""	/* Show files of type 'APPL' with ICN# with local ID 0 */
};

resource 'FREF' (129) {
	'ICON', 1, ""	/* Show files of type 'ICON' with ICN# with local ID 1 */
};

/* ----------------------------------------------------------------------------- */

resource 'BNDL' (128) {
	'ICED',		/* Application signature (creator) */
	0,			/* Resource ID of version data */
	{
		'ICN#',	/* This is how to map local ICN# ids into resource IDs */
		{
			0, 128;	/* Local ICN# 0 is in resource 128 */
			1, 129	/* Local ICN# 1 is in resource 129 */
		};
		'FREF',	/* This is how to map local FREF ids into resource IDs */
		{
			0, 128;	/* Local FREF 0 (arbitrary) is in resource 128 */
			1, 129	/* Local FREF 1 (also arbitrary) is in resource 129 */
		}
	}
};

/* ============================   About Box   ============================== */
resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 75, 150, 316},
		StaticText {
			disabled,
			"This sample program implements a\n"
			"simple icon editor with MacApp."
			"\n\nThis program was written "
			"with MacApp  1985-1989 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	{90, 100, 280, 412},
	201,
	{
	OK, visible, silent;
	OK, visible, silent;
	OK, visible, silent;
	OK, visible, silent
	}
};

/* ============================   Pencil Cursor   ============================== */

resource 'CURS' (kPencilCursorId, purgeable) {
	$"00F0 0088 0108 0190 0270 0220 0440 0440 0880 0880 1100 1E00 1C00 1800 10",
	$"00F0 00F8 01F8 01F0 03F0 03E0 07C0 07C0 0F80 0F80 1100 1200 1400 1800 10",
	{14, 3}
};

/* =============================   Icon Window   =============================== */

resource 'view' (kIconWindowId, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { kIconWindowHeight, kIconWindowWidth },
		sizeVariable, sizeVariable, shown, enabled,
		Window		{ "TWindow", zoomDocProc, goAwayBox, resizable, modeless,
					ignoreFirstClick, freeOnClosing, disposeOnFree, closesDocument,
					openWithDocument, dontAdaptToScreen, stagger, forceOnScreen,
					dontCenter, 'ICON', "" };

		'WIND', 'SCLR',	{ 0, 0 },
		{ kIconWindowHeight-kSBarSizeMinus1, kIconWindowWidth-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller	{ "TScroller", vertScrollBar, horzScrollBar, 0, 0, 16, 16,
					vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR', IncludeViews	{ kIconEditViewId }
	}
};

resource 'view' (kIconEditViewId, purgeable) {
	{
		root, 'ICON', { 0, 0 }, { kIconViewHeight, kIconViewWidth },
		sizeVariable, sizeVariable, shown, enabled,
		View		{ "TIconEditView"}
	}
};

/* ==============================   Seed Icon   ================================ */

resource 'ICON' (kSeedIconId, purgeable) {
	$"0001 0000 0002 8000 0004 4000 0008 2000 0010 1000 0020 0800 0040 0400 0080 0200"
	$"0100 0100 0200 0080 0400 0040 0800 0020 1000 0010 2000 0008 4000 3F04 8000 4082"
	$"4000 8041 2001 3022 1001 C814 080E 7F8F 0402 3007 0201 0007 0100 8007 0080 6007"
	$"0040 1FE7 0020 021F 0010 0407 0008 0800 0004 1000 0002 2000 0001 4000 0000 8000"
};

/* ================================   Menus   ================================== */

resource 'cmnu' (1) {
	1,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	 {
	/* [1] */	"About IconEdit",	noIcon,	noKey,	noMark,	plain,	cAboutApp;
	/* [2] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand
	}
};

/* ------------------------------------------------------------------------------ */

resource 'cmnu' (2) {
	2,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	 {
	/* [1] */	"New",				noIcon,	"N",	noMark,	plain,	cNew;
	/* [2] */	"Open",			noIcon,	"O",	noMark,	plain,	cOpen;
	/* [3] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [4] */	"Close",			noIcon,	noKey,	noMark,	plain,	cClose;
	/* [5] */	"Save",				noIcon,	noKey,	noMark,	plain,	cSave;
	/* [6] */	"Save As",			noIcon,	noKey,	noMark,	plain,	cSaveAs;
	/* [7] */	"Revert to Saved",	noIcon,	noKey,	noMark,	plain,	cRevert;
	/* [8] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [9] */	"Page Setup",		noIcon,	noKey,	noMark,	plain,	cPageSetup;
	/* [10] */	"Print",			noIcon,	noKey,	noMark,	plain,	cPrint;
	/* [11] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [12] */	"Quit",				noIcon,	"Q",	noMark,	plain,	cQuit
	}
};

/* ------------------------------------------------------------------------------ */

resource 'cmnu' (3) {
	3,
	textMenuProc,
	allEnabled,
	enabled,
	"Edit",
	 {
	/* [1] */	"Undo",				noIcon,	"Z",	noMark,	plain,	cUndo;
	/* [2] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [3] */	"Cut",				noIcon,	"X",	noMark,	plain,	cCut;
	/* [4] */	"Copy",				noIcon,	"C",	noMark,	plain,	cCopy;
	/* [5] */	"Paste",			noIcon,	"V",	noMark,	plain,	cPaste;
	/* [6] */	"Clear",			noIcon,	noKey,	noMark,	plain,	cClear;
	/* [7] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [8] */	"Show Clipboard",	noIcon,	noKey,	noMark,	plain,	cShowClipboard
	}
};

/* ------------------------------------------------------------------------------ */

resource 'cmnu' (4) {
	4,
	textMenuProc,
	allEnabled,
	enabled,
	"Icon",
	 {
	/* [1] */	"Zoom In", 			noIcon, "M",	noMark, plain,	cZoomIn;
	/* [2] */	"Zoom Out", 		noIcon, "L", 	noMark, plain,	cZoomOut;
	/* [3] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [4] */	"Invert", 			noIcon, "I", 	noMark, plain,	cInvert
	}
};

/* ------------------------------------------------------------------------------ */

resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	 {
	/* [1] */	"Page Setup Change", noIcon, noKey, noMark, plain, cChangePrinterStyle;
	/* [2] */	"Drawing", noIcon, noKey, noMark, plain, cDrawCommand
	}
};

/* ------------------------------------------------------------------------------ */

resource 'MBAR' (128) { {1; 2; 3; 4} };
