// =============================== standard includes =======================================
#ifndef __TYPES.R__
#include "Types.r"					// SIZE, WIND, STR  , MBAR etc.
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"				// needed for version resource
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"			// cmnu, etc.
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"				// view resources
#endif

#if qDebug
include "Debug.rsrc";				// always include
#endif

include "MacApp.rsrc" not 'ckid';		// always include
include "Printing.rsrc" not 'ckid';		// include standard MacApp printing resources

include "CRCCards" 'CODE';					// include youe CODE resources when running Rez
include "views.rsrc" not 'ckid';				
include "TypeMenu.rsrc" not 'ckid';			
include "Misc.rsrc" not 'ckid';					

// =============================== optional includes =======================================
include "Defaults.rsrc"	'cmnu' (mApple);				// default Apple menu
include "Defaults.rsrc"	'cmnu' (mFile);				// default File menu
include "Defaults.rsrc"	'cmnu' (mEdit);				// default Edit menu

#define cNewCardCmd					1001
#define cDeleteCardCmd				1002
#define cEditCardCmd					1003
#define cWriteCodeCmd				1004
#define cDelFieldCmd					1005
#define cDelMethodCmd				1006
#define cDelCollaboratorCmd		1007
#define cAddFieldCmd					1008
#define cAddMethodCmd				1009
#define cAddCollaboratorCmd		1010
#define cMoveViewCmd					1011
#define cChangeNameCmd				1012
#define cChangeSuperClassCmd		1013
#define cInPascalCmd 				1014
#define cInCPPCmd 					1015
#define cChangeFieldCmd 			1016
#define cChangeMethodCmd 			1017
#define cChangeCollaboratorCmd	1018

// =============================== debug window =================================
resource 'dbug' (kDebugParamsID,
#if qNames
"Debug",
#endif
	purgeable) {
		{350, 4, 450, 450},	// Bounding rect for debug window (or normal)
		396, 						// Font rsrc ID (monaco)
		9,				 			// Font size (normal = 9)
		60,						// Number of lines (normal = 120)
		90,						// Width of lines in characters (normal = 100)
		openInitially,			// open initially
		"Steve's Debug Window"	// Window title
};

//--------------------------------------------------------------------------------
resource 'seg!' (256,
#if qNames
"CRCCards",
#endif
	purgeable) {
	{	
		"GNonRes";
		"GDoCommand";
		"GOpen";
		"GSelCommand";
		"GClose";
		"GClipBoard";
		"GFile";
		"GWriteFile";
		"GPrint";
		"GTerminate";
		"GDebugger";
		"ATextHandler";
	}
};

resource 'mem!' (256,
#if qNames
"CRCCards",
#endif
	purgeable) {
	15 * 1024,		// Add to temporary reserve   
	0,					// Emergency reserve   
	10 * 1024		// Add to stack space   
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved, reserved, reserved, reserved, reserved, reserved, reserved,
#if qDebug
	1000 * 1024,
	750 * 1024
#else
	500 * 1024,
	400 * 1024
#endif
};



resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	 {
		"Page Setup Change", noIcon, noKey, noMark, plain, cChangePrinterStyle;
		"Typing", noIcon, noKey, noMark, plain, cTyping;
		"Card Move", noIcon, noKey, noMark, plain, cMoveViewCmd
	}

};

resource 'cmnu' (4) {
	4,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Design",
	 {
		"Edit Card", noIcon, noKey, noMark, plain, cEditCardCmd;
		"Add Card", noIcon, noKey, noMark, plain, cNewCardCmd;
		"Delete Card", noIcon, noKey, noMark, plain, cDeleteCardCmd;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Write Source Code", noIcon, noKey, noMark, plain, cWriteCodeCmd;
		"Pascal", noIcon, noKey, noMark, plain, cInPascalCmd;
		"C++", noIcon, noKey, noMark, plain, cInCPPCmd;
	}
};

resource 'cmnu' (5) {
	5,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Card",
	 {
		"Change Class Name", noIcon, noKey, noMark, plain, cChangeNameCmd;
		"Change Super Class", noIcon, noKey, noMark, plain, cChangeSuperClassCmd;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Add Field", noIcon, noKey, noMark, plain, cAddFieldCmd;
		"Add Method", noIcon, noKey, noMark, plain, cAddMethodCmd;
		"Add Collaborator", noIcon, noKey, noMark, plain, cAddCollaboratorCmd;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Delete Field", noIcon, noKey, noMark, plain, cDelFieldCmd;
		"Delete Method", noIcon, noKey, noMark, plain, cDelMethodCmd;
		"Delete Collaborator", noIcon, noKey, noMark, plain, cDelCollaboratorCmd;
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"card",
#endif
	purgeable) {
	{mApple; mFile; mEdit; 4; 5; }
};

RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x00,
	beta,
	0x05,
	verUs,
	"1.0a2",
	"1.0a2, 1990 Apple Computer, Inc.  All rights reserved."
};


resource 'vers' (2, ",Package Version", purgeable) {
	0x2,
	0x0,
	release,
	0x0,
	verUs,
	"1.0a2",
	"version 1.0a2",
};