Unit UCard;

INTERFACE

USES
	UMacApp,
	ToolUtils,
	Resources,
	Packages,
	UPrinting,
	UTEView,
	UDialog,
	UGridView,
	UCRCCards,
	UItem,
	UDesignDocument,
	UMyViews,
	UMyCommands,
	UTextHandler;


TYPE
	TCard = OBJECT(TObject)
		fDocument:					TDesignDocument;
		fDesignView:				TDesignView;
		fTextHandler:				TTextHandler;
		fClassName:					TItem;
		fSuperClass:				TItem;
		
		fEditView: 					TEditView;
		fSimpleCardView:		TSimpleView;
		fLocation: 					VPoint;
		
		fFieldList:					TMyList;
		fMethodList:				TMyMethodList;
		fCollaboratorList:	TMyList;
		
		FUNCTION TCard.GetDocument: TDesignDocument;
		PROCEDURE TCard.SetDocument(theDocument: TDesignDocument);
		FUNCTION TCard.GetDesignView: TDesignView;
		PROCEDURE TCard.SetDesignView(theDesignView: TDesignView);
		FUNCTION TCard.GetTextHandler: TTextHandler;
		PROCEDURE TCard.SetTextHandler(theTextHandler: TTextHandler);
		FUNCTION TCard.GetEditView: TEditView;
		PROCEDURE TCard.SetEditView(theEditView: TEditView);
		FUNCTION TCard.GetTheClass: TItem;
		PROCEDURE TCard.SetTheClass(anItem: TItem);
		FUNCTION TCard.GetTheSuperClass: TItem;
		PROCEDURE TCard.SetTheSuperClass(anItem: TItem);
		FUNCTION TCard.GetNumFields: ArrayIndex;
		FUNCTION TCard.GetNumMethods: ArrayIndex;
		FUNCTION TCard.GetNumCollaborators: ArrayIndex;
		PROCEDURE TCard.ChangeClass(theName: str255);
		PROCEDURE TCard.ChangeSuperClass(theName: str255);
		PROCEDURE TCard.ChangeField(theFieldItem: TFieldItem; 
																theName: Str255; theType: Str255);
		PROCEDURE TCard.ChangeMethod(theMethodItem: TMethodItem;
																	theName: Str255; IsOverride: Boolean);
		PROCEDURE TCard.ChangeCollaborator(theCollaboratorItem: TCollaboratorItem;
																				theName: Str255);		
		PROCEDURE TCard.CreateSimpleView(theDesignView: TDesignView; 
																		theDesignDoc: TDesignDocument);
		PROCEDURE TCard.DeleteSimpleView;
		PROCEDURE TCard.DeleteEditView;
		FUNCTION TCard.GetSimpleView: TSimpleView;
		PROCEDURE TCard.SetSimpleView(aSimpleView: TSimpleView);
		FUNCTION TCard.GetLocation: VPoint;
		PROCEDURE TCard.SetLocation(theLocation: VPoint);
		
		FUNCTION TCard.GetFields: TMyList;
		PROCEDURE TCard.SetFields(aFieldList: TMyList);
		FUNCTION TCard.GetMethods: TMyMethodList;
		PROCEDURE TCard.SetMethods(aMethodList: TMyMethodList);
		FUNCTION TCard.GetCollaborators: TMyList;
		PROCEDURE TCard.SetCollaborators(aCollaboratorList: TMyList);
		PROCEDURE TCard.AddCardToObjectLists(theCardToAdd: TCard);
		PROCEDURE TCard.RemoveCardFromObjectLists(theCardToRemove: TCard);
		PROCEDURE TCard.ChangeNameInObjectLists(theOldName, theNewName: Str255);
		PROCEDURE TCard.ICard(theDesignDoc: TDesignDocument; theLocation: VPoint);
		FUNCTION TCard.FieldPresent(theField: TFieldItem): boolean;
		FUNCTION TCard.GetFieldItemAtIndex(theIndex: ArrayIndex): TFieldItem;
		PROCEDURE TCard.AddFieldAtIndex(theField: TFieldItem; theIndex: ArrayIndex);
		FUNCTION TCard.GetIndexOfField(theField: TFieldItem): ArrayIndex;
		FUNCTION TCard.GetMethodItemAtIndex(theIndex: ArrayIndex): TMethodItem;
		FUNCTION TCard.GetIndexOfMethod(theMethod: TMethodItem): ArrayIndex;
		PROCEDURE TCard.AddMethodAtIndex(theMethod: TMethodItem; theIndex: ArrayIndex);
		FUNCTION TCard.GetCollaboratorItemAtIndex(theIndex: ArrayIndex): TCollaboratorItem;
		PROCEDURE TCard.AddCollaboratorAtIndex(theCollaborator: TCollaboratorItem; 
																						theIndex: ArrayIndex);
		FUNCTION TCard.GetIndexOfCollaborator(theCollaborator: TCollaboratorItem): ArrayIndex;
		PROCEDURE TCard.AddField(theField: TFieldItem);
		PROCEDURE TCard.AddMethod(theMethod: TMethodItem);
		PROCEDURE TCard.AddCollaborator(theCollaborator: TCollaboratorItem);
		PROCEDURE TCard.AddFieldsMethod;
		PROCEDURE TCard.DeleteField(theField: TFieldItem);
		PROCEDURE TCard.DeleteMethod(theMethod: TMethodItem);
		PROCEDURE TCard.DeleteCollaborator(theCollaborator: TCollaboratorItem);
		PROCEDURE TCard.WriteFieldInterface(theTEView: TMyTEView);
		PROCEDURE TCard.WriteMethodInterface(theTEView: TMyTEView);
		PROCEDURE TCard.WriteCollaboratorInterface(theTEView: TMyTEView);
		PROCEDURE TCard.WriteFwdClassDecl(theTEView: TMyTEView);
		PROCEDURE TCard.WriteInlineProcedures(theTEView: TMyTEView);
		PROCEDURE TCard.WriteInterface(theTEView: TMyTEView);
		PROCEDURE TCard.WriteImplementation(theTEView: TMyTEView);
		PROCEDURE TCard.TranslateTheCard(TheOldLanguage, TheNewLanguage:Integer);
		FUNCTION  TCard.ReturnBytes: LONGINT;
		PROCEDURE TCard.ReadCard(aRefNum: INTEGER);
		PROCEDURE TCard.WriteCard(aRefNum: INTEGER);
		PROCEDURE TCard.Free; OVERRIDE;
		PROCEDURE TCard.SetupFieldsMode;
		PROCEDURE TCard.SetupMethodsMode;
		PROCEDURE TCard.SetupCollaboratorsMode;
		PROCEDURE TCard.Fields(PROCEDURE DoToField(
							fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	END;

IMPLEMENTATION

{$I UCard.inc1.p}

END.