UNIT UTextHandler;

INTERFACE 

USES
	UMacApp,
	ToolUtils,
	Resources,
	Packages,
	UPrinting,
	UTEView,
	UDialog,
	UGridView,
	UCRCCards,
	UItem,
	UCard,
	UDesignDocument,
	UMyViews,
	UMyCommands;


CONST
	kInPascal = 1; {formerly kPascalStringOffset}
	kInCPP = 2; {formerly kCPPStringOffset}
	kNumberOfLanguages = 2;
	kTypeTableWidth = kNumberOfLanguages + 2;
	kTypeTableID = 1002;
	kObjectMenuID = 1003;
	kFieldsTypeOffset = kNumberOfLanguages + 1;
	kByAddressOffset = kNumberOfLanguages + 2;
	kTableEntryNotFound = MAXINT;

	
	
TYPE
	TTypeTablePointer = ^TTypeTableElement;
	TTypeTableElement = RECORD
		TypeName: ARRAY [1..kNumberOfLanguages] OF Str63;
		FieldsTypeConst : Str63;
		byAddress : boolean;		{if the type must be passed by address explitly in C++}
	END;											{most decent languages take care of this for you.}

	TTextHandler = OBJECT(TObject)
	
		{Data Structures}
		
		{Fields}
		fDesignDocument: TDesignDocument;
		fNumberOfElements: INTEGER;
		fTypeTable: TDynamicArray;
		fLanguage: Integer;
		
		{Methods}
		FUNCTION TTextHandler.GetDesignDocument: TDesignDocument;
		PROCEDURE TTextHandler.SetDesignDocument(theDesignDoc: TDesignDocument);
		FUNCTION TTextHandler.GetLanguage:Integer;
		PROCEDURE TTextHandler.SetLanguage(theLanguage:	Integer);
		PROCEDURE TTextHandler.ITTextHandler(theDesignDoc: TDesignDocument);
		PROCEDURE TTextHandler.Replace(VAR origString: str255; pattern, replacement: str255);
		FUNCTION TTextHandler.GetAndEntabRsrcString(itsResourceID:Integer):Str255;
		FUNCTION TTextHandler.GetTypeDefStr(theCard:TCard):Str255;
		FUNCTION TTextHandler.GetHeadingStr:Str255;
		FUNCTION TTextHandler.GetFieldsInterfaceStr:Str255;
		FUNCTION TTextHandler.GetMethodsInterfaceStr:Str255;
		FUNCTION TTextHandler.GetCollaboratorsInterfaceStr:Str255;
		FUNCTION TTextHandler.GetEndOfTypeDefStr:Str255;
		FUNCTION TTextHandler.GetStdMethStr(TheMethodItem:TMethodItem):Str255;
		FUNCTION TTextHandler.GetOverrideMethStr(TheMethodItem:TMethodItem):Str255;
		FUNCTION TTextHandler.GetStdImplMethStr(TheMethodItem:TMethodItem):Str255;
		FUNCTION TTextHandler.GetOverrideImplMethStr(TheMethodItem:TMethodItem):Str255;
		FUNCTION TTextHandler.GetGetAccessorStr(TheAccessorItem:TAccessorItem):Str255;
		FUNCTION TTextHandler.GetSetAccessorStr(TheAccessorItem:TAccessorItem):Str255;
		FUNCTION TTextHandler.GetImplGetAccessorStr(TheAccessorItem:TAccessorItem):Str255;
		FUNCTION TTextHandler.GetImplSetAccessorStr(TheAccessorItem:TAccessorItem):Str255;
		FUNCTION TTextHandler.GetImplementationStr:Str255;
		FUNCTION TTextHandler.GetUnitEndStr:Str255;
		FUNCTION TTextHandler.GetImplementationNoteStr(TheCard:TCard):Str255;
		FUNCTION TTextHandler.GetImplIncFileStr:Str255;
		FUNCTION TTextHandler.GetGetAccessorImplementation(TheGetAccessorItem:TGetAccessorItem):Str255;
		FUNCTION TTextHandler.GetSetAccessorImplementation(TheSetAccessorItem:TSetAccessorItem):Str255;
		FUNCTION TTextHandler.GetStdMethodImplementationStr(TheMethodItem:TMethodItem):Str255;
		FUNCTION TTextHandler.GetFieldsMethodDecStr(TheFieldsMethodItem:TFieldsMethodItem):Str255;
		FUNCTION TTextHandler.GetImplFieldsMethodDecStr(TheFieldsMethodItem:TFieldsMethodItem):Str255;
		FUNCTION TTextHandler.GetFieldsMethodImpStr1:Str255;
		FUNCTION TTextHandler.GetFieldsMethodImpStr2(TheFieldsMethodItem:TFieldsMethodItem):Str255;
		FUNCTION TTextHandler.GetFieldsMethodImpStr3:Str255;
		FUNCTION TTextHandler.GetFieldsMethodCodeLineStr(theFieldItem: TFieldItem):Str255;
		FUNCTION TTextHandler.GetTheTypeName(index:ArrayIndex): Str63;
		FUNCTION TTextHandler.ReturnFieldsTypeConst(theFieldItem: TFieldItem): str255;
		FUNCTION TTextHandler.ReturnByAddress(theFieldItem: TFieldItem): BOOLEAN;
		FUNCTION TTextHandler.GetIncludeStatement:Str255;
		FUNCTION TTextHandler.GetFieldItemDeclaration(theFieldItem:TFieldItem):Str255;
		FUNCTION TTextHandler.GetFieldItemImplDeclaration(theFieldItem:TFieldItem):Str255;
		FUNCTION TTextHandler.GetCollaboratorDeclaration
					(theCollaboratorItem:TCollaboratorItem):Str255;
		FUNCTION TTextHandler.GetImplCollaboratorDeclaration
					(theCollaboratorItem:TCollaboratorItem):Str255;
		FUNCTION TTextHandler.GetInterfaceFileName(theName: str255):Str255;
		FUNCTION TTextHandler.GetImplementationFileName(theName: str255):Str255;

		{typeTable methods}
		PROCEDURE TTextHandler.ReadInTypeTable;
		PROCEDURE TTextHandler.SetItemTypeMenu(thePopupMenu : TPopup);
		PROCEDURE TTextHandler.SetSuperClassTypeMenu(thePopupMenu : TPopup);
		PROCEDURE TTextHandler.SetCollaboratorsMenu(thePopupMenu : TPopup);
		PROCEDURE TTextHandler.ChangeLanguageTo(TheNewLanguage:Integer);
		FUNCTION TTextHandler.FindTypeTableEntry(TheLanguage : Integer; TheItem: TFieldItem):ArrayIndex;
		PROCEDURE TTextHandler.TranslateTheItem(TheOldLanguage, TheNewLanguage: Integer;
																			TheItem: TFieldItem);
		
		PROCEDURE TTextHandler.CheckFileName(VAR theName: str255);
		FUNCTION TTextHandler.GetInlineSetAccessorStr(TheSetAccessorItem:TSetAccessorItem):Str255;
		FUNCTION TTextHandler.GetInlineGetAccessorStr(TheGetAccessorItem:TGetAccessorItem):Str255;
		FUNCTION TTextHandler.GetFwdClassDeclStr(TheCard:TCard):Str255;
		PROCEDURE TTextHandler.Free;	OVERRIDE;
		PROCEDURE TTextHandler.Fields(PROCEDURE DoToField(
				fieldName: Str255; fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	END;


IMPLEMENTATION

{$I UTextHandler.inc1.p}
	
END.
