/* MacApp Drafter										*/
/* 							 							*/
/* File: MacApp Drafter.r								*/
/* 							 							*/
/* A sample C++ program by Danie Underwood				*/
/*														*/
/* Apple Integrated Systems								*/
/*														*/
/* 1990 Apple Computer, Inc.  All rights reserved.		*/



#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#if qDebug
include "Debug.rsrc";
#endif

include "MacApp.rsrc";
include "Dialog.rsrc";
include "Printing.rsrc";

include $$Shell("ObjApp")"MacApp Drafter" 'CODE';

include $$Shell("SrcApp")"MacApp Drafter.resources";
#include $$Shell("SrcApp")"MacApp DrafterViews.r";

type 'Text' {
	cstring;
};

#define	rText	'Text'


#include $$Shell("SrcApp")"MacApp DrafterData.r";



#define	kHierDisplayedMBar	131			/* MenuBar on hierarchical menu system */
#define	kDrafterStrings		10000

#define kSignature			'HELP'		/* Application signature */

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qdebug
	1500 * 1024,
	800 * 1024
#else
	900 * 1024,
	500 * 1024
#endif
};

/*	Printing to the LaserWriter is the time when the most temporary memory
	is in use.  We need the segments in use at that time */

resource 'seg!' (256, purgeable) {
	{
		"GWriteFile";
		"GClipboard";
		"GNonRes";
		"GFile";
		"GSelCommand";
		"GTerminate";
		"GClose";
		"GDoCommand";
	}
};

resource 'DITL' (phAboutApp, purgeable) {
	 {
			{160, 182, 180, 262},
			Button {
				enabled,
				"OK"
			};
			{10, 75, 150, 320},
			StaticText {
				disabled,
					"MacApp Drafter, a MacApp sample.\n"
					"by Danie UnderwoodApple Integrated Systems\n"
					"Apple Computer, Inc.\n"
					"\nThis program was written with MacApp 1985-1990 Apple Computer, Inc."
			};
			{10, 20, 42, 52},
			Icon {
				disabled,
				1
			}
	}
};

resource 'ALRT' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	{90, 80, 280, 482},
	phAboutApp,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};


include "Defaults.rsrc" 'cmnu' (mApple);		// Grab the default Apple/File menus
include "Defaults.rsrc" 'cmnu' (mFile);

resource 'cmnu' (mEdit) {
	mEdit,
	textMenuProc,
	AllEnabled,
	enabled,
	"Edit",
	 {
/* [ 1] */	"Undo",				noIcon,	"Z",	noMark,	plain,	cUndo;
/* [ 2] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [ 3] */	"Cut",				noIcon,	"X",	noMark,	plain,	cCut;
/* [ 4] */	"Copy",				noIcon,	"C",	noMark,	plain,	cCopy;
/* [ 5] */	"Paste",			noIcon,	"V",	noMark,	plain,	cPaste;
/* [ 6] */	"Clear",			noIcon,	noKey,	noMark,	plain,	cClear;
/* [ 7] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [ 8] */	"Select All",		noIcon,	"A",	noMark,	plain,	cSelectAll;
/* [ 9] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [10] */	"Show Clipboard",	noIcon,	noKey,	noMark,	plain,	cShowClipboard
	}
};

/* Displayed menus on a non-hierarchical system */
resource 'MBAR' (kMBarDisplayed) {
	{mApple; mFile; mEdit}
};

/* Displayed menus on a hierarchical system */
resource 'MBAR' (kHierDisplayedMBar) {
	{mApple; mFile; mEdit}
};

resource 'STR#' (kDefaultCredits,
#if qNames
	"kDefaultCredits",
#endif
	purgeable) {
	 {
	 "Special thanks to Ed Wischmeyer (Eds Airlines)";
	 " . . . and . . .";

	"The great people behind MacApp";

	"Engineers past and present";
	"Peter Alley";
	"Curt Bianchi";
	"Mary Boetcher";
	"Ken Doyle";
	"Steve Friedrich";
	"David Goldsmith";
	"Barry Haynes";
	"Chris Knepper";
	"Lonnie Millett";
	"Deb Orton";
	"Larry Rosenstein";
	"Larry Tesler";
	"Scott Wallace";
	"Russ Wetmore";

	"Testers past and present";
	"Dan Allen";
	"John Beswetherick";
	"Cliff Greyson";
	"Richard Kimberly";
	"Kuldip Nijjar";
	"Richard Rodseth";

	"Writers past and present";
	"Dave Bice";
	"Mikel Evins";
	"Bill Harris";
	"Marq Laube";
	"John Perry";
	"Don Reed";
	"Jon Simonoff";
	"Jon Singer";
	"Alan Spragens";
	"Andy Swartz";

	"Technical support past and present";
	"Darin Adler";
	"Mark Bennett";
	"Rick Blair";
	"Clarus the DogCow (Moof!)";
	"Bo3b Johnson";
	"Keith Rollin";
	"Andrew Shebanow";

	"Configuration Management";
	"Gary Davis";
	"Ming Low";

	"Product Managers past and present";
	"Harvey Alcabes";
	"Steve Burbeck";

	"Managers";
	"David Goldsmith (yes, he was a manager too!)";
	"Phac LeTuan";
	"Ron Metzker";
	"Jim Thomas";

	"Evangelizers";
	"Scott Knaster";
	"Jon Magill";
	"Gregg Williams";

	"MacApp Developers Association";
	"Bill Anderson";
	"Howard Katz";
	"Carl Nelson";
	"(206) 252-6946";

	"Other great people";
	"Rob Chandhok & John Pane @ Carnegie Mellon University";
	"Dan Cochran";
	"Eileen Crombie";
	"Patricia Eastman";
	"Ann Greyson";
	"Michael Hinkson";
	"Mark Lentczner";
	"Eileen Mayes";
	"Mom and Dad";
	"Kurt Schmucker";
	"Harry Yee";
	"Geri Younggren";
	"You, the billions and billions of MacApp programmers";

	"THE MacApp teachers";
	"Neal Goldstein";
	"Neil Rhodes";
	"Dave Wilson";

	"And because he insisted on being included";
	"Eagle I. Berns"

	 }
};

resource 'STR#' (kDrafterStrings,purgeable) {
	 {
	 	"MacApp Drafter";
		""
	}
};

resource 'BNDL' (128,
#if qNames
"Drafter",
#endif
	purgeable) {
	kSignature,
	0,
	{
		'ICN#',
		{0,128},
		'FREF',
		{0,128}
	}
};

type kSignature as 'STR ';
resource kSignature (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"MacApp Drafter 1.0\nBy Danie Underwood\nApple Integrated Systems\n1990 Apple Computer, Inc."
};

// Get the default MacApp application icon and file reference
include "Defaults.rsrc"  'FREF' (128);

// Version for the "application or file"
RESOURCE 'vers' (1,
#if qNames
	"Application Version",
#endif
	purgeable) {
	0x01,
	0x00,
	final,
	0x00,
	verUs,
	"1.0",
	"1.0, MacApp Drafter [a sample program]"
};

include "Defaults.rsrc"  'vers' (2);		// Overall package

type 'RGB#' {
	array RGBList {
		wide array ColorSpec {
				unsigned integer;		// RGB:	red
				unsigned integer;		//		green
				unsigned integer;		//		blue
		};
	};
};

resource 'RGB#' (1001,purgeable) {
	{
	 	{0xDAFF,0xC909,0x2847}		//Sort of brassy, goldy, yucky
	}
};

