/************************************************************

Created: Thursday, October 19, 1989 at 11:10 PM
	Balloons.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc. 1990
	All rights reserved


************************************************************/

#ifndef __BALLOONS__
#define __BALLOONS__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif



/* #define _Pack14			0xA830	  This is defined as a global already */

#define HMVersionWord			0x0001

	/* Help Mgr error range: -850 to -874 */		
#define hmHelpDisabled			-850
#define hmResNotFound			-851
#define hmMemFullErr			-852
#define hmBalloonAborted		-853
#define hmSameAsLastBalloon 	-854
#define hmBadSelector			-856
#define hmSkippedBalloon		-857
#define hmWrongVersion			-858
#define hmUnknownHelpType		-859
#define hmCouldNotLoadPackage	-860


#define hmGestaltHelpType		'help'
#define hmGestaltBalloonsOn 	0
#define hmGestaltBalloonsOff	1
		
#define kHMUsingHelpItem		1
#define kHMWhatIsItem			3
		
#define kHMHelpID				-5696
		
	/* System STR# resource indexes */
#define kHMMultiFinderIndex 	1
#define kHMMenuTitleIndex		2
#define kHMUsingHelpIndex		3
#define kHMWhatIsIndex			4
#define kHMInDragIndex			5
#define kHMInGrowIndex			6
#define kHMInGoAwayIndex		7
#define kHMInZoomIndex			8
#define kHMInScrollBar			9
#define kHMInDisabledScrollBar	10
#define kHMEasy1Access			11
#define kHMEasy2Access			12
#define kHMEasy3Access			13

	
	/* misc Constants */
#define kHMAboutHelpID		-5696
#define kHMHelpMenuID		-5696
#define kHMHelpIconOn		-5696
#define kHMHelpIconOff		-5695
	
	/* WhatIs default WDEF res ID */
#define kBalloonWDEFID		126
				
	/* Dialog item template type */
#define helpItem			1

	/* hrct Options */
#define kHMhrctAbsolute 	0
		
	/* Generic defines for the switch items used in 'hmnu' & 'hdlg' */
#define kHMEnabledItem		0
#define kHMDisabledItem 	1
#define kHMCheckedItem		2
#define kHMOtherItem		3

#define hdlgUseSubID		0		// if set then use sub ID's to fine res ID
#define hdlgLocalCoords 	1		// if set then use hdlg rects as local coords, ignoring item rects
#define hdlgSaveBits		2		// if set then use save bits behind balloon


	/* Option bits for hwin resources */
#define hwinUseResID			= 0;
#define hwinUseSubID			= 1;

	/* Constants for Help Types in 'hmnu', 'hdlg', 'hrct' resources */
#define HMStringItem		1
#define HMPictItem			2
#define HMStringResItem 	3
#define HMTEResItem 		6
#define HMSTRResItem		7
#define HMSkipItem			256
#define HMCompareItem		512
#define HMNamedResourceItem 1024
#define HMTrackCntlItem 	2048

		
	/* Constants for hmmHelpType's when filling out HMMessageRecord */
#define khmmString			1
#define khmmPict			2
#define khmmStringRes		3
#define khmmTEHandle		4
#define khmmPictHandle		5
#define khmmTERes			6
#define khmmSTRRes			7

#define kHMEnabled			1
#define kHMDisabled 		2
#define kHMChecked			4
#define kHMOther			8
		
	/* ResTypes for Styled TE Handles when extracting from Resources */
#define HMTEResType 		'thdl'
#define HMTEStyleType		'tsty'
#define HMSTHandleType		'tstb'
#define HMLHHandleType		'thtb'
		
		

typedef	struct
{
	short	hmmResID;
	short	hmmIndex;
} HMStringResType;

						


		


typedef	struct
{
	short			hmmHelpType;
	Str255			hmmString;
	
} HMStringMsgRecord, *HMStringMsgRecPtr;

typedef	struct
{
	short			hmmHelpType;
	short			hmmPict;
	char			fill[254];
	
} HMPictMsgRecord, *HMPictMsgRecPtr;

typedef	struct
{
	short			hmmHelpType;
	Handle			hmmTEHandle;
	char			fill[252];
	
} HMTEHMsgRecord, *HMTEHMsgRecPtr;

typedef	struct
{
	short			hmmHelpType;
	HMStringResType	hmmStrRes;
	char			fill[250];
	
} HMStrResMsgRecord, *HMStrResMsgRecPtr;

typedef	struct
{
	short			hmmHelpType;
	short			hmmResSTR;
	char			fill[252];
	
} HMResSTRMsgRecord, *HMResSTRMsgRecPtr;

typedef	struct
{
	short			hmmHelpType;
	PicHandle		hmmPictHandle;
	char			fill[252];
	
} HMPicHMsgRecord, *HMPicHMsgRecPtr;


typedef struct {
	short				hmVersion;
    HMStringMsgRecord	hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMDefaultRecord, *HMDefaultRecPtr;


typedef struct {
	short				hmVersion;
    HMStringMsgRecord	hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMStringDefaultRecord, *HMStringDefaultRecPtr;


typedef struct {
	short				hmVersion;
    HMPictMsgRecord		hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMPictDefaultRecord, *HMPictDefaultRecPtr;


typedef struct {
	short				hmVersion;
    HMTEHMsgRecord		hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMTEHDefaultRecord, *HMTEHDefaultRecPtr;


typedef struct {
	short				hmVersion;
    HMStrResMsgRecord	hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMStrResDefaultRecord, *HMStrResDefaultRecPtr;


typedef struct {
	short				hmVersion;
    HMPicHMsgRecord		hmDefMessage;
	short				hmHelpVRefNum;
	long				hmHelpDirID;
	Boolean				hmSearchAlternateFiles;
} HMPicHDefaultRecord, *HMPicHDefaultRecPtr;

typedef struct HMStringRecord {
	short				hmmHelpType;
	short				hmmFont;
	short				hmmFontSize;
	char				hmmMessage[256];
};


typedef	union	HMMessageRecord
{
	HMStringMsgRecord		HMStringMsg;
	HMPictMsgRecord			HMPictMsg;
	HMTEHMsgRecord			HMTEHMsg;
	HMStrResMsgRecord		HMStrResMsg;
	HMResSTRMsgRecord		HMResSTRMsg;
	HMPicHMsgRecord			HMPicHMsg;
} HMMessageRecord;

typedef	HMMessageRecord *HMMessageRecordPtr;

#ifdef __cplusplus
extern "C" {
#endif

pascal	short HMGetHelpMenuHandle(MenuHandle *mh)
		= {0x303C,0x0200,_Pack14};

pascal	short HMShowBalloon(	HMMessageRecord aHelpMsg,
								Point tip,
								Rect* alternateRect,
								Ptr tipProc,
								short theProc,short variant,
								Boolean saveBits)				
		= {0x303C,0x0B01,_Pack14};
				
pascal	short HMRemoveBalloon(void)
		= {0x303C,0x0002,_Pack14};
		
pascal	Boolean HMGetBalloons(void)
		= {0x303C,0x0003,_Pack14};					/* note: doesn't load package! */
		
pascal	short HMSetBalloons(Boolean flag)
		= {0x303C,0x0104,_Pack14};
		
pascal	short HMShowMenuBalloon(short itemNum,short itemMenuID,
								long itemFlags,long itemReserved,
								Point tip,
								Rect* alternateRect,
								Ptr	tipProc,
								short theProc,short variant)
		= {0x303C,0x0E05,_Pack14};

pascal	Boolean HMMouseInApplRgn(void)
		= {0x303C,0x0006,_Pack14};
		
pascal	Boolean HMIsBalloon(void)
		= {0x303C,0x0007,_Pack14};
		
pascal	short HMSetFont(short font)
		= {0x303C,0x0108,_Pack14};

pascal	short HMSetFontSize(short fontSize)
		= {0x303C,0x0109,_Pack14};

pascal	short HMGetFont(short *font)
		= {0x303C,0x020A,_Pack14};
		
pascal	short HMGetFontSize(short *fontSize)
		= {0x303C,0x020B,_Pack14};

pascal	short HMSetDialogResID(short resID)
		= {0x303C,0x010C,_Pack14};

pascal	short HMSetMenuResID(short menuID,short resID)
		= {0x303C,0x020D,_Pack14};

pascal	short HMBalloonRect(HMMessageRecord aHelpMsg,
								Rect *coolRect)
		= {0x303C,0x040E,_Pack14};				

pascal	short HMBalloonPict(HMMessageRecord aHelpMsg,
								Handle *coolPict)
		= {0x303C,0x040F,_Pack14};	
		
pascal	short HMScanTemplateItems(short whichID,short whichResFile,
								ResType whichType)
		= {0x303C,0x0410,_Pack14};	
	
		
pascal	short HMExtractHelpMsg(ResType whichType, short whichResID, short whichMsg,
								short whichState,
								HMMessageRecord *aHelpMsg)
		= {0x303C,0x0711,_Pack14};	

pascal	short HMFillCitationString(StringPtr origString, StringPtr stuffString,
								short key)
		= {0x303C,0x0512,_Pack14};	

pascal	short HMGetDialogResID(short *resID)
		= {0x303C,0x0213,_Pack14};

pascal	short HMGetMenuResID(short menuID,short *resID)
		= {0x303C,0x0314,_Pack14};

pascal	short HMGetBalloonWindow(WindowPtr *window)
		= {0x303C,0x0215,_Pack14};
		
#ifdef __cplusplus
}
#endif

#endif

