/************************************************************

Created: Friday, October 20, 1989 at 2:00 AM
	Devices.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	 1985-1990
	All rights reserved

************************************************************/


#ifndef __DEVICES__
#define __DEVICES__

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

enum {newSelMsg = 12};
enum {fillListMsg = 13};
enum {getSelMsg = 14};
enum {selectMsg = 15};
enum {deselectMsg = 16};
enum {terminateMsg = 17};
enum {buttonMsg = 19};
enum {chooserID = 1};
enum {initDev = 0};         /*Time for cdev to initialize itself*/
enum {hitDev = 1};          /*Hit on one of my items*/
enum {closeDev = 2};        /*Close yourself*/
enum {nulDev = 3};          /*Null event*/
enum {updateDev = 4};       /*Update event*/
enum {activDev = 5};        /*Activate event*/
enum {deactivDev = 6};      /*Deactivate event*/
enum {keyEvtDev = 7};       /*Key down/auto key*/
enum {macDev = 8};          /*Decide whether or not to show up*/
enum {undoDev = 9};
enum {cutDev = 10};
enum {copyDev = 11};
enum {pasteDev = 12};
enum {clearDev = 13};
enum {cursorDev = 14};
enum {cdevGenErr = -1};     /*General error; gray cdev w/o alert*/
enum {cdevMemErr = 0};      /*Memory shortfall; alert user please*/
enum {cdevResErr = 1};      /*Couldn't get a needed resource; alert*/
enum {cdevUnset = 3};       /* cdevValue is initialized to this*/

struct DCtlEntry {
	Ptr dCtlDriver;
	short dCtlFlags;
	QHdr dCtlQHdr;
	long dCtlPosition;
	Handle dCtlStorage;
	short dCtlRefNum;
	long dCtlCurTicks;
	WindowPtr dCtlWindow;
	short dCtlDelay;
	short dCtlEMask;
	short dCtlMenu;
};

typedef struct DCtlEntry DCtlEntry;
typedef DCtlEntry *DCtlPtr, **DCtlHandle;

struct AuxDCE {
	Ptr dCtlDriver;
	short dCtlFlags;
	QHdr dCtlQHdr;
	long dCtlPosition;
	Handle dCtlStorage;
	short dCtlRefNum;
	long dCtlCurTicks;
	GrafPtr dCtlWindow;
	short dCtlDelay;
	short dCtlEMask;
	short dCtlMenu;
	char dCtlSlot;
	char dCtlSlotId;
	long dCtlDevBase;
	Ptr dCtlOwner;
	char dCtlExtDev;
	char fillByte;
};

typedef struct AuxDCE AuxDCE;
typedef AuxDCE *AuxDCEPtr, **AuxDCEHandle;

#ifdef __cplusplus
extern "C" {
#endif
pascal DCtlHandle GetDCtlEntry(short refNum);
pascal Boolean SetChooserAlert(Boolean f);
pascal OSErr OpenDriver(const Str255 name,short *drvrRefNum);
OSErr opendriver(char *driverName,short *refNum);
pascal OSErr CloseDriver(short refNum); 
pascal OSErr Control(short refNum,short csCode,Ptr csParamPtr); 
pascal OSErr Status(short refNum,short csCode,Ptr csParamPtr);
pascal OSErr KillIO(short refNum);
pascal OSErr PBControl(ParmBlkPtr paramBlock,Boolean aSync);
pascal OSErr PBStatus(ParmBlkPtr paramBlock,Boolean aSync); 
pascal OSErr PBKillIO(ParmBlkPtr paramBlock,Boolean aSync); 
#ifdef __cplusplus
}
#endif

#endif
