/************************************************************

Created: Thursday, November 2, 1989
	EPPC.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	 1985-1990
	All rights reserved

************************************************************/

#ifndef __EPPC__
#define __EPPC__

#ifndef __PPCTOOLBOX__
#include <PPCToolbox.h>
#endif

#ifndef __PROCESSES__
#include <Processes.h>
#endif

#ifndef __EVENTS__
#include <Events.h>
#endif

enum {kHighLevelEvent = 23};

/* postOptions currently supported */

enum {receiverIDMask = 0x0000F000};
enum {receiverIDisPSN = 0x00008000};
enum {receiverIDisSignature = 0x00007000};
enum {receiverIDisSessionID = 0x00006000};
enum {receiverIDisTargetID = 0x00005000};
enum {systemOptionsMask = 0x00000F00};
enum {nReturnReceipt = 0x00000200};
enum {priorityMask = 0x000000FF};
enum {nAttnMsg = 0x00000001};
enum {registerOnNetwork = 0x80000000};

/*  error returns from Post and Accept */

enum {bufferIsSmall = -607};
enum {noOutstandingHLE = -608};
enum {connectionInValid = -609};

/*  constant for return receipts */

#define HighLevelEventMsgClass 'jaym'
#define rtrnReciptMsgID 'rtrn'
enum {msgWasPartiallyAccepted = 2};
enum {msgWasFullyAccepted = 1};
enum {msgWasNotAccepted = 0};

struct TargetID {
	long			sessionID;
	PortName		name;
	LocName 		location;
	PortName		recvrName;
};
typedef struct TargetID TargetID;

typedef struct TargetID *TargetIDPtr, SenderID, *SenderIDPtr;

typedef struct HighLevelEventMsg {
	unsigned short	HighLevelEventMsgHeaderLength;		
	unsigned short	version;
	unsigned long	reserved1;
	EventRecord		theMsgEvent;
	unsigned long	userRefcon;
	unsigned long	postingOptions;
	unsigned long	msgLength;
	};

typedef struct HighLevelEventMsg HighLevelEventMsg;

typedef struct HighLevelEventMsg *HighLevelEventMsgPtr, **HighLevelEventMsgHdl;

typedef pascal Boolean (*GetSpecificFilterProcPtr) (unsigned long *param, HighLevelEventMsgPtr msgBuff, TargetID *sender);

pascal OSErr
PostHighLevelEvent(EventRecord	*theEvent,
				unsigned long	receiverID, 
				unsigned long	msgRefcon,
				Ptr 			msgBuff,
				unsigned long	msgLen,
			unsigned long	postingOptions)
	= {0x3F3C,0x0034,0xA88F};

#ifdef __cplusplus
extern "C" {
#endif

pascal OSErr
AcceptHighLevelEvent(TargetID		*sender,
				unsigned long	*msgRefcon, 
				Ptr 			msgBuff,
				unsigned long	*msgLen)
	= {0x3F3C,0x0033,0xA88F};

pascal OSErr
GetProcessSerialNumberFromPortName(PortNamePtr portName, ProcessSerialNumberPtr pPSN)
		= {0x3F3C,0x0035,0xA88F};

pascal OSErr
GetPortNameFromProcessSerialNumber(PortNamePtr portName, ProcessSerialNumberPtr pPSN)
		= {0x3F3C,0x0046,0xA88F};
						
pascal Boolean
GetSpecificHighLevelEvent(GetSpecificFilterProcPtr aFilter, unsigned long *params, OSErr *err)
		= {0x3F3C,0x0045,0xA88F};

#ifdef __cplusplus
}
#endif

#endif		/* __EPPC__ */


