/************************************************************

Created: Thursday, January 25, 1990 at 11:51 AM
	Errors.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-1989
	All rights reserved

************************************************************/


#ifndef __ERRORS__
#define __ERRORS__

enum {qErr = -1};                       /*queue element not found during deletion*/
enum {vTypErr = -2};                    /*invalid queue element*/
enum {corErr = -3};                     /*core routine number out of range*/
enum {unimpErr = -4};                   /*unimplemented core routine*/
enum {seNoDB = -8};                     /*no debugger installed to handle debugger command*/
enum {controlErr = -17};                /*I/O System Errors*/
enum {statusErr = -18};                 /*I/O System Errors*/
enum {readErr = -19};                   /*I/O System Errors*/
enum {writErr = -20};                   /*I/O System Errors*/
enum {badUnitErr = -21};                /*I/O System Errors*/
enum {unitEmptyErr = -22};              /*I/O System Errors*/
enum {openErr = -23};                   /*I/O System Errors*/
enum {closErr = -24};                   /*I/O System Errors*/
enum {dRemovErr = -25};                 /*tried to remove an open driver*/
enum {dInstErr = -26};                  /*DrvrInstall couldn't find driver in resources */
enum {abortErr = -27};                  /*IO call aborted by KillIO*/
enum {iIOAbortErr = -27};               /*IO abort error (Printing Manager)*/
enum {notOpenErr = -28};                /*Couldn't rd/wr/ctl/sts cause driver not opened*/
enum {dirFulErr = -33};                 /*Directory full*/
enum {dskFulErr = -34};                 /*disk full*/
enum {nsvErr = -35};                    /*no such volume*/
enum {ioErr = -36};                     /*I/O error (bummers)*/
enum {bdNamErr = -37};                  /*there may be no bad names in the final system!*/
enum {fnOpnErr = -38};                  /*File not open*/
enum {eofErr = -39};                    /*End of file*/
enum {posErr = -40};                    /*tried to position to before start of file (r/w)*/
enum {mFulErr = -41};                   /*memory full (open) or file won't fit (load)*/
enum {tmfoErr = -42};                   /*too many files open*/
enum {fnfErr = -43};                    /*File not found*/
enum {wPrErr = -44};                    /*diskette is write protected.*/
enum {fLckdErr = -45};                  /*file is locked*/
enum {vLckdErr = -46};                  /*volume is locked*/
enum {fBsyErr = -47};                   /*File is busy (delete)*/
enum {dupFNErr = -48};                  /*duplicate filename (rename)*/
enum {opWrErr = -49};                   /*file already open with with write permission*/
enum {paramErr = -50};                  /*error in user parameter list*/
enum {rfNumErr = -51};                  /*refnum error*/
enum {gfpErr = -52};                    /*get file position error*/
enum {volOffLinErr = -53};              /*volume not on line error (was Ejected)*/
enum {permErr = -54};                   /*permissions error (on file open)*/
enum {pixMapTooDeepErr = -148};
enum {volOnLinErr = -55};               /*drive volume already on-line at MountVol*/
enum {nsDrvErr = -56};                  /*no such drive (tried to mount a bad drive num)*/
enum {noMacDskErr = -57};               /*not a mac diskette (sig bytes are wrong)*/
enum {extFSErr = -58};                  /*volume in question belongs to an external fs*/
enum {fsRnErr = -59};                   /*file system internal error:during rename the old entry was deleted but could not be restored.*/
enum {badMDBErr = -60};                 /*bad master directory block*/
enum {wrPermErr = -61};                 /*write permissions error*/
enum {fontDecError = -64};              /*error during font declaration*/
enum {lastDskErr = -64};                /*I/O System Errors*/
enum {noDriveErr = -64};                /*drive not installed*/
enum {offLinErr = -65};                 /*r/w requested for an off-line drive*/
enum {fontNotDeclared = -65};           /*font not declared*/
enum {noNybErr = -66};                  /*couldn't find 5 nybbles in 200 tries*/
enum {fontSubErr = -66};                /*font substitution occured*/
enum {noAdrMkErr = -67};                /*couldn't find valid addr mark*/
enum {dataVerErr = -68};                /*read verify compare failed*/
enum {badCksmErr = -69};                /*addr mark checksum didn't check*/
enum {badBtSlpErr = -70};               /*bad addr mark bit slip nibbles*/
enum {noDtaMkErr = -71};                /*couldn't find a data mark header*/
enum {badDCksum = -72};                 /*bad data mark checksum*/
enum {badDBtSlp = -73};                 /*bad data mark bit slip nibbles*/
enum {wrUnderrun = -74};                /*write underrun occurred*/
enum {cantStepErr = -75};               /*step handshake failed*/
enum {tk0BadErr = -76};                 /*track 0 detect doesn't change*/
enum {initIWMErr = -77};                /*unable to initialize IWM*/
enum {twoSideErr = -78};                /*tried to read 2nd side on a 1-sided drive*/
enum {spdAdjErr = -79};                 /*unable to correctly adjust disk speed*/
enum {seekErr = -80};                   /*track number wrong on address mark*/
enum {sectNFErr = -81};                 /*sector number never found on a track*/
enum {fmt1Err = -82};                   /*can't find sector 0 after track format*/
enum {fmt2Err = -83};                   /*can't get enough sync*/
enum {verErr = -84};                    /*track failed to verify*/
enum {firstDskErr = -84};               /*I/O System Errors*/
enum {clkRdErr = -85};                  /*unable to read same clock value twice*/
enum {clkWrErr = -86};                  /*time written did not verify*/
enum {prWrErr = -87};                   /*parameter ram written didn't read-verify*/
enum {prInitErr = -88};                 /*InitUtil found the parameter ram uninitialized*/
enum {rcvrErr = -89};                   /*SCC receiver error (framing; parity; OR)*/
enum {breakRecd = -90};                 /*Break received (SCC)*/
enum {ddpSktErr = -91};                 /*error in soket number*/
enum {ddpLenErr = -92};                 /*data length too big*/
enum {noBridgeErr = -93};               /*no network bridge for non-local send*/
enum {lapProtErr = -94};                /*error in attaching/detaching protocol*/
enum {excessCollsns = -95};             /*excessive collisions on write*/
enum {portInUse = -97};                 /*driver Open error code (port is in use)*/
enum {portNotCf = -98};                 /*driver Open error code (parameter RAM not configured for this connection)*/
enum {memROZErr = -99};                 /*hard error in ROZ*/
enum {noScrapErr = -100};               /*No scrap exists error*/
enum {noTypeErr = -102};                /*No object of that type in scrap*/
enum {memFullErr = -108};               /*Not enough room in heap zone*/
enum {nilHandleErr = -109};             /*Master Pointer was NIL in HandleZone or other*/
enum {memAdrErr = -110};                /*address was odd; or out of range*/
enum {memWZErr = -111};                 /*WhichZone failed (applied to free block)*/
enum {memPurErr = -112};                /*trying to purge a locked or non-purgeable block*/
enum {memAZErr = -113};                 /*Address in zone check failed*/
enum {memPCErr = -114};                 /*Pointer Check failed*/
enum {memBCErr = -115};                 /*Block Check failed*/
enum {memSCErr = -116};                 /*Size Check failed*/
enum {memLockedErr = -117};             /*trying to move a locked block (MoveHHi)*/
enum {dirNFErr = -120};                 /*Directory not found*/
enum {tmwdoErr = -121};                 /*No free WDCB available*/
enum {badMovErr = -122};                /*Move into offspring error*/
enum {wrgVolTypErr = -123};             /*Wrong volume type error [operation not supported for MFS]*/
enum {volGoneErr = -124};               /*Server volume has been disconnected.*/
enum {fsDSIntErr = -127};               /*Internal file system error*/
enum {userCanceledErr = -128};
enum {fidNotFound = -1300};             /*no file thread exists.*/
enum {fidExists = -1301};               /*file id already exists*/
enum {NotAFileErr = -1302};             /*directory specified*/
enum {DiffVolErr = -1303};              /*files on different volumes*/
enum {catChangedErr = -1304};           /*the catalog has been modified*/
enum {resNotFound = -192};              /*Resource not found*/
enum {resFNotFound = -193};             /*Resource file not found*/
enum {addResFailed = -194};             /*AddResource failed*/
enum {addRefFailed = -195};             /*AddReference failed*/
enum {rmvResFailed = -196};             /*RmveResource failed*/
enum {rmvRefFailed = -197};             /*RmveReference failed*/
enum {resAttrErr = -198};               /*attribute inconsistent with operation*/
enum {mapReadErr = -199};               /*map inconsistent with operation*/
enum {editionMgrInitErr = -450};        /*edition manager not inited by this app*/
enum {badSectionErr = -451};            /*not a valid SectionRecord*/
enum {notRegisteredSectionErr = -452};  /*not a registered SectionRecord*/
enum {badEditionFileErr = -453};        /*edition file is corrupt*/
enum {badSubPartErr = -454};            /*can not use sub parts in this release*/
enum {multiplePublisherWrn = -460};     /*A Publisher is already registered for that container*/
enum {containerNotFoundWrn = -461};     /*could not find editionContainer at this time*/
enum {containerAlreadyOpenWrn = -462};  /*container already opened by this section*/
enum {notThePublisherWrn = -463};       /*not the first registered publisher for that container*/
enum {userBreak = -490};                /*user debugger break*/
enum {strUserBreak = -491};             /*user debugger break; display string on stack*/
enum {exUserBreak = -492};              /*user debugger break; execute debugger commands on stack*/
enum {nbpBuffOvr = -1024};              /*Buffer overflow in LookupName*/
enum {nbpNoConfirm = -1025};
enum {nbpConfDiff = -1026};             /*Name confirmed at different socket*/
enum {nbpDuplicate = -1027};            /*Duplicate name exists already*/
enum {nbpNotFound = -1028};             /*Name not found on remove*/
enum {nbpNISErr = -1029};               /*Error trying to open the NIS*/
enum {aspBadVersNum = -1066};           /*Server cannot support this ASP version*/
enum {aspBufTooSmall = -1067};          /*Buffer too small*/
enum {aspNoMoreSess = -1068};           /*No more sessions on server*/
enum {aspNoServers = -1069};            /*No servers at that address*/
enum {aspParamErr = -1070};             /*Parameter error*/
enum {aspServerBusy = -1071};           /*Server cannot open another session*/
enum {aspSessClosed = -1072};           /*Session closed*/
enum {aspSizeErr = -1073};              /*Command block too big*/
enum {aspTooMany = -1074};              /*Too many clients (server error)*/
enum {aspNoAck = -1075};                /*No ack on attention request (server err)*/
enum {reqFailed = -1096};
enum {tooManyReqs = -1097};
enum {tooManySkts = -1098};
enum {badATPSkt = -1099};
enum {badBuffNum = -1100};
enum {noRelErr = -1101};
enum {cbNotFound = -1102};
enum {noSendResp = -1103};
enum {noDataArea = -1104};
enum {reqAborted = -1105};
enum {buf2SmallErr = -3101};
enum {noMPPErr = -3102};
enum {ckSumErr = -3103};
enum {extractErr = -3104};
enum {readQErr = -3105};
enum {atpLenErr = -3106};
enum {atpBadRsp = -3107};
enum {recNotFnd = -3108};
enum {sktClosedErr = -3109};
enum {afpAccessDenied = -5000};
enum {afpAuthContinue = -5001};
enum {afpBadUAM = -5002};
enum {afpBadVersNum = -5003};
enum {afpBitmapErr = -5004};
enum {afpCantMove = -5005};
enum {afpDenyConflict = -5006};
enum {afpDirNotEmpty = -5007};
enum {afpDiskFull = -5008};
enum {afpEofError = -5009};
enum {afpFileBusy = -5010};
enum {afpFlatVol = -5011};
enum {afpItemNotFound = -5012};
enum {memROZWarn = -99};                /*soft error in ROZ*/
enum {afpLockErr = -5013};
enum {afpMiscErr = -5014};
enum {afpNoMoreLocks = -5015};
enum {afpNoServer = -5016};
enum {afpObjectExists = -5017};
enum {afpObjectNotFound = -5018};
enum {afpParmErr = -5019};
enum {afpRangeNotLocked = -5020};
enum {afpRangeOverlap = -5021};
enum {afpSessClosed = -5022};
enum {afpUserNotAuth = -5023};
enum {afpCallNotSupported = -5024};
enum {afpObjectTypeErr = -5025};
enum {afpTooManyFilesOpen = -5026};
enum {afpServerGoingDown = -5027};
enum {afpCantRename = -5028};
enum {afpDirNotFound = -5029};
enum {afpIconTypeError = -5030};
enum {afpVolLocked = -5031};            /*Volume is Read-Only*/
enum {afpObjectLocked = -5032};         /*Object is M/R/D/W inhibited*/
enum {envNotPresent = -5500};           /*returned by glue.*/
enum {envBadVers = -5501};              /*Version non-positive*/
enum {envVersTooBig = -5502};           /*Version bigger than call can handle*/
enum {evtNotEnb = 1};                   /*event not enabled at PostEvent*/
enum {dsSysErr = 32767};                /*general system error*/
enum {dsBusError = 1};                  /*bus error */
enum {dsAddressErr = 2};                /*address error*/
enum {dsIllInstErr = 3};                /*illegal instruction error*/
enum {dsZeroDivErr = 4};                /*zero divide error*/
enum {dsChkErr = 5};                    /*check trap error*/
enum {dsOvflowErr = 6};                 /*overflow trap error*/
enum {dsPrivErr = 7};                   /*privilege violation error*/
enum {dsTraceErr = 8};                  /*trace mode error*/
enum {dsLineAErr = 9};                  /*line 1010 trap error*/
enum {dsLineFErr = 10};                 /*line 1111 trap error*/
enum {dsMiscErr = 11};                  /*miscellaneous hardware exception error*/
enum {dsCoreErr = 12};                  /*unimplemented core routine error*/
enum {dsIrqErr = 13};                   /*uninstalled interrupt error*/
enum {dsIOCoreErr = 14};                /*IO Core Error*/
enum {dsLoadErr = 15};                  /*Segment Loader Error*/
enum {dsFPErr = 16};                    /*Floating point error*/
enum {dsNoPackErr = 17};                /*package 0 not present*/
enum {dsNoPk1 = 18};                    /*package 1 not present*/
enum {dsNoPk2 = 19};                    /*package 2 not present*/
enum {dsNoPk3 = 20};                    /*package 3 not present*/
enum {dsNoPk4 = 21};                    /*package 4 not present*/
enum {dsNoPk5 = 22};                    /*package 5 not present*/
enum {dsNoPk6 = 23};                    /*package 6 not present*/
enum {dsNoPk7 = 24};                    /*package 7 not present*/
enum {dsMemFullErr = 25};               /*out of memory!*/
enum {dsBadLaunch = 26};                /*can't launch file*/
enum {dsFSErr = 27};                    /*file system map has been trashed*/
enum {dsStknHeap = 28};                 /*stack has moved into application heap*/
enum {dsReinsert = 30};                 /*request user to reinsert off-line volume*/
enum {dsNotThe1 = 31};                  /*not the disk I wanted*/
enum {negZcbFreeErr = 33};              /*ZcbFree has gone negative*/
enum {dsGreeting = 40};                 /*welcome to Macintosh greeting*/
enum {dsFinderErr = 41};                /*can't load the Finder error*/
enum {shutDownAlert = 42};              /*handled like a shutdown error*/
enum {menuPrgErr = 84};                 /*happens when a menu is purged*/
enum {swOverrunErr = 1};                /*serial driver error masks*/
enum {parityErr = 16};                  /*serial driver error masks*/
enum {hwOverrunErr = 32};               /*serial driver error masks*/
enum {framingErr = 64};                 /*serial driver error masks*/
enum {cMatchErr = -150};                /*Color2Index failed to find an index*/
enum {cTempMemErr = -151};              /*failed to allocate memory for temporary structures*/
enum {cNoMemErr = -152};                /*failed to allocate memory for structure*/
enum {cRangeErr = -153};                /*range error on colorTable request*/
enum {cProtectErr = -154};              /*colorTable entry protection violation*/
enum {cDevErr = -155};                  /*invalid type of graphics device*/
enum {cResErr = -156};                  /*invalid resolution for MakeITable*/
enum {unitTblFullErr = -29};            /*unit table has no more entries*/
enum {dceExtErr = -30};                 /*dce extension error*/
enum {dsBadSlotInt = 51};               /*unserviceable slot interrupt*/
enum {dsBadSANEopcode = 81};            /*bad opcode given to SANE Pack4*/
enum {dsNoPatch = 98};                  /*Can't patch for particular Model Mac*/
enum {dsBadPatch = 99};                 /*Can't load patch resource*/
enum {updPixMemErr = -125};             /*insufficient memory to update a pixmap*/
enum {mBarNFnd = -126};                 /*system error code for MBDF not found*/
enum {hMenuFindErr = -127};             /*could not find HMenu's parent in MenuKey*/
enum {noHardware = -200};               /*Sound Manager Error Returns*/
enum {notEnoughHardware = -201};        /*Sound Manager Error Returns*/
enum {queueFull = -203};                /*Sound Manager Error Returns*/
enum {resProblem = -204};               /*Sound Manager Error Returns*/
enum {badChannel = -205};               /*Sound Manager Error Returns*/
enum {badFormat = -206};                /*Sound Manager Error Returns*/
enum {notEnoughBufferSpace = -207};     /* could not allocate enough memory */
enum {badFileFormat = -208};            /* was not type AIFF or was of bad format,corrupt */
enum {channelBusy = -209};              /* the Channel is being used for a PFD already */
enum {buffersTooSmall = -210};          /* can not operate in the memory allowed */
enum {channelNotBusy = -211};
enum {noMoreRealTime = -212};           /* not enough CPU cycles left to add another task */
enum {smSDMInitErr = -290};             /*Error; SDM could not be initialized.*/
enum {smSRTInitErr = -291};             /*Error; Slot Resource Table could not be initialized.*/
enum {smPRAMInitErr = -292};            /*Error; Slot Resource Table could not be initialized.*/
enum {smPriInitErr = -293};             /*Error; Cards could not be initialized.*/
enum {nmTypErr = -299};
enum {smEmptySlot = -300};              /*No card in slot*/
enum {smCRCFail = -301};                /*CRC check failed for declaration data*/
enum {smFormatErr = -302};              /*FHeader Format is not Apple's*/
enum {smRevisionErr = -303};            /*Wrong revison level*/
enum {smNoDir = -304};                  /*Directory offset is Nil */
enum {smLWTstBad = -305};               /*Long Word test field <> $5A932BC7.*/
enum {smNosInfoArray = -306};           /*No sInfoArray. Memory Mgr error.*/
enum {smResrvErr = -307};               /*Fatal reserved error. Resreved field <> 0.*/
enum {smUnExBusErr = -308};             /*Unexpected BusError*/
enum {smBLFieldBad = -309};             /*ByteLanes field was bad.*/
enum {smFHBlockRdErr = -310};           /*Error occured during _sGetFHeader.*/
enum {smDisposePErr = -312};            /*_DisposePointer error*/
enum {smNoBoardsRsrc = -313};           /*No Board sResource.*/
enum {smGetPRErr = -314};               /*Error occured during _sGetPRAMRec (See SIMStatus).*/
enum {smNoBoardId = -315};              /*No Board Id.*/
enum {smInitStatVErr = -316};           /*The InitStatusV field was negative after primary or secondary init.*/
enum {smInitTblErr = -317};             /*An error occured while trying to initialize the Slot Resource Table.*/
enum {smNoJmpTbl = -318};               /*SDM jump table could not be created.*/
enum {smBadBoardId = -319};             /*BoardId was wrong; re-init the PRAM record.*/
enum {smBusErrTO = -320};               /*BusError time out.*/
enum {smBadRefId = -330};               /*Reference Id not found in List*/
enum {smBadsList = -331};               /*Bad sList: Id1 < Id2 < Id3 ...format is not followed.*/
enum {smReservedErr = -332};            /*Reserved field not zero*/
enum {smCodeRevErr = -333};             /*Code revision is wrong*/
enum {smCPUErr = -334};                 /*Code revision is wrong*/
enum {smsPointerNil = -335};            /*LPointer is nil From sOffsetData. If this error occurs; check sInfo rec for more information.*/
enum {smNilsBlockErr = -336};           /*Nil sBlock error (Dont allocate and try to use a nil sBlock)*/
enum {smSlotOOBErr = -337};             /*Slot out of bounds error*/
enum {smSelOOBErr = -338};              /*Selector out of bounds error*/
enum {smNewPErr = -339};                /*_NewPtr error*/
enum {smBlkMoveErr = -340};             /*_BlockMove error*/
enum {smCkStatusErr = -341};            /*Status of slot = fail.*/
enum {smGetDrvrNamErr = -342};          /*Error occured during _sGetDrvrName.*/
enum {smDisDrvrNamErr = -343};          /*Error occured during _sDisDrvrName.*/
enum {smNoMoresRsrcs = -344};           /*No more sResources*/
enum {smsGetDrvrErr = -345};            /*Error occurred during _sGetDriver.*/
enum {smBadsPtrErr = -346};             /*Bad pointer was passed to sCalcsPointer*/
enum {smByteLanesErr = -347};           /*NumByteLanes was determined to be zero.*/
enum {smOffsetErr = -348};              /*Offset was too big (temporary error*/
enum {smNoGoodOpens = -349};            /*No opens were successfull in the loop.*/
enum {smSRTOvrFlErr = -350};            /*SRT over flow.*/
enum {smRecNotFnd = -351};              /*Record not found in the SRT.*/
enum {slotNumErr = -360};               /*invalid slot # error*/
enum {gcrOnMFMErr = -400};              /*gcr format on high density media error*/
enum {rgnTooBigErr = -500};
enum {teScrapSizeErr = -501};           /*scrap item too big for text edit record*/
enum {hwParamErr = -502};               /*bad selector for _HWPriv*/

/*	The following errors are for primary or secondary init code.  The errors are logged in the
vendor status field of the sInfo record.  Normally the vendor error is not Apple's concern,
but a special error is needed to patch secondary inits.

 */

enum {svTempDisable = -32768};          /*Temporarily disable card but run primary init.*/
enum {svDisabled = -32640};             /*Reserve range -32640 to -32768 for Apple temp disables.*/
enum {siInitSDTblErr = 1};              /*slot int dispatch table could not be initialized.*/
enum {siInitVBLQsErr = 2};              /*VBLqueues for all slots could not be initialized.*/
enum {siInitSPTblErr = 3};              /*slot priority table could not be initialized.*/
enum {sdmJTInitErr = 10};               /*SDM Jump Table could not be initialized.*/
enum {sdmInitErr = 11};                 /*SDM could not be initialized.*/
enum {sdmSRTInitErr = 12};              /*Slot Resource Table could not be initialized.*/
enum {sdmPRAMInitErr = 13};             /*Slot PRAM could not be initialized.*/
enum {sdmPriInitErr = 14};              /*Cards could not be initialized.*/
enum {dsMBarNFnd = 85};                 /*Menu Manager Errors*/
enum {dsHMenuFindErr = 86};             /*Menu Manager Errors*/

extern short MacOSErr;

#ifdef __cplusplus
extern "C" {
#endif
pascal void SysError(short errorCode)
	= {0x301F,0xA9C9};
#ifdef __cplusplus
}
#endif

#endif
