/************************************************************

Created: Friday, October 20, 1989 at 3:04 AM
	Events.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-1989
	All rights reserved

************************************************************/


#ifndef __EVENTS__
#define __EVENTS__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

enum {nullEvent = 0};
enum {mouseDown = 1};
enum {mouseUp = 2};
enum {keyDown = 3};
enum {keyUp = 4};
enum {autoKey = 5};
enum {updateEvt = 6};
enum {diskEvt = 7};
enum {activateEvt = 8};
enum {networkEvt = 10};
enum {driverEvt = 11};
enum {app1Evt = 12};
enum {app2Evt = 13};
enum {app3Evt = 14};
enum {app4Evt = 15};
#define osEvt app4Evt
enum {charCodeMask = 0x000000FF};
enum {keyCodeMask = 0x0000FF00};
enum {adbAddrMask = 0x00FF0000};
enum {osEvtMessageMask = 0xFF000000};

/* OSEvent Messages */

enum {mouseMovedMessage = 0xFA};
enum {childDiedMessage = 0xFD};
enum {suspendResumeMessage = 0x01};

/* event mask equates */

enum {mDownMask = 2};
enum {mUpMask = 4};
enum {keyDownMask = 8};
enum {keyUpMask = 16};
enum {autoKeyMask = 32};
enum {updateMask = 64};
enum {diskMask = 128};
enum {activMask = 256};
enum {networkMask = 1024};
enum {driverMask = 2048};
enum {app1Mask = 4096};
enum {app2Mask = 8192};
enum {app3Mask = 16384};
enum {app4Mask = -32768};
enum {everyEvent = -1};

/* modifiers */

enum {activeFlag = 1};      /*bit 0 of modifiers for activate event*/
enum {btnState = 128};      /*Bit 7 of low byte is mouse button state*/
enum {cmdKey = 256};        /*Bit 0*/
enum {shiftKey = 512};      /*Bit 1*/
enum {alphaLock = 1024};    /*Bit 2 */
enum {optionKey = 2048};    /*Bit 3 of high byte*/
enum {controlKey = 4096};

typedef long KeyMap[4];


struct EventRecord {
	short what;
	long message;
	long when;
	Point where;
	short modifiers;
};

typedef struct EventRecord EventRecord;
#ifdef __cplusplus
extern "C" {
#endif
pascal Boolean GetNextEvent(short eventMask,EventRecord *theEvent)
	= 0xA970;
pascal Boolean WaitNextEvent(short mask,EventRecord *event,unsigned long sleep,
	RgnHandle mouseRgn)
	= 0xA860;
pascal Boolean EventAvail(short eventMask,EventRecord *theEvent)
	= 0xA971;
pascal void GetMouse(Point *mouseLoc)
	= 0xA972;
pascal Boolean Button(void)
	= 0xA974;
pascal Boolean StillDown(void)
	= 0xA973;
pascal Boolean WaitMouseUp(void)
	= 0xA977;
pascal void GetKeys(KeyMap theKeys)
	= 0xA976;
pascal unsigned long TickCount(void)
	= 0xA975;
pascal unsigned long GetDblTime(void)
	= {0x2EB8,0x02F0};
pascal unsigned long GetCaretTime(void)
	= {0x2EB8,0x02F4};
#ifdef __cplusplus
}
#endif

#endif
