/************************************************************

Created: Friday, October 20, 1989 at 1:38 PM
	Language.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1986-1990
	All rights reserved


************************************************************/


#ifndef __LANGUAGE__
#define __LANGUAGE__

/* Language Codes */

#define langEnglish 0
#define langFrench 1
#define langGerman 2
#define langItalian 3
#define langDutch 4
#define langSwedish 5
#define langSpanish 6
#define langDanish 7
#define langPortuguese 8															/*<x3>*/
#define langPortugese 8				/* old misspelled version, kept for compatibility */
#define langNorwegian 9
#define langHebrew 10
#define langJapanese 11
#define langArabic 12
#define langFinnish 13
#define langGreek 14
#define langIcelandic 15
#define langMaltese 16																/*<x3>*/
#define langMalta 16				/* old misspelled version, kept for compatibility */
#define langTurkish 17
#define langCroatian 18				/* Serbo-Croatian in Roman script */			/*<x18>*/
#define langYugoslavian 18			/* (use langCroatian, langSerbian, etc.) */		/*<x18>*/
#define langChinese 19				/* (use langTradChinese or langSimpChinese) */	/*<x13> */
#define langTradChinese 19			/* Chinese in traditional characters */			/*<x13> */
#define langUrdu 20
#define langHindi 21
#define langThai 22
#define langKorean 23																/*<x1.7>*/
#define langLithuanian 24															/*<x3>*/
#define langPolish 25																/*<x3>*/
#define langHungarian 26															/*<x3>*/
#define langEstonian 27																/*<x3>*/
#define langLettish 28																/*<x3>*/
#define langLatvian 28				/* Synonym for langLettish */					/*<x18>*/
#define langLapponian 29															/*<x3>*/
#define langLappish 29				/* Synonym for langLapponian */					/*<x18>*/
#define langFaeroese 30																/*<x3>*/
#define langFarsi 31																/*<x3>*/
#define langPersian 31				/* Synonym for langFarsi */						/*<x18>*/
#define langRussian 32																/*<x3>*/
#define langSimpChinese 33			/* Chinese in simplified characters */			/*<x13>*/
#define langFlemish 34				/* script is smRoman */							/*<1>*/
#define langIrish 35				/* script is smRoman */							/*<1>*/
#define langAlbanian 36				/* script is smRoman */							/*<1>*/
#define langRomanian 37				/* modified Roman script */						/*<1>*/
#define langCzech 38				/* Slavic Roman script */						/*<1>*/
#define langSlovak 39				/* Slavic Roman script */						/*<1>*/
#define langSlovenian 40			/* Slavic Roman script */						/*<1>*/
#define langYiddish 41				/* script is smHebrew */						/*<1>*/
#define langSerbian 42				/* Serbo-Croatian in Cyrillic script */			/*<1>*/
#define langMacedonian 43			/* script is smCyrillic */						/*<1>*/
#define langBulgarian 44			/* script is smCyrillic */						/*<1>*/
#define langUkrainian 45			/* script is smCyrillic */						/*<1>*/
#define langByelorussian 46			/* script is smCyrillic */						/*<1>*/
#define langUzbek 47				/* script is smCyrillic */						/*<1>*/
#define langKazakh 48				/* script is smCyrillic */						/*<1>*/
#define langAzerbaijani 49			/* Azerbaijani in Cyrillic script (USSR) */		/*<1>*/
#define langAzerbaijanAr 50			/* Azerbaijani in Arabic script (Iran) */		/*<1>*/
#define langArmenian 51				/* script is smArmenian */						/*<1>*/
#define langGeorgian 52				/* script is smGeorgian */						/*<1>*/
#define langMoldavian 53			/* Romanian in Cyrillic script */				/*<1>*/
#define langKirghiz 54				/* script is smCyrillic */						/*<1>*/
#define langTajiki 55				/* script is smCyrillic */						/*<1>*/
#define langTurkmen 56				/* script is smCyrillic */						/*<1>*/
#define langMongolian 57			/* Mongolian in Mongolian script */				/*<1>*/
#define langMongolianCyr 58			/* Mongolian in Cyrillic script */				/*<1>*/
#define langPashto 59				/* script is smArabic */						/*<1>*/
#define langKurdish 60				/* script is smArabic */						/*<1>*/
#define langKashmiri 61				/* script is smArabic */						/*<1>*/
#define langSindhi 62				/* script is smExtArabic */						/*<1>*/
#define langTibetan 63				/* script is smTibetan */						/*<1>*/
#define langNepali 64				/* script is smDevanagari */					/*<1>*/
#define langSanskrit 65				/* script is smDevanagari */					/*<1>*/
#define langMarathi 66				/* script is smDevanagari */					/*<1>*/
#define langBengali 67				/* script is smBengali */						/*<1>*/
#define langAssamese 68				/* script is smBengali */						/*<1>*/
#define langGujarati 69				/* script is smGujarati */						/*<1>*/
#define langPunjabi 70				/* script is smGurmukhi */						/*<1>*/
#define langOriya 71				/* script is smOriya */							/*<1>*/
#define langMalayalam 72			/* script is smMalayalam */						/*<1>*/
#define langKannada 73				/* script is smKannada */						/*<1>*/
#define langTamil 74				/* script is smTamil */							/*<1>*/
#define langTelugu 75				/* script is smTelugu */						/*<1>*/
#define langSinhalese 76			/* script is smSinhalese */						/*<1>*/
#define langBurmese 77				/* script is smBurmese */						/*<1>*/
#define langKhmer 78				/* script is smKhmer */							/*<1>*/
#define langLao 79					/* script is smLaotian */						/*<1>*/
#define langVietnamese 80			/* script is smVietnamese */					/*<1>*/
#define langIndonesian 81			/* script is smRoman */							/*<1>*/
#define langTagalog 82				/* script is smRoman */							/*<1>*/
#define langMalayRoman 83			/* Malay in Roman script */						/*<1>*/
#define langMalayArabic 84			/* Malay in Arabic script */					/*<1>*/
#define langAmharic 85				/* script is smEthiopic */						/*<1>*/
#define langTigrinya 86				/* script is smEthiopic */						/*<1>*/
#define langGalla 87				/* script is smEthiopic */						/*<1>*/
#define langOromo 87				/* Synonym for langGalla */						/*<1>*/
#define langSomali 88				/* script is smRoman */							/*<1>*/
#define langSwahili 89				/* script is smRoman */							/*<1>*/
#define langRuanda 90				/* script is smRoman */							/*<1>*/
#define langRundi 91				/* script is smRoman */							/*<1>*/
#define langChewa 92				/* script is smRoman */							/*<1>*/
#define langMalagasy 93				/* script is smRoman */							/*<1>*/
#define langEsperanto 94			/* modified Roman script */						/*<1>*/
#define langWelsh 128				/* script is smRoman */							/*<1>*/
#define langBasque 129				/* script is smRoman */							/*<1>*/
#define langCatalan 130				/* script is smRoman */							/*<1>*/
#define langLatin 131				/* script is smRoman */							/*<1>*/
#define langQuechua 132				/* script is smRoman */							/*<1>*/
#define langGuarani 133				/* script is smRoman */							/*<1>*/
#define langAymara 134				/* script is smRoman */							/*<1>*/
#define langTatar 135				/* script is smCyrillic */						/*<1>*/
#define langUighur 136				/* script is smArabic */						/*<1>*/
#define langDzongkha 137			/* (lang of Bhutan) script is smTibetan */		/*<1>*/
#define langJavaneseRom 138			/* Javanese in Roman script */					/*<1>*/
#define langSundaneseRom 139		/* Sundanese in Roman script */					/*<1>*/

#endif
