/************************************************************

Created: Friday, October 20, 1989 at 1:38 PM
	Script.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1986-1990
	All rights reserved

************************************************************/


#ifndef __SCRIPT__
#define __SCRIPT__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

/* Script Interface System Numbers */

enum {smRoman = 0};                         /*Font script is Roman.*/
enum {smJapanese = 1};                      /*Font script is Japanese.*/
enum {smChinese = 2};                       /*(use smTradChinese or smSimpChinese)*/
enum {smTradChinese = 2};                   /*Font script is Traditional Chinese.*/
enum {smKorean = 3};                        /*Font script is Korean.*/
enum {smArabic = 4};                        /*Font script is Arabic.*/
enum {smHebrew = 5};                        /*Font script is Hebrew.*/
enum {smGreek = 6};                         /*Font script is Greek.*/
enum {smRussian = 7};                       /*Font script is Russian.*/
enum {smCyrillic = 7};                      /*Equivalent to Russian.*/
enum {smRSymbol = 8};                       /*Font script is Right-left symbol.*/
enum {smDevanagari = 9};                    /*Font script is Devanagari.*/
enum {smGurmukhi = 10};                     /*Font script is Gurmukhi.*/
enum {smGujarati = 11};                     /*Font script is Gujarati.*/
enum {smOriya = 12};                        /*Font script is Oriya.*/
enum {smBengali = 13};                      /*Font script is Bengali.*/
enum {smTamil = 14};                        /*Font script is Tamil.*/
enum {smTelugu = 15};                       /*Font script is Telugu.*/
enum {smKannada = 16};                      /*Font script is Kannada.*/
enum {smMalayalam = 17};                    /*Font script is Malayalam.*/
enum {smSinhalese = 18};                    /*Font script is Sinhalese.*/
enum {smBurmese = 19};                      /*Font script is Burmese.*/
enum {smKhmer = 20};                        /*Font script is Khmer.*/
enum {smThai = 21};                         /*Font script is Thai.*/
enum {smLaotian = 22};                      /*Font script is Laotian.*/
enum {smGeorgian = 23};                     /*Font script is Georgian.*/
enum {smArmenian = 24};                     /*Font script is Armenian.*/
/*enum {smMaldivian = 25};*/          		/*(no more smMaldivian!)*/
enum {smSimpChinese = 25};                  /*Font script is Simplified Chinese.*/
enum {smTibetan = 26};                      /*Font script is Tibetan.*/
enum {smMongolian = 27};                    /*Font script is Mongolian.*/
enum {smGeez = 28};                			/*Font script is Geez/Ethiopic.*/				/*<1.2>*/
enum {smEthiopic = 28};              		/*Synonym for smGeez.*/							/*<18>*/
enum {smAmharic = 28};                		/*(old name for smGeez).*/
enum {smSlavic = 29};                       /*Font script is Slavic.*/
enum {smEastEurRoman = 29};           		/*Synonym for smSlavic.*/						/*<19>*/
enum {smVietnamese = 30};             		/*Font script is Vietnamese.*/
enum {smExtArabic = 31};              		/*Font script is extended Arabic.*/				/*<19>*/
enum {smSindhi = 31};                 		/*(old name for smExtArabic)*/					/*<19>*/
enum {smUninterp = 32};               		/*Font script is uninterpreted symbols.*/

/* Language codes - moved to Language.h */											/*<19>*/

/* Calendar Codes */

enum {calGregorian = 0};
enum {calArabicCivil = 1};
enum {calArabicLunar = 2};
enum {calJapanese = 3};
enum {calJewish = 4};
enum {calCoptic = 5};
enum {calPersian = 6};																/* <17> */

/* Integer Format Codes */

enum {intWestern = 0};
enum {intArabic = 1};
enum {intRoman = 2};
enum {intJapanese = 3};
enum {intEuropean = 4};
enum {intOutputMask = 0x8000};

/* CharByte byte types */

enum {smSingleByte = 0};
enum {smFirstByte = -1};
enum {smLastByte = 1};
enum {smMiddleByte = 2};

/* CharType field masks */

enum {smcTypeMask = 0x000F};
enum {smcReserved = 0x00F0};
enum {smcClassMask = 0x0F00};
enum {smcReserved12 = 0x1000};
enum {smcRightMask = 0x2000};
enum {smcUpperMask = 0x4000};
enum {smcDoubleMask = 0x8000};

/* Basic CharType character types */

enum {smCharPunct = 0x0000};
enum {smCharAscii = 0x0001};
enum {smCharEuro = 0x0007};
enum {smCharExtAscii = 0x0007};			/* More correct synonym for smCharEuro */		/*<18>*/

/* Additional CharType character types for script systems */

enum {smCharFISKana = 0x0002}; 			/*Katakana*/
enum {smCharFISGana = 0x0003}; 			/*Hiragana*/
enum {smCharFISIdeo = 0x0004}; 			/*Hanzi, Kanji, Hanja*/
enum {smCharFISGreek = 0x0005};			/*2-byte Greek in Far East systems*/
enum {smCharFISRussian = 0x0006};		/*2-byte Cyrillic in Far East systems*/
enum {smCharBidirect = 0x0008};			/*Arabic/Hebrew*/								/*<18>*/
enum {smCharFISHangul = 0x000C};		/*Hangul*/										/*<18>*/

/* CharType classes for punctuation (smCharPunct) */

enum {smPunctNormal = 0x0000};
enum {smPunctNumber = 0x0100};
enum {smPunctSymbol = 0x0200};
enum {smPunctBlank = 0x0300};

/* CharType classes for FIS (smCharFISIdeo) <6>*/

enum {smFISClassLvl0 = 0x0000};             /*level 0 char*/
enum {smFISClassLvl1 = 0x0100};             /*level 1 char*/
enum {smFISClassLvl2 = 0x0200};             /*level 2 char*/
enum {smFISClassUser = 0x0300};		        /*user char*/

/* CharType directions */

enum {smCharLeft = 0x0000};
enum {smCharRight = 0x2000};

/* CharType case modifers */

enum {smCharLower = 0x0000};
enum {smCharUpper = 0x4000};

/* CharType character size modifiers (1 or multiple bytes). */

enum {smChar1byte = 0x0000};
enum {smChar2byte = 0x8000};

/* Char2Pixel directions */

enum {smLeftCaret = 0};                     /*Place caret for left block.*/
enum {smRightCaret = -1};                   /*Place caret for right block.*/
enum {smHilite = 1};                        /*Direction is TESysJust.*/

/* Transliterate target types for Roman */

enum {smTransAscii = 0};
enum {smTransNative = 1};
enum {smTransCase = 0xFE};
enum {smTransSystem = 0xFF};                /*convert to system script*/

/* Transliterate target types for FIS */

enum {smTransAscii1 = 2};                   /*1-byte Roman*/
enum {smTransAscii2 = 3};                   /*2-byte Roman*/
enum {smTransKana1 = 4};                    /*1-byte Katakana*/
enum {smTransKana2 = 5};                    /*2-byte Katakana*/
enum {smTransGana2 = 7};                    /*2-byte Hiragana (no 1-byte Hiragana)*/

/* Transliterate target modifiers */

enum {smTransLower = 0x4000};
enum {smTransUpper = 0x8000};

/* Transliterate source mask - general */

enum {smMaskAll = 0xFFFFFFFF};              /*Convert all text*/

/* Transliterate source masks */

enum {smMaskAscii = 0x00000001};            /*2^smTransAscii*/
enum {smMaskNative = 0x00000002};           /*2^smTransNative*/

/* Transliterate source masks for FIS */

enum {smMaskAscii1 = 0x00000004};           /*2^smTransAscii1*/
enum {smMaskAscii2 = 0x00000008};           /*2^smTransAscii2*/
enum {smMaskKana1 = 0x00000010};            /*2^smTransKana1*/
enum {smMaskKana2 = 0x00000020};            /*2^smTransKana2*/
enum {smMaskGana2 = 0x00000080};            /*2^smTransGana2*/

/* Result values from GetEnvirons, SetEnvirons, GetScript and SetScript calls. */

enum {smNotInstalled = 0};                  /*routine not available in script*/
enum {smBadVerb = -1};                      /*Bad verb passed to a routine.*/
enum {smBadScript = -2};                    /*Bad script code passed to a routine.*/

/* GetEnvirons and SetEnvirons verbs */

enum {smVersion = 0};                       /*Environment version number.*/
enum {smMunged = 2};                        /*Globals change count.*/
enum {smEnabled = 4};                       /*Environment enabled flag.*/
enum {smBidirect = 6};                      /*At least on bidirect script.*/
enum {smFontForce = 8};                     /*Force font flag.*/
enum {smIntlForce = 10};                    /*Force intl flag.*/
enum {smForced = 12};                       /*script forced to system script.*/
enum {smDefault = 14};                      /*script defaulted to Roman script.*/
enum {smPrint = 16};                        /*Printer action routine.*/
enum {smSysScript = 18};                    /*System script.*/
enum {smLastScript = 20};                   /*Last keyboard script.*/
enum {smKeyScript = 22};                    /*Keyboard script.*/
enum {smSysRef = 24};                       /*System folder refNum.*/
enum {smKeyCache = 26};                     /*Keyboard table cache pointer.*/
enum {smKeySwap = 28};                      /*Swapping table pointer.*/
enum {smGenFlags = 30};                     /*General flags long*/
enum {smOverride = 32};                     /*Script override flags.*/
enum {smCharPortion = 34};                  /*Ch vs SpExtra proportion*/

/* New for System 7.0: */														/* <1.7> */
enum {smDoubleByte = 36};                   /*Flag for double-byte script installed*/
enum {smKCHRCache = 38};					/*Returns pointer to KCHR cache*/			/* <3> */
enum {smRegionCode = 40};					/*Returns current region code (verXxx)*/	/* <3> */


/* GetScript and SetScript verbs.
Note: Verbs private to script systems are negative, while
those general across script systems are non-negative. */

enum {smScriptVersion = 0};                 /*Script software version.*/
enum {smScriptMunged = 2};                  /*Script entry changed count.*/
enum {smScriptEnabled = 4};                 /*Script enabled flag.*/
enum {smScriptRight = 6};                   /*Right to left flag.*/
enum {smScriptJust = 8};                    /*Justification flag.*/
enum {smScriptRedraw = 10};                 /*Word redraw flag.*/
enum {smScriptSysFond = 12};                /*Preferred system font.*/
enum {smScriptAppFond = 14};                /*Preferred Application font.*/
enum {smScriptBundle = 16};                 /*Beginning of dictionary verbs.*/
enum {smScriptNumber = 16};                 /*Script itl0 id from dictionary.*/
enum {smScriptDate = 18};                   /*Script itl1 id from dictionary.*/
enum {smScriptSort = 20};                   /*Script itl2 id from dictionary.*/
enum {smScriptFlags = 22};                  /*flags word.*/
enum {smScriptToken = 24};                  /*Script itl3 id, from dictionary.*/
enum {smScriptRsvd3 = 26};                  /*reserved.*/
enum {smScriptLang = 28};                   /*Current language for script.*/
enum {smScriptNumDate = 30};                /*Script Number/Date formats.*/
enum {smScriptKeys = 32};                   /*Script KEYC id from dictionary.*/
enum {smScriptIcon = 34};                   /*Script SICN id from dictionary.*/
enum {smScriptPrint = 36};                  /*Script printer action routine.*/
enum {smScriptTrap = 38};                   /*Trap entry pointer.*/
enum {smScriptCreator = 40};                /*Script file creator.*/
enum {smScriptFile = 42};                   /*Script file name.*/
enum {smScriptName = 44};                   /*Script name.*/

/* There is a hole here for old Kanji private verbs 46-76 */

/* New for System 7.0: */															/* <1.3> */
enum {smScriptMonoFondSize = 78};           /*default monospace FOND (hi) & size (lo).*/
enum {smScriptPrefFondSize = 80};           /*preferred FOND (hi) & size (lo).*/
enum {smScriptSmallFondSize = 82};          /*default small FOND (hi) & size (lo).*/
enum {smScriptSysFondSize = 84};            /*default system FOND (hi) & size (lo).*/
enum {smScriptAppFondSize = 86};  		    /*default app FOND (hi) & size (lo)*/			/* <11> */
enum {smScriptHelpFondSize = 88};		    /*default Help Mgr FOND (hi) & size (lo)*/		/* <11> */
enum {smScriptValidStyles = 90};		    /*mask of valid styles for script*/				/* <16> */
enum {smScriptAliasStyle = 92};		    	/*style (set) to use for aliases*/				/* <16> */


/* Negative verbs for KeyScript */													/* <12> */

enum {smKeyNextScript = -1};			/* Switch to next available script */
enum {smKeySysScript = -2};				/* Switch to the system script */
enum {smKeyLastScript = -3};			/* Switch to last script */
enum {smKeySwapScript = -3};			/* Synonym for above */							/* <17> */
/* New for System 7.0: */
enum {smKeyNextKybd = -4};				/* Switch to next keyboard in current script */
/* Not currently implemented in System, may be implemented by script systems */		/* <17> */
enum {smKeySwapKybd = -5};				/* Switch to last-used keyboard in current keyscript */
enum {smKeyNextInputMethod = -6};		/* Switch to next input method in current keyscript */
enum {smKeySwapInputMethod = -7};		/* Switch to last-used input method in cur keyscript */
enum {smKeyToggleInline = -8};			/* Toggle inline input for current keyscript */
enum {smKeyToggleDirection = -9};		/* Toggle default line direction (TESysJust) */

/* Bits in the smScriptFlags word
(bits above 7 are non-static) */

enum {smsfIntellCP = 0};                    /*script has intellegent cut & paste*/
enum {smsfSingByte = 1};                    /*script has only single bytes*/
enum {smsfNatCase = 2};                     /*native chars have upper & lower case*/
enum {smsfContext = 3};                     /*contextual script (e.g. AIS-based)*/
enum {smsfNoForceFont = 4};                 /*Will not force characters.*/
enum {smsfB0Digits = 5};                    /*Has alternate digits at B0-B9.*/
enum {smsfAutoInit = 6};                    /*auto initialize the script*/					/* <11> */
enum {smsfForms = 13};                      /*Uses contextual forms for letters.*/
enum {smsfLigatures = 14};                  /*Uses contextual ligatures.*/
enum {smsfReverse = 15};                    /*Reverses native text, right-left.*/

/* Bits in the smGenFlags long.
First byte is set from itlc flags byte. */

enum {smfShowIcon = 31};                    /*Show icon even if only one script.*/
enum {smfDualCaret = 30};                   /*Use dual caret for mixed direction text.*/
enum {smfNameTagEnab = 29}; 				/*Reserved for internal use.*/

/* Roman script constants */

/* The following are here for backward compatibility, but should not be used. */	/* <17> */
/* This information should be obtained using GetScript. */
enum {romanSysFond = 0x3FFF};               /*system font id number*/
enum {romanAppFond = 3};                    /*application font id number.*/
enum {romanFlags = 0x0007};                 /*roman settings*/

/* Script Manager font equates. */

enum {smFondStart = 0x4000};                /*start from 16K.*/
enum {smFondEnd = 0xC000};                  /*past end of range at 48K.*/

/* Miscellaneous font equates. */

enum {smUprHalfCharSet = 0x80}; 			/*first char code in top half of std char set*/	/* <11> */

/* Character Set Extensions */

enum {diaeresisUprY = 0xD9};
enum {fraction = 0xDA};
enum {intlCurrency = 0xDB};
enum {leftSingGuillemet = 0xDC};
enum {rightSingGuillemet = 0xDD};
enum {fiLigature = 0xDE};
enum {flLigature = 0xDF};
enum {dblDagger = 0xE0};
enum {centeredDot = 0xE1};
enum {baseSingQuote = 0xE2};
enum {baseDblQuote = 0xE3};
enum {perThousand = 0xE4};
enum {circumflexUprA = 0xE5};
enum {circumflexUprE = 0xE6};
enum {acuteUprA = 0xE7};
enum {diaeresisUprE = 0xE8};
enum {graveUprE = 0xE9};
enum {acuteUprI = 0xEA};
enum {circumflexUprI = 0xEB};
enum {diaeresisUprI = 0xEC};
enum {graveUprI = 0xED};
enum {acuteUprO = 0xEE};
enum {circumflexUprO = 0xEF};
enum {appleLogo = 0xF0};
enum {graveUprO = 0xF1};
enum {acuteUprU = 0xF2};
enum {circumflexUprU = 0xF3};
enum {graveUprU = 0xF4};
enum {dotlessLwrI = 0xF5};
enum {circumflex = 0xF6};
enum {tilde = 0xF7};
enum {macron = 0xF8};
enum {breve = 0xF9};
enum {overDot = 0xFA};
enum {ring = 0xFB};
enum {cedilla = 0xFC};
enum {doubleAcute = 0xFD};
enum {ogonek = 0xFE};
enum {hachek = 0xFF};

/* String2Date status values */

enum {fatalDateTime = 0x8000};
enum {longDateFound = 1};
enum {leftOverChars = 2};
enum {sepNotIntlSep = 4};
enum {fieldOrderNotIntl = 8};
enum {extraneousStrings = 16};
enum {tooManySeps = 32};
enum {sepNotConsistent = 64};
enum {tokenErr = 0x8100};
enum {cantReadUtilities = 0x8200};
enum {dateTimeNotFound = 0x8400};
enum {dateTimeInvalid = 0x8800};

/* TokenType values */

enum {tokenIntl = 4};                       /*the itl resource number of the tokenizer*/
enum {tokenEmpty = -1};
enum {tokenUnknown = 0};
enum {tokenWhite = 1};
enum {tokenLeftLit = 2};
enum {tokenRightLit = 3};
enum {tokenAlpha = 4};
enum {tokenNumeric = 5};
enum {tokenNewLine = 6};
enum {tokenLeftComment = 7};
enum {tokenRightComment = 8};
enum {tokenLiteral = 9};
enum {tokenEscape = 10};
enum {tokenAltNum = 11};
enum {tokenRealNum = 12};
enum {tokenAltReal = 13};
enum {tokenReserve1 = 14};
enum {tokenReserve2 = 15};
enum {tokenLeftParen = 16};
enum {tokenRightParen = 17};
enum {tokenLeftBracket = 18};
enum {tokenRightBracket = 19};
enum {tokenLeftCurly = 20};
enum {tokenRightCurly = 21};
enum {tokenLeftEnclose = 22};
enum {tokenRightEnclose = 23};
enum {tokenPlus = 24};
enum {tokenMinus = 25};
enum {tokenAsterisk = 26};
enum {tokenDivide = 27};
enum {tokenPlusMinus = 28};
enum {tokenSlash = 29};
enum {tokenBackSlash = 30};
enum {tokenLess = 31};
enum {tokenGreat = 32};
enum {tokenEqual = 33};
enum {tokenLessEqual2 = 34};
enum {tokenLessEqual1 = 35};
enum {tokenGreatEqual2 = 36};
enum {tokenGreatEqual1 = 37};
enum {token2Equal = 38};
enum {tokenColonEqual = 39};
enum {tokenNotEqual = 40};
enum {tokenLessGreat = 41};
enum {tokenExclamEqual = 42};
enum {tokenExclam = 43};
enum {tokenTilda = 44};
enum {tokenTilde = 44};
enum {tokenComma = 45};
enum {tokenPeriod = 46};
enum {tokenLeft2Quote = 47};
enum {tokenRight2Quote = 48};
enum {tokenLeft1Quote = 49};
enum {tokenRight1Quote = 50};
enum {token2Quote = 51};
enum {token1Quote = 52};
enum {tokenSemicolon = 53};
enum {tokenPercent = 54};
enum {tokenCarat = 55};
enum {tokenUnderline = 56};
enum {tokenAmpersand = 57};
enum {tokenAtSign = 58};
enum {tokenBar = 59};
enum {tokenQuestion = 60};
enum {tokenPi = 61};
enum {tokenRoot = 62};
enum {tokenSigma = 63};
enum {tokenIntegral = 64};
enum {tokenMicro = 65};
enum {tokenCapPi = 66};
enum {tokenInfinity = 67};
enum {tokenColon = 68};
enum {tokenHash = 69};
enum {tokenDollar = 70};
enum {tokenNoBreakSpace = 71};
enum {tokenFraction = 72};
enum {tokenIntlCurrency = 73};
enum {tokenLeftSingGuillemet = 74};
enum {tokenRightSingGuillemet = 75};
enum {tokenPerThousand = 76};
enum {tokenEllipsis = 77};
enum {tokenCenterDot = 78};
enum {tokenNil = 127};
enum {delimPad = -2};

/* the NumberParts indices */

enum {tokLeftQuote = 1};
enum {tokRightQuote = 2};
enum {tokLeadPlacer = 3};
enum {tokLeader = 4};
enum {tokNonLeader = 5};
enum {tokZeroLead = 6};
enum {tokPercent = 7};
enum {tokPlusSign = 8};
enum {tokMinusSign = 9};
enum {tokThousands = 10};
enum {tokSeparator = 12};                   /*11 is a reserved field*/
enum {tokEscape = 13};
enum {tokDecPoint = 14};
enum {tokEPlus = 15};
enum {tokEMinus = 16};
enum {tokMaxSymbols = 31};
enum {curNumberPartsVersion = 1};           /*current version of NumberParts record*/
enum {fVNumber = 0};						/*first version of NumFormatString*/

/*	Date equates */

enum {smallDateBit = 31};                   /*Restrict valid date/time to range of Time global*/
enum {togChar12HourBit = 30};               /*If toggling hour by char, accept hours 1..12 only*/
enum {togCharZCycleBit = 29};               /*Modifier for togChar12HourBit: accept hours 0..11 only*/
enum {togDelta12HourBit = 28};              /*If toggling hour up/down, restrict to 12-hour range (am/pm)*/
enum {genCdevRangeBit = 27};                /*Restrict date/time to range used by genl CDEV*/
enum {validDateFields = -1};
enum {maxDateField = 10};
enum {eraMask = 0x0001};
enum {yearMask = 0x0002};
enum {monthMask = 0x0004};
enum {dayMask = 0x0008};
enum {hourMask = 0x0010};
enum {minuteMask = 0x0020};
enum {secondMask = 0x0040};
enum {dayOfWeekMask = 0x0080};
enum {dayOfYearMask = 0x0100};
enum {weekOfYearMask = 0x0200};
enum {pmMask = 0x0400};
enum {dateStdMask = 0x007F};

/* Toggle results */

enum {toggleUndefined = 0};
enum {toggleOK = 1};
enum {toggleBadField = 2};
enum {toggleBadDelta = 3};
enum {toggleBadChar = 4};
enum {toggleUnknown = 5};
enum {toggleBadNum = 6};
enum {toggleOutOfRange = 7};                /*synonym for toggleErr3*/
enum {toggleErr3 = 7};
enum {toggleErr4 = 8};
enum {toggleErr5 = 9};

/*  Constants for truncWhere argument in TruncString and TruncText  */

enum {smTruncEnd = 0};                      /* Truncate at end */
enum {smTruncMiddle = 0x4000};              /* Truncate in middle */

/* Constants for TruncString and TruncText results */							/* <12> */

enum {smNotTruncated = 0};		/* No truncation was necessary */
enum {smTruncated = 1};    		/* Truncation performed */
enum {smTruncErr = -1};			/* General error */

/* Constants for styleRunPosition argument in NPortionText, NDrawJust,	*/
/* NMeasureJust, NChar2Pixel, and NPixel2Char.							*/

enum {smOnlyStyleRun = 0};                  /* This is the only style run on the line.*/
enum {smLeftStyleRun = 1};                  /*This is leftmost of multiple style runs on the line.*/
enum {smRightStyleRun = 2};                 /*This is rightmost of multiple style runs on the line.*/
enum {smMiddleStyleRun = 3};					/* There are multiple style runs on the line and this	*/
											/* is neither the leftmost nor the rightmost.			*/

enum {tokenOK,tokenOverflow,stringOverflow,badDelim,badEnding,crash};
typedef unsigned char TokenResults;

enum {eraField,yearField,monthField,dayField,hourField,minuteField,secondField,
	dayOfWeekField,dayOfYearField,weekOfYearField,pmField,res1Field,res2Field,
	res3Field};
typedef unsigned char LongDateField;

enum {smBreakWord,smBreakChar,smBreakOverflow};
typedef unsigned char StyledLineBreakCode;

enum {fPositive,fNegative,fZero};
typedef unsigned char FormatClass;

enum {fFormatOK,fBestGuess,fOutOfSynch,fSpuriousChars,fMissingDelimiter,
	fExtraDecimal,fMissingLiteral,fExtraExp,fFormatOverflow,fFormStrIsNAN,
	fBadPartsTable,fExtraPercent,fExtraSeparator,fEmptyFormatString};
typedef unsigned char FormatResultType;

typedef char CharByteTable[256];
typedef short ToggleResults;


struct BreakTable {
	char charTypes[256];
	short tripleLength;
	short triples[1];
};

typedef struct BreakTable BreakTable;
typedef BreakTable *BreakTablePtr;

/* New NBreakTable for System 7.0: */	/* <1.8> */

struct NBreakTable {					/* <1.8> */
	signed char flags1;
	signed char flags2;
	short version;
	short classTableOff;
	short auxCTableOff;
	short backwdTableOff;
	short forwdTableOff;
	short doBackup;
	short reserved;
	char charTypes[256];
	short tables[1];
};

typedef struct NBreakTable NBreakTable;
typedef NBreakTable *NBreakTablePtr;

struct OffPair {
	short offFirst;
	short offSecond;
};

typedef struct OffPair OffPair;
typedef OffPair OffsetTable[3];


struct ItlcRecord {													/*<1.2> modified*/
	short itlcSystem;				/*default system script.*/
	short itlcReserved; 			/*reserved*/
	char itlcFontForce; 			/*default font force flag*/
	char itlcIntlForce; 			/*default intl force flag.*/
	char itlcOldKybd;				/*old keyboard*/
	char itlcFlags; 				/*general flags*/
    short itlcIconOffset;			/*script icon offset*/			/*<1.2>*/
    char itlcIconSide;				/*icon side*/					/*<1.2>*/
    char itlcIconRsvd;				/*rsvd for other icon info*/	/*<1.2>*/
    short itlcRegionCode;			/*preferred verXxx code.*/		/*<4>*/
    char itlcReserved3[34];			/*for future use*/				/*<4><6>*/
};

typedef struct ItlcRecord ItlcRecord;

struct ItlbRecord {
	short itlbNumber;				/*ITL0 id number.*/
	short itlbDate; 				/*ITL1 id number.*/
	short itlbSort; 				/*ITL2 id number.*/
	short itlbFlags;				/*Script flags*/
	short itlbToken;				/*ITL4 id number.*/
	short itlbReserved3;			/*reserved.*/
	short itlbLang; 				/*cur language for script */
	char itlbNumRep;				/*number representation code*/
	char itlbDateRep;				/*date representation code */
	short itlbKeys; 				/*KCHR id number.*/
	short itlbIcon; 				/*SICN id number.*/
};

typedef struct ItlbRecord ItlbRecord;

/* New ItlbExtRecord structure for System 7.0 */					/* <11> */

struct ItlbExtRecord {
	ItlbRecord	base;				/*un-extended ItlbRecord*/
	long		itlbLocalSize;		/*size of script's local record*/
	short		itlbMonoFond;		/*default monospace FOND ID*/
	short		itlbMonoSize;		/*default monospace font size*/
	short		itlbPrefFond;		/*preferred FOND ID*/
	short		itlbPrefSize;		/*preferred font size*/
	short		itlbSmallFond;		/*default small FOND ID*/
	short		itlbSmallSize;		/*default small font size*/
	short		itlbSysFond;		/*default system FOND ID*/
	short		itlbSysSize;		/*default system font size*/
	short		itlbAppFond;		/*default application FOND ID*/
	short		itlbAppSize;		/*default application font size*/
	short		itlbHelpFond;		/*default Help Mgr FOND ID*/
	short		itlbHelpSize;		/*default Help Mgr font size*/
	Style		itlbValidStyles;	/*set of valid styles for script*/		/* <16> */
	Style		itlbAliasStyle;		/*style (set) to mark aliases*/			/* <16> */
};

typedef struct ItlbExtRecord ItlbExtRecord;

struct MachineLocation {
	Fract latitude;
	Fract longitude;
	union{
		char dlsDelta;				/*signed byte; daylight savings delta*/
		long gmtDelta;				/*must mask - see documentation*/
		}gmtFlags;
};

typedef struct MachineLocation MachineLocation;
typedef short String2DateStatus;
typedef short TokenType;
typedef TokenType DelimType[2];
typedef TokenType CommentType[4];

struct TokenRec {
	TokenType theToken;
	Ptr position;					/*pointer into original Source*/
	long length;					/*length of text in original source*/
	StringPtr stringPosition;		/*Pascal/C string copy of identifier*/
};

typedef struct TokenRec TokenRec;
typedef TokenRec *TokenRecPtr;

struct TokenBlock {
	Ptr source; 					/*pointer to stream of characters*/
	long sourceLength;				/*length of source stream*/
	Ptr tokenList;					/*pointer to array of tokens*/
	long tokenLength;				/*maximum length of TokenList*/
	long tokenCount;				/*number tokens generated by tokenizer*/
	Ptr stringList; 				/*pointer to stream of identifiers*/
	long stringLength;				/*length of string list*/
	long stringCount;				/*number of bytes currently used*/
	Boolean doString;				/*make strings & put into StringLIst*/
	Boolean doAppend;				/*append to TokenList rather than replace*/
	Boolean doAlphanumeric; 		/*identifiers may include numeric*/
	Boolean doNest; 				/*do comments nest?*/
	TokenType leftDelims[2];
	TokenType rightDelims[2];
	TokenType leftComment[4];
	TokenType rightComment[4];
	TokenType escapeCode;			/*escape symbol code*/
	TokenType decimalCode;
	Handle itlResource; 			/*ptr to itl4 resource of current script*/
	long reserved[8];				/*must be zero!*/
};

typedef struct TokenBlock TokenBlock;
typedef TokenBlock *TokenBlockPtr;

struct UntokenTable {
	short len;
	short lastToken;
	short index[256];				/*index table; last = lastToken*/
};

typedef struct UntokenTable UntokenTable;
typedef UntokenTable *UntokenTablePtr, **UntokenTableHandle;

struct DateCacheRecord {
	short hidden[256];				/*only for temporary use*/
};

typedef struct DateCacheRecord DateCacheRecord;
typedef DateCacheRecord *DateCachePtr;

typedef comp LongDateTime;

union LongDateCvt {
	comp c;
	struct {
		long lHigh;
		long lLow;
		} hl;
};

typedef union LongDateCvt LongDateCvt;

union LongDateRec {
	struct {
		short era;
		short year;
		short month;
		short day;
		short hour;
		short minute;
		short second;
		short dayOfWeek;
		short dayOfYear;
		short weekOfYear;
		short pm;
		short res1;
		short res2;
		short res3;
		} ld;
	short list[14]; 				/*Index by LongDateField!*/
	struct {
		short eraAlt;
		DateTimeRec oldDate;
		} od;
};

typedef union LongDateRec LongDateRec;

typedef char DateDelta;

struct TogglePB {
	long togFlags;					/*caller normally sets low word to dateStdMask=$7F*/
	ResType amChars;				/*from intl0*/
	ResType pmChars;				/*from intl0*/
	long reserved[4];
};

typedef struct TogglePB TogglePB;
typedef short FormatOrder[1];
typedef FormatOrder *FormatOrderPtr;
typedef short FormatStatus;

union WideChar {
	char a[2];						/*0 is the high order character*/
	short b;
};

typedef union WideChar WideChar;

struct WideCharArr {
	short size;
	WideChar data[10];
};

typedef struct WideCharArr WideCharArr;
struct NumFormatString {
	char fLength;
	char fVersion;
	char data[254]; 				/*private data*/
};

typedef struct NumFormatString NumFormatString;
struct Itl4Rec {
	short flags;
	long resourceType;
	short resourceNum;
	short version;
	long resHeader1;
	long resHeader2;
	short numTables;				/*one-based*/
	long mapOffset; 				/*offsets are from record start*/
	long strOffset;
	long fetchOffset;
	long unTokenOffset;
	long defPartsOffset;
    long resOffset6;
	long resOffset7;
	long resOffset8;
};

typedef struct Itl4Rec Itl4Rec;

typedef Itl4Rec *Itl4Ptr, **Itl4Handle;

/* New NItl4Rec for System 7.0: */	/* <6> */

struct NItl4Rec {
    short flags;
    long resourceType;
    short resourceNum;
    short version;
    long resHeader1;
    long resHeader2;
    short numTables;                /*one-based*/
    long mapOffset;                 /*offsets are from record start*/
    long strOffset;
    long fetchOffset;
    long unTokenOffset;
    long defPartsOffset;
    long whtSpListOffset;			/* <1.8><14> */
    long resOffset7;
    long resOffset8;
	short resLength1;				/* <1.8> */
	short resLength2;				/* <1.8> */
	short resLength3;				/* <1.8> */
	short unTokenLength;			/* <1.8><10> */
	short defPartsLength;			/* <1.8><10> */
	short whtSpListLength;			/* <1.8><10><18> */
	short resLength7;				/* <1.8> */
	short resLength8;				/* <1.8> */
};

typedef struct NItl4Rec NItl4Rec;

typedef NItl4Rec *NItl4Ptr, **NItl4Handle;

struct NumberParts {
	short version;
	WideChar data[31];				/*index by [tokLeftQuote..tokMaxSymbols]*/
	WideCharArr pePlus;
	WideCharArr peMinus;
	WideCharArr peMinusPlus;
	WideCharArr altNumTable;
	char reserved[20];
};

typedef struct NumberParts NumberParts;
typedef NumberParts *NumberPartsPtr;

struct FVector {
	short start;
	short length;
};

typedef struct FVector FVector;
typedef FVector TripleInt[3];		/* index by [fPositive..fZero] */

struct ScriptRunStatus {
	char script;													/* <19> */
	char variant;													/* <19> */
};

typedef struct ScriptRunStatus ScriptRunStatus;

/* type for truncWhere parameter in new TruncString, TruncText */
typedef short TruncCode;

/* type for styleRunPosition parameter in NPixel2Char etc. */		/* <2> */
typedef short JustStyleCode;										/* <2> */


#ifdef __cplusplus
extern "C" {
#endif
pascal short FontScript(void)
	= {0x2F3C,0x8200,0x0000,0xA8B5};
pascal short IntlScript(void)
	= {0x2F3C,0x8200,0x0002,0xA8B5};
pascal void KeyScript(short code)
	= {0x2F3C,0x8002,0x0004,0xA8B5};
pascal short Font2Script(short fontNumber)
	= {0x2F3C,0x8202,0x0006,0xA8B5};
pascal long GetEnvirons(short verb)
	= {0x2F3C,0x8402,0x0008,0xA8B5};
pascal OSErr SetEnvirons(short verb,long param)
	= {0x2F3C,0x8206,0x000A,0xA8B5};
pascal long GetScript(short script,short verb)
	= {0x2F3C,0x8404,0x000C,0xA8B5};
pascal OSErr SetScript(short script,short verb,long param)
	= {0x2F3C,0x8208,0x000E,0xA8B5};
pascal short CharByte(Ptr textBuf,short textOffset)
	= {0x2F3C,0x8206,0x0010,0xA8B5};
pascal short CharType(Ptr textBuf,short textOffset)
	= {0x2F3C,0x8206,0x0012,0xA8B5};
pascal short Pixel2Char(Ptr textBuf,short textLen,short slop,short pixelWidth,
	Boolean *leadingEdge)
	= {0x2F3C,0x820E,0x0014,0xA8B5};
pascal short Char2Pixel(Ptr textBuf,short textLen,short slop,short offset,
	short direction)
	= {0x2F3C,0x820C,0x0016,0xA8B5};
pascal OSErr Transliterate(Handle srcHandle,Handle dstHandle,short target,
	long srcMask)
	= {0x2F3C,0x820E,0x0018,0xA8B5};
pascal void FindWord(Ptr textPtr,short textLength,short offset,Boolean leadingEdge,
	BreakTablePtr breaks,OffsetTable offsets)
	= {0x2F3C,0x8012,0x001A,0xA8B5};
pascal void HiliteText(Ptr textPtr,short textLength,short firstOffset,short secondOffset,
	OffsetTable offsets)
	= {0x2F3C,0x800E,0x001C,0xA8B5};
pascal void DrawJust(Ptr textPtr,short textLength,short slop)
	= {0x2F3C,0x8008,0x001E,0xA8B5};
pascal void MeasureJust(Ptr textPtr,short textLength,short slop,Ptr charLocs)
	= {0x2F3C,0x800C,0x0020,0xA8B5};
pascal Boolean ParseTable(CharByteTable table)
	= {0x2F3C,0x8204,0x0022,0xA8B5};
pascal short GetDefFontSize(void)
	= {0x3EB8,0x0BA8,0x6604,0x3EBC,0x000C}; 
pascal short GetSysFont(void)
	= {0x3EB8,0x0BA6};
pascal short GetAppFont(void)
	= {0x3EB8,0x0984};
pascal short GetMBarHeight(void)
	= {0x3EB8,0x0BAA};
pascal short GetSysJust(void)
	= {0x3EB8,0x0BAC};
pascal void SetSysJust(short newJust)
	= {0x31DF,0x0BAC};
pascal void ReadLocation(MachineLocation *loc)
	= {0x205F,0x203C,0x000C,0x00E4,0xA051}; 
pascal void WriteLocation(const MachineLocation *loc)
	= {0x205F,0x203C,0x000C,0x00E4,0xA052}; 
pascal void UprText(Ptr textPtr,short len)
    = {0x301F,0x205F,0xA054};
pascal void LwrText(Ptr textPtr,short len)
	= {0x301F,0x205F,0xA056};

/* New for 7.0 */													/* <1.8> */
pascal void LowerText(Ptr textPtr,short len)						/* <7> */
    = {0x301F,0x205F,0xA056}; 
pascal void StripText(Ptr textPtr,short len)						/* <1.8> */
    = {0x301F,0x205F,0xA256}; 
pascal void UpperText(Ptr textPtr,short len)						/* <7> */
    = {0x301F,0x205F,0xA456};
pascal void StripUpperText(Ptr textPtr,short len)					/* <1.8><7> */
    = {0x301F,0x205F,0xA656}; 

pascal StyledLineBreakCode StyledLineBreak(Ptr textPtr,long textLen,long textStart,
	long textEnd,long flags,Fixed *textWidth,long *textOffset)
	= {0x2F3C,0x821C,0xFFFE,0xA8B5};
pascal void GetFormatOrder(FormatOrderPtr ordering,short firstFormat,short lastFormat,
	Boolean lineRight,Ptr rlDirProc,Ptr dirParam)
	= {0x2F3C,0x8012,0xFFFC,0xA8B5};
pascal TokenResults IntlTokenize(TokenBlockPtr tokenParam)
	= {0x2F3C,0x8204,0xFFFA,0xA8B5};
pascal OSErr InitDateCache(DateCachePtr theCache)
	= {0x2F3C,0x8204,0xFFF8,0xA8B5};
pascal String2DateStatus String2Date(Ptr textPtr,long textLen,DateCachePtr theCache,
	long *lengthUsed,LongDateRec *dateTime)
	= {0x2F3C,0x8214,0xFFF6,0xA8B5};
pascal String2DateStatus String2Time(Ptr textPtr,long textLen,DateCachePtr theCache,
	long *lengthUsed,LongDateRec *dateTime)
	= {0x2F3C,0x8214,0xFFF4,0xA8B5};
pascal void LongDate2Secs(const LongDateRec *lDate,LongDateTime *lSecs)
	= {0x2F3C,0x8008,0xFFF2,0xA8B5};
pascal void LongSecs2Date(LongDateTime *lSecs,LongDateRec *lDate)
	= {0x2F3C,0x8008,0xFFF0,0xA8B5};
pascal ToggleResults ToggleDate(LongDateTime *lSecs,LongDateField field,
	DateDelta delta,short ch,const TogglePB *params)
	= {0x2F3C,0x820E,0xFFEE,0xA8B5};
pascal FormatStatus Str2Format(const Str255 inString,const NumberParts *partsTable,
	NumFormatString *outString)
	= {0x2F3C,0x820C,0xFFEC,0xA8B5};
pascal FormatStatus Format2Str(const NumFormatString *myCanonical,const NumberParts *partsTable,
	Str255 outString,TripleInt *positions)
	= {0x2F3C,0x8210,0xFFEA,0xA8B5};
pascal FormatStatus FormatX2Str(extended x,const NumFormatString *myCanonical,
	const NumberParts *partsTable,Str255 outString)
	= {0x2F3C,0x8210,0xFFE8,0xA8B5};
pascal FormatStatus FormatStr2X(const Str255 source,const NumFormatString *myCanonical,
	const NumberParts *partsTable,extended *x)
	= {0x2F3C,0x8210,0xFFE6,0xA8B5};
pascal Fixed PortionText(Ptr textPtr,long textLen)
	= {0x2F3C,0x8408,0x0024,0xA8B5};
pascal struct ScriptRunStatus FindScriptRun(Ptr textPtr,long textLen,long *lenUsed)
	= {0x2F3C,0x820C,0x0026,0xA8B5};
pascal long VisibleLength(Ptr textPtr,long textLen)
	= {0x2F3C,0x8408,0x0028,0xA8B5};
pascal short ValidDate(LongDateRec *vDate,long flags,LongDateTime *newSecs)
	= {0x2F3C,0x8204,0xFFE4,0xA8B5};

/* New for 7.0 */													/* <1.4> */

pascal void NFindWord(Ptr textPtr,short textLength,short offset,	/* <1.6> */
	Boolean leadingEdge,NBreakTablePtr nbreaks,OffsetTable offsets)	/* <1.8> */
    = {0x2F3C,0x8012,0xFFE2,0xA8B5}; 

pascal short TruncString(short width,Str255 theString,				/* <1.6><2.1><8> */
	TruncCode truncWhere)
    = {0x2F3C,0x8208,0xFFE0,0xA8B5}; 

pascal short TruncText(short width,Ptr textPtr,short *length,		/* <1.6><2.1><8> */
	TruncCode truncWhere)
    = {0x2F3C,0x820C,0xFFDE,0xA8B5}; 

pascal short ReplaceText(Handle baseText,Handle substitutionText,	/* <1.6> */
	Str15 key)
    = {0x2F3C,0x820C,0xFFDC,0xA8B5}; 

pascal short NPixel2Char(Ptr textBuf,long textLen,Fixed slop,Fixed pixelWidth,	/* <2><15> */
    Boolean *leadingEdge,Fixed *widthRemaining,JustStyleCode styleRunPosition,
	Point numer,Point denom)
    = {0x2F3C,0x8222,0x002E,0xA8B5}; 

pascal short NChar2Pixel(Ptr textBuf,long textLen,Fixed slop,long offset,		/* <2><15> */
    short direction,JustStyleCode styleRunPosition,Point numer,Point denom)
    = {0x2F3C,0x821C,0x0030,0xA8B5}; 

pascal void NDrawJust(Ptr textPtr,long textLength,Fixed slop,					/* <2><15> */
	JustStyleCode styleRunPosition,Point numer,Point denom)
    = {0x2F3C,0x8016,0x0032,0xA8B5}; 

pascal void NMeasureJust(Ptr textPtr,long textLength,Fixed slop,Ptr charLocs,	/* <2><15> */
	JustStyleCode styleRunPosition,Point numer,Point denom)
    = {0x2F3C,0x801A,0x0034,0xA8B5}; 

pascal Fixed NPortionText(Ptr textPtr,long textLen,								/* <2><15> */
	JustStyleCode styleRunPosition,Point numer,Point denom)
    = {0x2F3C,0x8412,0x0036,0xA8B5}; 

#ifdef __cplusplus
}
#endif

#endif
