/************************************************************

Created: Friday, October 20, 1989 at 2:31 PM
	Serial.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-1989
	All rights reserved

************************************************************/


#ifndef __SERIAL__
#define __SERIAL__

#ifndef __TYPES__
#include <Types.h>
#endif

enum {baud300 = 380};
enum {baud600 = 189};
enum {baud1200 = 94};
enum {baud1800 = 62};
enum {baud2400 = 46};
enum {baud3600 = 30};
enum {baud4800 = 22};
enum {baud7200 = 14};
enum {baud9600 = 10};
enum {baud19200 = 4};
enum {baud57600 = 0};
enum {stop10 = 16384};
enum {stop15 = -32768};
enum {stop20 = -16384};
enum {noParity = 0};
enum {oddParity = 4096};
enum {evenParity = 12288};
enum {data5 = 0};
enum {data6 = 2048};
enum {data7 = 1024};
enum {data8 = 3072};
enum {ctsEvent = 32};
enum {breakEvent = 128};
enum {xOffWasSent = 128};
enum {dtrNegated = 64};
enum {ainRefNum = -6};      /*serial port A input*/
enum {aoutRefNum = -7};     /*serial port A output*/
enum {binRefNum = -8};      /*serial port B input*/
enum {boutRefNum = -9};     /*serial port B output*/

enum {sPortA,sPortB};
typedef unsigned char SPortSel;

struct SerShk {
	char fXOn;				/*XOn flow control enabled flag*/
	char fCTS;				/*CTS flow control enabled flag*/
	unsigned char xOn;		/*XOn character*/
	unsigned char xOff; 	/*XOff character*/
	char errs;				/*errors mask bits*/
	char evts;				/*event enable mask bits*/
	char fInX;				/*Input flow control enabled flag*/
	char fDTR;				/*DTR input flow control flag*/
};

typedef struct SerShk SerShk;
struct SerStaRec {
	char cumErrs;
	char xOffSent;
	char rdPend;
	char wrPend;
	char ctsHold;
	char xOffHold;
};

typedef struct SerStaRec SerStaRec;
#ifdef __cplusplus
extern "C" {
#endif
pascal OSErr RAMSDOpen(SPortSel whichPort); 
pascal void RAMSDClose(SPortSel whichPort); 
pascal OSErr SerReset(short refNum,short serConfig);
pascal OSErr SerSetBuf(short refNum,Ptr serBPtr,short serBLen); 
pascal OSErr SerHShake(short refNum,const SerShk *flags);
pascal OSErr SerSetBrk(short refNum);
pascal OSErr SerClrBrk(short refNum);
pascal OSErr SerGetBuf(short refNum,long *count);
pascal OSErr SerStatus(short refNum,SerStaRec *serSta); 
#ifdef __cplusplus
}
#endif

#endif
