/************************************************************

Created: Thursday, February 4, 1990 at 11:51 PM
	StandardFile.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc. 1990
	All rights reserved


************************************************************/


#ifndef __STANDARDFILE__
#define __STANDARDFILE__


#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __FILES__
#include <Files.h>	/* to get definition for FSSpec */
#endif

#ifndef __DIALOGS__
#include <Dialogs.h>	/* to get definition for DialogPtr */
#endif

/* resource IDs and item offsets of pre-7.0 dialogs */
enum {putDlgID = -3999};
enum {putSave = 1};
enum {putCancel = 2};
enum {putEject = 5};
enum {putDrive = 6};
enum {putName = 7};
enum {getDlgID = -4000};
enum {getOpen = 1};
enum {getCancel = 3};
enum {getEject = 5};
enum {getDrive = 6};
enum {getNmList = 7};
enum {getScroll = 8};

/* resource IDs and item offsets of 7.0 dialogs */
enum {sfPutDialogID = (-6048)};
enum {sfGetDialogID = (-6047)};
enum {sfItemOpenButton = 1};
enum {sfItemCancelButton = 2};
enum {sfItemBalloonHelp = 3};
enum {sfItemVolumeUser = 4};
enum {sfItemEjectButton = 5};
enum {sfItemDesktopButton = 6};
enum {sfItemFileListUser = 7};
enum {sfItemPopUpMenuUser = 8};
enum {sfItemDividerLinePict = 9};
enum {sfItemFileNameTextEdit = 10};
enum {sfItemPromptStaticText = 11};
enum {sfItemNewFolderUser = 12};

/* pseudo-item hits for use in DlgHook */
enum {sfHookFirstCall = (-1)};
enum {sfHookCharOffset = 0x1000};
enum {sfHookNullEvent = 100};
enum {sfHookRebuildList = 101};
enum {sfHookFolderPopUp = 102};
enum {sfHookOpenFolder = 103};

/* the following are only in system 7.0+ */
enum {sfHookOpenAlias = 104};
enum {sfHookGotoDesktop = 105};
enum {sfHookGotoAliasTarget = 106};
enum {sfHookGotoParent = 107};
enum {sfHookGotoNextDrive = 108};
enum {sfHookGotoPrevDrive = 109};
enum {sfHookSetActiveOffset = 200};
enum {sfHookLastCall = (-2)};

/* the refcon field of the dialog record during a 		*/
/* modalfilter or dialoghook contains one the following */
#define sfMainDialogRefCon		'stdf'
#define sfNewFolderDialogRefCon	'nfdr'
#define sfReplaceDialogRefCon	'rplc'
#define sfStatWarnDialogRefCon	'stat'
#define sfErrorDialogRefCon		'err '


struct SFReply {
    Boolean good;
    Boolean copy;
    OSType fType;
    short vRefNum;
    short version;
    Str63 fName;
};
typedef struct SFReply SFReply;

struct StandardFileReply {
    Boolean 	sfGood;
    Boolean 	sfReplacing;
    OSType 		sfType;
    FSSpec		sfFile;
    ScriptCode	sfScript;
    short 		sfFlags;
    Boolean 	sfIsFolder;
    Boolean 	sfIsVolume;
	long		sfReserved1;
	short		sfReserved2;
};
typedef struct StandardFileReply StandardFileReply;

typedef pascal short (*DlgHookProcPtr)(short item, DialogPtr theDialog);
typedef pascal Boolean (*FileFilterProcPtr)(ParmBlkPtr PB);

/* the following also include an extra parameter of "your data pointer" */
typedef pascal short (*DlgHookYDProcPtr)(short item, DialogPtr theDialog, void *yourDataPtr);
typedef pascal Boolean (*ModalFilterYDProcPtr)(DialogPtr theDialog, EventRecord *theEvent, short *itemHit, void *yourDataPtr);
typedef pascal Boolean (*FileFilterYDProcPtr)(ParmBlkPtr PB, void *yourDataPtr);
typedef pascal void (*ActivateYDProcPtr)(DialogPtr theDialog, short itemNo, Boolean activating, void *yourDataPtr);

typedef OSType SFTypeList[4];



#ifdef __cplusplus
extern "C" {
#endif

/* using C style strings */
void sfpputfile(Point *where,char *prompt,char *origName,DlgHookProcPtr dlgHook,
    SFReply *reply,short dlgID,ModalFilterProcPtr filterProc); 
	
void sfgetfile(Point *where,char *prompt,FileFilterProcPtr fileFilter,short numTypes,
    SFTypeList typeList,DlgHookProcPtr dlgHook,SFReply *reply); 
	
void sfpgetfile(Point *where,char *prompt,FileFilterProcPtr fileFilter,
    short numTypes,SFTypeList typeList,DlgHookProcPtr dlgHook,SFReply *reply,
    short dlgID,ModalFilterProcPtr filterProc); 

void sfputfile(Point *where,char *prompt,char *origName,DlgHookProcPtr dlgHook,
    SFReply *reply); 


/* using Pascal style strings */
pascal void SFPutFile(Point where,const Str255 prompt,const Str255 origName,
  					  DlgHookProcPtr dlgHook,SFReply *reply)
			={ 0x3F3C, 0x0001, 0xA9EA };
	
pascal void SFGetFile(Point where,const Str255 prompt,FileFilterProcPtr fileFilter,
    				short numTypes,SFTypeList typeList,DlgHookProcPtr dlgHook,SFReply *reply)
			={ 0x3F3C, 0x0002, 0xA9EA };
	
pascal void SFPPutFile(Point where,const Str255 prompt,const Str255 origName,
				    DlgHookProcPtr dlgHook,SFReply *reply,short dlgID,ModalFilterProcPtr filterProc)
			={ 0x3F3C, 0x0003, 0xA9EA };

pascal void SFPGetFile(Point where,const Str255 prompt,FileFilterProcPtr fileFilter,
						short numTypes,SFTypeList typeList,DlgHookProcPtr dlgHook,SFReply *reply,
						short dlgID,ModalFilterProcPtr filterProc) 
			={ 0x3F3C, 0x0004, 0xA9EA };
		

pascal void StandardPutFile(const Str255 prompt,const Str255 defaultName,
							StandardFileReply *reply)
			={ 0x3F3C, 0x0005, 0xA9EA };
				
pascal void StandardGetFile(const Str255 prompt,FileFilterProcPtr fileFilter,
  					  	short numTypes,SFTypeList typeList,StandardFileReply *reply)
			={ 0x3F3C, 0x0006, 0xA9EA };
			
pascal void CustomPutFile(const Str255 prompt,const Str255 defaultName,
   					StandardFileReply *reply,short dlgID, Point where,
					DlgHookYDProcPtr dlgHook,ModalFilterYDProcPtr filterProc, 
					short *activeList, ActivateYDProcPtr activateProc, void *yourDataPtr) 
			={ 0x3F3C, 0x0007, 0xA9EA };
							
pascal void CustomGetFile(FileFilterYDProcPtr fileFilter,short numTypes,
					SFTypeList typeList, StandardFileReply *reply, short dlgID,
					Point where, DlgHookYDProcPtr dlgHook, ModalFilterYDProcPtr filterProc,
					short *activeList, ActivateYDProcPtr activateProc, void *yourDataPtr)
			={ 0x3F3C, 0x0008, 0xA9EA };

#ifdef __cplusplus
}
#endif


/*
 New StandardFile comments:
 
 activeList is pointer to array of integer (16-bits).
 first integer is length of list.
 following integers are possible activatable DITL items, in 
 the order that the tab key will cycle through.  The first
 in the list is the item made active when dialog is first shown.

 activateProc is a pointer to a procedure like:
	PROCEDURE MyActivateProc(theDialog: 	DialogPtr; 
								itemNo: 	INTEGER; 
								activating: BOOLEAN;
								yourDataPtr:Ptr); 
 The activateProc is called with activating=FALSE on the itemNo
 about to deactivate then with activating=TRUE on the itemNo
 about to become the active item. (like activate event)

 yourDataPtr is a nice little extra that makes life easier without
 globals.  CustomGetFile & CustomPPutFile when calling any of their
 call back procedures, pushes the extra parameter of yourDataPtr on
 the stack.  
 
 In addition the filterProc in CustomGetFile & CustomPPutFile is called
 before before SF does any mapping, instead of after.
*/


#endif

