/************************************************************

Created: Thursday, September 7, 1989 at 7:49 PM
	SysEqu.h
	C Interface to the Macintosh Libraries


	Copyright Apple Computer, Inc.	1985-90
	All rights reserved

************************************************************/


#ifndef __SYSEQU__
#define __SYSEQU__

enum {PCDeskPat = 0x20B};               /*[GLOBAL VAR]  desktop pat, top bit only! others are in use*/
enum {HiKeyLast = 0x216};               /*[GLOBAL VAR]  Same as KbdVars*/
enum {KbdLast = 0x218};                 /*[GLOBAL VAR]  Same as KbdVars+2*/
enum {ExpandMem = 0x2B6};               /*[GLOBAL VAR]  pointer to expanded memory block*/
enum {SCSIBase = 0x0C00};               /*[GLOBAL VAR]  (long) base address for SCSI chip read*/
enum {SCSIDMA = 0x0C04};                /*[GLOBAL VAR]  (long) base address for SCSI DMA*/
enum {SCSIHsk = 0x0C08};                /*[GLOBAL VAR]  (long) base address for SCSI handshake*/
enum {SCSIGlobals = 0x0C0C};            /*[GLOBAL VAR]  (long) ptr for SCSI mgr locals*/
enum {RGBBlack = 0x0C10};               /*[GLOBAL VAR]  (6 bytes) the black field for color*/
enum {RGBWhite = 0x0C16};               /*[GLOBAL VAR]  (6 bytes) the white field for color*/
enum {RowBits = 0x0C20};                /*[GLOBAL VAR]  (word) screen horizontal pixels*/
enum {ColLines = 0x0C22};               /*[GLOBAL VAR]  (word) screen vertical pixels*/
enum {ScreenBytes = 0x0C24};            /*[GLOBAL VAR]  (long) total screen bytes*/
enum {NMIFlag = 0x0C2C};                /*[GLOBAL VAR]  (byte) flag for NMI debounce*/
enum {VidType = 0x0C2D};                /*[GLOBAL VAR]  (byte) video board type ID*/
enum {VidMode = 0x0C2E};                /*[GLOBAL VAR]  (byte) video mode (4=4bit color)*/
enum {SCSIPoll = 0x0C2F};               /*[GLOBAL VAR]  (byte) poll for device zero only once.*/
enum {SEVarBase = 0x0C30};              /*[GLOBAL VAR] */
enum {MMUFlags = 0x0CB0};               /*[GLOBAL VAR]  (byte) cleared to zero (reserved for future use)*/
enum {MMUType = 0x0CB1};                /*[GLOBAL VAR]  (byte) kind of MMU present*/
enum {MMU32bit = 0x0CB2};               /*[GLOBAL VAR]  (byte) boolean reflecting current machine MMU mode*/
enum {MMUFluff = 0x0CB3};               /*[GLOBAL VAR]  (byte) fluff byte forced by reducing MMUMode to MMU32bit.*/
enum {MMUTbl = 0x0CB4};                 /*[GLOBAL VAR]  (long) pointer to MMU Mapping table*/
enum {MMUTblSize = 0x0CB8};             /*[GLOBAL VAR]  (long) size of the MMU mapping table*/
enum {SInfoPtr = 0x0CBC};               /*[GLOBAL VAR]  (long) pointer to Slot manager information*/
enum {ASCBase = 0x0CC0};                /*[GLOBAL VAR]  (long) pointer to Sound Chip*/
enum {SMGlobals = 0x0CC4};              /* (long) pointer to Sound Manager Globals*/
enum {TheGDevice = 0x0CC8};             /*[GLOBAL VAR]  (long) the current graphics device*/
enum {CQDGlobals = 0x0CCC};             /* (long) quickDraw global extensions*/
enum {ADBBase = 0x0CF8};                /*[GLOBAL VAR]  (long) pointer to Front Desk Buss Variables*/
enum {WarmStart = 0x0CFC};              /*[GLOBAL VAR]  (long) flag to indicate it is a warm start*/
enum {TimeDBRA = 0x0D00};               /*[GLOBAL VAR]  (word) number of iterations of DBRA per millisecond*/
enum {TimeSCCDB = 0x0D02};              /*[GLOBAL VAR]  (word) number of iter's of SCC access & DBRA.*/
enum {SlotQDT = 0x0D04};                /*[GLOBAL VAR]  ptr to slot queue table*/
enum {SlotPrTbl = 0x0D08};              /*[GLOBAL VAR]  ptr to slot priority table*/
enum {SlotVBLQ = 0x0D0C};               /*[GLOBAL VAR]  ptr to slot VBL queue table*/
enum {ScrnVBLPtr = 0x0D10};             /*[GLOBAL VAR]  save for ptr to main screen VBL queue*/
enum {SlotTICKS = 0x0D14};              /*[GLOBAL VAR]  ptr to slot tickcount table*/
enum {TableSeed = 0x0D20};              /*[GLOBAL VAR]  (long) seed value for color table ID's*/
enum {SRsrcTblPtr = 0x0D24};            /*[GLOBAL VAR]  (long) pointer to slot resource table.*/
enum {JVBLTask = 0x0D28};               /*[GLOBAL VAR]  vector to slot VBL task interrupt handler*/
enum {WMgrCPort = 0x0D2C};              /*[GLOBAL VAR]  window manager color port */
enum {VertRRate = 0x0D30};              /*[GLOBAL VAR]  (word) Vertical refresh rate for start manager. */
enum {ChunkyDepth = 0x0D60};            /*[GLOBAL VAR]  depth of the pixels*/
enum {CrsrPtr = 0x0D62};                /*[GLOBAL VAR]  pointer to cursor save area*/
enum {PortList = 0x0D66};               /*[GLOBAL VAR]  list of grafports*/
enum {MickeyBytes = 0x0D6A};            /*[GLOBAL VAR]  long pointer to cursor stuff*/
enum {QDErrLM = 0x0D6E};                /*[GLOBAL VAR] QDErr has name conflict w/ type. QuickDraw error code [word]*/
enum {VIA2DT = 0x0D70};                 /*[GLOBAL VAR]  32 bytes for VIA2 dispatch table for NuMac*/
enum {SInitFlags = 0x0D90};             /*[GLOBAL VAR]  StartInit.a flags [word]*/
enum {DTQueue = 0x0D92};                /*[GLOBAL VAR]  (10 bytes) deferred task queue header*/
enum {DTQFlags = 0x0D92};               /*[GLOBAL VAR]  flag word for DTQueue*/
enum {DTskQHdr = 0x0D94};               /*[GLOBAL VAR]  ptr to head of queue*/
enum {DTskQTail = 0x0D98};              /*[GLOBAL VAR]  ptr to tail of queue*/
enum {JDTInstall = 0x0D9C};             /*[GLOBAL VAR]  (long) ptr to deferred task install routine*/
enum {HiliteRGB = 0x0DA0};              /*[GLOBAL VAR]  6 bytes: rgb of hilite color*/
enum {TimeSCSIDB = 0x0DA6};             /*[GLOBAL VAR]  (word) number of iter's of SCSI access & DBRA*/
enum {DSCtrAdj = 0x0DA8};               /*[GLOBAL VAR]  (long) Center adjust for DS rect.*/
enum {IconTLAddr = 0x0DAC};             /*[GLOBAL VAR]  (long) pointer to where start icons are to be put.*/
enum {VideoInfoOK = 0x0DB0};            /*[GLOBAL VAR]  (long) Signals to CritErr that the Video card is ok*/
enum {EndSRTPtr = 0x0DB4};              /*[GLOBAL VAR]  (long) Pointer to the end of the Slot Resource Table (Not the SRT buffer).*/
enum {SDMJmpTblPtr = 0x0DB8};           /*[GLOBAL VAR]  (long) Pointer to the SDM jump table*/
enum {JSwapMMU = 0x0DBC};               /*[GLOBAL VAR]  (long) jump vector to SwapMMU routine*/
enum {SdmBusErr = 0x0DC0};              /*[GLOBAL VAR]  (long) Pointer to the SDM busErr handler*/
enum {LastTxGDevice = 0x0DC4};          /*[GLOBAL VAR]  (long) copy of TheGDevice set up for fast text measure*/
enum {NewCrsrJTbl = 0x88C};             /*[GLOBAL VAR]  location of new crsr jump vectors*/
enum {JAllocCrsr = 0x88C};              /*[GLOBAL VAR]  (long) vector to routine that allocates cursor*/
enum {JSetCCrsr = 0x890};               /*[GLOBAL VAR]  (long) vector to routine that sets color cursor*/
enum {JOpcodeProc = 0x894};             /*[GLOBAL VAR]  (long) vector to process new picture opcodes*/
enum {CrsrBase = 0x898};                /*[GLOBAL VAR]  (long) scrnBase for cursor*/
enum {CrsrDevice = 0x89C};              /*[GLOBAL VAR]  (long) current cursor device*/
enum {SrcDevice = 0x8A0};               /*[GLOBAL VAR]  (LONG) Src device for Stretchbits*/
enum {MainDevice = 0x8A4};              /*[GLOBAL VAR]  (long) the main screen device*/
enum {DeviceList = 0x8A8};              /*[GLOBAL VAR]  (long) list of display devices*/
enum {CrsrRow = 0x8AC};                 /*[GLOBAL VAR]  (word) rowbytes for current cursor screen*/
enum {QDColors = 0x8B0};                /*[GLOBAL VAR]  (long) handle to default colors*/
enum {HiliteMode = 0x938};              /*[GLOBAL VAR]  used for color highlighting*/
enum {BusErrVct = 0x08};                /*[GLOBAL VAR]  bus error vector*/
enum {RestProc = 0xA8C};                /*[GLOBAL VAR]  Resume procedure f InitDialogs [pointer]*/
enum {ROM85 = 0x28E};                   /*[GLOBAL VAR]  (word) actually high bit - 0 for ROM vers $75 (sic) and later*/
enum {ROMMapHndl = 0xB06};              /*[GLOBAL VAR]  (long) handle of ROM resource map*/
enum {ScrVRes = 0x102};                 /*[GLOBAL VAR] Pixels per inch vertically (word)
   screen vertical dots/inch [word]*/
enum {ScrHRes = 0x104};                 /*[GLOBAL VAR] Pixels per inch horizontally (word)
   screen horizontal dots/inch [word]*/
enum {ScrnBase = 0x824};                /*[GLOBAL VAR] Address of main screen buffer
   Screen Base [pointer]*/
enum {ScreenRow = 0x106};               /*[GLOBAL VAR]  rowBytes of screen [word]*/
enum {MBTicks = 0x16E};                 /*[GLOBAL VAR]  tick count @ last mouse button [long]*/
enum {JKybdTask = 0x21A};               /*[GLOBAL VAR]  keyboard VBL task hook [pointer]*/
enum {KeyLast = 0x184};                 /*[GLOBAL VAR]  ASCII for last valid keycode [word]*/
enum {KeyTime = 0x186};                 /*[GLOBAL VAR]  tickcount when KEYLAST was rec'd [long]*/
enum {KeyRepTime = 0x18A};              /*[GLOBAL VAR]  tickcount when key was last repeated [long]*/
enum {SPConfig = 0x1FB};                /*[GLOBAL VAR] Use types for serial ports (byte)
   config bits: 4-7 A, 0-3 B (see use type below)*/
enum {SPPortA = 0x1FC};                 /*[GLOBAL VAR] Modem port configuration (word)
   SCC port A configuration [word]*/
enum {SPPortB = 0x1FE};                 /*[GLOBAL VAR] Printer port configuration (word)
   SCC port B configuration [word]*/
enum {SCCRd = 0x1D8};                   /*[GLOBAL VAR] SCC read base address
   SCC base read address [pointer]*/
enum {SCCWr = 0x1DC};                   /*[GLOBAL VAR] SCC write base address
   SCC base write address [pointer]*/
enum {DoubleTime = 0x2F0};              /*[GLOBAL VAR] Double-click interval in ticks (long)
   double click ticks [long]*/
enum {CaretTime = 0x2F4};               /*[GLOBAL VAR] Caret-blink interval in ticks (long)
   caret blink ticks [long]*/
enum {KeyThresh = 0x18E};               /*[GLOBAL VAR] Auto-key threshold (word)
   threshold for key repeat [word]*/
enum {KeyRepThresh = 0x190};            /*[GLOBAL VAR] Auto-key rate (word)
   key repeat speed [word]*/
enum {SdVolume = 0x260};                /*[GLOBAL VAR] Current speaker volume (byte:  low-order three bits only)
   Global volume(sound) control [byte]*/
enum {Ticks = 0x16A};                   /*[GLOBAL VAR] Current number of ticks since system startup (long)
   Tick count, time since boot [unsigned long]*/
enum {TimeLM = 0x20C};                  /*[GLOBAL VAR] Time has name conflict w/ type. Clock time (extrapolated) [long]*/
enum {MonkeyLives = 0x100};             /*[GLOBAL VAR]  monkey lives if >= 0 [word]*/
enum {SEvtEnb = 0x15C};                 /*[GLOBAL VAR] 0 if SystemEvent should return FALSE (byte)
   enable SysEvent calls from GNE [byte]*/
enum {JournalFlag = 0x8DE};             /*[GLOBAL VAR] Journaling mode (word)
   journaling state [word]*/
enum {JournalRef = 0x8E8};              /*[GLOBAL VAR] Reference number of journaling device driver (word)
   Journalling driver's refnum [word]*/
enum {BufPtr = 0x10C};                  /*[GLOBAL VAR] Address of end of jump table
   top of application memory [pointer]*/
enum {StkLowPt = 0x110};                /*[GLOBAL VAR]  Lowest stack as measured in VBL task [pointer]*/
enum {TheZone = 0x118};                 /*[GLOBAL VAR] Address of current heap zone
   current heap zone [pointer]*/
enum {ApplLimit = 0x130};               /*[GLOBAL VAR] Application heap limit
   application limit [pointer]*/
enum {SysZone = 0x2A6};                 /*[GLOBAL VAR] Address of system heap zone
   system heap zone [pointer]*/
enum {ApplZone = 0x2AA};                /*[GLOBAL VAR] Address of application heap zone
   application heap zone [pointer]*/
enum {HeapEnd = 0x114};                 /*[GLOBAL VAR] Address of end of application heap zone
   end of heap [pointer]*/
enum {HiHeapMark = 0xBAE};              /*[GLOBAL VAR]  (long) highest address used by a zone below sp<01Nov85 JTC>*/
enum {MemErr = 0x220};                  /*[GLOBAL VAR]  last memory manager error [word]*/
enum {UTableBase = 0x11C};              /*[GLOBAL VAR] Base address of unit table
   unit I/O table [pointer]*/
enum {UnitNtryCnt = 0x1D2};             /*[GLOBAL VAR]  count of entries in unit table [word]*/
enum {JFetch = 0x8F4};                  /*[GLOBAL VAR] Jump vector for Fetch function
   fetch a byte routine for drivers [pointer]*/
enum {JStash = 0x8F8};                  /*[GLOBAL VAR] Jump vector for Stash function
   stash a byte routine for drivers [pointer]*/
enum {JIODone = 0x8FC};                 /*[GLOBAL VAR] Jump vector for IODone function
   IODone entry location [pointer]*/
enum {DrvQHdr = 0x308};                 /*[GLOBAL VAR] Drive queue header (10 bytes)
   queue header of drives in system [10 bytes]*/
enum {BootDrive = 0x210};               /*[GLOBAL VAR]  drive number of boot drive [word]*/
enum {EjectNotify = 0x338};             /*[GLOBAL VAR]  eject notify procedure [pointer]*/
enum {IAZNotify = 0x33C};               /*[GLOBAL VAR]  world swaps notify procedure [pointer]*/
enum {SFSaveDisk = 0x214};              /*[GLOBAL VAR] Negative of volume reference number used by Standard File Package (word)
   last vRefNum seen by standard file [word]*/
enum {CurDirStore = 0x398};             /*[GLOBAL VAR]  save dir across calls to Standard File [long]*/
enum {OneOne = 0xA02};                  /*[GLOBAL VAR] $00010001
   constant $00010001 [long]*/
enum {MinusOne = 0xA06};                /*[GLOBAL VAR] $FFFFFFFF
   constant $FFFFFFFF [long]*/
enum {Lo3Bytes = 0x31A};                /*[GLOBAL VAR] $00FFFFFF
   constant $00FFFFFF [long]*/
enum {ROMBase = 0x2AE};                 /*[GLOBAL VAR] Base address of ROM
   ROM base address [pointer]*/
enum {RAMBase = 0x2B2};                 /*[GLOBAL VAR] Trap dispatch table's base address for routines in RAM
   RAM base address [pointer]*/
enum {SysVersion = 0x15A};              /*[GLOBAL VAR]  version # of RAM-based system [word]*/
enum {RndSeed = 0x156};                 /*[GLOBAL VAR] Random number seed (long)
   random seed/number [long]*/
enum {Scratch20 = 0x1E4};               /*[GLOBAL VAR] 20-byte scratch area
   scratch [20 bytes]*/
enum {Scratch8 = 0x9FA};                /*[GLOBAL VAR] 8-byte scratch area
   scratch [8 bytes]*/
enum {ScrapSize = 0x960};               /*[GLOBAL VAR] Size in bytes of desk scrap (long)
   scrap length [long]*/
enum {ScrapHandle = 0x964};             /*[GLOBAL VAR] Handle to desk scrap in memory
   memory scrap [handle]*/
enum {ScrapCount = 0x968};              /*[GLOBAL VAR] Count changed by ZeroScrap (word)
   validation byte [word]*/
enum {ScrapState = 0x96A};              /*[GLOBAL VAR] Tells where desk scrap is (word)
   scrap state [word]*/
enum {ScrapName = 0x96C};               /*[GLOBAL VAR] Pointer to scrap file name (preceded by length byte)
   pointer to scrap name [pointer]*/
enum {IntlSpec = 0xBA0};                /*[GLOBAL VAR]  (long) - ptr to extra Intl data */
enum {SwitcherTPtr = 0x286};            /*[GLOBAL VAR]  Switcher's switch table */
enum {CPUFlag = 0x12F};                 /*[GLOBAL VAR]  $00=68000, $01=68010, $02=68020 (old ROM inits to $00)*/
enum {VIA = 0x1D4};                     /*[GLOBAL VAR] VIA base address
   VIA base address [pointer]*/
enum {IWM = 0x1E0};                     /*[GLOBAL VAR]  IWM base address [pointer]*/
enum {Lvl1DT = 0x192};                  /*[GLOBAL VAR] Level-1 secondary interrupt vector table (32 bytes)
   Interrupt level 1 dispatch table [32 bytes]*/
enum {Lvl2DT = 0x1B2};                  /*[GLOBAL VAR] Level-2 secondary interrupt vector table (32 bytes)
   Interrupt level 2 dispatch table [32 bytes]*/
enum {ExtStsDT = 0x2BE};                /*[GLOBAL VAR] External/status interrupt vector table (16 bytes)
   SCC ext/sts secondary dispatch table [16 bytes]*/
enum {SPValid = 0x1F8};                 /*[GLOBAL VAR] Validity status (byte)
   validation field ($A7) [byte]*/
enum {SPATalkA = 0x1F9};                /*[GLOBAL VAR] AppleTalk node ID hint for modem port (byte)
   AppleTalk node number hint for port A*/
enum {SPATalkB = 0x1FA};                /*[GLOBAL VAR] AppleTalk node ID hint for printer port (byte)
   AppleTalk node number hint for port B*/
enum {SPAlarm = 0x200};                 /*[GLOBAL VAR] Alarm setting (long)
   alarm time [long]*/
enum {SPFont = 0x204};                  /*[GLOBAL VAR] Application font number minus 1 (word)
   default application font number minus 1 [word]*/
enum {SPKbd = 0x206};                   /*[GLOBAL VAR] Auto-key threshold and rate (byte)
   kbd repeat thresh in 4/60ths [2 4-bit]*/
enum {SPPrint = 0x207};                 /*[GLOBAL VAR] Printer connection (byte)
   print stuff [byte]*/
enum {SPVolCtl = 0x208};                /*[GLOBAL VAR] Speaker volume setting in parameter RAM (byte)
   volume control [byte]*/
enum {SPClikCaret = 0x209};             /*[GLOBAL VAR] Double-click and caret-blink times (byte)
   double click/caret time in 4/60ths[2 4-bit]*/
enum {SPMisc1 = 0x20A};                 /*[GLOBAL VAR]  miscellaneous [1 byte]*/
enum {SPMisc2 = 0x20B};                 /*[GLOBAL VAR] Mouse scaling, system startup disk, menu blink (byte)
   miscellaneous [1 byte]*/
enum {GetParam = 0x1E4};                /*[GLOBAL VAR]  system parameter scratch [20 bytes]*/
enum {SysParam = 0x1F8};                /*[GLOBAL VAR] Low-memory copy of parameter RAM (20 bytes)
   system parameter memory [20 bytes]*/
enum {CrsrThresh = 0x8EC};              /*[GLOBAL VAR] Mouse-scaling threshold (word) 
   delta threshold for mouse scaling [word]*/
enum {JCrsrTask = 0x8EE};               /*[GLOBAL VAR]  address of CrsrVBLTask [long]*/
enum {MTemp = 0x828};                   /*[GLOBAL VAR]  Low-level interrupt mouse location [long]*/
enum {RawMouse = 0x82C};                /*[GLOBAL VAR]  un-jerked mouse coordinates [long]*/
enum {CrsrRect = 0x83C};                /*[GLOBAL VAR]  Cursor hit rectangle [8 bytes]*/
enum {TheCrsr = 0x844};                 /*[GLOBAL VAR]  Cursor data, mask & hotspot [68 bytes]*/
enum {CrsrAddr = 0x888};                /*[GLOBAL VAR]  Address of data under cursor [long]*/
enum {CrsrSave = 0x88C};                /*[GLOBAL VAR]  data under the cursor [64 bytes]*/
enum {CrsrVis = 0x8CC};                 /*[GLOBAL VAR]  Cursor visible? [byte]*/
enum {CrsrBusy = 0x8CD};                /*[GLOBAL VAR]  Cursor locked out? [byte]*/
enum {CrsrNew = 0x8CE};                 /*[GLOBAL VAR]  Cursor changed? [byte]*/
enum {CrsrState = 0x8D0};               /*[GLOBAL VAR]  Cursor nesting level [word]*/
enum {CrsrObscure = 0x8D2};             /*[GLOBAL VAR]  Cursor obscure semaphore [byte]*/
enum {KbdVars = 0x216};                 /*[GLOBAL VAR]  Keyboard manager variables [4 bytes]*/
enum {KbdType = 0x21E};                 /*[GLOBAL VAR]  keyboard model number [byte]*/
enum {MBState = 0x172};                 /*[GLOBAL VAR]  current mouse button state [byte]*/
enum {KeyMapLM = 0x174};                /*[GLOBAL VAR] KeyMap has name conflict w/ type. Bitmap of the keyboard [4 longs]*/
enum {KeypadMap = 0x17C};               /*[GLOBAL VAR]  bitmap for numeric pad-18bits [long]*/
enum {Key1Trans = 0x29E};               /*[GLOBAL VAR]  keyboard translator procedure [pointer]*/
enum {Key2Trans = 0x2A2};               /*[GLOBAL VAR]  numeric keypad translator procedure [pointer]*/
enum {JGNEFilter = 0x29A};              /*[GLOBAL VAR]  GetNextEvent filter proc [pointer]*/
enum {KeyMVars = 0xB04};                /*[GLOBAL VAR]  (word) for ROM KEYM proc state*/
enum {Mouse = 0x830};                   /*[GLOBAL VAR]  processed mouse coordinate [long]*/
enum {CrsrPin = 0x834};                 /*[GLOBAL VAR]  cursor pinning rectangle [8 bytes]*/
enum {CrsrCouple = 0x8CF};              /*[GLOBAL VAR]  cursor coupled to mouse? [byte]*/
enum {CrsrScale = 0x8D3};               /*[GLOBAL VAR]  cursor scaled? [byte]*/
enum {MouseMask = 0x8D6};               /*[GLOBAL VAR]  V-H mask for ANDing with mouse [long]*/
enum {MouseOffset = 0x8DA};             /*[GLOBAL VAR]  V-H offset for adding after ANDing [long]*/
enum {AlarmState = 0x21F};              /*[GLOBAL VAR]  Bit7=parity, Bit6=beeped, Bit0=enable [byte]*/
enum {VBLQueue = 0x160};                /*[GLOBAL VAR] Vertical retrace queue header (10 bytes)
   VBL queue header [10 bytes]*/
enum {SysEvtMask = 0x144};              /*[GLOBAL VAR] System event mask (word)
   system event mask [word]*/
enum {SysEvtBuf = 0x146};               /*[GLOBAL VAR]  system event queue element buffer [pointer]*/
enum {EventQueue = 0x14A};              /*[GLOBAL VAR] Event queue header (10 bytes)
   event queue header [10 bytes]*/
enum {EvtBufCnt = 0x154};               /*[GLOBAL VAR]  max number of events in SysEvtBuf - 1 [word]*/
enum {GZRootHnd = 0x328};               /*[GLOBAL VAR] Handle to relocatable block not to be moved by grow zone function
   root handle for GrowZone [handle]*/
enum {GZRootPtr = 0x32C};               /*[GLOBAL VAR]  root pointer for GrowZone [pointer]*/
enum {GZMoveHnd = 0x330};               /*[GLOBAL VAR]  moving handle for GrowZone [handle]*/
enum {MemTop = 0x108};                  /*[GLOBAL VAR] Address of end of RAM (on Macintosh XL, end of RAM available to applications)
   top of memory [pointer]*/
enum {MmInOK = 0x12E};                  /*[GLOBAL VAR]  initial memory mgr checks ok? [byte]*/
enum {HpChk = 0x316};                   /*[GLOBAL VAR]  heap check RAM code [pointer]*/
enum {MaskBC = 0x31A};                  /*[GLOBAL VAR]  Memory Manager Byte Count Mask [long]*/
enum {MaskHandle = 0x31A};              /*[GLOBAL VAR]  Memory Manager Handle Mask [long]*/
enum {MaskPtr = 0x31A};                 /*[GLOBAL VAR]  Memory Manager Pointer Mask [long]*/
enum {MinStack = 0x31E};                /*[GLOBAL VAR] Minimum space allotment for stack (long)
   min stack size used in InitApplZone [long]*/
enum {DefltStack = 0x322};              /*[GLOBAL VAR] Default space allotment for stack (long) 
   default size of stack [long]*/
enum {MMDefFlags = 0x326};              /*[GLOBAL VAR]  default zone flags [word]*/
enum {DSAlertTab = 0x2BA};              /*[GLOBAL VAR] Pointer to system error alert table in use
   system error alerts [pointer]*/
enum {DSAlertRect = 0x3F8};             /*[GLOBAL VAR] Rectangle enclosing system error alert (8 bytes)
   rectangle for disk-switch alert [8 bytes]*/
enum {DSDrawProc = 0x334};              /*[GLOBAL VAR]  alternate syserror draw procedure [pointer]*/
enum {DSWndUpdate = 0x15D};             /*[GLOBAL VAR]  GNE not to paintBehind DS AlertRect? [byte]*/
enum {WWExist = 0x8F2};                 /*[GLOBAL VAR]  window manager initialized? [byte]*/
enum {QDExist = 0x8F3};                 /*[GLOBAL VAR]  quickdraw is initialized [byte]*/
enum {ResumeProc = 0xA8C};              /*[GLOBAL VAR] Address of resume procedure
   Resume procedure from InitDialogs [pointer]*/
enum {DSErrCode = 0xAF0};               /*[GLOBAL VAR] Current system error ID (word)
   last system error alert ID*/
enum {IntFlag = 0x15F};                 /*[GLOBAL VAR]  reduce interrupt disable time when bit 7 = 0*/
enum {SerialVars = 0x2D0};              /*[GLOBAL VAR]  async driver variables [16 bytes]*/
enum {ABusVars = 0x2D8};                /*[GLOBAL VAR] Pointer to AppleTalk variables
  ;Pointer to AppleTalk local variables*/
enum {ABusDCE = 0x2DC};                 /*[GLOBAL VAR] ;Pointer to AppleTalk DCE*/
enum {PortAUse = 0x290};                /*[GLOBAL VAR]  bit 7: 1 = not in use, 0 = in use*/
enum {PortBUse = 0x291};                /*[GLOBAL VAR] Current availability of serial port B (byte)
   port B use, same format as PortAUse*/
enum {SCCASts = 0x2CE};                 /*[GLOBAL VAR]  SCC read reg 0 last ext/sts rupt - A [byte]*/
enum {SCCBSts = 0x2CF};                 /*[GLOBAL VAR]  SCC read reg 0 last ext/sts rupt - B [byte]*/
enum {DskErr = 0x142};                  /*[GLOBAL VAR]  disk routine result code [word]*/
enum {PWMBuf2 = 0x312};                 /*[GLOBAL VAR]  PWM buffer 1 (or 2 if sound) [pointer]*/
enum {SoundPtr = 0x262};                /*[GLOBAL VAR] Pointer to four-tone record
   4VE sound definition table [pointer]*/
enum {SoundBase = 0x266};               /*[GLOBAL VAR] Pointer to free-form synthesizer buffer
   sound bitMap [pointer]*/
enum {SoundVBL = 0x26A};                /*[GLOBAL VAR]  vertical retrace control element [16 bytes]*/
enum {SoundDCE = 0x27A};                /*[GLOBAL VAR]  sound driver DCE [pointer]*/
enum {SoundActive = 0x27E};             /*[GLOBAL VAR]  sound is active? [byte]*/
enum {SoundLevel = 0x27F};              /*[GLOBAL VAR] Amplitude in 740-byte buffer (byte)
   current level in buffer [byte]*/
enum {CurPitch = 0x280};                /*[GLOBAL VAR] Value of count in square-wave synthesizer buffer (word)
   current pitch value [word]*/
enum {DskVerify = 0x12C};               /*[GLOBAL VAR]  used by 3.5 disk driver for read/verify [byte]*/
enum {TagData = 0x2FA};                 /*[GLOBAL VAR]  sector tag info for disk drivers [14 bytes]*/
enum {BufTgFNum = 0x2FC};               /*[GLOBAL VAR] File tags buffer:  file number (long)
   file number [long]*/
enum {BufTgFFlg = 0x300};               /*[GLOBAL VAR] File tags buffer:  flags (word:  bit 1=1 if resource fork) 
   flags [word]*/
enum {BufTgFBkNum = 0x302};             /*[GLOBAL VAR] File tags buffer:  logical block number (word)
   logical block number [word]*/
enum {BufTgDate = 0x304};               /*[GLOBAL VAR] File tags buffer:  date and time of last modification (long)
   time stamp [word]*/
enum {ScrDmpEnb = 0x2F8};               /*[GLOBAL VAR] 0 if GetNextEvent shouldn't process Command-Shift-number combinations (byte)
   screen dump enabled? [byte]*/
enum {ScrDmpType = 0x2F9};              /*[GLOBAL VAR]  FF dumps screen, FE dumps front window [byte]*/
enum {ScrapVars = 0x960};               /*[GLOBAL VAR]  scrap manager variables [32 bytes]*/
enum {ScrapInfo = 0x960};               /*[GLOBAL VAR]  scrap length [long]*/
enum {ScrapEnd = 0x980};                /*[GLOBAL VAR]  end of scrap vars*/
enum {ScrapTag = 0x970};                /*[GLOBAL VAR]  scrap file name [STRING[15]]*/
enum {LaunchFlag = 0x902};              /*[GLOBAL VAR]  from launch or chain [byte]*/
enum {SaveSegHandle = 0x930};           /*[GLOBAL VAR]  seg 0 handle [handle]*/
enum {CurJTOffset = 0x934};             /*[GLOBAL VAR] Offset to jump table from location pointed to by A5 (word)
   current jump table offset [word]*/
enum {CurPageOption = 0x936};           /*[GLOBAL VAR] Sound/screen buffer configuration passed to Chain or Launch (word)
   current page 2 configuration [word]*/
enum {LoaderPBlock = 0x93A};            /*[GLOBAL VAR]  param block for ExitToShell [10 bytes]*/
enum {CurApRefNum = 0x900};             /*[GLOBAL VAR] Reference number of current application's resource file (word)
   refNum of application's resFile [word]*/
enum {CurrentA5 = 0x904};               /*[GLOBAL VAR] Address of boundary between application globals and application parameters
   current value of A5 [pointer]*/
enum {CurStackBase = 0x908};            /*[GLOBAL VAR] Address of base of stack; start of application globals
   current stack base [pointer]*/
enum {CurApName = 0x910};               /*[GLOBAL VAR] Name of current application (length byte followed by up to 31 characters)
   name of application [STRING[31]]*/
enum {LoadTrap = 0x12D};                /*[GLOBAL VAR]  trap before launch? [byte]*/
enum {SegHiEnable = 0xBB2};             /*[GLOBAL VAR]  (byte) 0 to disable MoveHHi in LoadSeg*/

/* Window Manager Globals */

enum {WindowList = 0x9D6};              /*[GLOBAL VAR] Pointer to first window in window list; 0 if using events but not windows
  Z-ordered linked list of windows [pointer]*/
enum {PaintWhite = 0x9DC};              /*[GLOBAL VAR] Flag for whether to paint window white before update event (word)
  erase newly drawn windows? [word]*/
enum {WMgrPort = 0x9DE};                /*[GLOBAL VAR] Pointer to Window Manager port 
  window manager's grafport [pointer]*/
enum {GrayRgn = 0x9EE};                 /*[GLOBAL VAR] Handle to region drawn as desktop
  rounded gray desk region [handle]*/
enum {CurActivate = 0xA64};             /*[GLOBAL VAR] Pointer to window to receive activate event
  window slated for activate event [pointer]*/
enum {CurDeactive = 0xA68};             /*[GLOBAL VAR] Pointer to window to receive deactivate event
  window slated for deactivate event [pointer]*/
enum {DragHook = 0x9F6};                /*[GLOBAL VAR] Address of procedure to execute during TrackGoAway, DragWindow, GrowWindow, DragGrayRgn, TrackControl, and DragControl
  user hook during dragging [pointer]*/
enum {DeskPattern = 0xA3C};             /*[GLOBAL VAR] Pattern with which desktop is painted (8 bytes)
  desk pattern [8 bytes]*/
enum {DeskHook = 0xA6C};                /*[GLOBAL VAR] Address of procedure for painting desktop or responding to clicks on desktop
  hook for painting the desk [pointer]*/
enum {GhostWindow = 0xA84};             /*[GLOBAL VAR] Pointer to window never to be considered frontmost
  window hidden from FrontWindow [pointer]*/

/* Text Edit Globals */

enum {TEDoText = 0xA70};                /*[GLOBAL VAR] Address of TextEdit multi-purpose routine
  textEdit doText proc hook [pointer]*/
enum {TERecal = 0xA74};                 /*[GLOBAL VAR] Address of routine to recalculate line starts for TextEdit
  textEdit recalText proc hook [pointer]*/
enum {TEScrpLength = 0xAB0};            /*[GLOBAL VAR] Size in bytes of TextEdit scrap (long)
  textEdit Scrap Length [word]*/
enum {TEScrpHandle = 0xAB4};            /*[GLOBAL VAR] Handle to TextEdit scrap
  textEdit Scrap [handle]*/
enum {TEWdBreak = 0xAF6};               /*[GLOBAL VAR] default word break routine [pointer]*/
enum {WordRedraw = 0xBA5};              /*[GLOBAL VAR] (byte) - used by TextEdit RecalDraw*/
enum {TESysJust = 0xBAC};               /*[GLOBAL VAR] (word) system justification (intl. textEdit)*/

/* Resource Manager Globals */

enum {TopMapHndl = 0xA50};              /*[GLOBAL VAR] Handle to resource map of most recently opened resource file
  topmost map in list [handle]*/
enum {SysMapHndl = 0xA54};              /*[GLOBAL VAR] Handle to map of system resource file
  system map [handle]*/
enum {SysMap = 0xA58};                  /*[GLOBAL VAR] Reference number of system resource file (word)
  reference number of system map [word]*/
enum {CurMap = 0xA5A};                  /*[GLOBAL VAR] Reference number of current resource file (word) 
  reference number of current map [word]*/
enum {ResReadOnly = 0xA5C};             /*[GLOBAL VAR] Read only flag [word]*/
enum {ResLoad = 0xA5E};                 /*[GLOBAL VAR] Current SetResLoad state (word)
  Auto-load feature [word]*/
enum {ResErr = 0xA60};                  /*[GLOBAL VAR] Current value of ResError (word)
  Resource error code [word]*/
enum {ResErrProc = 0xAF2};              /*[GLOBAL VAR] Address of resource error procedure
  Resource error procedure [pointer]*/
enum {SysResName = 0xAD8};              /*[GLOBAL VAR] Name of system resource file (length byte followed by up to 19 characters)
  Name of system resource file [STRING[19]]*/
enum {RomMapInsert = 0xB9E};            /*[GLOBAL VAR] (byte) determines if we should link in map*/
enum {TmpResLoad = 0xB9F};              /*[GLOBAL VAR] second byte is temporary ResLoad value.*/

/* Menu Mgr globals */

enum {MBarHeight = 0xBAA};              /*[GLOBAL VAR] height of the menu bar*/

/* CommToolbox Global */

enum {CommToolboxGlobals = 0x0BB4};     /*[GLOBAL VAR] pointer to CommToolbox globals */


#endif
