{
Created: Thursday, October 19, 1989 at 11:05 PM
	Aliases.p
	Pascal Interface to the Macintosh Libraries

	Copyright Apple Computer, Inc. 1989-90
	All rights reserved
}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT Aliases;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingAliases}
{$SETC UsingAliases := 1}

{$I+}
{$SETC AliasesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingFiles}
{$I $$Shell(PInterfaces)Files.p}
{$ENDC}
{$IFC UNDEFINED UsingMemory}
{$I $$Shell(PInterfaces)Memory.p}
{$ENDC}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$IFC UNDEFINED UsingFiles}
{$I $$Shell(PInterfaces)Files.p}
{$ENDC}
{$SETC UsingIncludes := AliasesIncludes}
	
	
{**********************************************************************
 ***************			Constants		***************************
 *********************************************************************}

CONST
	rAliasType		=	'alis'; 	{ Aliases are stored as resources of this type }
	
	{ define Alias Resolution action rules Mask }
	kARMmountVol	=	$0001;		{ mount the volume automatically }
	kARMnoUI		=	$0002;		{ no user interface allowed during resolution }
	kARMmultVols	=	$0008;		{ search on multiple volumes }
	kARMsearch		=	$0100;		{ search quickly }
	kARMsearchMore	=	$0200;		{ search further }
	kARMsearchRelFirst	=	$0400;	{ search target on a relative path first }
	
	{ define alias record information types }
	asiZoneName 	=	-3; 		{ get zone name }
	asiServerName	=	-2; 		{ get server name }
	asiVolumeName	=	-1; 		{ get volume name }
	asiAliasName	=	 0; 		{ get aliased file/folder/volume name }
	asiParentName	=	 1; 		{ get parent folder name }

{**********************************************************************
 ***************			Data Structures 	***********************
 *********************************************************************}

TYPE			
				
	AliasHandle 	=	^AliasPtr;		
	AliasPtr		=	^AliasRecord;		
	AliasRecord 	=	RECORD
							userType:		OSType;
							aliasSize:		INTEGER;
							{ what follows is a variable length amount of data }
						END;
						
	AliasInfoType	=	INTEGER; {alias record information type }
						
	AliasFilterProcPtr = ProcPtr; { FUNCTION Filter(cpbPtr: CInfoPB; VAR quitFlag: Boolean;
													 yourDataPtr: Ptr): Boolean	 }		
						

{**********************************************************************
 ***************			Public Interfaces		*******************
 *********************************************************************}
							
{****						High Level Routines 			****}
		
	{ Create Alias from 'fromFile' to 'target' }
	
	FUNCTION NewAlias(fromFile: FSSpecPtr;
						target: FSSpec;
						VAR alias: AliasHandle): OSErr; 
		INLINE $7002, $A823;
			
			
	{ create a minimal new alias for a target and return alias record handle }
	
	FUNCTION NewAliasMinimal(target: FSSpec;
						VAR alias: AliasHandle): OSErr; 
		INLINE $7008, $A823;
			
			
	{ create a minimal new alias from a target fullpath (optional zone and server name)
	and return alias record handle }
	
	FUNCTION NewAliasMinimalFromFullpath(fullpathLength: INTEGER;
						fullpath: Ptr;
						zoneName: Str31; serverName: Str31;
						VAR alias: AliasHandle): OSErr; 
		INLINE $7009, $A823;
			
			
	{ Given an alias handle and fromFile, resolve the alias, update the
	alias record and return aliased filename and wasChanged flag }
	
	FUNCTION ResolveAlias(fromFile: FSSpecPtr; alias: AliasHandle;
							VAR target: FSSpec;
							VAR wasChanged: Boolean): OSErr;
		INLINE $7003, $A823;


	{ Given an alias handle and an index specifying requested alias information
	type, return the information from alias record as a string. }
	
	FUNCTION GetAliasInfo(alias: AliasHandle;
						 index: AliasInfoType;
						 VAR theString: Str63): OSErr;
		INLINE $7007, $A823;
								

	{ given a file spec, return target file spec if input file spec is an alias.
	It resolves the entire alias chain or one step of the chain.  It returns
	info about whether the target is a folder or file; and whether the input
	file spec was an alias or not. }
	
	FUNCTION ResolveAliasFile(VAR theSpec: FSSpec;
							resolveAliasChains: Boolean;
							VAR targetIsFolder: Boolean;
							VAR wasAliased: Boolean): OSErr;
		INLINE $700C, $A823;



{****						Low Level Routines			****}

	{ Given an alias handle and 'fromFile', match the alias up to as
	many times as is in 'aliasCount', putting each possible 'toFile'
	in 'aliasList'.  Return actual number matched in 'aliasCount'
	and whether the alias needs to be updated in 'needsUpdate'. }
	
	FUNCTION MatchAlias(fromFile: FSSpecPtr; rulesMask: LONGINT;
						alias: AliasHandle; VAR aliasCount: INTEGER;
						aliasList: FSSpecArrayPtr;
						VAR needsUpdate: Boolean;
						AliasFilterProcPtr: ProcPtr;	
						yourDataPtr: UNIV Ptr): OSErr;
		INLINE $7005, $A823;


	{ Given a fromFile-newToFile pair and an alias handle, update the
	alias record pointed to by alias handle to represent newToFile
	as the new alias }
	
	FUNCTION UpdateAlias(fromFile: FSSpecPtr;
							target: FSSpec;
							alias: AliasHandle;
							VAR wasChanged: Boolean): OSErr;
		INLINE $7006, $A823;
	

{$ENDC}    { UsingAliases }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}

