{
	Created: Wednesday, November 1, 1989
	AppleEvents.p
	Pascal Interface to the Macintosh Libraries

	Copyright Apple Computer, Inc.	1985-1990
	All rights reserved
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT AppleEvents;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingAppleEvents}
{$SETC UsingAppleEvents := 1}

{$I+}
{$SETC AppleEventsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$IFC UNDEFINED UsingAppleTalk}
{$I $$Shell(PInterfaces)AppleTalk.p}
{$ENDC}
{$IFC UNDEFINED UsingEvents}
{$I $$Shell(PInterfaces)Events.p}
{$ENDC}
{$IFC UNDEFINED UsingPPCToolBox}
{$I $$Shell(PInterfaces)PPCToolBox.p}
{$ENDC}
{$IFC UNDEFINED UsingProcesses}
{$I $$Shell(PInterfaces)Processes.p}
{$ENDC}
{$IFC UNDEFINED UsingEPPC}
{$I $$Shell(PInterfaces)EPPC.p}
{$ENDC}
{$IFC UNDEFINED UsingNotification}
{$I $$Shell(PInterfaces)Notification.p}
{$ENDC}
{$SETC UsingIncludes := AppleEventsIncludes}

CONST
kAELongType 		= 'long';
kAEListType 		= 'list';
kAEWildType 		= '****';
kAEBooleanType		= 'bool';
kAETrueType 		= 'true';
kAEFalseType		= 'fals';
kAEAliasType		= 'alis';
kAEDirectObjectKeyword = '----';

kCoreEventClass 	= 'aevt';

kAEOpenApplication	= 'oapp';
kAEOpenDocuments	= 'odoc';
kAEPrintDocuments	= 'pdoc';
kAEQuitApplication	= 'quit';

kAENoReply			= $00000001;			{ Sender doesn't want a reply to event }
kAEQueueReply		= $00000002;			{ Sender wants a reply but won't wait }
kAEWaitReply		= $00000003;			{ Sender wants a reply and will be waiting }

kAENeverInteract	= $00000010;			{ Server should not interact with user }
kAECanInteract		= $00000020;			{ Server may try to interact with user }
kAEAlwaysInteract	= $00000030;			{ Server should always interact with user }

kAECanSwitchLayer	= $00000040;			{ Interaction may switch layer }

kAEDontReconnect	= $00000080;			{ don't reconnect if there is a
											 sessClosedErr }

kAEWantReceipt		= nReturnReceipt;		{ Send wants a receipt of message }

kAENormalPriority	= $00000000;			{ Post message at the end of event queue }
kAEHighPriority 	= nAttnMsg; 			{ Post message at the front of the event
											 queue }

kAutoGenerateRefcon = 0;

kAEEventNotInTable	= 0;					{ Passed to the general dispatch proc if }
											{ the event received was not in the
											{ dispatch table }

{ Error messages in response to reading and writing buffer contents }
kAECoercionFail 	= - 1700;
kAEDescNotFound 	= - 1701;
kAECorruptData		= - 1702;
kAEWrongDataType	= - 1703;
kAENotAEList		= - 1704;
kAEBadListElement	= - 1705;
kAEWrongVersion 	= - 1706;
kAENotAppleEvent	= - 1707;

{ Error messages in response to sending/receiving a message }
kAEEventNotFound	= - 1708;				{ The event isn't in the supplied event
											 table }
kAEReplyNotValid	= - 1709;				{ AEResetTimer was passed an invalid reply }
kAEUnknownSendMode	= - 1710;				{ Mode wasn't NoReply, WaitReply,
											 QueueReply; or Interaction level is
											 unknown }
KAEWaitCanceled 	= - 1711;				{ User cancelled out of wait loop for reply
											 or receipt }
kAETimeoutErr		= - 1712;				{ AppleEvent time out }

kAENoUserInteraction = - 1713;				{ no user interaction allowed }

TYPE
AEList				= LONGINT;
KeyWord 			= PACKED ARRAY [1..4] OF CHAR;
EventClass			= PACKED ARRAY [1..4] OF CHAR;
EventID 			= PACKED ARRAY [1..4] OF CHAR;
DescType			= OSType;

AEAddress			= RECORD
	CASE addressKind: LONGINT OF
		receiverIDisPSN:
			(receiverIDasPSN:	 ProcessSerialNumber);
		receiverIDisSignature:
			(receiverIDasSig:	 OSType);
		receiverIDisSessionID:
			(receiverIDasSess:	 LONGINT);
		receiverIDisTargetID:
			(receiverIDasTargetID: targetID);
	END;

AEAddressPtr		= ^AEAddress;
AEAddressHndl		= ^AEAddressPtr;

AEArrayType 		= (kAEDataArray, kAEPackedArray, kAEHandleArray, kAEDescArray,
					   kAEKeyDescArray);

AEDesc				= RECORD
	descriptorType: 	DescType;
	CASE boolean OF
		false:
			(asDataHdl: 		 Handle);
		true:
			(asAEList:			 AEList);
	END;

AEKeyDesc			= RECORD
	descKey:			KeyWord;
	descContent:		AEDesc;
	END;

FUNCTION AEInit(dispatchProc, coercionProc, nonAevtHandler: ProcPtr): OSErr;

PROCEDURE AEQuit;

FUNCTION AEPutPtr(theList: AEList;
			  index: LONGINT;
			  typeCode: DescType;
			  dataPtr: Ptr;
			  dataSize: LONGINT): OSErr;

FUNCTION AEPutDesc(theList: AEList;
			   index: LONGINT;
			   theDesc: AEDesc): OSErr;

FUNCTION AEPutKeyPtr(theList: AEList;
				 key: KeyWord;
				 typeCode: DescType;
				 dataPtr: Ptr;
				 dataSize: LONGINT): OSErr;

FUNCTION AEPutKeyDesc(theList: AEList;
				  key: KeyWord;
				  theDesc: AEDesc): OSErr;

FUNCTION AEGetNthPtr(theList: AEList;
				 index: LONGINT;
				 desiredType: DescType;
				 VAR key: KeyWord;
				 VAR typeCode: DescType;
				 dataPtr: Ptr;
				 maxSize: LONGINT;
				 VAR actualSize: LONGINT): OSErr;

FUNCTION AEGetNthDesc(theList: AEList;
				  index: LONGINT;
				  desiredType: DescType;
				  VAR key: KeyWord;
				  VAR theDesc: AEDesc): OSErr;

FUNCTION AEGetKeyPtr(theList: AEList;
				 key: KeyWord;
				 desiredType: DescType;
				 VAR typeCode: DescType;
				 dataPtr: Ptr;
				 maxSize: LONGINT;
				 VAR actualSize: LONGINT): OSErr;

FUNCTION AEGetKeyDesc(theList: AEList;
				  key: KeyWord;
				  desiredType: DescType;
				  VAR theDesc: AEDesc): OSErr;

FUNCTION AEGetArray(theList: AEList;
				arrayType: AEArrayType;
				arrayPtr: Ptr;
				bufSize: LONGINT;
				VAR elemType: DescType;
				VAR elemSize: LONGINT;
				VAR itemCount: LONGINT): OSErr;

FUNCTION AEPutArray(theList: AEList;
				arrayType: AEArrayType;
				arrayPtr: Ptr;
				elemType: DescType;
				elemSize: LONGINT;
				itemCount: LONGINT): OSErr;

FUNCTION AEDeleteIndex(theList: AEList;
				   index: LONGINT): OSErr;

FUNCTION AEDeleteKey(theList: AEList;
				 key: KeyWord): OSErr;

FUNCTION AECoerceDesc(desc: AEDesc;
				  toType: DescType;
				  VAR result: AEDesc): OSErr;

PROCEDURE AEDisposeAEList(theArg: AEList);

PROCEDURE AEDisposeAEDesc(theArg: AEDesc);

FUNCTION AECreateAevt(theEventClass: EventClass;
				  theEventID: EventID;
				  target: AEAddress;
				  theRefCon: LONGINT;
				  VAR result: AEList): OSErr;

PROCEDURE AEGetEventClassAndID(theAevt: AEList;
						   VAR theEventClass: EventClass;
						   VAR theEventID: EventID);
{ Extract the event class and id from the specified message }

PROCEDURE AEGetRefCon(theAevt: AEList;
				  VAR refcon: LONGINT);
{ Extract the event class and id from the specified message }

PROCEDURE AEGetAddress(theAevt: AEList;
				   VAR address: AEAddress);
{ Extract the address from the specified message }

FUNCTION AECreateList(factoringPtr: Ptr;
				  factoredSize: LONGINT;
				  isRecord: boolean;
				  VAR resultList: AEDesc): OSErr;

FUNCTION AECountListElems(theList: AEList): LONGINT;

FUNCTION AESend(theAevt: AEList;
			VAR theReply: AEList;
			sendMode: LONGINT;
			sendPriority: INTEGER;
			timeOut: LONGINT;
			idleProc: ProcPtr): OSErr;

FUNCTION AEResetTimer(reply: AEList): OSErr;
{ Convience routine.  Create and send a 'wait' message from the }
{ information in the reply. }

PROCEDURE AESetAddressByPSN(thePSN: ProcessSerialNumber;
						VAR theAddress: AEAddress);
{ Fill theAddressObject as receiverIDisPSN }

PROCEDURE AESetAddressBySignature(theSig: OSType;
							  VAR theAddress: AEAddress);
{ Fill theAddressObject as receiverIDisSignature }

PROCEDURE AESetAddressBySessionID(theSessionID: LONGINT;
							  VAR theAddress: AEAddress);
{ Fill theAddressObject as receiverIDisSessionID }

PROCEDURE AESetAddressByTargetID(theTargetID: targetID;
							 VAR theAddress: AEAddress);
{ Fill theAddressObject as receiverIDisTargetID }

FUNCTION AEProcessAppleEvent(eventRec: EventRecord): OSErr;

FUNCTION AEGetDispatchTableRsrc(tableID: INTEGER): OSErr;
{ Load an event table from a 'AEDF' resource.  This of course will only be	}
{ of use to applications using a general dispatch routine rather than doing }
{ a direct dispatch to a handler. }

FUNCTION AECreateDispatchTable(numEntries: INTEGER): OSErr;
{ Create an event table with one memory manager call for the number of events }
{ specified.  If more events are added to the table with AESetupEventTable, }
{ the table will be grown automatically. }

FUNCTION AEAddEvtToTable(theEventClass: EventClass;
					 theEventID: EventID;
					 value: LONGINT): OSErr;
{ Add a single event to the table, expanding if necessary. }

FUNCTION AEGetTableEntry(theEventClass: EventClass;
					 theEventID: EventID;
					 VAR theValue: LONGINT): OSErr;
{ returns the value of the specified event in theValue. }
{ kAEEventNotFound if not found. }

FUNCTION AEInteractWithUser(timeOut: LONGINT;	{ how long are you willing to wait }
						nmReqPtr: QElemPtr	{ your own custom notification }
						): OSErr;			{ return the error }

FUNCTION AEGetInteractLevel(theAevt: AEList): INTEGER;
{ returns kAENeverInteract, kAECanInteract or kAEAlwaysInteract }

{$ENDC} 										{ AppleEvents }

{$IFC NOT UsingIncludes}
END.
{$ENDC}
