{
	File:		Balloons.p

	Contains:	Interface file to call Balloon Help from Pascal

	Copyright:	 1989-1990 by Apple Computer, Inc.
				All rights reserved.
}

{$IFC UNDEFINED UsingIncludes}
	{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT Balloons;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingBalloons}
{$SETC UsingBalloons := 1}

{$I+}
{$SETC BalloonsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$IFC UNDEFINED UsingQuickdraw}
{$I $$Shell(PInterfaces)Quickdraw.p}
{$ENDC}
{$IFC UNDEFINED UsingMenus}
{$I $$Shell(PInterfaces)Menus.p}
{$ENDC}
{$IFC UNDEFINED UsingTextEdit}
{$I $$Shell(PInterfaces)TextEdit.p}
{$ENDC}
{$IFC UNDEFINED UsingTraps}
{$I $$Shell(PInterfaces)Traps.p}
{$ENDC}
{$SETC UsingIncludes := BalloonsIncludes}


CONST	

		HMVersionWord 			= $0002;
		
		{Help Mgr error range: -850 to -874}
		hmHelpDisabled			= -850;
		hmResNotFound			= -851;
		hmMemFullErr			= -852;
		hmBalloonAborted		= -853;
		hmSameAsLastBalloon		= -854;
		hmHelpManagerNotInited	= -855;
		hmHelpMsgParamErr		= -856;
		hmSkippedBalloon		= -857;
		hmWrongVersion			= -858;
		hmUnknownHelpType		= -859;
		hmCouldNotLoadPackage	= -860;

		
		hmGestaltHelpType		= 'help';
		hmGestaltBalloonsOn		= 0;
		hmGestaltBalloonsOff	= 1;

		kHMUsingHelpItem		= 1;
		kHMWhatIsItem			= 3;
		
		kHMHelpID				= -5696;
				
		{misc Constants}
		kHMAboutHelpID			= -5696;
		kHMHelpMenuID			= -16490;
		kHMHelpIconOn			= -5696;
		kHMHelpIconOff			= -5695;
		
		{WhatIs default WDEF res ID}
		kBalloonWDEFID			= 126;
		
		{Dialog item template type}
		helpItem				= 1;
		
		{hrct Options}
		kHMhrctAbsolute			= 0;		{option bit for LocalToGlobal origin correction}
		
		{ Generic defines for the switch items used in 'hmnu' & 'hdlg' }
		kHMEnabledItem			= 0;
		kHMDisabledItem			= 1;
		kHMCheckedItem			= 2;
		kHMOtherItem			= 3;
		
		{Option bits for hwin resources}
		hwinUseResID			= 0;
		hwinUseSubID			= 1;		{ if set then use sub IDs to find res ID }
		
		{Constants for Help Types in 'hmnu', 'hdlg', 'hrct' resources}
		HMStringItem			= 1;
		HMPictItem				= 2;
		HMStringResItem			= 3;
		HMTEResItem				= 6;
		HMSTRResItem			= 7;
		HMSkipItem				= 256;
		HMCompareItem			= 512;
		HMNamedResourceItem		= 1024;
		HMTrackCntlItem			= 2048;
		
		hdlgUseSubID			= 0; 		{ if set then use sub ID's to fine res ID }
		hdlgLocalCoords			= 1; 		{ if set then use hdlg rects as local coords, ignoring item rects }
		hdlgSaveBits			= 2; 		{ if set then use save bits behind balloon }


		{Constants for hmmHelpType's when filling out HMMessageRecord}
		khmmString				= 1;
		khmmPict				= 2;
		khmmStringRes			= 3;
		khmmTEHandle			= 4;
		khmmPictHandle			= 5;
		khmmTERes				= 6;
		khmmSTRRes				= 7;
		
		kHMEnabled				= 1;
		kHMDisabled				= 2;
		kHMChecked				= 4;
		kHMOther				= 8;
		
		{ResTypes for Styled TE Handles when extracting from Resources}
		HMTEResType				= 'thdl';
		HMTEStyleType			= 'tsty';
		HMSTHandleType			= 'tstb';
		HMLHHandleType			= 'thtb';
		
		HMMenuTemplate			= 'hmnu';
		HMDialogTemplate		= 'hdlg';
		HMRectTemplate			= 'hrct';
		
TYPE
		RectPtr			= ^Rect;
		
		HMStringResType	= RECORD
							hmmResID		: INTEGER;
							hmmIndex		: INTEGER;
						END;	
						
		HMMessageRecord	= RECORD
							hmmHelpType			: INTEGER;
							CASE INTEGER OF
							khmmString:		(hmmString			: STR255);
							khmmPict:		(hmmPict			: INTEGER);
							khmmStringRes:	(hmmStringRes		: HMStringResType);
							khmmTEHandle:	(hmmTEHandle		: TEHandle);
							khmmPictHandle:	(hmmPictHandle		: PicHandle);
							khmmTERes:		(hmmTERes			: INTEGER);
							khmmSTRRes:		(hmmSTRRes			: INTEGER);
						END;
		HMMessageRecPtr	= ^HMMessageRecord;
				
		HMStateRecord	= RECORD
							hmVersion				: INTEGER;
							hmUserLevel				: INTEGER;
						hmStateOptions			: LONGINT;
							hmFont					: INTEGER;
							hmFontSize				: INTEGER;
							hmWhatIsOn				: BOOLEAN;
						END;


{Public Interfaces}
FUNCTION  HMGetHelpMenuHandle(VAR mh: MenuHandle): OsErr;
		INLINE $303C,$0200,_Pack14;
		
FUNCTION  HMShowBalloon(aHelpMsg: HMMessageRecord;
						tip: Point;
						alternateRect: RectPtr;
						tipProc: Ptr;
						theProc,variant: INTEGER;
						saveBits: BOOLEAN): OSErr;
		INLINE $303C,$0B01,_Pack14;
				
FUNCTION  HMRemoveBalloon: OSErr;
		INLINE $303C,$0002,_Pack14;
		
FUNCTION  HMGetBalloons: BOOLEAN;
		INLINE $303C,$0003,_Pack14;		{note: doesn't load package!}
		
FUNCTION  HMSetBalloons(flag: BOOLEAN): OSErr;
		INLINE $303C,$0104,_Pack14;
		
FUNCTION  HMShowMenuBalloon(itemNum,itemMenuID: INTEGER;
							itemFlags,itemReserved: LONGINT;
							tip: Point; alternateRect: RectPtr; tipProc: Ptr;
							theProc,variant: INTEGER): OSErr;
		INLINE $303C,$0E05,_Pack14;
				
FUNCTION  HMMouseInApplRgn: BOOLEAN;
		INLINE $303C,$0006,_Pack14;
		
FUNCTION  HMIsBalloon: BOOLEAN;
		INLINE $303C,$0007,_Pack14;
		
FUNCTION HMSetFont(font: INTEGER): OSErr;
		INLINE $303C,$0108,_Pack14;

FUNCTION HMSetFontSize(fontSize: INTEGER): OSErr;
		INLINE $303C,$0109,_Pack14;

FUNCTION HMGetFont(VAR font: INTEGER): OSErr;
		INLINE $303C,$020A,_Pack14;

FUNCTION HMGetFontSize(VAR fontSize: INTEGER): OSErr;
		INLINE $303C,$020B,_Pack14;

FUNCTION HMSetDialogResID(resID: INTEGER): OSErr;
		INLINE $303C,$010C,_Pack14;
		
FUNCTION HMSetMenuResID(menuID,resID: INTEGER): OSErr;
		INLINE  $303C,$020D,_Pack14;
		
FUNCTION HMGetDialogResID(VAR resID: INTEGER): OSErr;
		INLINE  $303C,$0213,_Pack14;

FUNCTION HMGetMenuResID(menuID: INTEGER; VAR resID: INTEGER): OSErr;
		INLINE  $303C,$0314,_Pack14;
		
FUNCTION HMBalloonRect(aHelpMsg : HMMessageRecord;
						VAR coolRect: Rect): OSErr;
		INLINE $303C,$040E,_Pack14;
	
FUNCTION HMBalloonPict(aHelpMsg : HMMessageRecord;
						VAR coolPict: PicHandle): OSErr;
		INLINE $303C,$040F,_Pack14;
		
FUNCTION  HMScanTemplateItems(whichID,whichResFile: INTEGER;
							whichType: ResType): OSErr;
		INLINE $303C,$0410,_Pack14;
	
		
FUNCTION  HMExtractHelpMsg(whichType: ResType;
								whichResID, whichMsg, whichState: INTEGER;
								VAR aHelpMsg: HMMessageRecord): OsErr;
		INLINE $303C,$0711,_Pack14;
		
FUNCTION HMFillCitationString(origString,stuffString: StringPtr;
								key: Char): OsErr;
		INLINE $303C,$0512,_Pack14;
		
{$ENDC}    { UsingBalloons }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}





