{
	File:		Icons.p

	Contains:	Pascal interfaces for icon-handling routines

	Copyright:	 1990 by Apple Computer, Inc., all rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
	{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT Icons;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingIcons}
{$SETC UsingIcons := 1}

{$I+}
{$SETC IconsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$IFC UNDEFINED UsingQuickdraw}
{$I $$Shell(PInterfaces)QuickDraw.p}
{$ENDC}
{$SETC UsingIncludes := IconsIncludes}

CONST
	Large1BitMask		=	'ICN#';
	Large4BitData		=	'icl4';
	Large8BitData		=	'icl8';
	Small1BitMask		=	'ics#';
	Small4BitData		=	'ics4';
	Small8BitData		=	'ics8';
	Mini1BitMask		=	'sicn';
	Mini4BitData		=	'icm4';
	Mini8BitData		=	'icm8';

	{ IconSelectorValue masks }
	svLarge1Bit			=	$00000001;
	svLarge4Bit			=	$00000002;
	svLarge8Bit			=	$00000004;
	svSmall1Bit			=	$00000100;
	svSmall4Bit			=	$00000200;
	svSmall8Bit			=	$00000400;
	svMini1Bit			=	$00010000;
	svMini4Bit			=	$00020000;
	svMini8Bit			=	$00040000;
	svAllLargeData		=	$000000ff;
	svAllSmallData		=	$0000ff00;
	svAllMiniData		=	$00ff0000;
	svAll1BitData		=	(svLarge1Bit + svSmall1Bit + svMini1Bit);
	svAll4BitData		=	(svLarge4Bit + svSmall4Bit + svMini4Bit);
	svAll8BitData		=	(svLarge8Bit + svSmall8Bit + svMini8Bit);
	svAllAvailableData	=	$ffffffff;
	
	{ IconAlignmentType values	}
	atNone				=	$0;
	atVerticalCenter	=	$1;
	atTop				=	$2;
	atBottom			=	$3;
	atHorizontalCenter	=	$4;
	atAbsoluteCenter	=	(atVerticalCenter + atHorizontalCenter);
	atCenterTop			=	(atTop + atHorizontalCenter);
	atCenterBottom		=	(atBottom + atHorizontalCenter);
	atLeft				=	$8;
	atCenterLeft		=	(atVerticalCenter + atLeft);
	atTopLeft			=	(atTop + atLeft);
	atBottomLeft		=	(atBottom + atLeft);
	atRight				=	$C;
	atCenterRight		=	(atVerticalCenter + atRight);
	atTopRight			=	(atTop + atRight);
	atBottomRight		=	(atBottom + atRight);

	{ IconTransformType values }
	ttNone				=	$0;
	ttDisabled			=	$1;
	ttOffline			=	$2;
	ttOpen				=	$3;
	ttGhost				=	$4;
	ttLabel1			=	$0100;
	ttLabel2			=	$0200;
	ttLabel3			=	$0300;
	ttLabel4			=	$0400;
	ttLabel5			=	$0500;
	ttLabel6			=	$0600;
	ttLabel7			=	$0700;
	ttSelected			=	$4000;
	ttSelectedDisabled	=	(ttSelected + ttDisabled);
	ttSelectedOffline	=	(ttSelected + ttOffline);
	ttSelectedOpen		=	(ttSelected + ttOpen);
	ttSelectedGhost		=	(ttSelected + ttGhost);
	
TYPE
	IconSelectorValue	=	LONGINT;
	IconAlignmentType	=	INTEGER;
	IconTransformType	=	INTEGER;


	IconAction			=	ProcPtr;	{
											FUNCTION IconAction(theType: ResType;
														VAR theIcon: Handle;
														yourDataPtr: Ptr): OSErr;
										}
										
	IconGetter			=	ProcPtr;	{
											FUNCTION IconGetter(theType: ResType;
														yourDataPtr: Ptr): Handle;
										}

	FUNCTION PlotIconID(theRect: Rect;
						align: IconAlignmentType;
						transform: IconTransformType;
						theResID: INTEGER): OSErr;
		INLINE	$303C, $0500, $ABC9;
	
	FUNCTION NewIconSuite(VAR theIconSuite: Handle): OSErr;
		INLINE	$303C, $0207, $ABC9;
	
	FUNCTION AddIconToSuite(theIconData: Handle;
							theSuite: Handle;
							theType: ResType): OSErr;
		INLINE	$303C, $0608, $ABC9;
	
	FUNCTION GetIconFromSuite(VAR theIconData: Handle;
							theSuite: Handle;
							theType: ResType): OSErr;
		INLINE	$303C, $0609, $ABC9;
	
	FUNCTION ForEachIconDo(theSuite: Handle;
							selector: IconSelectorValue;
							action: IconAction;
							yourDataPtr: Ptr): OSErr;
		INLINE	$303C, $060A, $ABC9;
	
	FUNCTION GetIconSuite(VAR theIconSuite: Handle;
							theResID: INTEGER;
							selector: IconSelectorValue): OSErr;
		INLINE	$303C, $0501, $ABC9;
	
	FUNCTION DisposeIconSuite(theIconSuite: Handle;
							disposeData: BOOLEAN): OSErr;
		INLINE	$303C, $0302, $ABC9;
	
	FUNCTION PlotIconSuite(theRect: Rect;
							align: IconAlignmentType;
							transform: IconTransformType;
							theIconSuite: Handle): OSErr;
		INLINE	$303C, $0603, $ABC9;
	
	FUNCTION MakeIconCache(VAR theHandle: Handle;
							makeIcon: IconGetter;
							yourDataPtr: UNIV Ptr): OSErr;
		INLINE	$303C, $0604, $ABC9;
	
	FUNCTION LoadIconCache(theRect: Rect;
							align: IconAlignmentType;
							transform: IconTransformType;
							theIconCache: Handle): OSErr;
		INLINE	$303C, $0606, $ABC9;

	FUNCTION PlotIconMethod(theRect: Rect;
							align: IconAlignmentType;
							transform: IconTransformType;
							theMethod: IconGetter;
							yourDataPtr: UNIV Ptr): OSErr;
		INLINE $303C, $0805, $ABC9;
	
	FUNCTION GetLabel(labelNumber: INTEGER; VAR labelColor: RGBColor;
							VAR labelString: Str255): OSErr;
		INLINE $303C, $050B, $ABC9;
	
	FUNCTION SetLabel(labelNumber: INTEGER; labelColor: RGBColor;
							labelString: Str255): OSErr;
		INLINE $303C, $050C, $ABC9;
	
	FUNCTION PtInIconID(testPt: Point; iconRect: Rect;
					align: IconAlignmentType; iconID: INTEGER): BOOLEAN;
		INLINE $303C, $060D, $ABC9;

	FUNCTION PtInIconSuite(testPt: Point; iconRect: Rect;
					align: IconAlignmentType;
					theIconSuite: Handle): BOOLEAN;
		INLINE $303C, $070E, $ABC9;

	FUNCTION PtInIconMethod(testPt: Point; iconRect: Rect;
					align: IconAlignmentType;
					theMethod: IconGetter; yourDataPtr: Ptr): BOOLEAN;
		INLINE $303C, $090F, $ABC9;

	FUNCTION RectInIconID(testRect: Rect; iconRect: Rect;
					align: IconAlignmentType; iconID: INTEGER): BOOLEAN;
		INLINE $303C, $0610, $ABC9;

	FUNCTION RectInIconSuite(testRect: Rect; iconRect: Rect;
					align: IconAlignmentType;
					theIconSuite: Handle): BOOLEAN;
		INLINE $303C, $0711, $ABC9;

	FUNCTION RectInIconMethod(testRect: Rect; iconRect: Rect;
					align: IconAlignmentType;
					theMethod: IconGetter; yourDataPtr: Ptr): BOOLEAN;
		INLINE $303C, $0912, $ABC9;

	FUNCTION IconIDToRgn(theRgn: RgnHandle; iconRect: Rect;
					align: IconAlignmentType; iconID: INTEGER): OSErr;
		INLINE $303C, $0913, $ABC9;

	FUNCTION IconSuiteToRgn(theRgn: RgnHandle; iconRect: Rect;
					align: IconAlignmentType;
					theIconSuite: Handle): OSErr;
		INLINE $303C, $0914, $ABC9;

	FUNCTION IconMethodToRgn(theRgn: RgnHandle; iconRect: Rect;
					align: IconAlignmentType;
					theMethod: IconGetter; yourDataPtr: Ptr): OSErr;
		INLINE $303C, $0915, $ABC9;

{$ENDC}    { UsingIcons }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}
