{
	Created: Wednesday, November 1, 1989
	PPCToolBox.p
	Pascal Interface to the Macintosh Libraries

	Copyright Apple Computer, Inc.	1989-1990
	All rights reserved
}

{$IFC UNDEFINED UsingIncludes}
	{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT PPCToolBox;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingPPCToolBox}
{$SETC UsingPPCToolBox := 1}

{$I+}
{$SETC PPCToolBoxIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingAppleTalk}
{$I $$Shell(PInterfaces)AppleTalk.p}
{$ENDC}
{$SETC UsingIncludes := PPCToolBoxIncludes}

CONST

{ -900 to -950 are reserved for PPC    }		{### some capitalization changed }
	notInitErr		  = -900;
	tooManyPortsErr   = -901;
	nameTypeErr 	  = -902;
	noPortErr		  = -903;
	noGlobalsErr	  = -904;
	localOnlyErr	  = -905;
	destPortErr 	  = -906;
	sessTableErr	  = -907;
	noSessionErr	  = -908;
	badReqErr		  = -909;
	portNameExistsErr = -910;
	noPortTableErr	  = -911;
	userRejectErr	  = -912;
	noUserNameErr	  = -913;
	noToolboxNameErr  = -914;
	noResponseErr	  = -915;
	portClosedErr	  = -916;
	sessClosedErr	  = -917;
	atalkPhaseErr	  = -918; { apple talk is not phase 2 }
	badPortNameErr	  = -919;
	loginCancelErr	  = -920;
	unknownUserErr	  = -921;
	noDefaultUserErr  = -922;
	notLoggedInErr	  = -923;
	noUserRefErr	  = -924;
	networkErr		  = -925;
	noInformErr 	  = -926;
	authFailErr 	  = -927;
	noUserRecErr	  = -928;
	notSupportedErr   = -929;
	badServiceMethodErr =  -930;
	badLocNameErr	  = -931;
	guestNotAllowedErr = -932;

{ service Type }
	RealTime		=	1;
	StoreAndForward =	2;
	DontCare		=	3;
	Both			=	4;

{ lookup Type }
	NoLocName		=	0;	{ There is no PPCLocName }
	NbpName 		=	1;	{ Use AppleTalk NBP }
	NasName 		=	2;	{ Use Name and Authentication Service }

{ port Types }
	MacType 		=	1;	{ PortType is specified as standars mac creator and type }
	StrType 		=	2;	{ Port Type is in pascal string format }

{ Authentication Requests }
	Authenticate	=	1;	{ Authenticate incomming network requets }
	DontAuthenticate=	0;	{ Don't Authenticate }

{ Session Request Type returned in PPCInform }
	LocalRequest	=	1;	{ Local Session Request }
	NetworkRequest  =	2;	{ Network Session Request }

TYPE
	LocationNamePtr =	^LocationName;	{### used to be LocName }
	LocationName	=	RECORD
							CASE nameType:	INTEGER OF		
								NbpName:		
										(nbpName: EntityName);		{ NBP name entity }
								NasName:		
										(nasName: ARRAY [1..100] OF BYTE) { To be defined }
						END;

	PortNamePtr 	=	^PortName;	
	PortName		=	RECORD
							scriptCode: 		INTEGER;	{ Language Identifier }
							nameStr:			Str32;
							CASE typeSelector:	INTEGER OF
								StrType:
										(typeStr:	Str32);
								MacType:
										(portCreator:	ResType;
										 portType:		ResType)
						END;

	PPCOpenParamsPtr = ^PPCOpenParams;
	PPCOpenParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		 INTEGER;
							intUsePtr:		 Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							portRefNum: 	 INTEGER;
							serviceType:	SignedByte; 
							resFlag:	    SignedByte; { Was authRequest, set this to zero. authRequest is not an Option any more } 
							networkVisible: SignedByte; 
							nbpRegistered:	SignedByte; 
							name:			PortNamePtr;
							location:		LocationNamePtr;
						END;
						
	PPCInformParamsPtr = ^PPCInformParams;
	PPCInformParams  = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							portRefNum: 	 INTEGER;
							sessRefNum: 	LONGINT;
							autoAccept: 	Boolean;
							serviceMethod:	SignedByte;
							requestType:	SignedByte;
							userData:		LONGINT;
							name:			PortNamePtr;
							userName:		StringPtr;
							location:		LocationNamePtr;
						END;
						
	PPCStartParamsPtr = ^PPCStartParams;
	PPCStartParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							portRefNum: 	 INTEGER;
							sessRefNum: 	LONGINT;
							serviceMethod:	SignedByte; 
							userRefNum: 	INTEGER;
							userData:		LONGINT;
							rejectInfo: 	LONGINT;
							name:			PortNamePtr;
							location:		LocationNamePtr;
						END;
						
	PPCAcceptParamsPtr = ^PPCAcceptParams;
	PPCAcceptParams  = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		 INTEGER;
							intUsePtr:		 Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							sessRefNum: 	LONGINT;
						END;
						
	PPCRejectParamsPtr = ^PPCRejectParams;
	PPCRejectParams  = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							sessRefNum: 	LONGINT;
							rejectInfo: 	LONGINT;
						END;
	
	PPCWriteParamsPtr = ^PPCWriteParams;
	PPCWriteParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							sessRefNum: 	LONGINT;
							blockCreator:	ResType;
							blockType:		ResType;
							bufferLength:	LONGINT;
							actualLength:	LONGINT;
							userData:		LONGINT;
							bufferPtr:		Ptr;
							more:			SignedByte; 
						END;
	
	PPCReadParamsPtr = ^PPCReadParams;
	PPCReadParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		 INTEGER;
							intUsePtr:		 Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							sessRefNum: 	LONGINT;
							blockCreator:	ResType;
							blockType:		ResType;
							bufferLength:	LONGINT;
							actualLength:	LONGINT;
							userData:		LONGINT;
							bufferPtr:		Ptr;
							more:			SignedByte; 
						END;
	
	PPCEndParamsPtr = ^PPCEndParams;
	PPCEndParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		 INTEGER;
							intUsePtr:		 Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							sessRefNum: 	LONGINT;
						END;
	
	PPCCloseParamsPtr = ^PPCCloseParams;
	PPCCloseParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							portRefNum: 	 INTEGER;
						END;
	
	IPCListPortParamsPtr = ^IPCListPortParams;
	IPCListPortParams	 = RECORD
							qLink:			QElemPtr;
							cmdCode:		INTEGER;
							intUse: 		INTEGER;
							intUsePtr:		Ptr;
							cmdCompletion:	ProcPtr;
							cmdResult:		OSErr;
							reserved:		ARRAY [1..5] OF LONGINT;
							resFiller:		INTEGER;
							startIndex: 	INTEGER;
							requestCount:	INTEGER;
							actualCount:	INTEGER;
							name:			PortNamePtr;
							location:		LocationNamePtr;
							bufferPtr:		Ptr;							
							END;
							
	PPCParamBlk  = RECORD
						CASE INTEGER OF
							0: (openPB: 	PPCOpenParams);
							1: (informPB:	PPCInformParams);
							2: (startPB:	PPCStartParams);
							3: (acceptPB:	PPCAcceptParams);
							4: (rejectPB:	PPCRejectParams);
							5: (writePB:	PPCWriteParams);
							6: (readPB: 	PPCReadParams);
							7: (endPB:		PPCEndParams);
							8: (closePB:	PPCCloseParams);
							9: (listPB: 	IPCListPortParams);
					END;


	PortInfoPtr = ^PortInfo;
	PortInfo	 = RECORD
						authRequired:	INTEGER;
						name:			PortName;
					END;

FUNCTION PPCInit: OSErr;

FUNCTION PPCOpen(pb: PPCOpenParamsPtr; async: Boolean): OSErr;

FUNCTION PPCInform(pb: PPCInformParamsPtr; async: Boolean): OSErr;

FUNCTION PPCStart(pb: PPCStartParamsPtr; async: Boolean): OSErr;

FUNCTION PPCAccept(pb: PPCAcceptParamsPtr; async: Boolean): OSErr;

FUNCTION PPCReject(pb: PPCRejectParamsPtr; async: Boolean): OSErr;

FUNCTION PPCWrite(pb: PPCWriteParamsPtr; async: Boolean): OSErr;

FUNCTION PPCRead(pb: PPCReadParamsPtr; async: Boolean): OSErr;

FUNCTION PPCEnd(pb: PPCEndParamsPtr; async: Boolean): OSErr;

FUNCTION PPCClose(pb: PPCCloseParamsPtr; async: Boolean): OSErr;

FUNCTION IPCListPorts(pb: IPCListPortParamsPtr; async: Boolean): OSErr; 

FUNCTION PromptForUserIdentity (VAR userRef:		INTEGER;
									userName:		Str255;
								VAR guestSelected:	Boolean;
									allowGuest: 	Boolean;
									prompt: 		Str255): OSErr; 

FUNCTION DeleteUserIdentity (userRef: INTEGER): OSErr;

FUNCTION GetDefaultUser (VAR userRef: INTEGER; userName: Str255): OSErr;

FUNCTION StartSecureSession (pb:			PPCStartParamsPtr;
							userName:		Str255;
							useDefault: 	Boolean;
							allowGuest: 	Boolean;
							VAR guestSelected:	Boolean;
							prompt: 		Str255): OSErr;

FUNCTION PPCBrowser (	 prompt:			Str255;
						 applListLabel:		Str255;
						 defaultSpecified:	Boolean;
					 VAR theLoc:			LocationName;
					 VAR thePortInfo:		PortInfo;
					 	 portFilter:		ProcPtr): OSErr; INLINE $303C,$0B00,$A82B;


{$ENDC}    { UsingPPCToolBox }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}
