{
Created: Thursday, June 14, 1990       1:37:30 PM
	Sound.p
	Pascal Interface to the Macintosh Libraries

	Copyright Apple Computer, Inc.	1986-1990
	All rights reserved
}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT Sound;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingSound}
{$SETC UsingSound := 1}

{$I+}
{$SETC SoundIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$SETC UsingIncludes := SoundIncludes}

CONST
swMode 					= -1;
ftMode 					= 1;
ffMode 					= 0;
synthCodeRsrc 			= 'snth';
soundListRsrc 			= 'snd ';

{ synthesizer numbers for SndNewChannel }

noteSynth = 1;							{note synthesizer}
waveTableSynth 			= 3; 			{wave table synthesizer}
sampledSynth 			= 5;			{sampled sound synthesizer}
midiSynthIn 			= 7;			{MIDI synthesizer in}
midiSynthOut 			= 9;			{MIDI synthesizer out}

{ Param2 values }

midiInitChanFilter 		= $10;			{set to initialize a MIDI channel}
midiInitRawMode 		= $100; 		{set to send raw MIDI data}
twelthRootTwo 			= 1.05946309434;
infiniteTime 			= $7FFFFFFF;

{ command numbers for SndDoCommand }

nullCmd 				= 0;
initCmd 				= 1;
freeCmd 				= 2;
quietCmd 				= 3;
flushCmd 				= 4;
reInitCmd 				= 5;

waitCmd 				= 10;
pauseCmd 				= 11;
resumeCmd 				= 12;
callBackCmd 			= 13;
syncCmd 				= 14;
emptyCmd 				= 15;

tickleCmd 				= 20;
requestNextCmd 			= 21;
howOftenCmd 			= 22;
wakeUpCmd 				= 23;
availableCmd 			= 24;
versionCmd 				= 25;
totalLoadCmd 			= 26;
loadCmd 				= 27;

scaleCmd 				= 30;
tempoCmd 				= 31;

noteCmd 				= 40;
restCmd 				= 41;
freqCmd 				= 42;
ampCmd 					= 43;
timbreCmd 				= 44;

waveTableCmd 			= 60;
phaseCmd 				= 61;

soundCmd 				= 80;
bufferCmd 				= 81;
rateCmd 				= 82;
continueCmd 			= 83;
doubleBufferCmd 		= 84;
getRateCmd 				= 85;

sizeCmd 				= 90;
convertCmd 				= 91;

midiDataCmd 			= 100;
setPtrBit 				= 32768;
stdQLength 				= 128;
dataPointerFlag 		= 32768;

initSRateMask 			= 48;
initStereoMask 			= 192;
initChanLeft 			= 2;           	{left stereo channel }
initChanRight 			= 3;          	{right stereo channel}
initSRate22k 			= 32;          	{22k sampling rate}
initMono 				= 128;          {monophonic channel}
initStereo 				= 192;          {stereo channel}
initNoInterp 			= 4;
initNoSRC 				= 8;
initNoMultiChannel 		= 4096;
initMACE3 				= 768;
initMACE6 				= 1024;


initChan0 				= 4;			{channel 0 - wave table only}
initChan1 				= 5;			{channel 1 - wave table only}
initChan2 				= 6;			{channel 2 - wave table only}
initChan3 				= 7;			{channel 3 - wave table only}

stdSH 					= 0;
extSH 					= -1;
cmpSH 					= -2;
notCompressed 			= 0;
twoToOne 				= 1;
eightToThree 			= 2;
threeToOne 				= 3;
sixToOne 				= 4;
outsideCmpSH 			= 0;
insideCmpSH 			= 1;
aceSuccess 				= 0;
aceMemFull 				= 1;
aceNilBlock 			= 2;
aceBadComp 				= 3;
aceBadEncode 			= 4;
aceBadDest 				= 5;
aceBadCmd 				= 6;
sixToOnePacketSize 		= 8;
threeToOnePacketSize 	= 16;
stateBlockSize 			= 64;
leftOverBlockSize 		= 32;

firstSoundFormat = 1;       
secondSoundFormat = 2;      


dbBufferEmpty 			= $00000000;
dbBufferEmptyMask 		= $FFFFFFFE;
dbBufferReady 			= $00000001;
dbBufferExhausted 		= $00000002;
dbLastBuffer 			= $00000004;

{	errors codes for Sound Manager 7.0 }
notEnoughBufferSpace 	= -207;			{ could not allocate enough memory 				}
badFileFormat 	  		= -208;			{ was not type AIFF or was of bad format,corrupt 	}
channelBusy 	  		= -209;			{ the Channel is being used for a PFD already		}
buffersTooSmall   		= -210;			{ can not operate in the memory allowed			}
channelNotBusy 	  		= -211;	
noMoreRealTime 	 		= -212;			{ not enought CPU cycles left to add another task }
badParam 		  		= -213;			{ invalid argument }

{ constants for MACE in the dispatcher }
MACEToolNum					=	16;		
sMgrMACEVersion				=	0;
sMgrComp3to1				=	4;
sMgrExp1to3					=	8;
sMgrComp6to1				=	12;
sMgrExp1to6					=	16;

{ constants for Sound Manager Extensions in the dispatcher }
sMgrToolNum					=	8;		
sMgrSndSoundManagerVersion	=	0;
sMgrSndStartFilePlay		=	4;
sMgrSndPauseFilePlay		=	8;
sMgrSndStopFilePlay			=	12;
sMgrSndChannelStatus		=	16;
sMgrSndManagerStatus		=	20;
sMgrSndGetSysBeepState		=	24;
sMgrSndSetSysBeepState		=	28;
sMgrSndPlayDoubleBuffer		=	32;
sMgrSndGetBufferStufferLoad	=	36;
sMgrSndGetMixerLoad			=	40;



TYPE


FreeWave = PACKED ARRAY [0..30000] OF Byte;

FFSynthPtr = ^FFSynthRec;
FFSynthRec = RECORD
	mode: INTEGER;
	count: Fixed;
	waveBytes: FreeWave;
	END;

Tone = RECORD
	count: INTEGER;
	amplitude: INTEGER;
	duration: INTEGER;
	END;

Tones = ARRAY [0..5000] OF Tone;

SWSynthPtr = ^SWSynthRec;
SWSynthRec = RECORD
	mode: INTEGER;
	triplets: Tones;
	END;

Wave = PACKED ARRAY [0..255] OF Byte;

WavePtr = ^Wave;

FTSndRecPtr = ^FTSoundRec;
FTSoundRec = RECORD
	duration			: INTEGER;
	sound1Rate			: Fixed;
	sound1Phase			: LONGINT;
	sound2Rate			: Fixed;
	sound2Phase			: LONGINT;
	sound3Rate			: Fixed;
	sound3Phase			: LONGINT;
	sound4Rate			: Fixed;
	sound4Phase			: LONGINT;
	sound1Wave			: WavePtr;
	sound2Wave			: WavePtr;
	sound3Wave			: WavePtr;
	sound4Wave			: WavePtr;
	END;

FTSynthPtr = ^FTSynthRec;
FTSynthRec = RECORD
	mode				: INTEGER;
	sndRec				: FTSndRecPtr;
	END;

SndCommand = PACKED RECORD
	cmd: INTEGER;
	param1				: INTEGER;
	param2				: LONGINT;
	END;

Time = LONGINT;

ModifierStubPtr = ^ModifierStub;
ModifierStub = PACKED RECORD
	nextStub			: ModifierStubPtr;
	code				: ProcPtr;
	userInfo			: LONGINT;
	count				: Time;
	every				: Time;
	flags				: SignedByte;
	hState				: SignedByte;
	END;

SndChannelPtr = ^SndChannel;
SndChannel = PACKED RECORD
	nextChan			: SndChannelPtr;
	firstMod			: ModifierStubPtr;
	callBack			: ProcPtr;
	userInfo			: LONGINT;
	wait				: Time; 				{The following is for internal Sound Manager use only.}
	cmdInProgress		: SndCommand;
	flags				: INTEGER;
	qLength				: INTEGER;
	qHead				: INTEGER; 				{next spot to read or -1 if empty}
	qTail				: INTEGER; 				{next spot to write = qHead if full}
	queue				: ARRAY [0..127] OF SndCommand;
	END;

SoundHeaderPtr = ^SoundHeader;
SoundHeader = RECORD
	samplePtr			: Ptr; 				  	{if NIL then samples are in sampleArea}
	length				: LONGINT;
	sampleRate			: Fixed;
	loopStart			: LONGINT;
	loopEnd				: LONGINT;
    encode				: CHAR;
    baseNote			: CHAR;
	sampleArea			: PACKED ARRAY [0..0] OF Byte;
	END;

ModRef = RECORD
	modNumber			: INTEGER;
	modInit				: LONGINT;
	END;


					{	   MACE typedef structures	   }

StateBlockPtr = ^StateBlock;
StateBlock = RECORD
	stateVar			: ARRAY [0..stateBlockSize-1] OF INTEGER;
	END;

LeftOverBlockPtr = ^LeftOverBlock;
LeftOverBlock = RECORD
	count				: INTEGER;
	sampleArea			: ARRAY [0..leftOverBlockSize-1] OF INTEGER;
	END;

CmpSoundHeaderPtr = ^CmpSoundHeader;
CmpSoundHeader = RECORD
	samplePtr			: Ptr; 				  		{if NIL then samples are in sampleArea}
	numChannels			: LONGINT;					{ AIFC, number of channels  mono = 1 }
	sampleRate			: Fixed;					{ sample rate in Apples Fixed point representation }
	loopStart			: LONGINT;					{ loopStart of sound before compression }
	loopEnd				: LONGINT;					{ loopEnd of sound before compression }
    encode				: CHAR;						{ data structure used ,  stdSH, extSH, or cmpSH }
    baseNote			: CHAR;						{ same meaning as regular SoundHeader }	
	numSampleFrames		: LONGINT;					{ length in frames	( packetFrames or sampleFrames }
	AIFFSampleRate		: EXTENDED;					{ AIFC, IEEE sample rate }
	MarkerChunk			: Ptr;						{ AIFC, sync track }
	FutureUse1			: Ptr;						{ reserved by Apple }
	FutureUse2			: Ptr;						{ reserved by Apple }
	StateVars			: StateBlockPtr;			{ pointer to State Block }
	LeftOverSamples		: LeftOverBlockPtr;			{ used to save truncated samples between compression calls }
	compressionID		: INTEGER;					{ 0 means no compression, non zero means compressionID }
	packetSize			: INTEGER;					{ AIFC, number of bits in compressed sample packet }
	snthID				: INTEGER;					{ Resource ID of Sound Manager snth that contains NRT C/E }
	sampleSize			: INTEGER;					{ AIFC, number of bits in non-compressed sample }
	sampleArea			: PACKED ARRAY [0..0] OF Byte;	{ space for when samples follow directly }
	END;

ExtSoundHeaderPtr = ^ExtSoundHeader;
ExtSoundHeader = RECORD
	samplePtr			: Ptr; 				  		{if NIL then samples are in sampleArea}
	numChannels			: LONGINT;					{ AIFF, number of channels  mono = 1 }
	sampleRate			: Fixed;					{ sample rate in Apples Fixed point representation }
	loopStart			: LONGINT;					{ loopStart of sound before compression }
	loopEnd				: LONGINT;					{ loopEnd of sound before compression }
    encode				: CHAR;						{ data structure used ,  stdSH, extSH, or cmpSH }
    baseNote			: CHAR;						{ same meaning as regular SoundHeader }	
	numSampleFrames		: LONGINT;					{ length in total number of frames }
	AIFFSampleRate		: EXTENDED;					{ AIFF, IEEE sample rate }
	MarkerChunk			: Ptr;						{ AIFF, sync track }
	InstrumentChunks	: Ptr;						
	AESRecording		: Ptr;						
	sampleSize			: INTEGER;					{ AIFF, number of bits in sample }
	FutureUse1			: INTEGER;					{ reserved by Apple }
	FutureUse2			: LONGINT;					{ reserved by Apple }
	FutureUse3			: LONGINT;					{ reserved by Apple }
	FutureUse4			: LONGINT;					{ reserved by Apple }
	sampleArea			: PACKED ARRAY [0..0] OF Byte;	{ space for when samples follow directly }
	END;



SMStatusPtr = ^SMStatus;
SMStatus = RECORD
	smMaxCPULoad		: INTEGER;
	smNumChannels		: INTEGER;
	smCurCPULoad		: INTEGER;
	END;

SCStatusPtr = ^SCStatus;
SCStatus = RECORD
	scStartTime			: Fixed;
	scEndTime			: Fixed;
	scCurrentTime		: Fixed;
	scChannelBusy		: BOOLEAN;
	scChannelDisposed	: BOOLEAN;
	scChannelPaused		: BOOLEAN;
	scUnused			: INTEGER;
	scChannelAttributes	: LONGINT;
	scCPULoad			: LONGINT;
	END;

SndDoubleBufferPtr = ^SndDoubleBuffer;
SndDoubleBuffer = RECORD
	dbNumFrames			: LONGINT;
	dbFlags				: LONGINT;
	dbUserInfo			: ARRAY [0..1] OF LONGINT;
	dbSoundData			: ARRAY [0..0] OF INTEGER;
	END;

AudioSelectionPtr = ^AudioSelection;
AudioSelection = RECORD
	unitType			: LONGINT;
	selStart: Fixed;
	selEnd: Fixed;
	END;

SndDoubleBufferHeaderPtr = ^SndDoubleBufferHeader;
SndDoubleBufferHeader = RECORD
	dbhNumChannels		: INTEGER;
	dbhSampleSize		: INTEGER;
	dbhCompressionID	: INTEGER;
	dbhPacketSize		: INTEGER;
	dbhBufferPtr		: ARRAY [0..1] OF SndDoubleBufferPtr;
	dbhDoubleBack		: ProcPtr;
	END;

SndListPtr = ^SndListResource;
SndListResource = RECORD
	format: INTEGER;
	numModifiers		: INTEGER;
	modifierPart		: ARRAY [0..0] OF ModRef;
	numCommands			: INTEGER;
	commandPart			: ARRAY [0..0] OF SndCommand;
	dataPart			: PACKED ARRAY [0..0] OF Byte;
	END;




					{	   Trap Call Definitions	   }


FUNCTION SndDoCommand(chan: SndChannelPtr;cmd: SndCommand;noWait: BOOLEAN): OSErr;
	INLINE $A803;
FUNCTION SndDoImmediate(chan: SndChannelPtr;cmd: SndCommand): OSErr;
	INLINE $A804;
FUNCTION SndNewChannel(VAR chan: SndChannelPtr;synth: INTEGER;init: LONGINT;
	userRoutine: ProcPtr): OSErr;
	INLINE $A807;
FUNCTION SndDisposeChannel(chan: SndChannelPtr;quietNow: BOOLEAN): OSErr;
	INLINE $A801;
FUNCTION SndPlay(chan: SndChannelPtr;sndHdl: Handle;async: BOOLEAN): OSErr;
	INLINE $A805;
FUNCTION SndControl(id: INTEGER;VAR cmd: SndCommand): OSErr;
	INLINE $A806;
	
PROCEDURE SetSoundVol(level: INTEGER);
PROCEDURE GetSoundVol(VAR level: INTEGER);
PROCEDURE StartSound(synthRec: Ptr;numBytes: LONGINT;completionRtn: ProcPtr);
PROCEDURE StopSound;
FUNCTION SoundDone: BOOLEAN;
FUNCTION SndAddModifier(chan: SndChannelPtr;modifier: ProcPtr;id: INTEGER;
	init: LONGINT): OSErr;
	INLINE $A802;


{	Sound Manager Extension calls - a future Glue Library will replace these	}


FUNCTION SndSoundManagerVersion : LONGINT;
	INLINE $203C,sMgrSndSoundManagerVersion,sMgrToolNum,$A800;

FUNCTION SndStartFilePlay ( theChannel: SndChannelPtr; vRefNum: INTEGER; fName:  STR63;
		resNum: INTEGER; totalSpace: LONGINT; TheBuffer: Ptr;
		theSelection: AudioSelectionPtr; completionRtn:	ProcPtr;async: BOOLEAN): OSErr;
	INLINE $203C,sMgrSndStartFilePlay,sMgrToolNum,$A800;

FUNCTION SndPauseFilePlay (theChannel: SndChannelPtr): OSErr;
	INLINE $203C,sMgrSndPauseFilePlay,sMgrToolNum,$A800;

FUNCTION SndStopFilePlay (theChannel: SndChannelPtr;async: BOOLEAN): OSErr;
	INLINE $203C,sMgrSndStopFilePlay,sMgrToolNum,$A800;

FUNCTION SndChannelStatus (theChannel: SndChannelPtr; 
				theLength: INTEGER; theStatus: SCStatusPtr ): OSErr;
	INLINE $203C,sMgrSndChannelStatus,sMgrToolNum,$A800;

FUNCTION SndManagerStatus (theLength: INTEGER; theStatus: SCStatusPtr ): OSErr;
	INLINE $203C,sMgrSndManagerStatus,sMgrToolNum,$A800;

FUNCTION SndGetSysBeepState ( VAR sysBeepState: INTEGER): OSErr;
	INLINE $203C,sMgrSndGetSysBeepState,sMgrToolNum,$A800;

FUNCTION SndSetSysBeepState ( sysBeepState: INTEGER): OSErr;
	INLINE $203C,sMgrSndSetSysBeepState,sMgrToolNum,$A800;

FUNCTION SndPlayDoubleBuffer ( theChannel: SndChannelPtr;
				 theParams:	SndDoubleBufferHeaderPtr): OSErr;
	INLINE $203C,sMgrSndPlayDoubleBuffer,sMgrToolNum,$A800;

FUNCTION SndGetBufferStufferLoad (channelFeatures:	INTEGER): INTEGER;
	INLINE $203C,sMgrSndGetBufferStufferLoad,sMgrToolNum,$A800;

FUNCTION SndGetMixerLoad (numChannels:	INTEGER): INTEGER;
	INLINE $203C,sMgrSndGetMixerLoad,sMgrToolNum,$A800;

FUNCTION MACEVersion : LONGINT;
	INLINE $203C,sMgrMACEVersion,MACEToolNum,$A800;

PROCEDURE Comp3to1 ( inBuffer:	Ptr; outBuffer:	Ptr;
			Cnt:	LONGINT; inState:	Ptr; outState:	Ptr;
				numChannels:	LONGINT ;whichChannel:	LONGINT);
	INLINE $203C,sMgrComp3to1,MACEToolNum,$A800;

PROCEDURE Comp6to1 ( inBuffer:	Ptr; outBuffer:	Ptr;
			Cnt:	LONGINT; inState:	Ptr; outState:	Ptr;
				numChannels:	LONGINT ;whichChannel:	LONGINT);
	INLINE $203C,sMgrComp6to1,MACEToolNum,$A800;

PROCEDURE Exp1to3 ( inBuffer:	Ptr; outBuffer:	Ptr;
			Cnt:	LONGINT; inState:	Ptr; outState:	Ptr;
				numChannels:	LONGINT ;whichChannel:	LONGINT);
	INLINE $203C,sMgrExp1to3,MACEToolNum,$A800;

PROCEDURE Exp1to6 ( inBuffer:	Ptr; outBuffer:	Ptr;
			Cnt:	LONGINT; inState:	Ptr; outState:	Ptr;
				numChannels:	LONGINT ;whichChannel:	LONGINT);
	INLINE $203C,sMgrExp1to6,MACEToolNum,$A800;



{$ENDC}    { UsingSound }

{$IFC NOT UsingIncludes}
	END.
{$ENDC}

