{
Created: Wednesday, June 27, 1990 at 6:42 PM
    SoundInput.p
    Pascal Interface to the Macintosh Libraries

        Copyright Apple Computer, Inc. 1989-1990
        All rights reserved
}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT SoundInput;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingSoundInput}
{$SETC UsingSoundInput := 1}

{$I+}
{$SETC SoundInputIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$SETC UsingIncludes := SoundInputIncludes}


CONST
{Error codes}

noSoundInHardware =		-220;
badSoundInDevice =		-221;
noBufferSpecified =		-222;
noCompletionRoutine =	-223;
invalidSampleRate =		-225;
invalidSampleSize =		-226;
deviceBusyErr =			-227;
badDeviceName =			-228;
badRefNum =				-229;
floppyNotAllowed =		-230;
unknownInfoType =		-231;
unknownQuality =		-232;

MOVEL = $203C;	

{function selectors for the Sound Input calls}

sInToolNum =				20;			{tool number of sIn for SndDispVersion call}
sInVersion =				0;
sInSndRecord =				4;
sInSndRecordToFile =		8;
sInSignInDevice =			12;
sInSignOutDevice =			16;
sInGetIndexedDevice =		20;
sInOpenDevice =				24;
sInCloseDevice =			28;
sInRecord =					32;
sInRecordToFile =			36;
sInPauseRecording =			40;
sInResumeRecording =		44;
sInStopRecording =			48;
sInGetRecordingStatus =		52;
sInGetDeviceInfo =			56;
sInSetDeviceInfo =			60;
sInMilliSecondsToBytes =	64;
sInBytesToMilliSeconds =	68;


TYPE

SPBPtr = ^SPB;
SPB = RECORD
	sInRefNum:			LONGINT;
	count:				LONGINT;
	milliseconds:		LONGINT;
	bufferLength:		LONGINT;
	sInputBufferPtr:	Ptr;
	completionRoutine:	ProcPtr;
	interruptRoutine:	ProcPtr;
	userLong:			LONGINT;
	error:				OSErr;
	END;



FUNCTION SPBVersion : LONGINT;
	INLINE MOVEL,sInVersion,sInToolNum,$A800;

FUNCTION SndRecord(filterProc: ProcPtr; corner: Point; quality: OSType;
	VAR sndHandle: Handle) : OSErr;
	INLINE MOVEL,sInSndRecord,sInToolNum,$A800;

FUNCTION SndRecordToFile(filterProc: ProcPtr; corner: Point; quality: OSType;
	vRefNum: INTEGER; fName: Str255) : OSErr;
	INLINE MOVEL,sInSndRecordToFile,sInToolNum,$A800;

FUNCTION SPBSignInDevice(deviceRefNum: INTEGER; deviceName: Str255) : OSErr;
	INLINE MOVEL,sInSignInDevice,sInToolNum,$A800;

FUNCTION SPBSignOutDevice(deviceRefNum: INTEGER) : OSErr;
	INLINE MOVEL,sInSignOutDevice,sInToolNum,$A800;

FUNCTION SPBGetIndexedDevice(count: INTEGER; VAR deviceName: Str255; deviceIconPtr: Ptr) : OSErr;
	INLINE MOVEL,sInGetIndexedDevice,sInToolNum,$A800;

FUNCTION SPBOpenDevice(deviceName: Str255; permission: INTEGER; VAR sInRefNum: LONGINT) : OSErr;
	INLINE MOVEL,sInOpenDevice,sInToolNum,$A800;

FUNCTION SPBCloseDevice(sInRefNum: LONGINT) : OSErr;
	INLINE MOVEL,sInCloseDevice,sInToolNum,$A800;

FUNCTION SPBRecord(sInParamPtr: SPBPtr; asynchFlag: BOOLEAN) : OSErr;
	INLINE MOVEL,sInRecord,sInToolNum,$A800;

FUNCTION SPBRecordToFile(fRefNum: INTEGER; sInParamPtr: SPBPtr; asynchFlag: BOOLEAN) : OSErr;
	INLINE MOVEL,sInRecordToFile,sInToolNum,$A800;

FUNCTION SPBPauseRecording(sInRefNum: LONGINT) : OSErr;
	INLINE MOVEL,sInPauseRecording,sInToolNum,$A800;

FUNCTION SPBResumeRecording(sInRefNum: LONGINT) : OSErr;
	INLINE MOVEL,sInResumeRecording,sInToolNum,$A800;

FUNCTION SPBStopRecording(sInRefNum: LONGINT) : OSErr;
	INLINE MOVEL,sInStopRecording,sInToolNum,$A800;

FUNCTION SPBGetRecordingStatus(sInRefNum: LONGINT; VAR recordingStatus: INTEGER; VAR meterLevel: INTEGER;
	VAR totalSamplesToRecord: LONGINT; VAR numberOfSamplesRecorded: LONGINT;
	VAR totalMsecsToRecord: LONGINT; VAR numberOfMsecsRecorded: LONGINT) : OSErr;
	INLINE MOVEL,sInGetRecordingStatus,sInToolNum,$A800;

FUNCTION SPBGetDeviceInfo(sInRefNum: LONGINT; infoType: OSType; infoData: Ptr) : OSErr;
	INLINE MOVEL,sInGetDeviceInfo,sInToolNum,$A800;

FUNCTION SPBSetDeviceInfo(sInRefNum: LONGINT; infoType: OSType; infoData: Ptr) : OSErr;
	INLINE MOVEL,sInSetDeviceInfo,sInToolNum,$A800;

FUNCTION SPBMilliSecondsToBytes(sInRefNum: LONGINT; VAR milliSeconds: LONGINT) : OSErr;
	INLINE MOVEL,sInMilliSecondsToBytes,sInToolNum,$A800;

FUNCTION SPBBytesToMilliSeconds(sInRefNum: LONGINT; VAR byteCount: LONGINT) : OSErr;
	INLINE MOVEL,sInBytesToMilliSeconds,sInToolNum,$A800;

{$ENDC}    { UsingSoundInput }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}

