{
Created: Wednesday, June 27, 1990 at 6:42 PM
    VMCalls.p
    Pascal Interface to the Macintosh Libraries

        Copyright Apple Computer, Inc. 1989-1990
        All rights reserved
}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT VMCalls;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingVMCalls}
{$SETC UsingVMCalls := 1}

{$I+}
{$SETC VMCallsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$SETC UsingIncludes := VMCallsIncludes}

CONST

{ values for PageState }

kPageInMemory = 0;
kPageOnDisk = 1;
kNotPaged = 2;

{ trap number of MemoryDispatch }

_MemoryDispatch = $A05C;

{ trap number of DeferUserFn }

_DeferUserFn = $A08F;

{ trap number of DebugUtil }

_DebugUtil = $A08D;

{ error codes }

notEnoughMemoryErr = -620;                                          { insufficient physical memory }
notHeldErr = -621;                                                  { specified range of memory is not held }
cannotMakeContiguousErr = -622;                                     { cannot make specified range contiguous }
notLockedErr = -623;                                                { specified range of memory is not locked }
interruptsMaskedErr = -624;                                         { dont call with interrupts masked }
cannotDeferErr = -625;                                              { unable to defer additional user functions }
defaultPhysicalEntryCount = 8;                                      { default number of physical blocks in table }

TYPE
	MemoryBlock =
		RECORD
		address					: Ptr;			{ start of block }
		count					: LONGINT;		{ size of block }
		END;

	LogicalToPhysicalTable =
		RECORD
		logical					: MemoryBlock;	{ logical block }
		physical				: ARRAY [0..defaultPhysicalEntryCount-1] OF MemoryBlock;
												{ equivalent physical blocks }
		END;

	PageState = INTEGER;
	StatusRegisterContents = INTEGER;

{ VM calls }

FUNCTION HoldMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ keep pages in memory }
FUNCTION UnholdMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ allow pages to swap to backing store }

FUNCTION LockMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ lock pages to physical memory }
FUNCTION LockMemoryContiguous(address: UNIV Ptr; count: LONGINT): OSErr;
	{ lock pages to contiguous physical memory }
FUNCTION UnlockMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ allow pages to re-map to physical memory }

FUNCTION GetPhysical(VAR addresses: LogicalToPhysicalTable; VAR physicalEntryCount: LONGINT): OSErr;
	{ map a logical block to physical blocks }

FUNCTION DeferUserFn(userfunc: ProcPtr; argument: Ptr): OSErr;
	{ delay execution of a procedure until page faulting is safe }

{ debugger support functions }

FUNCTION DebuggerGetMax: LONGINT;
	{ return the highest function number supported }
PROCEDURE DebuggerEnter;
	{ enter the debugging state }
PROCEDURE DebuggerExit;
	{ exit the debugging state }
FUNCTION DebuggerPoll: LONGINT;
	{ keyboard polling without interrupts }

FUNCTION GetPageState(address: UNIV Ptr): PageState;
	{ return the state of the page containing the address }

FUNCTION PageFaultFatal: BOOLEAN;
	{ determine if a page fault would currently be fatal }

FUNCTION DebuggerLockMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ lock memory but do not disable cacheing of data }
FUNCTION DebuggerUnlockMemory(address: UNIV Ptr; count: LONGINT): OSErr;
	{ undo the effects of DebuggerLockMemory }

FUNCTION EnterSupervisorMode: StatusRegisterContents;
	{ explicitly enter supervisor mode }


{$ENDC}    { UsingVMCalls }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}

