/* Copyright Apple Computer, Inc. 1981-1988 */


type 'mxbm'{
	integer = $$CountOf(symbols);          /* Number of entries     */
	array symbols { pString; pString; };   /* Macro name; expansion */
};
	
resource 'mxbm' (100) {
    {   /* Useful command lines */

	/* Clear breakpoints, A-Trap breaks and then go */
	"GG",			"BRC;ATC;G",

	/* Break at the first instruction of a segment after loading it */
	"GS",			"SB 12D 1;G;T 2;SB 12D 0",

	/* Pop the return address of the stack and go to it */
	"RTS",			"PC = SP^;SP = SP + 4",

          /* Enter "GTO n" to go till offset n in the current procedure is reached */
    	"GTO",			"GT :+",

          /* Enter "BRO n" to set a breakpoint at offset n in the current procedure */
    	"BRO",			"BR :+",

	/* Displays the port assuming the A5 world is set up */
    	"thePort",		"DM A5^^ WindowRecord",

          /* IJ disassembles starting from the destination of a JMP instruction */
    	"IJ",			"IL (.+2)^",


	"ABusVars",		"02D8",
	"ACount",			"0A9A",
	"ADBBase",		"0CF8",
	"AGBHandle",		"0D1C",
	"AlarmState",		"021F",
	"ANumber",		"0A98",
	"ApFontID",		"0984",
	"App2Packs",		"0BC8",
	"ApplLimit",		"0130",
	"ApplScratch",		"0A78",
	"ApplZone",		"02AA",
	"AppPacks",		"0AB8",
	"AppParmHandle",		"0AEC",
	"ASCBase",		"0CC0",
	"AtalkHk1",		"0B14",
	"AtalkHk2",		"0B18",
	"AtMenuBottom",		"0A0C",
	"AuxCtlHead",		"0CD4",
	"AuxWinHead",		"0CD0",

	"BNMQHd",			"0B60",
	"BootDrive",		"0210",
	"BootMask",		"0B0E",
	"BootTmp8",		"0B36",
	"BtDskRfn",		"0B34",
	"BufPtr",			"010C",
	"BufTgDate",		"0304",
	"BufTgFBkNum",		"0302",
	"BufTgFFlg",		"0300",
	"BufTgFNum",		"02FC",

	"CaretTime",		"02F4",
	"ChooserBits",		"0946",
	"ChunkyDepth",		"0D60",
	"CkdDB",			"0340",
	"CloseOrnHook",		"0A88",
	"ColLines",		"0C22",
	"CoreEditVars",		"0954",
	"CPUFlag",		"012F",
	"CQDGlobals",		"0CCC",
	"CrsrAddr",		"0888",
	"CrsrBase",		"0898",
	"CrsrBusy",		"08CD",
	"CrsrCouple",		"08CF",
	"CrsrDevice",		"089C",
	"CrsrNew",		"08CE",
	"CrsrObscure",		"08D2",
	"CrsrPin",		"0834",
	"CrsrPtr",		"0D62",
	"CrsrRect",		"083C",
	"CrsrRow",		"08AC",
	"CrsrSave",		"088C",
	"CrsrScale",		"08D3",
	"CrsrState",		"08D0",
	"CrsrThresh",		"08EC",
	"CrsrVis",		"08CC",
	"CurActivate",		"0A64",
	"CurApName",		"0910",
	"CurApRefNum",		"0900",
	"CurDeactive",		"0A68",
	"CurDeKind",		"0A22",
	"CurDirStore",		"0398",
	"CurDragAction",		"0A46",
	"CurFMDenom",		"0994",
	"CurFMDevice",		"098E",
	"CurFMFace",		"098C",
	"CurFMFamily",		"0988",
	"CurFMInput",		"0988",
	"CurFMNeedBits",		"098D",
	"CurFMNumer",		"0990",
	"CurFMSize",		"098A",
	"CurJTOffset",		"0934",
	"CurMap",			"0A5A",
	"CurPageOption",		"0936",
	"CurPitch",		"0280",
	"CurrentA5",		"0904",
	"CurStackBase",		"0908",

	"DABeeper",		"0A9C",
	"DAStrings",		"0AA0",
	"DefltStack",		"0322",
	"DefVCBPtr",		"0352",
	"DeskCPat",		"0CD8",
	"DeskHook",		"0A6C",
	"SetOSDefKey",		"0CDC",
	"DeskPattern",		"0A3C",
	"DeskPort",		"09E2",
	"DeviceList",		"08A8",
	"DiskVars",		"0222",
	"DlgFont",		"0AFA",
	"DoubleTime",		"02F0",
	"DragFlag",		"0A44",
	"DragHook",		"09F6",
	"DragPattern",		"0A34",
	"DrMstrBlk",		"034C",
	"DrvQHdr",		"0308",
	"DSAlertRect",		"03F8",
	"DSAlertTab",		"02BA",
	"DSCtrAdj",		"0DA8",
	"DSDrawProc",		"0334",
	"DSErrCode",		"0AF0",
	"DskErr",			"0142",
	"DskRtnAdr",		"0124",
	"DskSwtchHook",		"03EA",
	"DskVerify",		"012C",
	"DskWr11",		"012F",
	"DSWndUpdate",		"015D",
	"DTQFlags",		"0D92",
	"DTQueue",		"0D92",
	"DTskQHdr",		"0D94",
	"DTskQTail",		"0D98",

	"EjectNotify",		"0338",
	"EndSRTPtr",		"0DB4",
	"ErCode",			"03A2",
	"EventQueue",		"014A",
	"EvtBufCnt",		"0154",
	"ExpandMem",		"02B6",
	"ExtFSHook",		"03E6",
	"ExtStsDT",		"02BE",

	"FCBSPtr",		"034E",
	"FDevDisable",		"0BB3",
	"FileVars",		"0340",
	"Filler3A",		"0214",
	"Finder",			"0261",
	"FinderName",		"02E0",
	"FLckUnlck",		"0348",
	"FlEvtMask",		"025E",
	"FlushOnly",		"0346",
	"FMDefaultSize",		"0987",
	"FMDotsPerInch",		"09B2",
	"FMExist",		"0D42",
	"FMgrOutRec",		"0998",
	"FMStyleTab",		"09B6",
	"FondID",			"0BC6",
	"FondState",		"0903",
	"FontFlag",		"015E",
	"FOutAscent",		"09A5",
	"FOutBold",		"099E",
	"FOutDenom",		"09AE",
	"FOutDescent",		"09A6",
	"FOutError",		"0998",
	"FOutExtra",		"09A4",
	"FOutFontHandle",		"099A",
	"FOutItalic",		"099F",
	"FOutLeading",		"09A8",
	"FOutNumer",		"09AA",
	"FOutRec",		"0998",
	"FOutShadow",		"09A3",
	"FOutULOffset",		"09A0",
	"FOutULShadow",		"09A1",
	"FOutULThick",		"09A2",
	"FOutUnused",		"09A9",
	"FOutWidMax",		"09A7",
	"FPState",		"0A4A",
	"FractEnable",		"0BF4",
	"FrcSync",		"0349",
	"FSBusy",			"0360",
	"FScaleDisable",		"0A63",
	"FScaleHFact",		"0BF6",
	"FScaleVFact",		"0BFA",
	"FSFCBLen",		"03F6",
	"FSQHdr",			"0360",
	"FSQHead",		"0362",
	"FSQTail",		"0366",
	"FSQueueHook",		"03E2",
	"FSTemp4",		"03DE",
	"FSTemp8",		"03D6",
	"FSVarEnd",		"03F6",

	"GetParam",		"01E4",
	"GhostWindow",		"0A84",
	"GotStrike",		"0986",
	"GrafBegin",		"0800",
	"GrafVar",		"0824",
	"GrayRgn",		"09EE",
	"GZMoveHnd",		"0330",
	"GZRootHnd",		"0328",
	"GZRootPtr",		"032C",

	"HeapEnd",		"0114",
	"HFSFlags",		"0376",
	"HiHeapMark",		"0BAE",
	"HiKeyLast",		"0216",
	"HiliteMode",		"0938",
	"HiliteRGB",		"0DA0",
	"HpChk",			"0316",
	"HWCfgFlags",		"0B22",

	"IAZNotify",		"033C",
	"IconBitmap",		"0A0E",
	"IconTLAddr",		"0DAC",
	"IntFlag",		"015F",
	"IntlSpec",		"0BA0",
	"IWM",			"01E0",

	"JAdrDisk",		"0252",
	"JAllocCrsr",		"088C",
	"JControl",		"0242",
	"JCrsrObscure",		"081C",
	"JCrsrTask",		"08EE",
	"JDCDReset",		"0B48",
	"JDiskPrime",		"0226",
	"JDiskSel",		"0B40",
	"jDTInstall",		"0D9C",
	"JFetch",			"08F4",
	"JFigTrkSpd",		"0222",
	"JFontInfo",		"08E4",
	"JGNEFilter",		"029A",
	"JHideCursor",		"0800",
	"JInitCrsr",		"0814",
	"JIODone",		"08FC",
	"JKybdTask",		"021A",
	"JMakeSpdTbl",		"024E",
	"JOpcodeProc",		"0894",
	"JournalFlag",		"08DE",
	"JournalRef",		"08E8",
	"JRdAddr",		"022A",
	"JRdData",		"022E",
	"JRecal",			"023E",
	"JReSeek",		"024A",
	"JScrnAddr",		"080C",
	"JScrnSize",		"0810",
	"JSeek",			"0236",
	"JSendCmd",		"0B44",
	"JSetCCrsr",		"0890",
	"JSetCrsr",		"0818",
	"JSetSpeed",		"0256",
	"JSetUpPoll",		"023A",
	"JShell",			"0212",
	"JShieldCursor",		"0808",
	"JShowCursor",		"0804",
	"JStash",			"08F8",
	"JSwapFont",		"08E0",
	"jSwapMMU",		"0DBC",
	"JUpdateProc",		"0820",
	"JVBLTask",		"0D28",
	"JWakeUp",		"0246",
	"JWrData",		"0232",

	"KbdLast",		"0218",
	"KbdType",		"021E",
	"KbdVars",		"0216",
	"Key1Trans",		"029E",
	"Key2Trans",		"02A2",
	"KeyLast",		"0184",
	"KeyMap",			"0174",
	"KeyMVars",		"0B04",
	"KeypadMap",		"017C",
	"KeyRepThresh",		"0190",
	"KeyRepTime",		"018A",
	"KeyThresh",		"018E",
	"KeyTime",		"0186",

	"LastDepth",		"0D40",
	"LastFond",		"0BC2",
	"LastFore",		"0D36",
	"LastLGlobal",		"0944",
	"LastMode",		"0D3E",
	"LastPGlobal",		"0954",
	"LastSPExtra",		"0B4C",
	"LastTGLobal",		"0AFC",
	"LastTxGDevice",		"0DC4",
	"LaunchFlag",		"0902",
	"LGrafJump",		"0824",
	"LoaderPBlock",		"093A",
	"LoadFiller",		"090C",
	"LoadTrap",		"012D",
	"LoadVars",		"0900",
	"Lvl1DT",			"0192",
	"Lvl2DT",			"01B2",

	"MacJmp",			"0120",
	"MacPgm",			"0316",
	"MAErrProc",		"0BE8",
	"MainDevice",		"08A4",
	"MaskBC",			"031A",
	"MaskHandle",		"031A",
	"MaskPtr",		"031A",
	"MASuperTab",		"0BEC",
	"MaxDB",			"0344",
	"MBarEnable",		"0A20",
	"MBarHeight",		"0BAA",
	"MBarHook",		"0A2C",
	"MBDFHndl",		"0B58",
	"MBSaveLoc",		"0B5C",
	"MBState",		"0172",
	"MBTicks",		"016E",
	"MemErr",			"0220",
	"MemTop",			"0108",
	"MenuCInfo",		"0D50",
	"MenuDisable",		"0B54",
	"MenuFlash",		"0A24",
	"MenuHook",		"0A30",
	"MenuList",		"0A1C",
	"MickeyBytes",		"0D6A",
	"MinStack",		"031E",
	"MMDefFlags",		"0326",
	"MmInOK",			"012E",
	"MMU32bit",		"0CB2",
	"MMUFlags",		"0CB0",
	"MMUFluff",		"0CB3",
	"MMUTbl",			"0CB4",
	"MMUTblSize",		"0CB8",
	"MMUType",		"0CB1",
	"MonkeyLives",		"0100",
	"Mouse",			"0830",
	"MouseMask",		"08D6",
	"MouseOffset",		"08DA",
	"MrMacHook",		"0A2C",
	"MTemp",			"0828",

     };
};


resource 'mxbm' (101) {
    {   	"NewCrsrJTbl",		"088C",
	"NewMount",		"034A",
	"NewUnused",		"0BC0",
	"NiblTbl",		"025A",
	"NMIFlag",		"0C2C",
	"NxtDB",			"0342",

	"OldContent",		"09EA",
	"OldStructure",		"09E6",

	"PaintWhite",		"09DC",
	"Params",			"03A4",
	"pCDeskPat",		"020B",
	"PmgrHandle",		"0DC8",
	"PollProc",		"013E",
	"PollRtnAddr",		"0128",
	"PollStack",		"013A",
	"PortAUse",		"0290",
	"PortBUse",		"0291",
	"PortList",		"0D66",
	"PrintErr",		"0944",
	"PrintVars",		"0944",
	"PWMBuf1",		"0B0A",
	"PWMBuf2",		"0312",
	"PWMValue",		"0138",

	"QDColors",		"08B0",
	"QDErr",			"0D6E",
	"QDExist",		"08F3",

	"RAMBase",		"02B2",
	"RawMouse",		"082C",
	"RegRsrc",		"0347",
	"ReqstVol",		"03EE",
	"ResErr",			"0A60",
	"ResErrProc",		"0AF2",
	"ResLoad",		"0A5E",
	"ResReadOnly",		"0A5C",
	"RestProc",		"0A8C",
	"ResumeProc",		"0A8C",
	"RGBBlack",		"0C10",
	"RGBWhite",		"0C16",
	"RgSvArea",		"036A",
	"RMgrHiVars",		"0B80",
	"RMgrPerm",		"0BA4",
	"RndSeed",		"0156",
	"ROM85",			"028E",
	"ROMBase",		"02AE",
	"RomFont0",		"0980",
	"ROMMapHndl",		"0B06",
	"RomMapInsert",		"0B9E",
	"RowBits",		"0C20",
	"RSDHndl",		"028A",

	"SavedHandle",		"0A28",
	"SavedHilite",		"0D43",
	"SaveFondFlags",		"0986",
	"SaveProc",		"0A90",
	"SaveSegHandle",		"0930",
	"SaveSP",			"0A94",
	"SaveUpdate",		"09DA",
	"SaveVisRgn",		"09F2",
	"SCCASts",		"02CE",
	"SCCBSts",		"02CF",
	"SCCRd",			"01D8",
	"SCCWr",			"01DC",
	"ScrapCount",		"0968",
	"ScrapHandle",		"0964",
	"ScrapInfo",		"0960",
	"ScrapName",		"096C",
	"ScrapSize",		"0960",
	"ScrapState",		"096A",
	"ScrapTag",		"0970",
	"ScrapVars",		"0960",
	"Scratch20",		"01E4",
	"Scratch8",		"09FA",
	"ScrDmpEnb",		"02F8",
	"ScrDmpType",		"02F9",
	"ScreenBytes",		"0C24",
	"ScreenRow",		"0106",
	"ScreenVars",		"0292",
	"ScrHRes",		"0104",
	"ScrnBase",		"0824",
	"ScrnVBLPtr",		"0D10",
	"ScrVRes",		"0102",
	"SCSIBase",		"0C00",
	"SCSIDMA",		"0C04",
	"SCSIDrvrs",		"0B2E",
	"SCSIFlag",		"0B22",
	"SCSIGlobals",		"0C0C",
	"SCSIHsk",		"0C08",
	"SCSIPoll",		"0C2F",
	"SdEnable",		"0261",
	"SDMBusErr",		"0DC0",
	"SDMJmpTblPtr",		"0DB8",
	"SdVolume",		"0260",
	"SegHiEnable",		"0BB2",
	"SerialVars",		"02D0",
	"SEVarBase",		"0C30",
	"SEvtEnb",		"015C",
	"SFSaveDisk",		"0214",
	"SInfoPtr",		"0CBC",
	"SInitFlags",		"0D90",
	"SlotPrTbl",		"0D08",
	"SlotQDT",		"0D04",
	"SlotTICKS",		"0D14",
	"SlotVBLQ",		"0D0C",
	"SMGlobals",		"0CC4",
	"SmgrCore",		"0BA0",
	"SonyVars",		"0134",
	"SoundActive",		"027E",
	"SoundBase",		"0266",
	"SoundDCE",		"027A",
	"SoundGlue",		"0AE8",
	"SoundLevel",		"027F",
	"SoundPtr",		"0262",
	"SoundVars",		"0262",
	"SoundVBL",		"026A",
	"SPAlarm",		"0200",
	"SPATalkA",		"01F9",
	"SPATalkB",		"01FA",
	"SPClikCaret",		"0209",
	"SPConfig",		"01FB",
	"SPFont",			"0204",
	"SPKbd",			"0206",
	"SPMisc1",		"020A",
	"SPMisc2",		"020B",
	"SPPortA",		"01FC",
	"SPPortB",		"01FE",
	"SPPrint",		"0207",
	"SPValid",		"01F8",
	"SPVolCtl",		"0208",
	"SrcDevice",		"08A0",
	"SRsrcTblPtr",		"0D24",
	"StkLowPt",		"0110",
	"Switcher",		"0282",
	"SwitcherTPtr",		"0286",
	"SynListHandle",		"0D32",
	"SysCom",			"0100",
	"SysEvtBuf",		"0146",
	"SysEvtMask",		"0144",
	"SysFontFam",		"0BA6",
	"SysFontSize",		"0BA8",
	"SysMap",			"0A58",
	"SysMapHndl",		"0A54",
	"SysParam",		"01F8",
	"SysResName",		"0AD8",
	"SysVersion",		"015A",
	"SysZone",		"02A6",

	"T1Arbitrate",		"0B3F",
	"TableSeed",		"0D20",
	"TagData",		"02FA",
	"TaskLock",		"0A62",
	"TEDoText",		"0A70",
	"TempRect",		"09FA",
	"TERecal",		"0A74",
	"TEScrpHandle",		"0AB4",
	"TEScrpLength",		"0AB0",
	"TESysJust",		"0BAC",
	"TEWdBreak",		"0AF6",
	"TheCrsr",		"0844",
	"TheGDevice",		"0CC8",
	"TheMenu",		"0A26",
	"TheZone",		"0118",
	"Ticks",			"016A",
	"Time",			"020C",
	"TimeDBRA",		"0D00",
	"TimeSCCDB",		"0D02",
	"TimeSCSIDB",		"0DA6",
	"TimeVars",		"0B30",
	"TmpResLoad",		"0B9F",
	"Tocks",			"0173",
	"ToExtFS",		"03F2",
	"ToolScratch",		"09CE",
	"TopMapHndl",		"0A50",
	"TopMenuItem",		"0A0A",
	"TrapAgain",		"0B00",
	"Twitcher1",		"0B50",
	"Twitcher2",		"0B7C",

	"UnitNtryCnt",		"01D2",
	"UsedFWidths",		"0BF5",
	"UTableBase",		"011C",

	"VBLQueue",		"0160",
	"VCBQHdr",		"0356",
	"VertRRate",		"0D30",
	"VIA",			"01D4",
	"VIA2DT",			"0D70",
	"VideoInfoOK",		"0DB0",
	"VidMode",		"0C2E",
	"VidType",		"0C2D",

	"WarmStart",		"0CFC",
	"WidthListHand",		"08E4",
	"WidthPtr",		"0B10",
	"WidthTabHandle",		"0B2A",
	"WindowList",		"09D6",
	"WMgrCPort",		"0D2C",
	"WMgrPort",		"09DE",
	"WordRedraw",		"0BA5",
	"WWExist",		"08F2",
     };
};
